
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMBarInfo
    ( 

-- * Exported types
    DOMBarInfo(..)                          ,
    DOMBarInfoK                             ,
    toDOMBarInfo                            ,
    noDOMBarInfo                            ,


 -- * Methods
-- ** dOMBarInfoGetVisible
    dOMBarInfoGetVisible                    ,




 -- * Properties
-- ** Visible
    DOMBarInfoVisiblePropertyInfo           ,
    getDOMBarInfoVisible                    ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMBarInfo = DOMBarInfo (ForeignPtr DOMBarInfo)
foreign import ccall "webkit_dom_bar_info_get_type"
    c_webkit_dom_bar_info_get_type :: IO GType

type instance ParentTypes DOMBarInfo = DOMBarInfoParentTypes
type DOMBarInfoParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMBarInfo where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_bar_info_get_type
    

class GObject o => DOMBarInfoK o
instance (GObject o, IsDescendantOf DOMBarInfo o) => DOMBarInfoK o

toDOMBarInfo :: DOMBarInfoK o => o -> IO DOMBarInfo
toDOMBarInfo = unsafeCastTo DOMBarInfo

noDOMBarInfo :: Maybe DOMBarInfo
noDOMBarInfo = Nothing

-- VVV Prop "visible"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMBarInfoVisible :: (MonadIO m, DOMBarInfoK o) => o -> m Bool
getDOMBarInfoVisible obj = liftIO $ getObjectPropertyBool obj "visible"

data DOMBarInfoVisiblePropertyInfo
instance AttrInfo DOMBarInfoVisiblePropertyInfo where
    type AttrAllowedOps DOMBarInfoVisiblePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMBarInfoVisiblePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMBarInfoVisiblePropertyInfo = DOMBarInfoK
    type AttrGetType DOMBarInfoVisiblePropertyInfo = Bool
    type AttrLabel DOMBarInfoVisiblePropertyInfo = "DOMBarInfo::visible"
    attrGet _ = getDOMBarInfoVisible
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMBarInfo = DOMBarInfoAttributeList
type DOMBarInfoAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo), '("visible", DOMBarInfoVisiblePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMBarInfo = DOMBarInfoSignalList
type DOMBarInfoSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMBarInfo::get_visible
-- method type : MemberFunction
-- Args : [Arg {argName = "self", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "self", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_bar_info_get_visible" webkit_dom_bar_info_get_visible :: 
    Ptr () ->                               -- self : TBasicType TVoid
    IO CInt

{-# DEPRECATED dOMBarInfoGetVisible ["(Since version 2.2)"]#-}
dOMBarInfoGetVisible ::
    (MonadIO m) =>
    Ptr () ->                               -- self
    m Bool
dOMBarInfoGetVisible self = liftIO $ do
    result <- webkit_dom_bar_info_get_visible self
    let result' = (/= 0) result
    return result'


