
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMBarProp
    ( 

-- * Exported types
    DOMBarProp(..)                          ,
    DOMBarPropK                             ,
    toDOMBarProp                            ,
    noDOMBarProp                            ,


 -- * Methods
-- ** dOMBarPropGetVisible
    dOMBarPropGetVisible                    ,




 -- * Properties
-- ** Visible
    DOMBarPropVisiblePropertyInfo           ,
    getDOMBarPropVisible                    ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMBarProp = DOMBarProp (ForeignPtr DOMBarProp)
foreign import ccall "webkit_dom_bar_prop_get_type"
    c_webkit_dom_bar_prop_get_type :: IO GType

type instance ParentTypes DOMBarProp = DOMBarPropParentTypes
type DOMBarPropParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMBarProp where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_bar_prop_get_type
    

class GObject o => DOMBarPropK o
instance (GObject o, IsDescendantOf DOMBarProp o) => DOMBarPropK o

toDOMBarProp :: DOMBarPropK o => o -> IO DOMBarProp
toDOMBarProp = unsafeCastTo DOMBarProp

noDOMBarProp :: Maybe DOMBarProp
noDOMBarProp = Nothing

-- VVV Prop "visible"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMBarPropVisible :: (MonadIO m, DOMBarPropK o) => o -> m Bool
getDOMBarPropVisible obj = liftIO $ getObjectPropertyBool obj "visible"

data DOMBarPropVisiblePropertyInfo
instance AttrInfo DOMBarPropVisiblePropertyInfo where
    type AttrAllowedOps DOMBarPropVisiblePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMBarPropVisiblePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMBarPropVisiblePropertyInfo = DOMBarPropK
    type AttrGetType DOMBarPropVisiblePropertyInfo = Bool
    type AttrLabel DOMBarPropVisiblePropertyInfo = "DOMBarProp::visible"
    attrGet _ = getDOMBarPropVisible
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMBarProp = DOMBarPropAttributeList
type DOMBarPropAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo), '("visible", DOMBarPropVisiblePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMBarProp = DOMBarPropSignalList
type DOMBarPropSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMBarProp::get_visible
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMBarProp", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMBarProp", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_bar_prop_get_visible" webkit_dom_bar_prop_get_visible :: 
    Ptr DOMBarProp ->                       -- _obj : TInterface "WebKit" "DOMBarProp"
    IO CInt


dOMBarPropGetVisible ::
    (MonadIO m, DOMBarPropK a) =>
    a ->                                    -- _obj
    m Bool
dOMBarPropGetVisible _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_bar_prop_get_visible _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'


