
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMBatteryManager
    ( 

-- * Exported types
    DOMBatteryManager(..)                   ,
    DOMBatteryManagerK                      ,
    toDOMBatteryManager                     ,
    noDOMBatteryManager                     ,


 -- * Methods
-- ** dOMBatteryManagerDispatchEvent
    dOMBatteryManagerDispatchEvent          ,


-- ** dOMBatteryManagerGetCharging
    dOMBatteryManagerGetCharging            ,


-- ** dOMBatteryManagerGetChargingTime
    dOMBatteryManagerGetChargingTime        ,


-- ** dOMBatteryManagerGetDischargingTime
    dOMBatteryManagerGetDischargingTime     ,


-- ** dOMBatteryManagerGetLevel
    dOMBatteryManagerGetLevel               ,




 -- * Properties
-- ** Charging
    DOMBatteryManagerChargingPropertyInfo   ,
    getDOMBatteryManagerCharging            ,


-- ** ChargingTime
    DOMBatteryManagerChargingTimePropertyInfo,
    getDOMBatteryManagerChargingTime        ,


-- ** DischargingTime
    DOMBatteryManagerDischargingTimePropertyInfo,
    getDOMBatteryManagerDischargingTime     ,


-- ** Level
    DOMBatteryManagerLevelPropertyInfo      ,
    getDOMBatteryManagerLevel               ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMBatteryManager = DOMBatteryManager (ForeignPtr DOMBatteryManager)
foreign import ccall "webkit_dom_battery_manager_get_type"
    c_webkit_dom_battery_manager_get_type :: IO GType

type instance ParentTypes DOMBatteryManager = DOMBatteryManagerParentTypes
type DOMBatteryManagerParentTypes = '[DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMBatteryManager where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_battery_manager_get_type
    

class GObject o => DOMBatteryManagerK o
instance (GObject o, IsDescendantOf DOMBatteryManager o) => DOMBatteryManagerK o

toDOMBatteryManager :: DOMBatteryManagerK o => o -> IO DOMBatteryManager
toDOMBatteryManager = unsafeCastTo DOMBatteryManager

noDOMBatteryManager :: Maybe DOMBatteryManager
noDOMBatteryManager = Nothing

-- VVV Prop "charging"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMBatteryManagerCharging :: (MonadIO m, DOMBatteryManagerK o) => o -> m Bool
getDOMBatteryManagerCharging obj = liftIO $ getObjectPropertyBool obj "charging"

data DOMBatteryManagerChargingPropertyInfo
instance AttrInfo DOMBatteryManagerChargingPropertyInfo where
    type AttrAllowedOps DOMBatteryManagerChargingPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMBatteryManagerChargingPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMBatteryManagerChargingPropertyInfo = DOMBatteryManagerK
    type AttrGetType DOMBatteryManagerChargingPropertyInfo = Bool
    type AttrLabel DOMBatteryManagerChargingPropertyInfo = "DOMBatteryManager::charging"
    attrGet _ = getDOMBatteryManagerCharging
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "charging-time"
   -- Type: TBasicType TDouble
   -- Flags: [PropertyReadable]

getDOMBatteryManagerChargingTime :: (MonadIO m, DOMBatteryManagerK o) => o -> m Double
getDOMBatteryManagerChargingTime obj = liftIO $ getObjectPropertyDouble obj "charging-time"

data DOMBatteryManagerChargingTimePropertyInfo
instance AttrInfo DOMBatteryManagerChargingTimePropertyInfo where
    type AttrAllowedOps DOMBatteryManagerChargingTimePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMBatteryManagerChargingTimePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMBatteryManagerChargingTimePropertyInfo = DOMBatteryManagerK
    type AttrGetType DOMBatteryManagerChargingTimePropertyInfo = Double
    type AttrLabel DOMBatteryManagerChargingTimePropertyInfo = "DOMBatteryManager::charging-time"
    attrGet _ = getDOMBatteryManagerChargingTime
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "discharging-time"
   -- Type: TBasicType TDouble
   -- Flags: [PropertyReadable]

getDOMBatteryManagerDischargingTime :: (MonadIO m, DOMBatteryManagerK o) => o -> m Double
getDOMBatteryManagerDischargingTime obj = liftIO $ getObjectPropertyDouble obj "discharging-time"

data DOMBatteryManagerDischargingTimePropertyInfo
instance AttrInfo DOMBatteryManagerDischargingTimePropertyInfo where
    type AttrAllowedOps DOMBatteryManagerDischargingTimePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMBatteryManagerDischargingTimePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMBatteryManagerDischargingTimePropertyInfo = DOMBatteryManagerK
    type AttrGetType DOMBatteryManagerDischargingTimePropertyInfo = Double
    type AttrLabel DOMBatteryManagerDischargingTimePropertyInfo = "DOMBatteryManager::discharging-time"
    attrGet _ = getDOMBatteryManagerDischargingTime
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "level"
   -- Type: TBasicType TDouble
   -- Flags: [PropertyReadable]

getDOMBatteryManagerLevel :: (MonadIO m, DOMBatteryManagerK o) => o -> m Double
getDOMBatteryManagerLevel obj = liftIO $ getObjectPropertyDouble obj "level"

data DOMBatteryManagerLevelPropertyInfo
instance AttrInfo DOMBatteryManagerLevelPropertyInfo where
    type AttrAllowedOps DOMBatteryManagerLevelPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMBatteryManagerLevelPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMBatteryManagerLevelPropertyInfo = DOMBatteryManagerK
    type AttrGetType DOMBatteryManagerLevelPropertyInfo = Double
    type AttrLabel DOMBatteryManagerLevelPropertyInfo = "DOMBatteryManager::level"
    attrGet _ = getDOMBatteryManagerLevel
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMBatteryManager = DOMBatteryManagerAttributeList
type DOMBatteryManagerAttributeList = ('[ '("charging", DOMBatteryManagerChargingPropertyInfo), '("charging-time", DOMBatteryManagerChargingTimePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("discharging-time", DOMBatteryManagerDischargingTimePropertyInfo), '("level", DOMBatteryManagerLevelPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMBatteryManager = DOMBatteryManagerSignalList
type DOMBatteryManagerSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMBatteryManager::dispatch_event
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMBatteryManager", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "event", argType = TInterface "WebKit" "DOMEvent", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMBatteryManager", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "event", argType = TInterface "WebKit" "DOMEvent", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_battery_manager_dispatch_event" webkit_dom_battery_manager_dispatch_event :: 
    Ptr DOMBatteryManager ->                -- _obj : TInterface "WebKit" "DOMBatteryManager"
    Ptr DOMEvent ->                         -- event : TInterface "WebKit" "DOMEvent"
    Ptr (Ptr GError) ->                     -- error
    IO CInt

{-# DEPRECATED dOMBatteryManagerDispatchEvent ["(Since version 2.4)","Use webkit_dom_event_target_dispatch_event() instead."]#-}
dOMBatteryManagerDispatchEvent ::
    (MonadIO m, DOMBatteryManagerK a, DOMEventK b) =>
    a ->                                    -- _obj
    b ->                                    -- event
    m ()
dOMBatteryManagerDispatchEvent _obj event = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let event' = unsafeManagedPtrCastPtr event
    onException (do
        _ <- propagateGError $ webkit_dom_battery_manager_dispatch_event _obj' event'
        touchManagedPtr _obj
        touchManagedPtr event
        return ()
     ) (do
        return ()
     )

-- method DOMBatteryManager::get_charging
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMBatteryManager", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMBatteryManager", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_battery_manager_get_charging" webkit_dom_battery_manager_get_charging :: 
    Ptr DOMBatteryManager ->                -- _obj : TInterface "WebKit" "DOMBatteryManager"
    IO CInt


dOMBatteryManagerGetCharging ::
    (MonadIO m, DOMBatteryManagerK a) =>
    a ->                                    -- _obj
    m Bool
dOMBatteryManagerGetCharging _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_battery_manager_get_charging _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMBatteryManager::get_charging_time
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMBatteryManager", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMBatteryManager", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TDouble
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_battery_manager_get_charging_time" webkit_dom_battery_manager_get_charging_time :: 
    Ptr DOMBatteryManager ->                -- _obj : TInterface "WebKit" "DOMBatteryManager"
    IO CDouble


dOMBatteryManagerGetChargingTime ::
    (MonadIO m, DOMBatteryManagerK a) =>
    a ->                                    -- _obj
    m Double
dOMBatteryManagerGetChargingTime _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_battery_manager_get_charging_time _obj'
    let result' = realToFrac result
    touchManagedPtr _obj
    return result'

-- method DOMBatteryManager::get_discharging_time
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMBatteryManager", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMBatteryManager", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TDouble
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_battery_manager_get_discharging_time" webkit_dom_battery_manager_get_discharging_time :: 
    Ptr DOMBatteryManager ->                -- _obj : TInterface "WebKit" "DOMBatteryManager"
    IO CDouble


dOMBatteryManagerGetDischargingTime ::
    (MonadIO m, DOMBatteryManagerK a) =>
    a ->                                    -- _obj
    m Double
dOMBatteryManagerGetDischargingTime _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_battery_manager_get_discharging_time _obj'
    let result' = realToFrac result
    touchManagedPtr _obj
    return result'

-- method DOMBatteryManager::get_level
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMBatteryManager", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMBatteryManager", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TDouble
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_battery_manager_get_level" webkit_dom_battery_manager_get_level :: 
    Ptr DOMBatteryManager ->                -- _obj : TInterface "WebKit" "DOMBatteryManager"
    IO CDouble


dOMBatteryManagerGetLevel ::
    (MonadIO m, DOMBatteryManagerK a) =>
    a ->                                    -- _obj
    m Double
dOMBatteryManagerGetLevel _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_battery_manager_get_level _obj'
    let result' = realToFrac result
    touchManagedPtr _obj
    return result'


