
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMCDATASection
    ( 

-- * Exported types
    DOMCDATASection(..)                     ,
    DOMCDATASectionK                        ,
    toDOMCDATASection                       ,
    noDOMCDATASection                       ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMCDATASection = DOMCDATASection (ForeignPtr DOMCDATASection)
foreign import ccall "webkit_dom_cdata_section_get_type"
    c_webkit_dom_cdata_section_get_type :: IO GType

type instance ParentTypes DOMCDATASection = DOMCDATASectionParentTypes
type DOMCDATASectionParentTypes = '[DOMText, DOMCharacterData, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMCDATASection where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_cdata_section_get_type
    

class GObject o => DOMCDATASectionK o
instance (GObject o, IsDescendantOf DOMCDATASection o) => DOMCDATASectionK o

toDOMCDATASection :: DOMCDATASectionK o => o -> IO DOMCDATASection
toDOMCDATASection = unsafeCastTo DOMCDATASection

noDOMCDATASection :: Maybe DOMCDATASection
noDOMCDATASection = Nothing

type instance AttributeList DOMCDATASection = DOMCDATASectionAttributeList
type DOMCDATASectionAttributeList = ('[ '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("data", DOMCharacterDataDataPropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("length", DOMCharacterDataLengthPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("whole-text", DOMTextWholeTextPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMCDATASection = DOMCDATASectionSignalList
type DOMCDATASectionSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


