
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMCSSStyleDeclaration
    ( 

-- * Exported types
    DOMCSSStyleDeclaration(..)              ,
    DOMCSSStyleDeclarationK                 ,
    toDOMCSSStyleDeclaration                ,
    noDOMCSSStyleDeclaration                ,


 -- * Methods
-- ** dOMCSSStyleDeclarationGetCssText
    dOMCSSStyleDeclarationGetCssText        ,


-- ** dOMCSSStyleDeclarationGetLength
    dOMCSSStyleDeclarationGetLength         ,


-- ** dOMCSSStyleDeclarationGetParentRule
    dOMCSSStyleDeclarationGetParentRule     ,


-- ** dOMCSSStyleDeclarationGetPropertyCssValue
    dOMCSSStyleDeclarationGetPropertyCssValue,


-- ** dOMCSSStyleDeclarationGetPropertyPriority
    dOMCSSStyleDeclarationGetPropertyPriority,


-- ** dOMCSSStyleDeclarationGetPropertyShorthand
    dOMCSSStyleDeclarationGetPropertyShorthand,


-- ** dOMCSSStyleDeclarationGetPropertyValue
    dOMCSSStyleDeclarationGetPropertyValue  ,


-- ** dOMCSSStyleDeclarationIsPropertyImplicit
    dOMCSSStyleDeclarationIsPropertyImplicit,


-- ** dOMCSSStyleDeclarationItem
    dOMCSSStyleDeclarationItem              ,


-- ** dOMCSSStyleDeclarationRemoveProperty
    dOMCSSStyleDeclarationRemoveProperty    ,


-- ** dOMCSSStyleDeclarationSetCssText
    dOMCSSStyleDeclarationSetCssText        ,


-- ** dOMCSSStyleDeclarationSetProperty
    dOMCSSStyleDeclarationSetProperty       ,




 -- * Properties
-- ** CssText
    DOMCSSStyleDeclarationCssTextPropertyInfo,
    constructDOMCSSStyleDeclarationCssText  ,
    getDOMCSSStyleDeclarationCssText        ,
    setDOMCSSStyleDeclarationCssText        ,


-- ** Length
    DOMCSSStyleDeclarationLengthPropertyInfo,
    getDOMCSSStyleDeclarationLength         ,


-- ** ParentRule
    DOMCSSStyleDeclarationParentRulePropertyInfo,
    getDOMCSSStyleDeclarationParentRule     ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMCSSStyleDeclaration = DOMCSSStyleDeclaration (ForeignPtr DOMCSSStyleDeclaration)
foreign import ccall "webkit_dom_css_style_declaration_get_type"
    c_webkit_dom_css_style_declaration_get_type :: IO GType

type instance ParentTypes DOMCSSStyleDeclaration = DOMCSSStyleDeclarationParentTypes
type DOMCSSStyleDeclarationParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMCSSStyleDeclaration where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_css_style_declaration_get_type
    

class GObject o => DOMCSSStyleDeclarationK o
instance (GObject o, IsDescendantOf DOMCSSStyleDeclaration o) => DOMCSSStyleDeclarationK o

toDOMCSSStyleDeclaration :: DOMCSSStyleDeclarationK o => o -> IO DOMCSSStyleDeclaration
toDOMCSSStyleDeclaration = unsafeCastTo DOMCSSStyleDeclaration

noDOMCSSStyleDeclaration :: Maybe DOMCSSStyleDeclaration
noDOMCSSStyleDeclaration = Nothing

-- VVV Prop "css-text"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMCSSStyleDeclarationCssText :: (MonadIO m, DOMCSSStyleDeclarationK o) => o -> m T.Text
getDOMCSSStyleDeclarationCssText obj = liftIO $ getObjectPropertyString obj "css-text"

setDOMCSSStyleDeclarationCssText :: (MonadIO m, DOMCSSStyleDeclarationK o) => o -> T.Text -> m ()
setDOMCSSStyleDeclarationCssText obj val = liftIO $ setObjectPropertyString obj "css-text" val

constructDOMCSSStyleDeclarationCssText :: T.Text -> IO ([Char], GValue)
constructDOMCSSStyleDeclarationCssText val = constructObjectPropertyString "css-text" val

data DOMCSSStyleDeclarationCssTextPropertyInfo
instance AttrInfo DOMCSSStyleDeclarationCssTextPropertyInfo where
    type AttrAllowedOps DOMCSSStyleDeclarationCssTextPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMCSSStyleDeclarationCssTextPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMCSSStyleDeclarationCssTextPropertyInfo = DOMCSSStyleDeclarationK
    type AttrGetType DOMCSSStyleDeclarationCssTextPropertyInfo = T.Text
    type AttrLabel DOMCSSStyleDeclarationCssTextPropertyInfo = "DOMCSSStyleDeclaration::css-text"
    attrGet _ = getDOMCSSStyleDeclarationCssText
    attrSet _ = setDOMCSSStyleDeclarationCssText
    attrConstruct _ = constructDOMCSSStyleDeclarationCssText

-- VVV Prop "length"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMCSSStyleDeclarationLength :: (MonadIO m, DOMCSSStyleDeclarationK o) => o -> m Word64
getDOMCSSStyleDeclarationLength obj = liftIO $ getObjectPropertyUInt64 obj "length"

data DOMCSSStyleDeclarationLengthPropertyInfo
instance AttrInfo DOMCSSStyleDeclarationLengthPropertyInfo where
    type AttrAllowedOps DOMCSSStyleDeclarationLengthPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMCSSStyleDeclarationLengthPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMCSSStyleDeclarationLengthPropertyInfo = DOMCSSStyleDeclarationK
    type AttrGetType DOMCSSStyleDeclarationLengthPropertyInfo = Word64
    type AttrLabel DOMCSSStyleDeclarationLengthPropertyInfo = "DOMCSSStyleDeclaration::length"
    attrGet _ = getDOMCSSStyleDeclarationLength
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "parent-rule"
   -- Type: TInterface "WebKit" "DOMCSSRule"
   -- Flags: [PropertyReadable]

getDOMCSSStyleDeclarationParentRule :: (MonadIO m, DOMCSSStyleDeclarationK o) => o -> m DOMCSSRule
getDOMCSSStyleDeclarationParentRule obj = liftIO $ getObjectPropertyObject obj "parent-rule" DOMCSSRule

data DOMCSSStyleDeclarationParentRulePropertyInfo
instance AttrInfo DOMCSSStyleDeclarationParentRulePropertyInfo where
    type AttrAllowedOps DOMCSSStyleDeclarationParentRulePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMCSSStyleDeclarationParentRulePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMCSSStyleDeclarationParentRulePropertyInfo = DOMCSSStyleDeclarationK
    type AttrGetType DOMCSSStyleDeclarationParentRulePropertyInfo = DOMCSSRule
    type AttrLabel DOMCSSStyleDeclarationParentRulePropertyInfo = "DOMCSSStyleDeclaration::parent-rule"
    attrGet _ = getDOMCSSStyleDeclarationParentRule
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMCSSStyleDeclaration = DOMCSSStyleDeclarationAttributeList
type DOMCSSStyleDeclarationAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo), '("css-text", DOMCSSStyleDeclarationCssTextPropertyInfo), '("length", DOMCSSStyleDeclarationLengthPropertyInfo), '("parent-rule", DOMCSSStyleDeclarationParentRulePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMCSSStyleDeclaration = DOMCSSStyleDeclarationSignalList
type DOMCSSStyleDeclarationSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMCSSStyleDeclaration::get_css_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_css_style_declaration_get_css_text" webkit_dom_css_style_declaration_get_css_text :: 
    Ptr DOMCSSStyleDeclaration ->           -- _obj : TInterface "WebKit" "DOMCSSStyleDeclaration"
    IO CString


dOMCSSStyleDeclarationGetCssText ::
    (MonadIO m, DOMCSSStyleDeclarationK a) =>
    a ->                                    -- _obj
    m T.Text
dOMCSSStyleDeclarationGetCssText _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_css_style_declaration_get_css_text _obj'
    checkUnexpectedReturnNULL "webkit_dom_css_style_declaration_get_css_text" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMCSSStyleDeclaration::get_length
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_css_style_declaration_get_length" webkit_dom_css_style_declaration_get_length :: 
    Ptr DOMCSSStyleDeclaration ->           -- _obj : TInterface "WebKit" "DOMCSSStyleDeclaration"
    IO Word64


dOMCSSStyleDeclarationGetLength ::
    (MonadIO m, DOMCSSStyleDeclarationK a) =>
    a ->                                    -- _obj
    m Word64
dOMCSSStyleDeclarationGetLength _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_css_style_declaration_get_length _obj'
    touchManagedPtr _obj
    return result

-- method DOMCSSStyleDeclaration::get_parent_rule
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMCSSRule"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_css_style_declaration_get_parent_rule" webkit_dom_css_style_declaration_get_parent_rule :: 
    Ptr DOMCSSStyleDeclaration ->           -- _obj : TInterface "WebKit" "DOMCSSStyleDeclaration"
    IO (Ptr DOMCSSRule)


dOMCSSStyleDeclarationGetParentRule ::
    (MonadIO m, DOMCSSStyleDeclarationK a) =>
    a ->                                    -- _obj
    m DOMCSSRule
dOMCSSStyleDeclarationGetParentRule _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_css_style_declaration_get_parent_rule _obj'
    checkUnexpectedReturnNULL "webkit_dom_css_style_declaration_get_parent_rule" result
    result' <- (wrapObject DOMCSSRule) result
    touchManagedPtr _obj
    return result'

-- method DOMCSSStyleDeclaration::get_property_css_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMCSSValue"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_css_style_declaration_get_property_css_value" webkit_dom_css_style_declaration_get_property_css_value :: 
    Ptr DOMCSSStyleDeclaration ->           -- _obj : TInterface "WebKit" "DOMCSSStyleDeclaration"
    CString ->                              -- propertyName : TBasicType TUTF8
    IO (Ptr DOMCSSValue)

{-# DEPRECATED dOMCSSStyleDeclarationGetPropertyCssValue ["(Since version 2.2)"]#-}
dOMCSSStyleDeclarationGetPropertyCssValue ::
    (MonadIO m, DOMCSSStyleDeclarationK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- propertyName
    m DOMCSSValue
dOMCSSStyleDeclarationGetPropertyCssValue _obj propertyName = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    propertyName' <- textToCString propertyName
    result <- webkit_dom_css_style_declaration_get_property_css_value _obj' propertyName'
    checkUnexpectedReturnNULL "webkit_dom_css_style_declaration_get_property_css_value" result
    result' <- (newObject DOMCSSValue) result
    touchManagedPtr _obj
    freeMem propertyName'
    return result'

-- method DOMCSSStyleDeclaration::get_property_priority
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_css_style_declaration_get_property_priority" webkit_dom_css_style_declaration_get_property_priority :: 
    Ptr DOMCSSStyleDeclaration ->           -- _obj : TInterface "WebKit" "DOMCSSStyleDeclaration"
    CString ->                              -- propertyName : TBasicType TUTF8
    IO CString


dOMCSSStyleDeclarationGetPropertyPriority ::
    (MonadIO m, DOMCSSStyleDeclarationK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- propertyName
    m T.Text
dOMCSSStyleDeclarationGetPropertyPriority _obj propertyName = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    propertyName' <- textToCString propertyName
    result <- webkit_dom_css_style_declaration_get_property_priority _obj' propertyName'
    checkUnexpectedReturnNULL "webkit_dom_css_style_declaration_get_property_priority" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    freeMem propertyName'
    return result'

-- method DOMCSSStyleDeclaration::get_property_shorthand
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_css_style_declaration_get_property_shorthand" webkit_dom_css_style_declaration_get_property_shorthand :: 
    Ptr DOMCSSStyleDeclaration ->           -- _obj : TInterface "WebKit" "DOMCSSStyleDeclaration"
    CString ->                              -- propertyName : TBasicType TUTF8
    IO CString


dOMCSSStyleDeclarationGetPropertyShorthand ::
    (MonadIO m, DOMCSSStyleDeclarationK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- propertyName
    m T.Text
dOMCSSStyleDeclarationGetPropertyShorthand _obj propertyName = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    propertyName' <- textToCString propertyName
    result <- webkit_dom_css_style_declaration_get_property_shorthand _obj' propertyName'
    checkUnexpectedReturnNULL "webkit_dom_css_style_declaration_get_property_shorthand" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    freeMem propertyName'
    return result'

-- method DOMCSSStyleDeclaration::get_property_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_css_style_declaration_get_property_value" webkit_dom_css_style_declaration_get_property_value :: 
    Ptr DOMCSSStyleDeclaration ->           -- _obj : TInterface "WebKit" "DOMCSSStyleDeclaration"
    CString ->                              -- propertyName : TBasicType TUTF8
    IO CString


dOMCSSStyleDeclarationGetPropertyValue ::
    (MonadIO m, DOMCSSStyleDeclarationK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- propertyName
    m T.Text
dOMCSSStyleDeclarationGetPropertyValue _obj propertyName = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    propertyName' <- textToCString propertyName
    result <- webkit_dom_css_style_declaration_get_property_value _obj' propertyName'
    checkUnexpectedReturnNULL "webkit_dom_css_style_declaration_get_property_value" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    freeMem propertyName'
    return result'

-- method DOMCSSStyleDeclaration::is_property_implicit
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_css_style_declaration_is_property_implicit" webkit_dom_css_style_declaration_is_property_implicit :: 
    Ptr DOMCSSStyleDeclaration ->           -- _obj : TInterface "WebKit" "DOMCSSStyleDeclaration"
    CString ->                              -- propertyName : TBasicType TUTF8
    IO CInt


dOMCSSStyleDeclarationIsPropertyImplicit ::
    (MonadIO m, DOMCSSStyleDeclarationK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- propertyName
    m Bool
dOMCSSStyleDeclarationIsPropertyImplicit _obj propertyName = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    propertyName' <- textToCString propertyName
    result <- webkit_dom_css_style_declaration_is_property_implicit _obj' propertyName'
    let result' = (/= 0) result
    touchManagedPtr _obj
    freeMem propertyName'
    return result'

-- method DOMCSSStyleDeclaration::item
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_css_style_declaration_item" webkit_dom_css_style_declaration_item :: 
    Ptr DOMCSSStyleDeclaration ->           -- _obj : TInterface "WebKit" "DOMCSSStyleDeclaration"
    Word64 ->                               -- index : TBasicType TUInt64
    IO CString


dOMCSSStyleDeclarationItem ::
    (MonadIO m, DOMCSSStyleDeclarationK a) =>
    a ->                                    -- _obj
    Word64 ->                               -- index
    m T.Text
dOMCSSStyleDeclarationItem _obj index = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_css_style_declaration_item _obj' index
    checkUnexpectedReturnNULL "webkit_dom_css_style_declaration_item" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMCSSStyleDeclaration::remove_property
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_css_style_declaration_remove_property" webkit_dom_css_style_declaration_remove_property :: 
    Ptr DOMCSSStyleDeclaration ->           -- _obj : TInterface "WebKit" "DOMCSSStyleDeclaration"
    CString ->                              -- propertyName : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO CString


dOMCSSStyleDeclarationRemoveProperty ::
    (MonadIO m, DOMCSSStyleDeclarationK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- propertyName
    m T.Text
dOMCSSStyleDeclarationRemoveProperty _obj propertyName = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    propertyName' <- textToCString propertyName
    onException (do
        result <- propagateGError $ webkit_dom_css_style_declaration_remove_property _obj' propertyName'
        checkUnexpectedReturnNULL "webkit_dom_css_style_declaration_remove_property" result
        result' <- cstringToText result
        freeMem result
        touchManagedPtr _obj
        freeMem propertyName'
        return result'
     ) (do
        freeMem propertyName'
     )

-- method DOMCSSStyleDeclaration::set_css_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_css_style_declaration_set_css_text" webkit_dom_css_style_declaration_set_css_text :: 
    Ptr DOMCSSStyleDeclaration ->           -- _obj : TInterface "WebKit" "DOMCSSStyleDeclaration"
    CString ->                              -- value : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMCSSStyleDeclarationSetCssText ::
    (MonadIO m, DOMCSSStyleDeclarationK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMCSSStyleDeclarationSetCssText _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    onException (do
        propagateGError $ webkit_dom_css_style_declaration_set_css_text _obj' value'
        touchManagedPtr _obj
        freeMem value'
        return ()
     ) (do
        freeMem value'
     )

-- method DOMCSSStyleDeclaration::set_property
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "priority", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMCSSStyleDeclaration", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "propertyName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "priority", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_css_style_declaration_set_property" webkit_dom_css_style_declaration_set_property :: 
    Ptr DOMCSSStyleDeclaration ->           -- _obj : TInterface "WebKit" "DOMCSSStyleDeclaration"
    CString ->                              -- propertyName : TBasicType TUTF8
    CString ->                              -- value : TBasicType TUTF8
    CString ->                              -- priority : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMCSSStyleDeclarationSetProperty ::
    (MonadIO m, DOMCSSStyleDeclarationK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- propertyName
    T.Text ->                               -- value
    T.Text ->                               -- priority
    m ()
dOMCSSStyleDeclarationSetProperty _obj propertyName value priority = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    propertyName' <- textToCString propertyName
    value' <- textToCString value
    priority' <- textToCString priority
    onException (do
        propagateGError $ webkit_dom_css_style_declaration_set_property _obj' propertyName' value' priority'
        touchManagedPtr _obj
        freeMem propertyName'
        freeMem value'
        freeMem priority'
        return ()
     ) (do
        freeMem propertyName'
        freeMem value'
        freeMem priority'
     )


