
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMComment
    ( 

-- * Exported types
    DOMComment(..)                          ,
    DOMCommentK                             ,
    toDOMComment                            ,
    noDOMComment                            ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMComment = DOMComment (ForeignPtr DOMComment)
foreign import ccall "webkit_dom_comment_get_type"
    c_webkit_dom_comment_get_type :: IO GType

type instance ParentTypes DOMComment = DOMCommentParentTypes
type DOMCommentParentTypes = '[DOMCharacterData, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMComment where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_comment_get_type
    

class GObject o => DOMCommentK o
instance (GObject o, IsDescendantOf DOMComment o) => DOMCommentK o

toDOMComment :: DOMCommentK o => o -> IO DOMComment
toDOMComment = unsafeCastTo DOMComment

noDOMComment :: Maybe DOMComment
noDOMComment = Nothing

type instance AttributeList DOMComment = DOMCommentAttributeList
type DOMCommentAttributeList = ('[ '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("data", DOMCharacterDataDataPropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("length", DOMCharacterDataLengthPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMComment = DOMCommentSignalList
type DOMCommentSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


