
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMConsole
    ( 

-- * Exported types
    DOMConsole(..)                          ,
    DOMConsoleK                             ,
    toDOMConsole                            ,
    noDOMConsole                            ,


 -- * Methods
-- ** dOMConsoleGetMemory
    dOMConsoleGetMemory                     ,


-- ** dOMConsoleGroupEnd
    dOMConsoleGroupEnd                      ,


-- ** dOMConsoleTime
    dOMConsoleTime                          ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMConsole = DOMConsole (ForeignPtr DOMConsole)
foreign import ccall "webkit_dom_console_get_type"
    c_webkit_dom_console_get_type :: IO GType

type instance ParentTypes DOMConsole = DOMConsoleParentTypes
type DOMConsoleParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMConsole where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_console_get_type
    

class GObject o => DOMConsoleK o
instance (GObject o, IsDescendantOf DOMConsole o) => DOMConsoleK o

toDOMConsole :: DOMConsoleK o => o -> IO DOMConsole
toDOMConsole = unsafeCastTo DOMConsole

noDOMConsole :: Maybe DOMConsole
noDOMConsole = Nothing

type instance AttributeList DOMConsole = DOMConsoleAttributeList
type DOMConsoleAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMConsole = DOMConsoleSignalList
type DOMConsoleSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMConsole::get_memory
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMConsole", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMConsole", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_console_get_memory" webkit_dom_console_get_memory :: 
    Ptr DOMConsole ->                       -- _obj : TInterface "WebKit" "DOMConsole"
    IO ()

{-# DEPRECATED dOMConsoleGetMemory ["(Since version 2.2)"]#-}
dOMConsoleGetMemory ::
    (MonadIO m, DOMConsoleK a) =>
    a ->                                    -- _obj
    m ()
dOMConsoleGetMemory _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_console_get_memory _obj'
    touchManagedPtr _obj
    return ()

-- method DOMConsole::group_end
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMConsole", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMConsole", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_console_group_end" webkit_dom_console_group_end :: 
    Ptr DOMConsole ->                       -- _obj : TInterface "WebKit" "DOMConsole"
    IO ()


dOMConsoleGroupEnd ::
    (MonadIO m, DOMConsoleK a) =>
    a ->                                    -- _obj
    m ()
dOMConsoleGroupEnd _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_console_group_end _obj'
    touchManagedPtr _obj
    return ()

-- method DOMConsole::time
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMConsole", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "title", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMConsole", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "title", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_console_time" webkit_dom_console_time :: 
    Ptr DOMConsole ->                       -- _obj : TInterface "WebKit" "DOMConsole"
    CString ->                              -- title : TBasicType TUTF8
    IO ()


dOMConsoleTime ::
    (MonadIO m, DOMConsoleK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- title
    m ()
dOMConsoleTime _obj title = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    title' <- textToCString title
    webkit_dom_console_time _obj' title'
    touchManagedPtr _obj
    freeMem title'
    return ()


