
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMDOMNamedFlowCollection
    ( 

-- * Exported types
    DOMDOMNamedFlowCollection(..)           ,
    DOMDOMNamedFlowCollectionK              ,
    toDOMDOMNamedFlowCollection             ,
    noDOMDOMNamedFlowCollection             ,


 -- * Methods
-- ** dOMDOMNamedFlowCollectionGetLength
    dOMDOMNamedFlowCollectionGetLength      ,


-- ** dOMDOMNamedFlowCollectionItem
    dOMDOMNamedFlowCollectionItem           ,


-- ** dOMDOMNamedFlowCollectionNamedItem
    dOMDOMNamedFlowCollectionNamedItem      ,




 -- * Properties
-- ** Length
    DOMDOMNamedFlowCollectionLengthPropertyInfo,
    getDOMDOMNamedFlowCollectionLength      ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMDOMNamedFlowCollection = DOMDOMNamedFlowCollection (ForeignPtr DOMDOMNamedFlowCollection)
foreign import ccall "webkit_dom_dom_named_flow_collection_get_type"
    c_webkit_dom_dom_named_flow_collection_get_type :: IO GType

type instance ParentTypes DOMDOMNamedFlowCollection = DOMDOMNamedFlowCollectionParentTypes
type DOMDOMNamedFlowCollectionParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMDOMNamedFlowCollection where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_dom_named_flow_collection_get_type
    

class GObject o => DOMDOMNamedFlowCollectionK o
instance (GObject o, IsDescendantOf DOMDOMNamedFlowCollection o) => DOMDOMNamedFlowCollectionK o

toDOMDOMNamedFlowCollection :: DOMDOMNamedFlowCollectionK o => o -> IO DOMDOMNamedFlowCollection
toDOMDOMNamedFlowCollection = unsafeCastTo DOMDOMNamedFlowCollection

noDOMDOMNamedFlowCollection :: Maybe DOMDOMNamedFlowCollection
noDOMDOMNamedFlowCollection = Nothing

-- VVV Prop "length"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMDOMNamedFlowCollectionLength :: (MonadIO m, DOMDOMNamedFlowCollectionK o) => o -> m Word64
getDOMDOMNamedFlowCollectionLength obj = liftIO $ getObjectPropertyUInt64 obj "length"

data DOMDOMNamedFlowCollectionLengthPropertyInfo
instance AttrInfo DOMDOMNamedFlowCollectionLengthPropertyInfo where
    type AttrAllowedOps DOMDOMNamedFlowCollectionLengthPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMDOMNamedFlowCollectionLengthPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDOMNamedFlowCollectionLengthPropertyInfo = DOMDOMNamedFlowCollectionK
    type AttrGetType DOMDOMNamedFlowCollectionLengthPropertyInfo = Word64
    type AttrLabel DOMDOMNamedFlowCollectionLengthPropertyInfo = "DOMDOMNamedFlowCollection::length"
    attrGet _ = getDOMDOMNamedFlowCollectionLength
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMDOMNamedFlowCollection = DOMDOMNamedFlowCollectionAttributeList
type DOMDOMNamedFlowCollectionAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo), '("length", DOMDOMNamedFlowCollectionLengthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMDOMNamedFlowCollection = DOMDOMNamedFlowCollectionSignalList
type DOMDOMNamedFlowCollectionSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMDOMNamedFlowCollection::get_length
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMNamedFlowCollection", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMNamedFlowCollection", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_dom_named_flow_collection_get_length" webkit_dom_dom_named_flow_collection_get_length :: 
    Ptr DOMDOMNamedFlowCollection ->        -- _obj : TInterface "WebKit" "DOMDOMNamedFlowCollection"
    IO Word64


dOMDOMNamedFlowCollectionGetLength ::
    (MonadIO m, DOMDOMNamedFlowCollectionK a) =>
    a ->                                    -- _obj
    m Word64
dOMDOMNamedFlowCollectionGetLength _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_dom_named_flow_collection_get_length _obj'
    touchManagedPtr _obj
    return result

-- method DOMDOMNamedFlowCollection::item
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMNamedFlowCollection", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMNamedFlowCollection", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMWebKitNamedFlow"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_dom_named_flow_collection_item" webkit_dom_dom_named_flow_collection_item :: 
    Ptr DOMDOMNamedFlowCollection ->        -- _obj : TInterface "WebKit" "DOMDOMNamedFlowCollection"
    Word64 ->                               -- index : TBasicType TUInt64
    IO (Ptr DOMWebKitNamedFlow)


dOMDOMNamedFlowCollectionItem ::
    (MonadIO m, DOMDOMNamedFlowCollectionK a) =>
    a ->                                    -- _obj
    Word64 ->                               -- index
    m DOMWebKitNamedFlow
dOMDOMNamedFlowCollectionItem _obj index = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_dom_named_flow_collection_item _obj' index
    checkUnexpectedReturnNULL "webkit_dom_dom_named_flow_collection_item" result
    result' <- (wrapObject DOMWebKitNamedFlow) result
    touchManagedPtr _obj
    return result'

-- method DOMDOMNamedFlowCollection::named_item
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMNamedFlowCollection", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMNamedFlowCollection", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMWebKitNamedFlow"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_dom_named_flow_collection_named_item" webkit_dom_dom_named_flow_collection_named_item :: 
    Ptr DOMDOMNamedFlowCollection ->        -- _obj : TInterface "WebKit" "DOMDOMNamedFlowCollection"
    CString ->                              -- name : TBasicType TUTF8
    IO (Ptr DOMWebKitNamedFlow)


dOMDOMNamedFlowCollectionNamedItem ::
    (MonadIO m, DOMDOMNamedFlowCollectionK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- name
    m DOMWebKitNamedFlow
dOMDOMNamedFlowCollectionNamedItem _obj name = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    name' <- textToCString name
    result <- webkit_dom_dom_named_flow_collection_named_item _obj' name'
    checkUnexpectedReturnNULL "webkit_dom_dom_named_flow_collection_named_item" result
    result' <- (wrapObject DOMWebKitNamedFlow) result
    touchManagedPtr _obj
    freeMem name'
    return result'


