
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMDOMSettableTokenList
    ( 

-- * Exported types
    DOMDOMSettableTokenList(..)             ,
    DOMDOMSettableTokenListK                ,
    toDOMDOMSettableTokenList               ,
    noDOMDOMSettableTokenList               ,


 -- * Methods
-- ** dOMDOMSettableTokenListGetValue
    dOMDOMSettableTokenListGetValue         ,


-- ** dOMDOMSettableTokenListSetValue
    dOMDOMSettableTokenListSetValue         ,




 -- * Properties
-- ** Value
    DOMDOMSettableTokenListValuePropertyInfo,
    constructDOMDOMSettableTokenListValue   ,
    getDOMDOMSettableTokenListValue         ,
    setDOMDOMSettableTokenListValue         ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMDOMSettableTokenList = DOMDOMSettableTokenList (ForeignPtr DOMDOMSettableTokenList)
foreign import ccall "webkit_dom_dom_settable_token_list_get_type"
    c_webkit_dom_dom_settable_token_list_get_type :: IO GType

type instance ParentTypes DOMDOMSettableTokenList = DOMDOMSettableTokenListParentTypes
type DOMDOMSettableTokenListParentTypes = '[DOMDOMTokenList, DOMObject, GObject.Object]

instance GObject DOMDOMSettableTokenList where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_dom_settable_token_list_get_type
    

class GObject o => DOMDOMSettableTokenListK o
instance (GObject o, IsDescendantOf DOMDOMSettableTokenList o) => DOMDOMSettableTokenListK o

toDOMDOMSettableTokenList :: DOMDOMSettableTokenListK o => o -> IO DOMDOMSettableTokenList
toDOMDOMSettableTokenList = unsafeCastTo DOMDOMSettableTokenList

noDOMDOMSettableTokenList :: Maybe DOMDOMSettableTokenList
noDOMDOMSettableTokenList = Nothing

-- VVV Prop "value"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMDOMSettableTokenListValue :: (MonadIO m, DOMDOMSettableTokenListK o) => o -> m T.Text
getDOMDOMSettableTokenListValue obj = liftIO $ getObjectPropertyString obj "value"

setDOMDOMSettableTokenListValue :: (MonadIO m, DOMDOMSettableTokenListK o) => o -> T.Text -> m ()
setDOMDOMSettableTokenListValue obj val = liftIO $ setObjectPropertyString obj "value" val

constructDOMDOMSettableTokenListValue :: T.Text -> IO ([Char], GValue)
constructDOMDOMSettableTokenListValue val = constructObjectPropertyString "value" val

data DOMDOMSettableTokenListValuePropertyInfo
instance AttrInfo DOMDOMSettableTokenListValuePropertyInfo where
    type AttrAllowedOps DOMDOMSettableTokenListValuePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMDOMSettableTokenListValuePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMDOMSettableTokenListValuePropertyInfo = DOMDOMSettableTokenListK
    type AttrGetType DOMDOMSettableTokenListValuePropertyInfo = T.Text
    type AttrLabel DOMDOMSettableTokenListValuePropertyInfo = "DOMDOMSettableTokenList::value"
    attrGet _ = getDOMDOMSettableTokenListValue
    attrSet _ = setDOMDOMSettableTokenListValue
    attrConstruct _ = constructDOMDOMSettableTokenListValue

type instance AttributeList DOMDOMSettableTokenList = DOMDOMSettableTokenListAttributeList
type DOMDOMSettableTokenListAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo), '("length", DOMDOMTokenListLengthPropertyInfo), '("value", DOMDOMSettableTokenListValuePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMDOMSettableTokenList = DOMDOMSettableTokenListSignalList
type DOMDOMSettableTokenListSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMDOMSettableTokenList::get_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMSettableTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMSettableTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_dom_settable_token_list_get_value" webkit_dom_dom_settable_token_list_get_value :: 
    Ptr DOMDOMSettableTokenList ->          -- _obj : TInterface "WebKit" "DOMDOMSettableTokenList"
    IO CString


dOMDOMSettableTokenListGetValue ::
    (MonadIO m, DOMDOMSettableTokenListK a) =>
    a ->                                    -- _obj
    m T.Text
dOMDOMSettableTokenListGetValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_dom_settable_token_list_get_value _obj'
    checkUnexpectedReturnNULL "webkit_dom_dom_settable_token_list_get_value" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMDOMSettableTokenList::set_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMSettableTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMSettableTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_dom_settable_token_list_set_value" webkit_dom_dom_settable_token_list_set_value :: 
    Ptr DOMDOMSettableTokenList ->          -- _obj : TInterface "WebKit" "DOMDOMSettableTokenList"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMDOMSettableTokenListSetValue ::
    (MonadIO m, DOMDOMSettableTokenListK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMDOMSettableTokenListSetValue _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_dom_settable_token_list_set_value _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


