
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMDOMStringMap
    ( 

-- * Exported types
    DOMDOMStringMap(..)                     ,
    DOMDOMStringMapK                        ,
    toDOMDOMStringMap                       ,
    noDOMDOMStringMap                       ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMDOMStringMap = DOMDOMStringMap (ForeignPtr DOMDOMStringMap)
foreign import ccall "webkit_dom_dom_string_map_get_type"
    c_webkit_dom_dom_string_map_get_type :: IO GType

type instance ParentTypes DOMDOMStringMap = DOMDOMStringMapParentTypes
type DOMDOMStringMapParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMDOMStringMap where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_dom_string_map_get_type
    

class GObject o => DOMDOMStringMapK o
instance (GObject o, IsDescendantOf DOMDOMStringMap o) => DOMDOMStringMapK o

toDOMDOMStringMap :: DOMDOMStringMapK o => o -> IO DOMDOMStringMap
toDOMDOMStringMap = unsafeCastTo DOMDOMStringMap

noDOMDOMStringMap :: Maybe DOMDOMStringMap
noDOMDOMStringMap = Nothing

type instance AttributeList DOMDOMStringMap = DOMDOMStringMapAttributeList
type DOMDOMStringMapAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMDOMStringMap = DOMDOMStringMapSignalList
type DOMDOMStringMapSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


