
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMDOMTokenList
    ( 

-- * Exported types
    DOMDOMTokenList(..)                     ,
    DOMDOMTokenListK                        ,
    toDOMDOMTokenList                       ,
    noDOMDOMTokenList                       ,


 -- * Methods
-- ** dOMDOMTokenListAdd
    dOMDOMTokenListAdd                      ,


-- ** dOMDOMTokenListContains
    dOMDOMTokenListContains                 ,


-- ** dOMDOMTokenListGetLength
    dOMDOMTokenListGetLength                ,


-- ** dOMDOMTokenListItem
    dOMDOMTokenListItem                     ,


-- ** dOMDOMTokenListRemove
    dOMDOMTokenListRemove                   ,


-- ** dOMDOMTokenListToggle
    dOMDOMTokenListToggle                   ,




 -- * Properties
-- ** Length
    DOMDOMTokenListLengthPropertyInfo       ,
    getDOMDOMTokenListLength                ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMDOMTokenList = DOMDOMTokenList (ForeignPtr DOMDOMTokenList)
foreign import ccall "webkit_dom_dom_token_list_get_type"
    c_webkit_dom_dom_token_list_get_type :: IO GType

type instance ParentTypes DOMDOMTokenList = DOMDOMTokenListParentTypes
type DOMDOMTokenListParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMDOMTokenList where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_dom_token_list_get_type
    

class GObject o => DOMDOMTokenListK o
instance (GObject o, IsDescendantOf DOMDOMTokenList o) => DOMDOMTokenListK o

toDOMDOMTokenList :: DOMDOMTokenListK o => o -> IO DOMDOMTokenList
toDOMDOMTokenList = unsafeCastTo DOMDOMTokenList

noDOMDOMTokenList :: Maybe DOMDOMTokenList
noDOMDOMTokenList = Nothing

-- VVV Prop "length"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMDOMTokenListLength :: (MonadIO m, DOMDOMTokenListK o) => o -> m Word64
getDOMDOMTokenListLength obj = liftIO $ getObjectPropertyUInt64 obj "length"

data DOMDOMTokenListLengthPropertyInfo
instance AttrInfo DOMDOMTokenListLengthPropertyInfo where
    type AttrAllowedOps DOMDOMTokenListLengthPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMDOMTokenListLengthPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMDOMTokenListLengthPropertyInfo = DOMDOMTokenListK
    type AttrGetType DOMDOMTokenListLengthPropertyInfo = Word64
    type AttrLabel DOMDOMTokenListLengthPropertyInfo = "DOMDOMTokenList::length"
    attrGet _ = getDOMDOMTokenListLength
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMDOMTokenList = DOMDOMTokenListAttributeList
type DOMDOMTokenListAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo), '("length", DOMDOMTokenListLengthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMDOMTokenList = DOMDOMTokenListSignalList
type DOMDOMTokenListSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMDOMTokenList::add
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "tokens", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "tokens", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_dom_token_list_add" webkit_dom_dom_token_list_add :: 
    Ptr DOMDOMTokenList ->                  -- _obj : TInterface "WebKit" "DOMDOMTokenList"
    CString ->                              -- tokens : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMDOMTokenListAdd ::
    (MonadIO m, DOMDOMTokenListK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- tokens
    m ()
dOMDOMTokenListAdd _obj tokens = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    tokens' <- textToCString tokens
    onException (do
        propagateGError $ webkit_dom_dom_token_list_add _obj' tokens'
        touchManagedPtr _obj
        freeMem tokens'
        return ()
     ) (do
        freeMem tokens'
     )

-- method DOMDOMTokenList::contains
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "token", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "token", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_dom_token_list_contains" webkit_dom_dom_token_list_contains :: 
    Ptr DOMDOMTokenList ->                  -- _obj : TInterface "WebKit" "DOMDOMTokenList"
    CString ->                              -- token : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO CInt


dOMDOMTokenListContains ::
    (MonadIO m, DOMDOMTokenListK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- token
    m ()
dOMDOMTokenListContains _obj token = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    token' <- textToCString token
    onException (do
        _ <- propagateGError $ webkit_dom_dom_token_list_contains _obj' token'
        touchManagedPtr _obj
        freeMem token'
        return ()
     ) (do
        freeMem token'
     )

-- method DOMDOMTokenList::get_length
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_dom_token_list_get_length" webkit_dom_dom_token_list_get_length :: 
    Ptr DOMDOMTokenList ->                  -- _obj : TInterface "WebKit" "DOMDOMTokenList"
    IO Word64


dOMDOMTokenListGetLength ::
    (MonadIO m, DOMDOMTokenListK a) =>
    a ->                                    -- _obj
    m Word64
dOMDOMTokenListGetLength _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_dom_token_list_get_length _obj'
    touchManagedPtr _obj
    return result

-- method DOMDOMTokenList::item
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_dom_token_list_item" webkit_dom_dom_token_list_item :: 
    Ptr DOMDOMTokenList ->                  -- _obj : TInterface "WebKit" "DOMDOMTokenList"
    Word64 ->                               -- index : TBasicType TUInt64
    IO CString


dOMDOMTokenListItem ::
    (MonadIO m, DOMDOMTokenListK a) =>
    a ->                                    -- _obj
    Word64 ->                               -- index
    m T.Text
dOMDOMTokenListItem _obj index = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_dom_token_list_item _obj' index
    checkUnexpectedReturnNULL "webkit_dom_dom_token_list_item" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMDOMTokenList::remove
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "tokens", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "tokens", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_dom_token_list_remove" webkit_dom_dom_token_list_remove :: 
    Ptr DOMDOMTokenList ->                  -- _obj : TInterface "WebKit" "DOMDOMTokenList"
    CString ->                              -- tokens : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMDOMTokenListRemove ::
    (MonadIO m, DOMDOMTokenListK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- tokens
    m ()
dOMDOMTokenListRemove _obj tokens = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    tokens' <- textToCString tokens
    onException (do
        propagateGError $ webkit_dom_dom_token_list_remove _obj' tokens'
        touchManagedPtr _obj
        freeMem tokens'
        return ()
     ) (do
        freeMem tokens'
     )

-- method DOMDOMTokenList::toggle
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "token", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "force", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMDOMTokenList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "token", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "force", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_dom_token_list_toggle" webkit_dom_dom_token_list_toggle :: 
    Ptr DOMDOMTokenList ->                  -- _obj : TInterface "WebKit" "DOMDOMTokenList"
    CString ->                              -- token : TBasicType TUTF8
    CInt ->                                 -- force : TBasicType TBoolean
    Ptr (Ptr GError) ->                     -- error
    IO CInt


dOMDOMTokenListToggle ::
    (MonadIO m, DOMDOMTokenListK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- token
    Bool ->                                 -- force
    m ()
dOMDOMTokenListToggle _obj token force = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    token' <- textToCString token
    let force' = (fromIntegral . fromEnum) force
    onException (do
        _ <- propagateGError $ webkit_dom_dom_token_list_toggle _obj' token' force'
        touchManagedPtr _obj
        freeMem token'
        return ()
     ) (do
        freeMem token'
     )


