
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMEntityReference
    ( 

-- * Exported types
    DOMEntityReference(..)                  ,
    DOMEntityReferenceK                     ,
    toDOMEntityReference                    ,
    noDOMEntityReference                    ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMEntityReference = DOMEntityReference (ForeignPtr DOMEntityReference)
foreign import ccall "webkit_dom_entity_reference_get_type"
    c_webkit_dom_entity_reference_get_type :: IO GType

type instance ParentTypes DOMEntityReference = DOMEntityReferenceParentTypes
type DOMEntityReferenceParentTypes = '[DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMEntityReference where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_entity_reference_get_type
    

class GObject o => DOMEntityReferenceK o
instance (GObject o, IsDescendantOf DOMEntityReference o) => DOMEntityReferenceK o

toDOMEntityReference :: DOMEntityReferenceK o => o -> IO DOMEntityReference
toDOMEntityReference = unsafeCastTo DOMEntityReference

noDOMEntityReference :: Maybe DOMEntityReference
noDOMEntityReference = Nothing

type instance AttributeList DOMEntityReference = DOMEntityReferenceAttributeList
type DOMEntityReferenceAttributeList = ('[ '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMEntityReference = DOMEntityReferenceSignalList
type DOMEntityReferenceSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


