
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLAnchorElement
    ( 

-- * Exported types
    DOMHTMLAnchorElement(..)                ,
    DOMHTMLAnchorElementK                   ,
    toDOMHTMLAnchorElement                  ,
    noDOMHTMLAnchorElement                  ,


 -- * Methods
-- ** dOMHTMLAnchorElementGetCharset
    dOMHTMLAnchorElementGetCharset          ,


-- ** dOMHTMLAnchorElementGetCoords
    dOMHTMLAnchorElementGetCoords           ,


-- ** dOMHTMLAnchorElementGetDownload
    dOMHTMLAnchorElementGetDownload         ,


-- ** dOMHTMLAnchorElementGetHash
    dOMHTMLAnchorElementGetHash             ,


-- ** dOMHTMLAnchorElementGetHost
    dOMHTMLAnchorElementGetHost             ,


-- ** dOMHTMLAnchorElementGetHostname
    dOMHTMLAnchorElementGetHostname         ,


-- ** dOMHTMLAnchorElementGetHref
    dOMHTMLAnchorElementGetHref             ,


-- ** dOMHTMLAnchorElementGetHreflang
    dOMHTMLAnchorElementGetHreflang         ,


-- ** dOMHTMLAnchorElementGetName
    dOMHTMLAnchorElementGetName             ,


-- ** dOMHTMLAnchorElementGetOrigin
    dOMHTMLAnchorElementGetOrigin           ,


-- ** dOMHTMLAnchorElementGetPathname
    dOMHTMLAnchorElementGetPathname         ,


-- ** dOMHTMLAnchorElementGetPing
    dOMHTMLAnchorElementGetPing             ,


-- ** dOMHTMLAnchorElementGetPort
    dOMHTMLAnchorElementGetPort             ,


-- ** dOMHTMLAnchorElementGetProtocol
    dOMHTMLAnchorElementGetProtocol         ,


-- ** dOMHTMLAnchorElementGetRel
    dOMHTMLAnchorElementGetRel              ,


-- ** dOMHTMLAnchorElementGetRev
    dOMHTMLAnchorElementGetRev              ,


-- ** dOMHTMLAnchorElementGetSearch
    dOMHTMLAnchorElementGetSearch           ,


-- ** dOMHTMLAnchorElementGetShape
    dOMHTMLAnchorElementGetShape            ,


-- ** dOMHTMLAnchorElementGetTarget
    dOMHTMLAnchorElementGetTarget           ,


-- ** dOMHTMLAnchorElementGetText
    dOMHTMLAnchorElementGetText             ,


-- ** dOMHTMLAnchorElementSetCharset
    dOMHTMLAnchorElementSetCharset          ,


-- ** dOMHTMLAnchorElementSetCoords
    dOMHTMLAnchorElementSetCoords           ,


-- ** dOMHTMLAnchorElementSetDownload
    dOMHTMLAnchorElementSetDownload         ,


-- ** dOMHTMLAnchorElementSetHash
    dOMHTMLAnchorElementSetHash             ,


-- ** dOMHTMLAnchorElementSetHost
    dOMHTMLAnchorElementSetHost             ,


-- ** dOMHTMLAnchorElementSetHostname
    dOMHTMLAnchorElementSetHostname         ,


-- ** dOMHTMLAnchorElementSetHref
    dOMHTMLAnchorElementSetHref             ,


-- ** dOMHTMLAnchorElementSetHreflang
    dOMHTMLAnchorElementSetHreflang         ,


-- ** dOMHTMLAnchorElementSetName
    dOMHTMLAnchorElementSetName             ,


-- ** dOMHTMLAnchorElementSetPathname
    dOMHTMLAnchorElementSetPathname         ,


-- ** dOMHTMLAnchorElementSetPing
    dOMHTMLAnchorElementSetPing             ,


-- ** dOMHTMLAnchorElementSetPort
    dOMHTMLAnchorElementSetPort             ,


-- ** dOMHTMLAnchorElementSetProtocol
    dOMHTMLAnchorElementSetProtocol         ,


-- ** dOMHTMLAnchorElementSetRel
    dOMHTMLAnchorElementSetRel              ,


-- ** dOMHTMLAnchorElementSetRev
    dOMHTMLAnchorElementSetRev              ,


-- ** dOMHTMLAnchorElementSetSearch
    dOMHTMLAnchorElementSetSearch           ,


-- ** dOMHTMLAnchorElementSetShape
    dOMHTMLAnchorElementSetShape            ,


-- ** dOMHTMLAnchorElementSetTarget
    dOMHTMLAnchorElementSetTarget           ,




 -- * Properties
-- ** Charset
    DOMHTMLAnchorElementCharsetPropertyInfo ,
    constructDOMHTMLAnchorElementCharset    ,
    getDOMHTMLAnchorElementCharset          ,
    setDOMHTMLAnchorElementCharset          ,


-- ** Coords
    DOMHTMLAnchorElementCoordsPropertyInfo  ,
    constructDOMHTMLAnchorElementCoords     ,
    getDOMHTMLAnchorElementCoords           ,
    setDOMHTMLAnchorElementCoords           ,


-- ** Download
    DOMHTMLAnchorElementDownloadPropertyInfo,
    constructDOMHTMLAnchorElementDownload   ,
    getDOMHTMLAnchorElementDownload         ,
    setDOMHTMLAnchorElementDownload         ,


-- ** Hash
    DOMHTMLAnchorElementHashPropertyInfo    ,
    constructDOMHTMLAnchorElementHash       ,
    getDOMHTMLAnchorElementHash             ,
    setDOMHTMLAnchorElementHash             ,


-- ** Host
    DOMHTMLAnchorElementHostPropertyInfo    ,
    constructDOMHTMLAnchorElementHost       ,
    getDOMHTMLAnchorElementHost             ,
    setDOMHTMLAnchorElementHost             ,


-- ** Hostname
    DOMHTMLAnchorElementHostnamePropertyInfo,
    constructDOMHTMLAnchorElementHostname   ,
    getDOMHTMLAnchorElementHostname         ,
    setDOMHTMLAnchorElementHostname         ,


-- ** Href
    DOMHTMLAnchorElementHrefPropertyInfo    ,
    constructDOMHTMLAnchorElementHref       ,
    getDOMHTMLAnchorElementHref             ,
    setDOMHTMLAnchorElementHref             ,


-- ** Hreflang
    DOMHTMLAnchorElementHreflangPropertyInfo,
    constructDOMHTMLAnchorElementHreflang   ,
    getDOMHTMLAnchorElementHreflang         ,
    setDOMHTMLAnchorElementHreflang         ,


-- ** Name
    DOMHTMLAnchorElementNamePropertyInfo    ,
    constructDOMHTMLAnchorElementName       ,
    getDOMHTMLAnchorElementName             ,
    setDOMHTMLAnchorElementName             ,


-- ** Origin
    DOMHTMLAnchorElementOriginPropertyInfo  ,
    getDOMHTMLAnchorElementOrigin           ,


-- ** Pathname
    DOMHTMLAnchorElementPathnamePropertyInfo,
    constructDOMHTMLAnchorElementPathname   ,
    getDOMHTMLAnchorElementPathname         ,
    setDOMHTMLAnchorElementPathname         ,


-- ** Ping
    DOMHTMLAnchorElementPingPropertyInfo    ,
    constructDOMHTMLAnchorElementPing       ,
    getDOMHTMLAnchorElementPing             ,
    setDOMHTMLAnchorElementPing             ,


-- ** Port
    DOMHTMLAnchorElementPortPropertyInfo    ,
    constructDOMHTMLAnchorElementPort       ,
    getDOMHTMLAnchorElementPort             ,
    setDOMHTMLAnchorElementPort             ,


-- ** Protocol
    DOMHTMLAnchorElementProtocolPropertyInfo,
    constructDOMHTMLAnchorElementProtocol   ,
    getDOMHTMLAnchorElementProtocol         ,
    setDOMHTMLAnchorElementProtocol         ,


-- ** Rel
    DOMHTMLAnchorElementRelPropertyInfo     ,
    constructDOMHTMLAnchorElementRel        ,
    getDOMHTMLAnchorElementRel              ,
    setDOMHTMLAnchorElementRel              ,


-- ** Rev
    DOMHTMLAnchorElementRevPropertyInfo     ,
    constructDOMHTMLAnchorElementRev        ,
    getDOMHTMLAnchorElementRev              ,
    setDOMHTMLAnchorElementRev              ,


-- ** Search
    DOMHTMLAnchorElementSearchPropertyInfo  ,
    constructDOMHTMLAnchorElementSearch     ,
    getDOMHTMLAnchorElementSearch           ,
    setDOMHTMLAnchorElementSearch           ,


-- ** Shape
    DOMHTMLAnchorElementShapePropertyInfo   ,
    constructDOMHTMLAnchorElementShape      ,
    getDOMHTMLAnchorElementShape            ,
    setDOMHTMLAnchorElementShape            ,


-- ** Target
    DOMHTMLAnchorElementTargetPropertyInfo  ,
    constructDOMHTMLAnchorElementTarget     ,
    getDOMHTMLAnchorElementTarget           ,
    setDOMHTMLAnchorElementTarget           ,


-- ** Text
    DOMHTMLAnchorElementTextPropertyInfo    ,
    getDOMHTMLAnchorElementText             ,


-- ** Type
    DOMHTMLAnchorElementTypePropertyInfo    ,
    constructDOMHTMLAnchorElementType       ,
    getDOMHTMLAnchorElementType             ,
    setDOMHTMLAnchorElementType             ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLAnchorElement = DOMHTMLAnchorElement (ForeignPtr DOMHTMLAnchorElement)
foreign import ccall "webkit_dom_html_anchor_element_get_type"
    c_webkit_dom_html_anchor_element_get_type :: IO GType

type instance ParentTypes DOMHTMLAnchorElement = DOMHTMLAnchorElementParentTypes
type DOMHTMLAnchorElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLAnchorElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_anchor_element_get_type
    

class GObject o => DOMHTMLAnchorElementK o
instance (GObject o, IsDescendantOf DOMHTMLAnchorElement o) => DOMHTMLAnchorElementK o

toDOMHTMLAnchorElement :: DOMHTMLAnchorElementK o => o -> IO DOMHTMLAnchorElement
toDOMHTMLAnchorElement = unsafeCastTo DOMHTMLAnchorElement

noDOMHTMLAnchorElement :: Maybe DOMHTMLAnchorElement
noDOMHTMLAnchorElement = Nothing

-- VVV Prop "charset"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementCharset :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementCharset obj = liftIO $ getObjectPropertyString obj "charset"

setDOMHTMLAnchorElementCharset :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementCharset obj val = liftIO $ setObjectPropertyString obj "charset" val

constructDOMHTMLAnchorElementCharset :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementCharset val = constructObjectPropertyString "charset" val

data DOMHTMLAnchorElementCharsetPropertyInfo
instance AttrInfo DOMHTMLAnchorElementCharsetPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementCharsetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementCharsetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementCharsetPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementCharsetPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementCharsetPropertyInfo = "DOMHTMLAnchorElement::charset"
    attrGet _ = getDOMHTMLAnchorElementCharset
    attrSet _ = setDOMHTMLAnchorElementCharset
    attrConstruct _ = constructDOMHTMLAnchorElementCharset

-- VVV Prop "coords"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementCoords :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementCoords obj = liftIO $ getObjectPropertyString obj "coords"

setDOMHTMLAnchorElementCoords :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementCoords obj val = liftIO $ setObjectPropertyString obj "coords" val

constructDOMHTMLAnchorElementCoords :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementCoords val = constructObjectPropertyString "coords" val

data DOMHTMLAnchorElementCoordsPropertyInfo
instance AttrInfo DOMHTMLAnchorElementCoordsPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementCoordsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementCoordsPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementCoordsPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementCoordsPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementCoordsPropertyInfo = "DOMHTMLAnchorElement::coords"
    attrGet _ = getDOMHTMLAnchorElementCoords
    attrSet _ = setDOMHTMLAnchorElementCoords
    attrConstruct _ = constructDOMHTMLAnchorElementCoords

-- VVV Prop "download"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementDownload :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementDownload obj = liftIO $ getObjectPropertyString obj "download"

setDOMHTMLAnchorElementDownload :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementDownload obj val = liftIO $ setObjectPropertyString obj "download" val

constructDOMHTMLAnchorElementDownload :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementDownload val = constructObjectPropertyString "download" val

data DOMHTMLAnchorElementDownloadPropertyInfo
instance AttrInfo DOMHTMLAnchorElementDownloadPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementDownloadPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementDownloadPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementDownloadPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementDownloadPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementDownloadPropertyInfo = "DOMHTMLAnchorElement::download"
    attrGet _ = getDOMHTMLAnchorElementDownload
    attrSet _ = setDOMHTMLAnchorElementDownload
    attrConstruct _ = constructDOMHTMLAnchorElementDownload

-- VVV Prop "hash"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementHash :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementHash obj = liftIO $ getObjectPropertyString obj "hash"

setDOMHTMLAnchorElementHash :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementHash obj val = liftIO $ setObjectPropertyString obj "hash" val

constructDOMHTMLAnchorElementHash :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementHash val = constructObjectPropertyString "hash" val

data DOMHTMLAnchorElementHashPropertyInfo
instance AttrInfo DOMHTMLAnchorElementHashPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementHashPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementHashPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementHashPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementHashPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementHashPropertyInfo = "DOMHTMLAnchorElement::hash"
    attrGet _ = getDOMHTMLAnchorElementHash
    attrSet _ = setDOMHTMLAnchorElementHash
    attrConstruct _ = constructDOMHTMLAnchorElementHash

-- VVV Prop "host"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementHost :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementHost obj = liftIO $ getObjectPropertyString obj "host"

setDOMHTMLAnchorElementHost :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementHost obj val = liftIO $ setObjectPropertyString obj "host" val

constructDOMHTMLAnchorElementHost :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementHost val = constructObjectPropertyString "host" val

data DOMHTMLAnchorElementHostPropertyInfo
instance AttrInfo DOMHTMLAnchorElementHostPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementHostPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementHostPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementHostPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementHostPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementHostPropertyInfo = "DOMHTMLAnchorElement::host"
    attrGet _ = getDOMHTMLAnchorElementHost
    attrSet _ = setDOMHTMLAnchorElementHost
    attrConstruct _ = constructDOMHTMLAnchorElementHost

-- VVV Prop "hostname"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementHostname :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementHostname obj = liftIO $ getObjectPropertyString obj "hostname"

setDOMHTMLAnchorElementHostname :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementHostname obj val = liftIO $ setObjectPropertyString obj "hostname" val

constructDOMHTMLAnchorElementHostname :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementHostname val = constructObjectPropertyString "hostname" val

data DOMHTMLAnchorElementHostnamePropertyInfo
instance AttrInfo DOMHTMLAnchorElementHostnamePropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementHostnamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementHostnamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementHostnamePropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementHostnamePropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementHostnamePropertyInfo = "DOMHTMLAnchorElement::hostname"
    attrGet _ = getDOMHTMLAnchorElementHostname
    attrSet _ = setDOMHTMLAnchorElementHostname
    attrConstruct _ = constructDOMHTMLAnchorElementHostname

-- VVV Prop "href"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementHref :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementHref obj = liftIO $ getObjectPropertyString obj "href"

setDOMHTMLAnchorElementHref :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementHref obj val = liftIO $ setObjectPropertyString obj "href" val

constructDOMHTMLAnchorElementHref :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementHref val = constructObjectPropertyString "href" val

data DOMHTMLAnchorElementHrefPropertyInfo
instance AttrInfo DOMHTMLAnchorElementHrefPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementHrefPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementHrefPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementHrefPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementHrefPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementHrefPropertyInfo = "DOMHTMLAnchorElement::href"
    attrGet _ = getDOMHTMLAnchorElementHref
    attrSet _ = setDOMHTMLAnchorElementHref
    attrConstruct _ = constructDOMHTMLAnchorElementHref

-- VVV Prop "hreflang"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementHreflang :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementHreflang obj = liftIO $ getObjectPropertyString obj "hreflang"

setDOMHTMLAnchorElementHreflang :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementHreflang obj val = liftIO $ setObjectPropertyString obj "hreflang" val

constructDOMHTMLAnchorElementHreflang :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementHreflang val = constructObjectPropertyString "hreflang" val

data DOMHTMLAnchorElementHreflangPropertyInfo
instance AttrInfo DOMHTMLAnchorElementHreflangPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementHreflangPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementHreflangPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementHreflangPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementHreflangPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementHreflangPropertyInfo = "DOMHTMLAnchorElement::hreflang"
    attrGet _ = getDOMHTMLAnchorElementHreflang
    attrSet _ = setDOMHTMLAnchorElementHreflang
    attrConstruct _ = constructDOMHTMLAnchorElementHreflang

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementName :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementName obj = liftIO $ getObjectPropertyString obj "name"

setDOMHTMLAnchorElementName :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementName obj val = liftIO $ setObjectPropertyString obj "name" val

constructDOMHTMLAnchorElementName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementName val = constructObjectPropertyString "name" val

data DOMHTMLAnchorElementNamePropertyInfo
instance AttrInfo DOMHTMLAnchorElementNamePropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementNamePropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementNamePropertyInfo = "DOMHTMLAnchorElement::name"
    attrGet _ = getDOMHTMLAnchorElementName
    attrSet _ = setDOMHTMLAnchorElementName
    attrConstruct _ = constructDOMHTMLAnchorElementName

-- VVV Prop "origin"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLAnchorElementOrigin :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementOrigin obj = liftIO $ getObjectPropertyString obj "origin"

data DOMHTMLAnchorElementOriginPropertyInfo
instance AttrInfo DOMHTMLAnchorElementOriginPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementOriginPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementOriginPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLAnchorElementOriginPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementOriginPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementOriginPropertyInfo = "DOMHTMLAnchorElement::origin"
    attrGet _ = getDOMHTMLAnchorElementOrigin
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "pathname"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementPathname :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementPathname obj = liftIO $ getObjectPropertyString obj "pathname"

setDOMHTMLAnchorElementPathname :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementPathname obj val = liftIO $ setObjectPropertyString obj "pathname" val

constructDOMHTMLAnchorElementPathname :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementPathname val = constructObjectPropertyString "pathname" val

data DOMHTMLAnchorElementPathnamePropertyInfo
instance AttrInfo DOMHTMLAnchorElementPathnamePropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementPathnamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementPathnamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementPathnamePropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementPathnamePropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementPathnamePropertyInfo = "DOMHTMLAnchorElement::pathname"
    attrGet _ = getDOMHTMLAnchorElementPathname
    attrSet _ = setDOMHTMLAnchorElementPathname
    attrConstruct _ = constructDOMHTMLAnchorElementPathname

-- VVV Prop "ping"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementPing :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementPing obj = liftIO $ getObjectPropertyString obj "ping"

setDOMHTMLAnchorElementPing :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementPing obj val = liftIO $ setObjectPropertyString obj "ping" val

constructDOMHTMLAnchorElementPing :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementPing val = constructObjectPropertyString "ping" val

data DOMHTMLAnchorElementPingPropertyInfo
instance AttrInfo DOMHTMLAnchorElementPingPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementPingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementPingPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementPingPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementPingPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementPingPropertyInfo = "DOMHTMLAnchorElement::ping"
    attrGet _ = getDOMHTMLAnchorElementPing
    attrSet _ = setDOMHTMLAnchorElementPing
    attrConstruct _ = constructDOMHTMLAnchorElementPing

-- VVV Prop "port"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementPort :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementPort obj = liftIO $ getObjectPropertyString obj "port"

setDOMHTMLAnchorElementPort :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementPort obj val = liftIO $ setObjectPropertyString obj "port" val

constructDOMHTMLAnchorElementPort :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementPort val = constructObjectPropertyString "port" val

data DOMHTMLAnchorElementPortPropertyInfo
instance AttrInfo DOMHTMLAnchorElementPortPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementPortPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementPortPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementPortPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementPortPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementPortPropertyInfo = "DOMHTMLAnchorElement::port"
    attrGet _ = getDOMHTMLAnchorElementPort
    attrSet _ = setDOMHTMLAnchorElementPort
    attrConstruct _ = constructDOMHTMLAnchorElementPort

-- VVV Prop "protocol"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementProtocol :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementProtocol obj = liftIO $ getObjectPropertyString obj "protocol"

setDOMHTMLAnchorElementProtocol :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementProtocol obj val = liftIO $ setObjectPropertyString obj "protocol" val

constructDOMHTMLAnchorElementProtocol :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementProtocol val = constructObjectPropertyString "protocol" val

data DOMHTMLAnchorElementProtocolPropertyInfo
instance AttrInfo DOMHTMLAnchorElementProtocolPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementProtocolPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementProtocolPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementProtocolPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementProtocolPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementProtocolPropertyInfo = "DOMHTMLAnchorElement::protocol"
    attrGet _ = getDOMHTMLAnchorElementProtocol
    attrSet _ = setDOMHTMLAnchorElementProtocol
    attrConstruct _ = constructDOMHTMLAnchorElementProtocol

-- VVV Prop "rel"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementRel :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementRel obj = liftIO $ getObjectPropertyString obj "rel"

setDOMHTMLAnchorElementRel :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementRel obj val = liftIO $ setObjectPropertyString obj "rel" val

constructDOMHTMLAnchorElementRel :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementRel val = constructObjectPropertyString "rel" val

data DOMHTMLAnchorElementRelPropertyInfo
instance AttrInfo DOMHTMLAnchorElementRelPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementRelPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementRelPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementRelPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementRelPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementRelPropertyInfo = "DOMHTMLAnchorElement::rel"
    attrGet _ = getDOMHTMLAnchorElementRel
    attrSet _ = setDOMHTMLAnchorElementRel
    attrConstruct _ = constructDOMHTMLAnchorElementRel

-- VVV Prop "rev"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementRev :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementRev obj = liftIO $ getObjectPropertyString obj "rev"

setDOMHTMLAnchorElementRev :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementRev obj val = liftIO $ setObjectPropertyString obj "rev" val

constructDOMHTMLAnchorElementRev :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementRev val = constructObjectPropertyString "rev" val

data DOMHTMLAnchorElementRevPropertyInfo
instance AttrInfo DOMHTMLAnchorElementRevPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementRevPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementRevPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementRevPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementRevPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementRevPropertyInfo = "DOMHTMLAnchorElement::rev"
    attrGet _ = getDOMHTMLAnchorElementRev
    attrSet _ = setDOMHTMLAnchorElementRev
    attrConstruct _ = constructDOMHTMLAnchorElementRev

-- VVV Prop "search"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementSearch :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementSearch obj = liftIO $ getObjectPropertyString obj "search"

setDOMHTMLAnchorElementSearch :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementSearch obj val = liftIO $ setObjectPropertyString obj "search" val

constructDOMHTMLAnchorElementSearch :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementSearch val = constructObjectPropertyString "search" val

data DOMHTMLAnchorElementSearchPropertyInfo
instance AttrInfo DOMHTMLAnchorElementSearchPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementSearchPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementSearchPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementSearchPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementSearchPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementSearchPropertyInfo = "DOMHTMLAnchorElement::search"
    attrGet _ = getDOMHTMLAnchorElementSearch
    attrSet _ = setDOMHTMLAnchorElementSearch
    attrConstruct _ = constructDOMHTMLAnchorElementSearch

-- VVV Prop "shape"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementShape :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementShape obj = liftIO $ getObjectPropertyString obj "shape"

setDOMHTMLAnchorElementShape :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementShape obj val = liftIO $ setObjectPropertyString obj "shape" val

constructDOMHTMLAnchorElementShape :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementShape val = constructObjectPropertyString "shape" val

data DOMHTMLAnchorElementShapePropertyInfo
instance AttrInfo DOMHTMLAnchorElementShapePropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementShapePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementShapePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementShapePropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementShapePropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementShapePropertyInfo = "DOMHTMLAnchorElement::shape"
    attrGet _ = getDOMHTMLAnchorElementShape
    attrSet _ = setDOMHTMLAnchorElementShape
    attrConstruct _ = constructDOMHTMLAnchorElementShape

-- VVV Prop "target"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementTarget :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementTarget obj = liftIO $ getObjectPropertyString obj "target"

setDOMHTMLAnchorElementTarget :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementTarget obj val = liftIO $ setObjectPropertyString obj "target" val

constructDOMHTMLAnchorElementTarget :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementTarget val = constructObjectPropertyString "target" val

data DOMHTMLAnchorElementTargetPropertyInfo
instance AttrInfo DOMHTMLAnchorElementTargetPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementTargetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementTargetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementTargetPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementTargetPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementTargetPropertyInfo = "DOMHTMLAnchorElement::target"
    attrGet _ = getDOMHTMLAnchorElementTarget
    attrSet _ = setDOMHTMLAnchorElementTarget
    attrConstruct _ = constructDOMHTMLAnchorElementTarget

-- VVV Prop "text"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLAnchorElementText :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementText obj = liftIO $ getObjectPropertyString obj "text"

data DOMHTMLAnchorElementTextPropertyInfo
instance AttrInfo DOMHTMLAnchorElementTextPropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementTextPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementTextPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLAnchorElementTextPropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementTextPropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementTextPropertyInfo = "DOMHTMLAnchorElement::text"
    attrGet _ = getDOMHTMLAnchorElementText
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAnchorElementType :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> m T.Text
getDOMHTMLAnchorElementType obj = liftIO $ getObjectPropertyString obj "type"

setDOMHTMLAnchorElementType :: (MonadIO m, DOMHTMLAnchorElementK o) => o -> T.Text -> m ()
setDOMHTMLAnchorElementType obj val = liftIO $ setObjectPropertyString obj "type" val

constructDOMHTMLAnchorElementType :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAnchorElementType val = constructObjectPropertyString "type" val

data DOMHTMLAnchorElementTypePropertyInfo
instance AttrInfo DOMHTMLAnchorElementTypePropertyInfo where
    type AttrAllowedOps DOMHTMLAnchorElementTypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAnchorElementTypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAnchorElementTypePropertyInfo = DOMHTMLAnchorElementK
    type AttrGetType DOMHTMLAnchorElementTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLAnchorElementTypePropertyInfo = "DOMHTMLAnchorElement::type"
    attrGet _ = getDOMHTMLAnchorElementType
    attrSet _ = setDOMHTMLAnchorElementType
    attrConstruct _ = constructDOMHTMLAnchorElementType

type instance AttributeList DOMHTMLAnchorElement = DOMHTMLAnchorElementAttributeList
type DOMHTMLAnchorElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("charset", DOMHTMLAnchorElementCharsetPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("coords", DOMHTMLAnchorElementCoordsPropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("download", DOMHTMLAnchorElementDownloadPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hash", DOMHTMLAnchorElementHashPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("host", DOMHTMLAnchorElementHostPropertyInfo), '("hostname", DOMHTMLAnchorElementHostnamePropertyInfo), '("href", DOMHTMLAnchorElementHrefPropertyInfo), '("hreflang", DOMHTMLAnchorElementHreflangPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("name", DOMHTMLAnchorElementNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("origin", DOMHTMLAnchorElementOriginPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("pathname", DOMHTMLAnchorElementPathnamePropertyInfo), '("ping", DOMHTMLAnchorElementPingPropertyInfo), '("port", DOMHTMLAnchorElementPortPropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("protocol", DOMHTMLAnchorElementProtocolPropertyInfo), '("rel", DOMHTMLAnchorElementRelPropertyInfo), '("rev", DOMHTMLAnchorElementRevPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("search", DOMHTMLAnchorElementSearchPropertyInfo), '("shape", DOMHTMLAnchorElementShapePropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("target", DOMHTMLAnchorElementTargetPropertyInfo), '("text", DOMHTMLAnchorElementTextPropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("type", DOMHTMLAnchorElementTypePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLAnchorElement = DOMHTMLAnchorElementSignalList
type DOMHTMLAnchorElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLAnchorElement::get_charset
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_charset" webkit_dom_html_anchor_element_get_charset :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetCharset ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetCharset _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_charset _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_charset" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_coords
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_coords" webkit_dom_html_anchor_element_get_coords :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetCoords ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetCoords _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_coords _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_coords" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_download
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_download" webkit_dom_html_anchor_element_get_download :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetDownload ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetDownload _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_download _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_download" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_hash
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_hash" webkit_dom_html_anchor_element_get_hash :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetHash ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetHash _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_hash _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_hash" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_host
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_host" webkit_dom_html_anchor_element_get_host :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetHost ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetHost _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_host _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_host" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_hostname
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_hostname" webkit_dom_html_anchor_element_get_hostname :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetHostname ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetHostname _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_hostname _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_hostname" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_href
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_href" webkit_dom_html_anchor_element_get_href :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetHref ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetHref _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_href _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_href" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_hreflang
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_hreflang" webkit_dom_html_anchor_element_get_hreflang :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetHreflang ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetHreflang _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_hreflang _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_hreflang" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_name" webkit_dom_html_anchor_element_get_name :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetName ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_origin
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_origin" webkit_dom_html_anchor_element_get_origin :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetOrigin ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetOrigin _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_origin _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_origin" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_pathname
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_pathname" webkit_dom_html_anchor_element_get_pathname :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetPathname ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetPathname _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_pathname _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_pathname" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_ping
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_ping" webkit_dom_html_anchor_element_get_ping :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetPing ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetPing _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_ping _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_ping" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_port
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_port" webkit_dom_html_anchor_element_get_port :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetPort ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetPort _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_port _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_port" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_protocol
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_protocol" webkit_dom_html_anchor_element_get_protocol :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetProtocol ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetProtocol _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_protocol _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_protocol" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_rel
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_rel" webkit_dom_html_anchor_element_get_rel :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetRel ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetRel _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_rel _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_rel" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_rev
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_rev" webkit_dom_html_anchor_element_get_rev :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetRev ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetRev _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_rev _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_rev" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_search
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_search" webkit_dom_html_anchor_element_get_search :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetSearch ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetSearch _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_search _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_search" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_shape
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_shape" webkit_dom_html_anchor_element_get_shape :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetShape ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetShape _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_shape _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_shape" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_target
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_target" webkit_dom_html_anchor_element_get_target :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetTarget ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetTarget _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_target _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_target" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::get_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_get_text" webkit_dom_html_anchor_element_get_text :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    IO CString


dOMHTMLAnchorElementGetText ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAnchorElementGetText _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_anchor_element_get_text _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_anchor_element_get_text" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAnchorElement::set_charset
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_charset" webkit_dom_html_anchor_element_set_charset :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetCharset ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetCharset _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_charset _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_coords
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_coords" webkit_dom_html_anchor_element_set_coords :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetCoords ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetCoords _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_coords _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_download
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_download" webkit_dom_html_anchor_element_set_download :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetDownload ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetDownload _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_download _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_hash
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_hash" webkit_dom_html_anchor_element_set_hash :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetHash ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetHash _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_hash _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_host
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_host" webkit_dom_html_anchor_element_set_host :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetHost ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetHost _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_host _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_hostname
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_hostname" webkit_dom_html_anchor_element_set_hostname :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetHostname ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetHostname _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_hostname _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_href
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_href" webkit_dom_html_anchor_element_set_href :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetHref ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetHref _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_href _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_hreflang
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_hreflang" webkit_dom_html_anchor_element_set_hreflang :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetHreflang ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetHreflang _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_hreflang _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_name" webkit_dom_html_anchor_element_set_name :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetName ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetName _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_name _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_pathname
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_pathname" webkit_dom_html_anchor_element_set_pathname :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetPathname ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetPathname _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_pathname _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_ping
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_ping" webkit_dom_html_anchor_element_set_ping :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetPing ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetPing _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_ping _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_port
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_port" webkit_dom_html_anchor_element_set_port :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetPort ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetPort _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_port _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_protocol
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_protocol" webkit_dom_html_anchor_element_set_protocol :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetProtocol ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetProtocol _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_protocol _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_rel
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_rel" webkit_dom_html_anchor_element_set_rel :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetRel ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetRel _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_rel _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_rev
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_rev" webkit_dom_html_anchor_element_set_rev :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetRev ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetRev _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_rev _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_search
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_search" webkit_dom_html_anchor_element_set_search :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetSearch ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetSearch _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_search _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_shape
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_shape" webkit_dom_html_anchor_element_set_shape :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetShape ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetShape _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_shape _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAnchorElement::set_target
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAnchorElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_anchor_element_set_target" webkit_dom_html_anchor_element_set_target :: 
    Ptr DOMHTMLAnchorElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAnchorElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAnchorElementSetTarget ::
    (MonadIO m, DOMHTMLAnchorElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAnchorElementSetTarget _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_anchor_element_set_target _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


