
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLAppletElement
    ( 

-- * Exported types
    DOMHTMLAppletElement(..)                ,
    DOMHTMLAppletElementK                   ,
    toDOMHTMLAppletElement                  ,
    noDOMHTMLAppletElement                  ,


 -- * Methods
-- ** dOMHTMLAppletElementGetAlign
    dOMHTMLAppletElementGetAlign            ,


-- ** dOMHTMLAppletElementGetAlt
    dOMHTMLAppletElementGetAlt              ,


-- ** dOMHTMLAppletElementGetArchive
    dOMHTMLAppletElementGetArchive          ,


-- ** dOMHTMLAppletElementGetCode
    dOMHTMLAppletElementGetCode             ,


-- ** dOMHTMLAppletElementGetCodeBase
    dOMHTMLAppletElementGetCodeBase         ,


-- ** dOMHTMLAppletElementGetHeight
    dOMHTMLAppletElementGetHeight           ,


-- ** dOMHTMLAppletElementGetHspace
    dOMHTMLAppletElementGetHspace           ,


-- ** dOMHTMLAppletElementGetName
    dOMHTMLAppletElementGetName             ,


-- ** dOMHTMLAppletElementGetObject
    dOMHTMLAppletElementGetObject           ,


-- ** dOMHTMLAppletElementGetVspace
    dOMHTMLAppletElementGetVspace           ,


-- ** dOMHTMLAppletElementGetWidth
    dOMHTMLAppletElementGetWidth            ,


-- ** dOMHTMLAppletElementSetAlign
    dOMHTMLAppletElementSetAlign            ,


-- ** dOMHTMLAppletElementSetAlt
    dOMHTMLAppletElementSetAlt              ,


-- ** dOMHTMLAppletElementSetArchive
    dOMHTMLAppletElementSetArchive          ,


-- ** dOMHTMLAppletElementSetCode
    dOMHTMLAppletElementSetCode             ,


-- ** dOMHTMLAppletElementSetCodeBase
    dOMHTMLAppletElementSetCodeBase         ,


-- ** dOMHTMLAppletElementSetHeight
    dOMHTMLAppletElementSetHeight           ,


-- ** dOMHTMLAppletElementSetHspace
    dOMHTMLAppletElementSetHspace           ,


-- ** dOMHTMLAppletElementSetName
    dOMHTMLAppletElementSetName             ,


-- ** dOMHTMLAppletElementSetObject
    dOMHTMLAppletElementSetObject           ,


-- ** dOMHTMLAppletElementSetVspace
    dOMHTMLAppletElementSetVspace           ,


-- ** dOMHTMLAppletElementSetWidth
    dOMHTMLAppletElementSetWidth            ,




 -- * Properties
-- ** Align
    DOMHTMLAppletElementAlignPropertyInfo   ,
    constructDOMHTMLAppletElementAlign      ,
    getDOMHTMLAppletElementAlign            ,
    setDOMHTMLAppletElementAlign            ,


-- ** Alt
    DOMHTMLAppletElementAltPropertyInfo     ,
    constructDOMHTMLAppletElementAlt        ,
    getDOMHTMLAppletElementAlt              ,
    setDOMHTMLAppletElementAlt              ,


-- ** Archive
    DOMHTMLAppletElementArchivePropertyInfo ,
    constructDOMHTMLAppletElementArchive    ,
    getDOMHTMLAppletElementArchive          ,
    setDOMHTMLAppletElementArchive          ,


-- ** Code
    DOMHTMLAppletElementCodePropertyInfo    ,
    constructDOMHTMLAppletElementCode       ,
    getDOMHTMLAppletElementCode             ,
    setDOMHTMLAppletElementCode             ,


-- ** CodeBase
    DOMHTMLAppletElementCodeBasePropertyInfo,
    constructDOMHTMLAppletElementCodeBase   ,
    getDOMHTMLAppletElementCodeBase         ,
    setDOMHTMLAppletElementCodeBase         ,


-- ** Height
    DOMHTMLAppletElementHeightPropertyInfo  ,
    constructDOMHTMLAppletElementHeight     ,
    getDOMHTMLAppletElementHeight           ,
    setDOMHTMLAppletElementHeight           ,


-- ** Hspace
    DOMHTMLAppletElementHspacePropertyInfo  ,
    constructDOMHTMLAppletElementHspace     ,
    getDOMHTMLAppletElementHspace           ,
    setDOMHTMLAppletElementHspace           ,


-- ** Name
    DOMHTMLAppletElementNamePropertyInfo    ,
    constructDOMHTMLAppletElementName       ,
    getDOMHTMLAppletElementName             ,
    setDOMHTMLAppletElementName             ,


-- ** Object
    DOMHTMLAppletElementObjectPropertyInfo  ,
    constructDOMHTMLAppletElementObject     ,
    getDOMHTMLAppletElementObject           ,
    setDOMHTMLAppletElementObject           ,


-- ** Vspace
    DOMHTMLAppletElementVspacePropertyInfo  ,
    constructDOMHTMLAppletElementVspace     ,
    getDOMHTMLAppletElementVspace           ,
    setDOMHTMLAppletElementVspace           ,


-- ** Width
    DOMHTMLAppletElementWidthPropertyInfo   ,
    constructDOMHTMLAppletElementWidth      ,
    getDOMHTMLAppletElementWidth            ,
    setDOMHTMLAppletElementWidth            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLAppletElement = DOMHTMLAppletElement (ForeignPtr DOMHTMLAppletElement)
foreign import ccall "webkit_dom_html_applet_element_get_type"
    c_webkit_dom_html_applet_element_get_type :: IO GType

type instance ParentTypes DOMHTMLAppletElement = DOMHTMLAppletElementParentTypes
type DOMHTMLAppletElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLAppletElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_applet_element_get_type
    

class GObject o => DOMHTMLAppletElementK o
instance (GObject o, IsDescendantOf DOMHTMLAppletElement o) => DOMHTMLAppletElementK o

toDOMHTMLAppletElement :: DOMHTMLAppletElementK o => o -> IO DOMHTMLAppletElement
toDOMHTMLAppletElement = unsafeCastTo DOMHTMLAppletElement

noDOMHTMLAppletElement :: Maybe DOMHTMLAppletElement
noDOMHTMLAppletElement = Nothing

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAppletElementAlign :: (MonadIO m, DOMHTMLAppletElementK o) => o -> m T.Text
getDOMHTMLAppletElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLAppletElementAlign :: (MonadIO m, DOMHTMLAppletElementK o) => o -> T.Text -> m ()
setDOMHTMLAppletElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLAppletElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAppletElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLAppletElementAlignPropertyInfo
instance AttrInfo DOMHTMLAppletElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLAppletElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAppletElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAppletElementAlignPropertyInfo = DOMHTMLAppletElementK
    type AttrGetType DOMHTMLAppletElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLAppletElementAlignPropertyInfo = "DOMHTMLAppletElement::align"
    attrGet _ = getDOMHTMLAppletElementAlign
    attrSet _ = setDOMHTMLAppletElementAlign
    attrConstruct _ = constructDOMHTMLAppletElementAlign

-- VVV Prop "alt"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAppletElementAlt :: (MonadIO m, DOMHTMLAppletElementK o) => o -> m T.Text
getDOMHTMLAppletElementAlt obj = liftIO $ getObjectPropertyString obj "alt"

setDOMHTMLAppletElementAlt :: (MonadIO m, DOMHTMLAppletElementK o) => o -> T.Text -> m ()
setDOMHTMLAppletElementAlt obj val = liftIO $ setObjectPropertyString obj "alt" val

constructDOMHTMLAppletElementAlt :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAppletElementAlt val = constructObjectPropertyString "alt" val

data DOMHTMLAppletElementAltPropertyInfo
instance AttrInfo DOMHTMLAppletElementAltPropertyInfo where
    type AttrAllowedOps DOMHTMLAppletElementAltPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAppletElementAltPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAppletElementAltPropertyInfo = DOMHTMLAppletElementK
    type AttrGetType DOMHTMLAppletElementAltPropertyInfo = T.Text
    type AttrLabel DOMHTMLAppletElementAltPropertyInfo = "DOMHTMLAppletElement::alt"
    attrGet _ = getDOMHTMLAppletElementAlt
    attrSet _ = setDOMHTMLAppletElementAlt
    attrConstruct _ = constructDOMHTMLAppletElementAlt

-- VVV Prop "archive"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAppletElementArchive :: (MonadIO m, DOMHTMLAppletElementK o) => o -> m T.Text
getDOMHTMLAppletElementArchive obj = liftIO $ getObjectPropertyString obj "archive"

setDOMHTMLAppletElementArchive :: (MonadIO m, DOMHTMLAppletElementK o) => o -> T.Text -> m ()
setDOMHTMLAppletElementArchive obj val = liftIO $ setObjectPropertyString obj "archive" val

constructDOMHTMLAppletElementArchive :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAppletElementArchive val = constructObjectPropertyString "archive" val

data DOMHTMLAppletElementArchivePropertyInfo
instance AttrInfo DOMHTMLAppletElementArchivePropertyInfo where
    type AttrAllowedOps DOMHTMLAppletElementArchivePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAppletElementArchivePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAppletElementArchivePropertyInfo = DOMHTMLAppletElementK
    type AttrGetType DOMHTMLAppletElementArchivePropertyInfo = T.Text
    type AttrLabel DOMHTMLAppletElementArchivePropertyInfo = "DOMHTMLAppletElement::archive"
    attrGet _ = getDOMHTMLAppletElementArchive
    attrSet _ = setDOMHTMLAppletElementArchive
    attrConstruct _ = constructDOMHTMLAppletElementArchive

-- VVV Prop "code"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAppletElementCode :: (MonadIO m, DOMHTMLAppletElementK o) => o -> m T.Text
getDOMHTMLAppletElementCode obj = liftIO $ getObjectPropertyString obj "code"

setDOMHTMLAppletElementCode :: (MonadIO m, DOMHTMLAppletElementK o) => o -> T.Text -> m ()
setDOMHTMLAppletElementCode obj val = liftIO $ setObjectPropertyString obj "code" val

constructDOMHTMLAppletElementCode :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAppletElementCode val = constructObjectPropertyString "code" val

data DOMHTMLAppletElementCodePropertyInfo
instance AttrInfo DOMHTMLAppletElementCodePropertyInfo where
    type AttrAllowedOps DOMHTMLAppletElementCodePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAppletElementCodePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAppletElementCodePropertyInfo = DOMHTMLAppletElementK
    type AttrGetType DOMHTMLAppletElementCodePropertyInfo = T.Text
    type AttrLabel DOMHTMLAppletElementCodePropertyInfo = "DOMHTMLAppletElement::code"
    attrGet _ = getDOMHTMLAppletElementCode
    attrSet _ = setDOMHTMLAppletElementCode
    attrConstruct _ = constructDOMHTMLAppletElementCode

-- VVV Prop "code-base"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAppletElementCodeBase :: (MonadIO m, DOMHTMLAppletElementK o) => o -> m T.Text
getDOMHTMLAppletElementCodeBase obj = liftIO $ getObjectPropertyString obj "code-base"

setDOMHTMLAppletElementCodeBase :: (MonadIO m, DOMHTMLAppletElementK o) => o -> T.Text -> m ()
setDOMHTMLAppletElementCodeBase obj val = liftIO $ setObjectPropertyString obj "code-base" val

constructDOMHTMLAppletElementCodeBase :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAppletElementCodeBase val = constructObjectPropertyString "code-base" val

data DOMHTMLAppletElementCodeBasePropertyInfo
instance AttrInfo DOMHTMLAppletElementCodeBasePropertyInfo where
    type AttrAllowedOps DOMHTMLAppletElementCodeBasePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAppletElementCodeBasePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAppletElementCodeBasePropertyInfo = DOMHTMLAppletElementK
    type AttrGetType DOMHTMLAppletElementCodeBasePropertyInfo = T.Text
    type AttrLabel DOMHTMLAppletElementCodeBasePropertyInfo = "DOMHTMLAppletElement::code-base"
    attrGet _ = getDOMHTMLAppletElementCodeBase
    attrSet _ = setDOMHTMLAppletElementCodeBase
    attrConstruct _ = constructDOMHTMLAppletElementCodeBase

-- VVV Prop "height"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAppletElementHeight :: (MonadIO m, DOMHTMLAppletElementK o) => o -> m T.Text
getDOMHTMLAppletElementHeight obj = liftIO $ getObjectPropertyString obj "height"

setDOMHTMLAppletElementHeight :: (MonadIO m, DOMHTMLAppletElementK o) => o -> T.Text -> m ()
setDOMHTMLAppletElementHeight obj val = liftIO $ setObjectPropertyString obj "height" val

constructDOMHTMLAppletElementHeight :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAppletElementHeight val = constructObjectPropertyString "height" val

data DOMHTMLAppletElementHeightPropertyInfo
instance AttrInfo DOMHTMLAppletElementHeightPropertyInfo where
    type AttrAllowedOps DOMHTMLAppletElementHeightPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAppletElementHeightPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAppletElementHeightPropertyInfo = DOMHTMLAppletElementK
    type AttrGetType DOMHTMLAppletElementHeightPropertyInfo = T.Text
    type AttrLabel DOMHTMLAppletElementHeightPropertyInfo = "DOMHTMLAppletElement::height"
    attrGet _ = getDOMHTMLAppletElementHeight
    attrSet _ = setDOMHTMLAppletElementHeight
    attrConstruct _ = constructDOMHTMLAppletElementHeight

-- VVV Prop "hspace"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAppletElementHspace :: (MonadIO m, DOMHTMLAppletElementK o) => o -> m Int64
getDOMHTMLAppletElementHspace obj = liftIO $ getObjectPropertyInt64 obj "hspace"

setDOMHTMLAppletElementHspace :: (MonadIO m, DOMHTMLAppletElementK o) => o -> Int64 -> m ()
setDOMHTMLAppletElementHspace obj val = liftIO $ setObjectPropertyInt64 obj "hspace" val

constructDOMHTMLAppletElementHspace :: Int64 -> IO ([Char], GValue)
constructDOMHTMLAppletElementHspace val = constructObjectPropertyInt64 "hspace" val

data DOMHTMLAppletElementHspacePropertyInfo
instance AttrInfo DOMHTMLAppletElementHspacePropertyInfo where
    type AttrAllowedOps DOMHTMLAppletElementHspacePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAppletElementHspacePropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLAppletElementHspacePropertyInfo = DOMHTMLAppletElementK
    type AttrGetType DOMHTMLAppletElementHspacePropertyInfo = Int64
    type AttrLabel DOMHTMLAppletElementHspacePropertyInfo = "DOMHTMLAppletElement::hspace"
    attrGet _ = getDOMHTMLAppletElementHspace
    attrSet _ = setDOMHTMLAppletElementHspace
    attrConstruct _ = constructDOMHTMLAppletElementHspace

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAppletElementName :: (MonadIO m, DOMHTMLAppletElementK o) => o -> m T.Text
getDOMHTMLAppletElementName obj = liftIO $ getObjectPropertyString obj "name"

setDOMHTMLAppletElementName :: (MonadIO m, DOMHTMLAppletElementK o) => o -> T.Text -> m ()
setDOMHTMLAppletElementName obj val = liftIO $ setObjectPropertyString obj "name" val

constructDOMHTMLAppletElementName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAppletElementName val = constructObjectPropertyString "name" val

data DOMHTMLAppletElementNamePropertyInfo
instance AttrInfo DOMHTMLAppletElementNamePropertyInfo where
    type AttrAllowedOps DOMHTMLAppletElementNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAppletElementNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAppletElementNamePropertyInfo = DOMHTMLAppletElementK
    type AttrGetType DOMHTMLAppletElementNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLAppletElementNamePropertyInfo = "DOMHTMLAppletElement::name"
    attrGet _ = getDOMHTMLAppletElementName
    attrSet _ = setDOMHTMLAppletElementName
    attrConstruct _ = constructDOMHTMLAppletElementName

-- VVV Prop "object"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAppletElementObject :: (MonadIO m, DOMHTMLAppletElementK o) => o -> m T.Text
getDOMHTMLAppletElementObject obj = liftIO $ getObjectPropertyString obj "object"

setDOMHTMLAppletElementObject :: (MonadIO m, DOMHTMLAppletElementK o) => o -> T.Text -> m ()
setDOMHTMLAppletElementObject obj val = liftIO $ setObjectPropertyString obj "object" val

constructDOMHTMLAppletElementObject :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAppletElementObject val = constructObjectPropertyString "object" val

data DOMHTMLAppletElementObjectPropertyInfo
instance AttrInfo DOMHTMLAppletElementObjectPropertyInfo where
    type AttrAllowedOps DOMHTMLAppletElementObjectPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAppletElementObjectPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAppletElementObjectPropertyInfo = DOMHTMLAppletElementK
    type AttrGetType DOMHTMLAppletElementObjectPropertyInfo = T.Text
    type AttrLabel DOMHTMLAppletElementObjectPropertyInfo = "DOMHTMLAppletElement::object"
    attrGet _ = getDOMHTMLAppletElementObject
    attrSet _ = setDOMHTMLAppletElementObject
    attrConstruct _ = constructDOMHTMLAppletElementObject

-- VVV Prop "vspace"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAppletElementVspace :: (MonadIO m, DOMHTMLAppletElementK o) => o -> m Int64
getDOMHTMLAppletElementVspace obj = liftIO $ getObjectPropertyInt64 obj "vspace"

setDOMHTMLAppletElementVspace :: (MonadIO m, DOMHTMLAppletElementK o) => o -> Int64 -> m ()
setDOMHTMLAppletElementVspace obj val = liftIO $ setObjectPropertyInt64 obj "vspace" val

constructDOMHTMLAppletElementVspace :: Int64 -> IO ([Char], GValue)
constructDOMHTMLAppletElementVspace val = constructObjectPropertyInt64 "vspace" val

data DOMHTMLAppletElementVspacePropertyInfo
instance AttrInfo DOMHTMLAppletElementVspacePropertyInfo where
    type AttrAllowedOps DOMHTMLAppletElementVspacePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAppletElementVspacePropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLAppletElementVspacePropertyInfo = DOMHTMLAppletElementK
    type AttrGetType DOMHTMLAppletElementVspacePropertyInfo = Int64
    type AttrLabel DOMHTMLAppletElementVspacePropertyInfo = "DOMHTMLAppletElement::vspace"
    attrGet _ = getDOMHTMLAppletElementVspace
    attrSet _ = setDOMHTMLAppletElementVspace
    attrConstruct _ = constructDOMHTMLAppletElementVspace

-- VVV Prop "width"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAppletElementWidth :: (MonadIO m, DOMHTMLAppletElementK o) => o -> m T.Text
getDOMHTMLAppletElementWidth obj = liftIO $ getObjectPropertyString obj "width"

setDOMHTMLAppletElementWidth :: (MonadIO m, DOMHTMLAppletElementK o) => o -> T.Text -> m ()
setDOMHTMLAppletElementWidth obj val = liftIO $ setObjectPropertyString obj "width" val

constructDOMHTMLAppletElementWidth :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAppletElementWidth val = constructObjectPropertyString "width" val

data DOMHTMLAppletElementWidthPropertyInfo
instance AttrInfo DOMHTMLAppletElementWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLAppletElementWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAppletElementWidthPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAppletElementWidthPropertyInfo = DOMHTMLAppletElementK
    type AttrGetType DOMHTMLAppletElementWidthPropertyInfo = T.Text
    type AttrLabel DOMHTMLAppletElementWidthPropertyInfo = "DOMHTMLAppletElement::width"
    attrGet _ = getDOMHTMLAppletElementWidth
    attrSet _ = setDOMHTMLAppletElementWidth
    attrConstruct _ = constructDOMHTMLAppletElementWidth

type instance AttributeList DOMHTMLAppletElement = DOMHTMLAppletElementAttributeList
type DOMHTMLAppletElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLAppletElementAlignPropertyInfo), '("alt", DOMHTMLAppletElementAltPropertyInfo), '("archive", DOMHTMLAppletElementArchivePropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("code", DOMHTMLAppletElementCodePropertyInfo), '("code-base", DOMHTMLAppletElementCodeBasePropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("height", DOMHTMLAppletElementHeightPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("hspace", DOMHTMLAppletElementHspacePropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("name", DOMHTMLAppletElementNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("object", DOMHTMLAppletElementObjectPropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("vspace", DOMHTMLAppletElementVspacePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("width", DOMHTMLAppletElementWidthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLAppletElement = DOMHTMLAppletElementSignalList
type DOMHTMLAppletElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLAppletElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_get_align" webkit_dom_html_applet_element_get_align :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    IO CString


dOMHTMLAppletElementGetAlign ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAppletElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_applet_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_applet_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAppletElement::get_alt
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_get_alt" webkit_dom_html_applet_element_get_alt :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    IO CString


dOMHTMLAppletElementGetAlt ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAppletElementGetAlt _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_applet_element_get_alt _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_applet_element_get_alt" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAppletElement::get_archive
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_get_archive" webkit_dom_html_applet_element_get_archive :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    IO CString


dOMHTMLAppletElementGetArchive ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAppletElementGetArchive _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_applet_element_get_archive _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_applet_element_get_archive" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAppletElement::get_code
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_get_code" webkit_dom_html_applet_element_get_code :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    IO CString


dOMHTMLAppletElementGetCode ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAppletElementGetCode _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_applet_element_get_code _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_applet_element_get_code" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAppletElement::get_code_base
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_get_code_base" webkit_dom_html_applet_element_get_code_base :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    IO CString


dOMHTMLAppletElementGetCodeBase ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAppletElementGetCodeBase _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_applet_element_get_code_base _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_applet_element_get_code_base" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAppletElement::get_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_get_height" webkit_dom_html_applet_element_get_height :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    IO CString


dOMHTMLAppletElementGetHeight ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAppletElementGetHeight _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_applet_element_get_height _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_applet_element_get_height" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAppletElement::get_hspace
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_get_hspace" webkit_dom_html_applet_element_get_hspace :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    IO Int64


dOMHTMLAppletElementGetHspace ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLAppletElementGetHspace _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_applet_element_get_hspace _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLAppletElement::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_get_name" webkit_dom_html_applet_element_get_name :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    IO CString


dOMHTMLAppletElementGetName ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAppletElementGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_applet_element_get_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_applet_element_get_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAppletElement::get_object
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_get_object" webkit_dom_html_applet_element_get_object :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    IO CString


dOMHTMLAppletElementGetObject ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAppletElementGetObject _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_applet_element_get_object _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_applet_element_get_object" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAppletElement::get_vspace
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_get_vspace" webkit_dom_html_applet_element_get_vspace :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    IO Int64


dOMHTMLAppletElementGetVspace ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLAppletElementGetVspace _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_applet_element_get_vspace _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLAppletElement::get_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_get_width" webkit_dom_html_applet_element_get_width :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    IO CString


dOMHTMLAppletElementGetWidth ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAppletElementGetWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_applet_element_get_width _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_applet_element_get_width" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAppletElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_set_align" webkit_dom_html_applet_element_set_align :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAppletElementSetAlign ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAppletElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_applet_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAppletElement::set_alt
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_set_alt" webkit_dom_html_applet_element_set_alt :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAppletElementSetAlt ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAppletElementSetAlt _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_applet_element_set_alt _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAppletElement::set_archive
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_set_archive" webkit_dom_html_applet_element_set_archive :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAppletElementSetArchive ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAppletElementSetArchive _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_applet_element_set_archive _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAppletElement::set_code
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_set_code" webkit_dom_html_applet_element_set_code :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAppletElementSetCode ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAppletElementSetCode _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_applet_element_set_code _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAppletElement::set_code_base
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_set_code_base" webkit_dom_html_applet_element_set_code_base :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAppletElementSetCodeBase ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAppletElementSetCodeBase _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_applet_element_set_code_base _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAppletElement::set_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_set_height" webkit_dom_html_applet_element_set_height :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAppletElementSetHeight ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAppletElementSetHeight _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_applet_element_set_height _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAppletElement::set_hspace
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_set_hspace" webkit_dom_html_applet_element_set_hspace :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    Int64 ->                                -- value : TBasicType TInt64
    IO ()


dOMHTMLAppletElementSetHspace ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLAppletElementSetHspace _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_applet_element_set_hspace _obj' value
    touchManagedPtr _obj
    return ()

-- method DOMHTMLAppletElement::set_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_set_name" webkit_dom_html_applet_element_set_name :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAppletElementSetName ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAppletElementSetName _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_applet_element_set_name _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAppletElement::set_object
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_set_object" webkit_dom_html_applet_element_set_object :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAppletElementSetObject ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAppletElementSetObject _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_applet_element_set_object _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAppletElement::set_vspace
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_set_vspace" webkit_dom_html_applet_element_set_vspace :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    Int64 ->                                -- value : TBasicType TInt64
    IO ()


dOMHTMLAppletElementSetVspace ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLAppletElementSetVspace _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_applet_element_set_vspace _obj' value
    touchManagedPtr _obj
    return ()

-- method DOMHTMLAppletElement::set_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAppletElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_applet_element_set_width" webkit_dom_html_applet_element_set_width :: 
    Ptr DOMHTMLAppletElement ->             -- _obj : TInterface "WebKit" "DOMHTMLAppletElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAppletElementSetWidth ::
    (MonadIO m, DOMHTMLAppletElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAppletElementSetWidth _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_applet_element_set_width _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


