
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLAreaElement
    ( 

-- * Exported types
    DOMHTMLAreaElement(..)                  ,
    DOMHTMLAreaElementK                     ,
    toDOMHTMLAreaElement                    ,
    noDOMHTMLAreaElement                    ,


 -- * Methods
-- ** dOMHTMLAreaElementGetAlt
    dOMHTMLAreaElementGetAlt                ,


-- ** dOMHTMLAreaElementGetCoords
    dOMHTMLAreaElementGetCoords             ,


-- ** dOMHTMLAreaElementGetHash
    dOMHTMLAreaElementGetHash               ,


-- ** dOMHTMLAreaElementGetHost
    dOMHTMLAreaElementGetHost               ,


-- ** dOMHTMLAreaElementGetHostname
    dOMHTMLAreaElementGetHostname           ,


-- ** dOMHTMLAreaElementGetHref
    dOMHTMLAreaElementGetHref               ,


-- ** dOMHTMLAreaElementGetNoHref
    dOMHTMLAreaElementGetNoHref             ,


-- ** dOMHTMLAreaElementGetPathname
    dOMHTMLAreaElementGetPathname           ,


-- ** dOMHTMLAreaElementGetPing
    dOMHTMLAreaElementGetPing               ,


-- ** dOMHTMLAreaElementGetPort
    dOMHTMLAreaElementGetPort               ,


-- ** dOMHTMLAreaElementGetProtocol
    dOMHTMLAreaElementGetProtocol           ,


-- ** dOMHTMLAreaElementGetSearch
    dOMHTMLAreaElementGetSearch             ,


-- ** dOMHTMLAreaElementGetShape
    dOMHTMLAreaElementGetShape              ,


-- ** dOMHTMLAreaElementGetTarget
    dOMHTMLAreaElementGetTarget             ,


-- ** dOMHTMLAreaElementSetAlt
    dOMHTMLAreaElementSetAlt                ,


-- ** dOMHTMLAreaElementSetCoords
    dOMHTMLAreaElementSetCoords             ,


-- ** dOMHTMLAreaElementSetHref
    dOMHTMLAreaElementSetHref               ,


-- ** dOMHTMLAreaElementSetNoHref
    dOMHTMLAreaElementSetNoHref             ,


-- ** dOMHTMLAreaElementSetPing
    dOMHTMLAreaElementSetPing               ,


-- ** dOMHTMLAreaElementSetShape
    dOMHTMLAreaElementSetShape              ,


-- ** dOMHTMLAreaElementSetTarget
    dOMHTMLAreaElementSetTarget             ,




 -- * Properties
-- ** Alt
    DOMHTMLAreaElementAltPropertyInfo       ,
    constructDOMHTMLAreaElementAlt          ,
    getDOMHTMLAreaElementAlt                ,
    setDOMHTMLAreaElementAlt                ,


-- ** Coords
    DOMHTMLAreaElementCoordsPropertyInfo    ,
    constructDOMHTMLAreaElementCoords       ,
    getDOMHTMLAreaElementCoords             ,
    setDOMHTMLAreaElementCoords             ,


-- ** Hash
    DOMHTMLAreaElementHashPropertyInfo      ,
    getDOMHTMLAreaElementHash               ,


-- ** Host
    DOMHTMLAreaElementHostPropertyInfo      ,
    getDOMHTMLAreaElementHost               ,


-- ** Hostname
    DOMHTMLAreaElementHostnamePropertyInfo  ,
    getDOMHTMLAreaElementHostname           ,


-- ** Href
    DOMHTMLAreaElementHrefPropertyInfo      ,
    constructDOMHTMLAreaElementHref         ,
    getDOMHTMLAreaElementHref               ,
    setDOMHTMLAreaElementHref               ,


-- ** NoHref
    DOMHTMLAreaElementNoHrefPropertyInfo    ,
    constructDOMHTMLAreaElementNoHref       ,
    getDOMHTMLAreaElementNoHref             ,
    setDOMHTMLAreaElementNoHref             ,


-- ** Pathname
    DOMHTMLAreaElementPathnamePropertyInfo  ,
    getDOMHTMLAreaElementPathname           ,


-- ** Ping
    DOMHTMLAreaElementPingPropertyInfo      ,
    constructDOMHTMLAreaElementPing         ,
    getDOMHTMLAreaElementPing               ,
    setDOMHTMLAreaElementPing               ,


-- ** Port
    DOMHTMLAreaElementPortPropertyInfo      ,
    getDOMHTMLAreaElementPort               ,


-- ** Protocol
    DOMHTMLAreaElementProtocolPropertyInfo  ,
    getDOMHTMLAreaElementProtocol           ,


-- ** Search
    DOMHTMLAreaElementSearchPropertyInfo    ,
    getDOMHTMLAreaElementSearch             ,


-- ** Shape
    DOMHTMLAreaElementShapePropertyInfo     ,
    constructDOMHTMLAreaElementShape        ,
    getDOMHTMLAreaElementShape              ,
    setDOMHTMLAreaElementShape              ,


-- ** Target
    DOMHTMLAreaElementTargetPropertyInfo    ,
    constructDOMHTMLAreaElementTarget       ,
    getDOMHTMLAreaElementTarget             ,
    setDOMHTMLAreaElementTarget             ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLAreaElement = DOMHTMLAreaElement (ForeignPtr DOMHTMLAreaElement)
foreign import ccall "webkit_dom_html_area_element_get_type"
    c_webkit_dom_html_area_element_get_type :: IO GType

type instance ParentTypes DOMHTMLAreaElement = DOMHTMLAreaElementParentTypes
type DOMHTMLAreaElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLAreaElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_area_element_get_type
    

class GObject o => DOMHTMLAreaElementK o
instance (GObject o, IsDescendantOf DOMHTMLAreaElement o) => DOMHTMLAreaElementK o

toDOMHTMLAreaElement :: DOMHTMLAreaElementK o => o -> IO DOMHTMLAreaElement
toDOMHTMLAreaElement = unsafeCastTo DOMHTMLAreaElement

noDOMHTMLAreaElement :: Maybe DOMHTMLAreaElement
noDOMHTMLAreaElement = Nothing

-- VVV Prop "alt"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAreaElementAlt :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementAlt obj = liftIO $ getObjectPropertyString obj "alt"

setDOMHTMLAreaElementAlt :: (MonadIO m, DOMHTMLAreaElementK o) => o -> T.Text -> m ()
setDOMHTMLAreaElementAlt obj val = liftIO $ setObjectPropertyString obj "alt" val

constructDOMHTMLAreaElementAlt :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAreaElementAlt val = constructObjectPropertyString "alt" val

data DOMHTMLAreaElementAltPropertyInfo
instance AttrInfo DOMHTMLAreaElementAltPropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementAltPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementAltPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAreaElementAltPropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementAltPropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementAltPropertyInfo = "DOMHTMLAreaElement::alt"
    attrGet _ = getDOMHTMLAreaElementAlt
    attrSet _ = setDOMHTMLAreaElementAlt
    attrConstruct _ = constructDOMHTMLAreaElementAlt

-- VVV Prop "coords"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAreaElementCoords :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementCoords obj = liftIO $ getObjectPropertyString obj "coords"

setDOMHTMLAreaElementCoords :: (MonadIO m, DOMHTMLAreaElementK o) => o -> T.Text -> m ()
setDOMHTMLAreaElementCoords obj val = liftIO $ setObjectPropertyString obj "coords" val

constructDOMHTMLAreaElementCoords :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAreaElementCoords val = constructObjectPropertyString "coords" val

data DOMHTMLAreaElementCoordsPropertyInfo
instance AttrInfo DOMHTMLAreaElementCoordsPropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementCoordsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementCoordsPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAreaElementCoordsPropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementCoordsPropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementCoordsPropertyInfo = "DOMHTMLAreaElement::coords"
    attrGet _ = getDOMHTMLAreaElementCoords
    attrSet _ = setDOMHTMLAreaElementCoords
    attrConstruct _ = constructDOMHTMLAreaElementCoords

-- VVV Prop "hash"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLAreaElementHash :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementHash obj = liftIO $ getObjectPropertyString obj "hash"

data DOMHTMLAreaElementHashPropertyInfo
instance AttrInfo DOMHTMLAreaElementHashPropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementHashPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementHashPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLAreaElementHashPropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementHashPropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementHashPropertyInfo = "DOMHTMLAreaElement::hash"
    attrGet _ = getDOMHTMLAreaElementHash
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "host"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLAreaElementHost :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementHost obj = liftIO $ getObjectPropertyString obj "host"

data DOMHTMLAreaElementHostPropertyInfo
instance AttrInfo DOMHTMLAreaElementHostPropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementHostPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementHostPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLAreaElementHostPropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementHostPropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementHostPropertyInfo = "DOMHTMLAreaElement::host"
    attrGet _ = getDOMHTMLAreaElementHost
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "hostname"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLAreaElementHostname :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementHostname obj = liftIO $ getObjectPropertyString obj "hostname"

data DOMHTMLAreaElementHostnamePropertyInfo
instance AttrInfo DOMHTMLAreaElementHostnamePropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementHostnamePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementHostnamePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLAreaElementHostnamePropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementHostnamePropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementHostnamePropertyInfo = "DOMHTMLAreaElement::hostname"
    attrGet _ = getDOMHTMLAreaElementHostname
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "href"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAreaElementHref :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementHref obj = liftIO $ getObjectPropertyString obj "href"

setDOMHTMLAreaElementHref :: (MonadIO m, DOMHTMLAreaElementK o) => o -> T.Text -> m ()
setDOMHTMLAreaElementHref obj val = liftIO $ setObjectPropertyString obj "href" val

constructDOMHTMLAreaElementHref :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAreaElementHref val = constructObjectPropertyString "href" val

data DOMHTMLAreaElementHrefPropertyInfo
instance AttrInfo DOMHTMLAreaElementHrefPropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementHrefPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementHrefPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAreaElementHrefPropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementHrefPropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementHrefPropertyInfo = "DOMHTMLAreaElement::href"
    attrGet _ = getDOMHTMLAreaElementHref
    attrSet _ = setDOMHTMLAreaElementHref
    attrConstruct _ = constructDOMHTMLAreaElementHref

-- VVV Prop "no-href"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAreaElementNoHref :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m Bool
getDOMHTMLAreaElementNoHref obj = liftIO $ getObjectPropertyBool obj "no-href"

setDOMHTMLAreaElementNoHref :: (MonadIO m, DOMHTMLAreaElementK o) => o -> Bool -> m ()
setDOMHTMLAreaElementNoHref obj val = liftIO $ setObjectPropertyBool obj "no-href" val

constructDOMHTMLAreaElementNoHref :: Bool -> IO ([Char], GValue)
constructDOMHTMLAreaElementNoHref val = constructObjectPropertyBool "no-href" val

data DOMHTMLAreaElementNoHrefPropertyInfo
instance AttrInfo DOMHTMLAreaElementNoHrefPropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementNoHrefPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementNoHrefPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLAreaElementNoHrefPropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementNoHrefPropertyInfo = Bool
    type AttrLabel DOMHTMLAreaElementNoHrefPropertyInfo = "DOMHTMLAreaElement::no-href"
    attrGet _ = getDOMHTMLAreaElementNoHref
    attrSet _ = setDOMHTMLAreaElementNoHref
    attrConstruct _ = constructDOMHTMLAreaElementNoHref

-- VVV Prop "pathname"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLAreaElementPathname :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementPathname obj = liftIO $ getObjectPropertyString obj "pathname"

data DOMHTMLAreaElementPathnamePropertyInfo
instance AttrInfo DOMHTMLAreaElementPathnamePropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementPathnamePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementPathnamePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLAreaElementPathnamePropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementPathnamePropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementPathnamePropertyInfo = "DOMHTMLAreaElement::pathname"
    attrGet _ = getDOMHTMLAreaElementPathname
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "ping"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAreaElementPing :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementPing obj = liftIO $ getObjectPropertyString obj "ping"

setDOMHTMLAreaElementPing :: (MonadIO m, DOMHTMLAreaElementK o) => o -> T.Text -> m ()
setDOMHTMLAreaElementPing obj val = liftIO $ setObjectPropertyString obj "ping" val

constructDOMHTMLAreaElementPing :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAreaElementPing val = constructObjectPropertyString "ping" val

data DOMHTMLAreaElementPingPropertyInfo
instance AttrInfo DOMHTMLAreaElementPingPropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementPingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementPingPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAreaElementPingPropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementPingPropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementPingPropertyInfo = "DOMHTMLAreaElement::ping"
    attrGet _ = getDOMHTMLAreaElementPing
    attrSet _ = setDOMHTMLAreaElementPing
    attrConstruct _ = constructDOMHTMLAreaElementPing

-- VVV Prop "port"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLAreaElementPort :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementPort obj = liftIO $ getObjectPropertyString obj "port"

data DOMHTMLAreaElementPortPropertyInfo
instance AttrInfo DOMHTMLAreaElementPortPropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementPortPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementPortPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLAreaElementPortPropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementPortPropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementPortPropertyInfo = "DOMHTMLAreaElement::port"
    attrGet _ = getDOMHTMLAreaElementPort
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "protocol"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLAreaElementProtocol :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementProtocol obj = liftIO $ getObjectPropertyString obj "protocol"

data DOMHTMLAreaElementProtocolPropertyInfo
instance AttrInfo DOMHTMLAreaElementProtocolPropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementProtocolPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementProtocolPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLAreaElementProtocolPropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementProtocolPropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementProtocolPropertyInfo = "DOMHTMLAreaElement::protocol"
    attrGet _ = getDOMHTMLAreaElementProtocol
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "search"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLAreaElementSearch :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementSearch obj = liftIO $ getObjectPropertyString obj "search"

data DOMHTMLAreaElementSearchPropertyInfo
instance AttrInfo DOMHTMLAreaElementSearchPropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementSearchPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementSearchPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLAreaElementSearchPropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementSearchPropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementSearchPropertyInfo = "DOMHTMLAreaElement::search"
    attrGet _ = getDOMHTMLAreaElementSearch
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "shape"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAreaElementShape :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementShape obj = liftIO $ getObjectPropertyString obj "shape"

setDOMHTMLAreaElementShape :: (MonadIO m, DOMHTMLAreaElementK o) => o -> T.Text -> m ()
setDOMHTMLAreaElementShape obj val = liftIO $ setObjectPropertyString obj "shape" val

constructDOMHTMLAreaElementShape :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAreaElementShape val = constructObjectPropertyString "shape" val

data DOMHTMLAreaElementShapePropertyInfo
instance AttrInfo DOMHTMLAreaElementShapePropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementShapePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementShapePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAreaElementShapePropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementShapePropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementShapePropertyInfo = "DOMHTMLAreaElement::shape"
    attrGet _ = getDOMHTMLAreaElementShape
    attrSet _ = setDOMHTMLAreaElementShape
    attrConstruct _ = constructDOMHTMLAreaElementShape

-- VVV Prop "target"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLAreaElementTarget :: (MonadIO m, DOMHTMLAreaElementK o) => o -> m T.Text
getDOMHTMLAreaElementTarget obj = liftIO $ getObjectPropertyString obj "target"

setDOMHTMLAreaElementTarget :: (MonadIO m, DOMHTMLAreaElementK o) => o -> T.Text -> m ()
setDOMHTMLAreaElementTarget obj val = liftIO $ setObjectPropertyString obj "target" val

constructDOMHTMLAreaElementTarget :: T.Text -> IO ([Char], GValue)
constructDOMHTMLAreaElementTarget val = constructObjectPropertyString "target" val

data DOMHTMLAreaElementTargetPropertyInfo
instance AttrInfo DOMHTMLAreaElementTargetPropertyInfo where
    type AttrAllowedOps DOMHTMLAreaElementTargetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLAreaElementTargetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLAreaElementTargetPropertyInfo = DOMHTMLAreaElementK
    type AttrGetType DOMHTMLAreaElementTargetPropertyInfo = T.Text
    type AttrLabel DOMHTMLAreaElementTargetPropertyInfo = "DOMHTMLAreaElement::target"
    attrGet _ = getDOMHTMLAreaElementTarget
    attrSet _ = setDOMHTMLAreaElementTarget
    attrConstruct _ = constructDOMHTMLAreaElementTarget

type instance AttributeList DOMHTMLAreaElement = DOMHTMLAreaElementAttributeList
type DOMHTMLAreaElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("alt", DOMHTMLAreaElementAltPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("coords", DOMHTMLAreaElementCoordsPropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hash", DOMHTMLAreaElementHashPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("host", DOMHTMLAreaElementHostPropertyInfo), '("hostname", DOMHTMLAreaElementHostnamePropertyInfo), '("href", DOMHTMLAreaElementHrefPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("no-href", DOMHTMLAreaElementNoHrefPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("pathname", DOMHTMLAreaElementPathnamePropertyInfo), '("ping", DOMHTMLAreaElementPingPropertyInfo), '("port", DOMHTMLAreaElementPortPropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("protocol", DOMHTMLAreaElementProtocolPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("search", DOMHTMLAreaElementSearchPropertyInfo), '("shape", DOMHTMLAreaElementShapePropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("target", DOMHTMLAreaElementTargetPropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLAreaElement = DOMHTMLAreaElementSignalList
type DOMHTMLAreaElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLAreaElement::get_alt
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_alt" webkit_dom_html_area_element_get_alt :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetAlt ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetAlt _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_alt _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_alt" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_coords
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_coords" webkit_dom_html_area_element_get_coords :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetCoords ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetCoords _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_coords _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_coords" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_hash
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_hash" webkit_dom_html_area_element_get_hash :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetHash ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetHash _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_hash _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_hash" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_host
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_host" webkit_dom_html_area_element_get_host :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetHost ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetHost _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_host _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_host" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_hostname
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_hostname" webkit_dom_html_area_element_get_hostname :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetHostname ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetHostname _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_hostname _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_hostname" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_href
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_href" webkit_dom_html_area_element_get_href :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetHref ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetHref _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_href _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_href" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_no_href
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_no_href" webkit_dom_html_area_element_get_no_href :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CInt


dOMHTMLAreaElementGetNoHref ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLAreaElementGetNoHref _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_no_href _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_pathname
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_pathname" webkit_dom_html_area_element_get_pathname :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetPathname ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetPathname _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_pathname _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_pathname" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_ping
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_ping" webkit_dom_html_area_element_get_ping :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetPing ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetPing _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_ping _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_ping" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_port
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_port" webkit_dom_html_area_element_get_port :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetPort ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetPort _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_port _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_port" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_protocol
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_protocol" webkit_dom_html_area_element_get_protocol :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetProtocol ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetProtocol _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_protocol _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_protocol" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_search
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_search" webkit_dom_html_area_element_get_search :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetSearch ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetSearch _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_search _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_search" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_shape
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_shape" webkit_dom_html_area_element_get_shape :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetShape ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetShape _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_shape _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_shape" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::get_target
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_get_target" webkit_dom_html_area_element_get_target :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    IO CString


dOMHTMLAreaElementGetTarget ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLAreaElementGetTarget _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_area_element_get_target _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_area_element_get_target" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLAreaElement::set_alt
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_set_alt" webkit_dom_html_area_element_set_alt :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAreaElementSetAlt ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAreaElementSetAlt _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_area_element_set_alt _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAreaElement::set_coords
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_set_coords" webkit_dom_html_area_element_set_coords :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAreaElementSetCoords ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAreaElementSetCoords _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_area_element_set_coords _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAreaElement::set_href
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_set_href" webkit_dom_html_area_element_set_href :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAreaElementSetHref ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAreaElementSetHref _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_area_element_set_href _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAreaElement::set_no_href
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_set_no_href" webkit_dom_html_area_element_set_no_href :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLAreaElementSetNoHref ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLAreaElementSetNoHref _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_area_element_set_no_href _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLAreaElement::set_ping
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_set_ping" webkit_dom_html_area_element_set_ping :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAreaElementSetPing ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAreaElementSetPing _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_area_element_set_ping _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAreaElement::set_shape
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_set_shape" webkit_dom_html_area_element_set_shape :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAreaElementSetShape ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAreaElementSetShape _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_area_element_set_shape _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLAreaElement::set_target
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLAreaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_area_element_set_target" webkit_dom_html_area_element_set_target :: 
    Ptr DOMHTMLAreaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLAreaElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLAreaElementSetTarget ::
    (MonadIO m, DOMHTMLAreaElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLAreaElementSetTarget _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_area_element_set_target _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


