
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLBRElement
    ( 

-- * Exported types
    DOMHTMLBRElement(..)                    ,
    DOMHTMLBRElementK                       ,
    toDOMHTMLBRElement                      ,
    noDOMHTMLBRElement                      ,


 -- * Methods
-- ** dOMHTMLBRElementGetClear
    dOMHTMLBRElementGetClear                ,


-- ** dOMHTMLBRElementSetClear
    dOMHTMLBRElementSetClear                ,




 -- * Properties
-- ** Clear
    DOMHTMLBRElementClearPropertyInfo       ,
    constructDOMHTMLBRElementClear          ,
    getDOMHTMLBRElementClear                ,
    setDOMHTMLBRElementClear                ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLBRElement = DOMHTMLBRElement (ForeignPtr DOMHTMLBRElement)
foreign import ccall "webkit_dom_htmlbr_element_get_type"
    c_webkit_dom_htmlbr_element_get_type :: IO GType

type instance ParentTypes DOMHTMLBRElement = DOMHTMLBRElementParentTypes
type DOMHTMLBRElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLBRElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_htmlbr_element_get_type
    

class GObject o => DOMHTMLBRElementK o
instance (GObject o, IsDescendantOf DOMHTMLBRElement o) => DOMHTMLBRElementK o

toDOMHTMLBRElement :: DOMHTMLBRElementK o => o -> IO DOMHTMLBRElement
toDOMHTMLBRElement = unsafeCastTo DOMHTMLBRElement

noDOMHTMLBRElement :: Maybe DOMHTMLBRElement
noDOMHTMLBRElement = Nothing

-- VVV Prop "clear"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLBRElementClear :: (MonadIO m, DOMHTMLBRElementK o) => o -> m T.Text
getDOMHTMLBRElementClear obj = liftIO $ getObjectPropertyString obj "clear"

setDOMHTMLBRElementClear :: (MonadIO m, DOMHTMLBRElementK o) => o -> T.Text -> m ()
setDOMHTMLBRElementClear obj val = liftIO $ setObjectPropertyString obj "clear" val

constructDOMHTMLBRElementClear :: T.Text -> IO ([Char], GValue)
constructDOMHTMLBRElementClear val = constructObjectPropertyString "clear" val

data DOMHTMLBRElementClearPropertyInfo
instance AttrInfo DOMHTMLBRElementClearPropertyInfo where
    type AttrAllowedOps DOMHTMLBRElementClearPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLBRElementClearPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLBRElementClearPropertyInfo = DOMHTMLBRElementK
    type AttrGetType DOMHTMLBRElementClearPropertyInfo = T.Text
    type AttrLabel DOMHTMLBRElementClearPropertyInfo = "DOMHTMLBRElement::clear"
    attrGet _ = getDOMHTMLBRElementClear
    attrSet _ = setDOMHTMLBRElementClear
    attrConstruct _ = constructDOMHTMLBRElementClear

type instance AttributeList DOMHTMLBRElement = DOMHTMLBRElementAttributeList
type DOMHTMLBRElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("clear", DOMHTMLBRElementClearPropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLBRElement = DOMHTMLBRElementSignalList
type DOMHTMLBRElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLBRElement::get_clear
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlbr_element_get_clear" webkit_dom_htmlbr_element_get_clear :: 
    Ptr DOMHTMLBRElement ->                 -- _obj : TInterface "WebKit" "DOMHTMLBRElement"
    IO CString


dOMHTMLBRElementGetClear ::
    (MonadIO m, DOMHTMLBRElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLBRElementGetClear _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_htmlbr_element_get_clear _obj'
    checkUnexpectedReturnNULL "webkit_dom_htmlbr_element_get_clear" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLBRElement::set_clear
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlbr_element_set_clear" webkit_dom_htmlbr_element_set_clear :: 
    Ptr DOMHTMLBRElement ->                 -- _obj : TInterface "WebKit" "DOMHTMLBRElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLBRElementSetClear ::
    (MonadIO m, DOMHTMLBRElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLBRElementSetClear _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_htmlbr_element_set_clear _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


