
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLBaseElement
    ( 

-- * Exported types
    DOMHTMLBaseElement(..)                  ,
    DOMHTMLBaseElementK                     ,
    toDOMHTMLBaseElement                    ,
    noDOMHTMLBaseElement                    ,


 -- * Methods
-- ** dOMHTMLBaseElementGetHref
    dOMHTMLBaseElementGetHref               ,


-- ** dOMHTMLBaseElementGetTarget
    dOMHTMLBaseElementGetTarget             ,


-- ** dOMHTMLBaseElementSetHref
    dOMHTMLBaseElementSetHref               ,


-- ** dOMHTMLBaseElementSetTarget
    dOMHTMLBaseElementSetTarget             ,




 -- * Properties
-- ** Href
    DOMHTMLBaseElementHrefPropertyInfo      ,
    constructDOMHTMLBaseElementHref         ,
    getDOMHTMLBaseElementHref               ,
    setDOMHTMLBaseElementHref               ,


-- ** Target
    DOMHTMLBaseElementTargetPropertyInfo    ,
    constructDOMHTMLBaseElementTarget       ,
    getDOMHTMLBaseElementTarget             ,
    setDOMHTMLBaseElementTarget             ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLBaseElement = DOMHTMLBaseElement (ForeignPtr DOMHTMLBaseElement)
foreign import ccall "webkit_dom_html_base_element_get_type"
    c_webkit_dom_html_base_element_get_type :: IO GType

type instance ParentTypes DOMHTMLBaseElement = DOMHTMLBaseElementParentTypes
type DOMHTMLBaseElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLBaseElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_base_element_get_type
    

class GObject o => DOMHTMLBaseElementK o
instance (GObject o, IsDescendantOf DOMHTMLBaseElement o) => DOMHTMLBaseElementK o

toDOMHTMLBaseElement :: DOMHTMLBaseElementK o => o -> IO DOMHTMLBaseElement
toDOMHTMLBaseElement = unsafeCastTo DOMHTMLBaseElement

noDOMHTMLBaseElement :: Maybe DOMHTMLBaseElement
noDOMHTMLBaseElement = Nothing

-- VVV Prop "href"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLBaseElementHref :: (MonadIO m, DOMHTMLBaseElementK o) => o -> m T.Text
getDOMHTMLBaseElementHref obj = liftIO $ getObjectPropertyString obj "href"

setDOMHTMLBaseElementHref :: (MonadIO m, DOMHTMLBaseElementK o) => o -> T.Text -> m ()
setDOMHTMLBaseElementHref obj val = liftIO $ setObjectPropertyString obj "href" val

constructDOMHTMLBaseElementHref :: T.Text -> IO ([Char], GValue)
constructDOMHTMLBaseElementHref val = constructObjectPropertyString "href" val

data DOMHTMLBaseElementHrefPropertyInfo
instance AttrInfo DOMHTMLBaseElementHrefPropertyInfo where
    type AttrAllowedOps DOMHTMLBaseElementHrefPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLBaseElementHrefPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLBaseElementHrefPropertyInfo = DOMHTMLBaseElementK
    type AttrGetType DOMHTMLBaseElementHrefPropertyInfo = T.Text
    type AttrLabel DOMHTMLBaseElementHrefPropertyInfo = "DOMHTMLBaseElement::href"
    attrGet _ = getDOMHTMLBaseElementHref
    attrSet _ = setDOMHTMLBaseElementHref
    attrConstruct _ = constructDOMHTMLBaseElementHref

-- VVV Prop "target"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLBaseElementTarget :: (MonadIO m, DOMHTMLBaseElementK o) => o -> m T.Text
getDOMHTMLBaseElementTarget obj = liftIO $ getObjectPropertyString obj "target"

setDOMHTMLBaseElementTarget :: (MonadIO m, DOMHTMLBaseElementK o) => o -> T.Text -> m ()
setDOMHTMLBaseElementTarget obj val = liftIO $ setObjectPropertyString obj "target" val

constructDOMHTMLBaseElementTarget :: T.Text -> IO ([Char], GValue)
constructDOMHTMLBaseElementTarget val = constructObjectPropertyString "target" val

data DOMHTMLBaseElementTargetPropertyInfo
instance AttrInfo DOMHTMLBaseElementTargetPropertyInfo where
    type AttrAllowedOps DOMHTMLBaseElementTargetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLBaseElementTargetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLBaseElementTargetPropertyInfo = DOMHTMLBaseElementK
    type AttrGetType DOMHTMLBaseElementTargetPropertyInfo = T.Text
    type AttrLabel DOMHTMLBaseElementTargetPropertyInfo = "DOMHTMLBaseElement::target"
    attrGet _ = getDOMHTMLBaseElementTarget
    attrSet _ = setDOMHTMLBaseElementTarget
    attrConstruct _ = constructDOMHTMLBaseElementTarget

type instance AttributeList DOMHTMLBaseElement = DOMHTMLBaseElementAttributeList
type DOMHTMLBaseElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("href", DOMHTMLBaseElementHrefPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("target", DOMHTMLBaseElementTargetPropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLBaseElement = DOMHTMLBaseElementSignalList
type DOMHTMLBaseElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLBaseElement::get_href
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_base_element_get_href" webkit_dom_html_base_element_get_href :: 
    Ptr DOMHTMLBaseElement ->               -- _obj : TInterface "WebKit" "DOMHTMLBaseElement"
    IO CString


dOMHTMLBaseElementGetHref ::
    (MonadIO m, DOMHTMLBaseElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLBaseElementGetHref _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_base_element_get_href _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_base_element_get_href" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLBaseElement::get_target
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_base_element_get_target" webkit_dom_html_base_element_get_target :: 
    Ptr DOMHTMLBaseElement ->               -- _obj : TInterface "WebKit" "DOMHTMLBaseElement"
    IO CString


dOMHTMLBaseElementGetTarget ::
    (MonadIO m, DOMHTMLBaseElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLBaseElementGetTarget _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_base_element_get_target _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_base_element_get_target" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLBaseElement::set_href
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_base_element_set_href" webkit_dom_html_base_element_set_href :: 
    Ptr DOMHTMLBaseElement ->               -- _obj : TInterface "WebKit" "DOMHTMLBaseElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLBaseElementSetHref ::
    (MonadIO m, DOMHTMLBaseElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLBaseElementSetHref _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_base_element_set_href _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLBaseElement::set_target
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_base_element_set_target" webkit_dom_html_base_element_set_target :: 
    Ptr DOMHTMLBaseElement ->               -- _obj : TInterface "WebKit" "DOMHTMLBaseElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLBaseElementSetTarget ::
    (MonadIO m, DOMHTMLBaseElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLBaseElementSetTarget _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_base_element_set_target _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


