
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLBaseFontElement
    ( 

-- * Exported types
    DOMHTMLBaseFontElement(..)              ,
    DOMHTMLBaseFontElementK                 ,
    toDOMHTMLBaseFontElement                ,
    noDOMHTMLBaseFontElement                ,


 -- * Methods
-- ** dOMHTMLBaseFontElementGetColor
    dOMHTMLBaseFontElementGetColor          ,


-- ** dOMHTMLBaseFontElementGetFace
    dOMHTMLBaseFontElementGetFace           ,


-- ** dOMHTMLBaseFontElementGetSize
    dOMHTMLBaseFontElementGetSize           ,


-- ** dOMHTMLBaseFontElementSetColor
    dOMHTMLBaseFontElementSetColor          ,


-- ** dOMHTMLBaseFontElementSetFace
    dOMHTMLBaseFontElementSetFace           ,


-- ** dOMHTMLBaseFontElementSetSize
    dOMHTMLBaseFontElementSetSize           ,




 -- * Properties
-- ** Color
    DOMHTMLBaseFontElementColorPropertyInfo ,
    constructDOMHTMLBaseFontElementColor    ,
    getDOMHTMLBaseFontElementColor          ,
    setDOMHTMLBaseFontElementColor          ,


-- ** Face
    DOMHTMLBaseFontElementFacePropertyInfo  ,
    constructDOMHTMLBaseFontElementFace     ,
    getDOMHTMLBaseFontElementFace           ,
    setDOMHTMLBaseFontElementFace           ,


-- ** Size
    DOMHTMLBaseFontElementSizePropertyInfo  ,
    constructDOMHTMLBaseFontElementSize     ,
    getDOMHTMLBaseFontElementSize           ,
    setDOMHTMLBaseFontElementSize           ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLBaseFontElement = DOMHTMLBaseFontElement (ForeignPtr DOMHTMLBaseFontElement)
foreign import ccall "webkit_dom_html_base_font_element_get_type"
    c_webkit_dom_html_base_font_element_get_type :: IO GType

type instance ParentTypes DOMHTMLBaseFontElement = DOMHTMLBaseFontElementParentTypes
type DOMHTMLBaseFontElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLBaseFontElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_base_font_element_get_type
    

class GObject o => DOMHTMLBaseFontElementK o
instance (GObject o, IsDescendantOf DOMHTMLBaseFontElement o) => DOMHTMLBaseFontElementK o

toDOMHTMLBaseFontElement :: DOMHTMLBaseFontElementK o => o -> IO DOMHTMLBaseFontElement
toDOMHTMLBaseFontElement = unsafeCastTo DOMHTMLBaseFontElement

noDOMHTMLBaseFontElement :: Maybe DOMHTMLBaseFontElement
noDOMHTMLBaseFontElement = Nothing

-- VVV Prop "color"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLBaseFontElementColor :: (MonadIO m, DOMHTMLBaseFontElementK o) => o -> m T.Text
getDOMHTMLBaseFontElementColor obj = liftIO $ getObjectPropertyString obj "color"

setDOMHTMLBaseFontElementColor :: (MonadIO m, DOMHTMLBaseFontElementK o) => o -> T.Text -> m ()
setDOMHTMLBaseFontElementColor obj val = liftIO $ setObjectPropertyString obj "color" val

constructDOMHTMLBaseFontElementColor :: T.Text -> IO ([Char], GValue)
constructDOMHTMLBaseFontElementColor val = constructObjectPropertyString "color" val

data DOMHTMLBaseFontElementColorPropertyInfo
instance AttrInfo DOMHTMLBaseFontElementColorPropertyInfo where
    type AttrAllowedOps DOMHTMLBaseFontElementColorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLBaseFontElementColorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLBaseFontElementColorPropertyInfo = DOMHTMLBaseFontElementK
    type AttrGetType DOMHTMLBaseFontElementColorPropertyInfo = T.Text
    type AttrLabel DOMHTMLBaseFontElementColorPropertyInfo = "DOMHTMLBaseFontElement::color"
    attrGet _ = getDOMHTMLBaseFontElementColor
    attrSet _ = setDOMHTMLBaseFontElementColor
    attrConstruct _ = constructDOMHTMLBaseFontElementColor

-- VVV Prop "face"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLBaseFontElementFace :: (MonadIO m, DOMHTMLBaseFontElementK o) => o -> m T.Text
getDOMHTMLBaseFontElementFace obj = liftIO $ getObjectPropertyString obj "face"

setDOMHTMLBaseFontElementFace :: (MonadIO m, DOMHTMLBaseFontElementK o) => o -> T.Text -> m ()
setDOMHTMLBaseFontElementFace obj val = liftIO $ setObjectPropertyString obj "face" val

constructDOMHTMLBaseFontElementFace :: T.Text -> IO ([Char], GValue)
constructDOMHTMLBaseFontElementFace val = constructObjectPropertyString "face" val

data DOMHTMLBaseFontElementFacePropertyInfo
instance AttrInfo DOMHTMLBaseFontElementFacePropertyInfo where
    type AttrAllowedOps DOMHTMLBaseFontElementFacePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLBaseFontElementFacePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLBaseFontElementFacePropertyInfo = DOMHTMLBaseFontElementK
    type AttrGetType DOMHTMLBaseFontElementFacePropertyInfo = T.Text
    type AttrLabel DOMHTMLBaseFontElementFacePropertyInfo = "DOMHTMLBaseFontElement::face"
    attrGet _ = getDOMHTMLBaseFontElementFace
    attrSet _ = setDOMHTMLBaseFontElementFace
    attrConstruct _ = constructDOMHTMLBaseFontElementFace

-- VVV Prop "size"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLBaseFontElementSize :: (MonadIO m, DOMHTMLBaseFontElementK o) => o -> m Int64
getDOMHTMLBaseFontElementSize obj = liftIO $ getObjectPropertyInt64 obj "size"

setDOMHTMLBaseFontElementSize :: (MonadIO m, DOMHTMLBaseFontElementK o) => o -> Int64 -> m ()
setDOMHTMLBaseFontElementSize obj val = liftIO $ setObjectPropertyInt64 obj "size" val

constructDOMHTMLBaseFontElementSize :: Int64 -> IO ([Char], GValue)
constructDOMHTMLBaseFontElementSize val = constructObjectPropertyInt64 "size" val

data DOMHTMLBaseFontElementSizePropertyInfo
instance AttrInfo DOMHTMLBaseFontElementSizePropertyInfo where
    type AttrAllowedOps DOMHTMLBaseFontElementSizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLBaseFontElementSizePropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLBaseFontElementSizePropertyInfo = DOMHTMLBaseFontElementK
    type AttrGetType DOMHTMLBaseFontElementSizePropertyInfo = Int64
    type AttrLabel DOMHTMLBaseFontElementSizePropertyInfo = "DOMHTMLBaseFontElement::size"
    attrGet _ = getDOMHTMLBaseFontElementSize
    attrSet _ = setDOMHTMLBaseFontElementSize
    attrConstruct _ = constructDOMHTMLBaseFontElementSize

type instance AttributeList DOMHTMLBaseFontElement = DOMHTMLBaseFontElementAttributeList
type DOMHTMLBaseFontElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("color", DOMHTMLBaseFontElementColorPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("face", DOMHTMLBaseFontElementFacePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("size", DOMHTMLBaseFontElementSizePropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLBaseFontElement = DOMHTMLBaseFontElementSignalList
type DOMHTMLBaseFontElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLBaseFontElement::get_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_base_font_element_get_color" webkit_dom_html_base_font_element_get_color :: 
    Ptr DOMHTMLBaseFontElement ->           -- _obj : TInterface "WebKit" "DOMHTMLBaseFontElement"
    IO CString


dOMHTMLBaseFontElementGetColor ::
    (MonadIO m, DOMHTMLBaseFontElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLBaseFontElementGetColor _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_base_font_element_get_color _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_base_font_element_get_color" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLBaseFontElement::get_face
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_base_font_element_get_face" webkit_dom_html_base_font_element_get_face :: 
    Ptr DOMHTMLBaseFontElement ->           -- _obj : TInterface "WebKit" "DOMHTMLBaseFontElement"
    IO CString


dOMHTMLBaseFontElementGetFace ::
    (MonadIO m, DOMHTMLBaseFontElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLBaseFontElementGetFace _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_base_font_element_get_face _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_base_font_element_get_face" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLBaseFontElement::get_size
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_base_font_element_get_size" webkit_dom_html_base_font_element_get_size :: 
    Ptr DOMHTMLBaseFontElement ->           -- _obj : TInterface "WebKit" "DOMHTMLBaseFontElement"
    IO Int64


dOMHTMLBaseFontElementGetSize ::
    (MonadIO m, DOMHTMLBaseFontElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLBaseFontElementGetSize _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_base_font_element_get_size _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLBaseFontElement::set_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_base_font_element_set_color" webkit_dom_html_base_font_element_set_color :: 
    Ptr DOMHTMLBaseFontElement ->           -- _obj : TInterface "WebKit" "DOMHTMLBaseFontElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLBaseFontElementSetColor ::
    (MonadIO m, DOMHTMLBaseFontElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLBaseFontElementSetColor _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_base_font_element_set_color _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLBaseFontElement::set_face
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_base_font_element_set_face" webkit_dom_html_base_font_element_set_face :: 
    Ptr DOMHTMLBaseFontElement ->           -- _obj : TInterface "WebKit" "DOMHTMLBaseFontElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLBaseFontElementSetFace ::
    (MonadIO m, DOMHTMLBaseFontElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLBaseFontElementSetFace _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_base_font_element_set_face _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLBaseFontElement::set_size
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLBaseFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_base_font_element_set_size" webkit_dom_html_base_font_element_set_size :: 
    Ptr DOMHTMLBaseFontElement ->           -- _obj : TInterface "WebKit" "DOMHTMLBaseFontElement"
    Int64 ->                                -- value : TBasicType TInt64
    IO ()


dOMHTMLBaseFontElementSetSize ::
    (MonadIO m, DOMHTMLBaseFontElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLBaseFontElementSetSize _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_base_font_element_set_size _obj' value
    touchManagedPtr _obj
    return ()


