
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLButtonElement
    ( 

-- * Exported types
    DOMHTMLButtonElement(..)                ,
    DOMHTMLButtonElementK                   ,
    toDOMHTMLButtonElement                  ,
    noDOMHTMLButtonElement                  ,


 -- * Methods
-- ** dOMHTMLButtonElementCheckValidity
    dOMHTMLButtonElementCheckValidity       ,


-- ** dOMHTMLButtonElementGetAutofocus
    dOMHTMLButtonElementGetAutofocus        ,


-- ** dOMHTMLButtonElementGetDisabled
    dOMHTMLButtonElementGetDisabled         ,


-- ** dOMHTMLButtonElementGetForm
    dOMHTMLButtonElementGetForm             ,


-- ** dOMHTMLButtonElementGetFormAction
    dOMHTMLButtonElementGetFormAction       ,


-- ** dOMHTMLButtonElementGetFormEnctype
    dOMHTMLButtonElementGetFormEnctype      ,


-- ** dOMHTMLButtonElementGetFormMethod
    dOMHTMLButtonElementGetFormMethod       ,


-- ** dOMHTMLButtonElementGetFormNoValidate
    dOMHTMLButtonElementGetFormNoValidate   ,


-- ** dOMHTMLButtonElementGetFormTarget
    dOMHTMLButtonElementGetFormTarget       ,


-- ** dOMHTMLButtonElementGetLabels
    dOMHTMLButtonElementGetLabels           ,


-- ** dOMHTMLButtonElementGetName
    dOMHTMLButtonElementGetName             ,


-- ** dOMHTMLButtonElementGetValidationMessage
    dOMHTMLButtonElementGetValidationMessage,


-- ** dOMHTMLButtonElementGetValidity
    dOMHTMLButtonElementGetValidity         ,


-- ** dOMHTMLButtonElementGetValue
    dOMHTMLButtonElementGetValue            ,


-- ** dOMHTMLButtonElementGetWillValidate
    dOMHTMLButtonElementGetWillValidate     ,


-- ** dOMHTMLButtonElementSetAutofocus
    dOMHTMLButtonElementSetAutofocus        ,


-- ** dOMHTMLButtonElementSetCustomValidity
    dOMHTMLButtonElementSetCustomValidity   ,


-- ** dOMHTMLButtonElementSetDisabled
    dOMHTMLButtonElementSetDisabled         ,


-- ** dOMHTMLButtonElementSetFormAction
    dOMHTMLButtonElementSetFormAction       ,


-- ** dOMHTMLButtonElementSetFormEnctype
    dOMHTMLButtonElementSetFormEnctype      ,


-- ** dOMHTMLButtonElementSetFormMethod
    dOMHTMLButtonElementSetFormMethod       ,


-- ** dOMHTMLButtonElementSetFormNoValidate
    dOMHTMLButtonElementSetFormNoValidate   ,


-- ** dOMHTMLButtonElementSetFormTarget
    dOMHTMLButtonElementSetFormTarget       ,


-- ** dOMHTMLButtonElementSetName
    dOMHTMLButtonElementSetName             ,


-- ** dOMHTMLButtonElementSetValue
    dOMHTMLButtonElementSetValue            ,




 -- * Properties
-- ** Autofocus
    DOMHTMLButtonElementAutofocusPropertyInfo,
    constructDOMHTMLButtonElementAutofocus  ,
    getDOMHTMLButtonElementAutofocus        ,
    setDOMHTMLButtonElementAutofocus        ,


-- ** Disabled
    DOMHTMLButtonElementDisabledPropertyInfo,
    constructDOMHTMLButtonElementDisabled   ,
    getDOMHTMLButtonElementDisabled         ,
    setDOMHTMLButtonElementDisabled         ,


-- ** Form
    DOMHTMLButtonElementFormPropertyInfo    ,
    getDOMHTMLButtonElementForm             ,


-- ** FormAction
    DOMHTMLButtonElementFormActionPropertyInfo,
    constructDOMHTMLButtonElementFormAction ,
    getDOMHTMLButtonElementFormAction       ,
    setDOMHTMLButtonElementFormAction       ,


-- ** FormEnctype
    DOMHTMLButtonElementFormEnctypePropertyInfo,
    constructDOMHTMLButtonElementFormEnctype,
    getDOMHTMLButtonElementFormEnctype      ,
    setDOMHTMLButtonElementFormEnctype      ,


-- ** FormMethod
    DOMHTMLButtonElementFormMethodPropertyInfo,
    constructDOMHTMLButtonElementFormMethod ,
    getDOMHTMLButtonElementFormMethod       ,
    setDOMHTMLButtonElementFormMethod       ,


-- ** FormNoValidate
    DOMHTMLButtonElementFormNoValidatePropertyInfo,
    constructDOMHTMLButtonElementFormNoValidate,
    getDOMHTMLButtonElementFormNoValidate   ,
    setDOMHTMLButtonElementFormNoValidate   ,


-- ** FormTarget
    DOMHTMLButtonElementFormTargetPropertyInfo,
    constructDOMHTMLButtonElementFormTarget ,
    getDOMHTMLButtonElementFormTarget       ,
    setDOMHTMLButtonElementFormTarget       ,


-- ** Labels
    DOMHTMLButtonElementLabelsPropertyInfo  ,
    getDOMHTMLButtonElementLabels           ,


-- ** Name
    DOMHTMLButtonElementNamePropertyInfo    ,
    constructDOMHTMLButtonElementName       ,
    getDOMHTMLButtonElementName             ,
    setDOMHTMLButtonElementName             ,


-- ** Type
    DOMHTMLButtonElementTypePropertyInfo    ,
    constructDOMHTMLButtonElementType       ,
    getDOMHTMLButtonElementType             ,
    setDOMHTMLButtonElementType             ,


-- ** ValidationMessage
    DOMHTMLButtonElementValidationMessagePropertyInfo,
    getDOMHTMLButtonElementValidationMessage,


-- ** Validity
    DOMHTMLButtonElementValidityPropertyInfo,
    getDOMHTMLButtonElementValidity         ,


-- ** Value
    DOMHTMLButtonElementValuePropertyInfo   ,
    constructDOMHTMLButtonElementValue      ,
    getDOMHTMLButtonElementValue            ,
    setDOMHTMLButtonElementValue            ,


-- ** WillValidate
    DOMHTMLButtonElementWillValidatePropertyInfo,
    getDOMHTMLButtonElementWillValidate     ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLButtonElement = DOMHTMLButtonElement (ForeignPtr DOMHTMLButtonElement)
foreign import ccall "webkit_dom_html_button_element_get_type"
    c_webkit_dom_html_button_element_get_type :: IO GType

type instance ParentTypes DOMHTMLButtonElement = DOMHTMLButtonElementParentTypes
type DOMHTMLButtonElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLButtonElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_button_element_get_type
    

class GObject o => DOMHTMLButtonElementK o
instance (GObject o, IsDescendantOf DOMHTMLButtonElement o) => DOMHTMLButtonElementK o

toDOMHTMLButtonElement :: DOMHTMLButtonElementK o => o -> IO DOMHTMLButtonElement
toDOMHTMLButtonElement = unsafeCastTo DOMHTMLButtonElement

noDOMHTMLButtonElement :: Maybe DOMHTMLButtonElement
noDOMHTMLButtonElement = Nothing

-- VVV Prop "autofocus"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLButtonElementAutofocus :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m Bool
getDOMHTMLButtonElementAutofocus obj = liftIO $ getObjectPropertyBool obj "autofocus"

setDOMHTMLButtonElementAutofocus :: (MonadIO m, DOMHTMLButtonElementK o) => o -> Bool -> m ()
setDOMHTMLButtonElementAutofocus obj val = liftIO $ setObjectPropertyBool obj "autofocus" val

constructDOMHTMLButtonElementAutofocus :: Bool -> IO ([Char], GValue)
constructDOMHTMLButtonElementAutofocus val = constructObjectPropertyBool "autofocus" val

data DOMHTMLButtonElementAutofocusPropertyInfo
instance AttrInfo DOMHTMLButtonElementAutofocusPropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementAutofocusPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementAutofocusPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLButtonElementAutofocusPropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementAutofocusPropertyInfo = Bool
    type AttrLabel DOMHTMLButtonElementAutofocusPropertyInfo = "DOMHTMLButtonElement::autofocus"
    attrGet _ = getDOMHTMLButtonElementAutofocus
    attrSet _ = setDOMHTMLButtonElementAutofocus
    attrConstruct _ = constructDOMHTMLButtonElementAutofocus

-- VVV Prop "disabled"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLButtonElementDisabled :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m Bool
getDOMHTMLButtonElementDisabled obj = liftIO $ getObjectPropertyBool obj "disabled"

setDOMHTMLButtonElementDisabled :: (MonadIO m, DOMHTMLButtonElementK o) => o -> Bool -> m ()
setDOMHTMLButtonElementDisabled obj val = liftIO $ setObjectPropertyBool obj "disabled" val

constructDOMHTMLButtonElementDisabled :: Bool -> IO ([Char], GValue)
constructDOMHTMLButtonElementDisabled val = constructObjectPropertyBool "disabled" val

data DOMHTMLButtonElementDisabledPropertyInfo
instance AttrInfo DOMHTMLButtonElementDisabledPropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementDisabledPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementDisabledPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLButtonElementDisabledPropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementDisabledPropertyInfo = Bool
    type AttrLabel DOMHTMLButtonElementDisabledPropertyInfo = "DOMHTMLButtonElement::disabled"
    attrGet _ = getDOMHTMLButtonElementDisabled
    attrSet _ = setDOMHTMLButtonElementDisabled
    attrConstruct _ = constructDOMHTMLButtonElementDisabled

-- VVV Prop "form"
   -- Type: TInterface "WebKit" "DOMHTMLFormElement"
   -- Flags: [PropertyReadable]

getDOMHTMLButtonElementForm :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m DOMHTMLFormElement
getDOMHTMLButtonElementForm obj = liftIO $ getObjectPropertyObject obj "form" DOMHTMLFormElement

data DOMHTMLButtonElementFormPropertyInfo
instance AttrInfo DOMHTMLButtonElementFormPropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementFormPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementFormPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLButtonElementFormPropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementFormPropertyInfo = DOMHTMLFormElement
    type AttrLabel DOMHTMLButtonElementFormPropertyInfo = "DOMHTMLButtonElement::form"
    attrGet _ = getDOMHTMLButtonElementForm
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "form-action"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLButtonElementFormAction :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m T.Text
getDOMHTMLButtonElementFormAction obj = liftIO $ getObjectPropertyString obj "form-action"

setDOMHTMLButtonElementFormAction :: (MonadIO m, DOMHTMLButtonElementK o) => o -> T.Text -> m ()
setDOMHTMLButtonElementFormAction obj val = liftIO $ setObjectPropertyString obj "form-action" val

constructDOMHTMLButtonElementFormAction :: T.Text -> IO ([Char], GValue)
constructDOMHTMLButtonElementFormAction val = constructObjectPropertyString "form-action" val

data DOMHTMLButtonElementFormActionPropertyInfo
instance AttrInfo DOMHTMLButtonElementFormActionPropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementFormActionPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementFormActionPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLButtonElementFormActionPropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementFormActionPropertyInfo = T.Text
    type AttrLabel DOMHTMLButtonElementFormActionPropertyInfo = "DOMHTMLButtonElement::form-action"
    attrGet _ = getDOMHTMLButtonElementFormAction
    attrSet _ = setDOMHTMLButtonElementFormAction
    attrConstruct _ = constructDOMHTMLButtonElementFormAction

-- VVV Prop "form-enctype"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLButtonElementFormEnctype :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m T.Text
getDOMHTMLButtonElementFormEnctype obj = liftIO $ getObjectPropertyString obj "form-enctype"

setDOMHTMLButtonElementFormEnctype :: (MonadIO m, DOMHTMLButtonElementK o) => o -> T.Text -> m ()
setDOMHTMLButtonElementFormEnctype obj val = liftIO $ setObjectPropertyString obj "form-enctype" val

constructDOMHTMLButtonElementFormEnctype :: T.Text -> IO ([Char], GValue)
constructDOMHTMLButtonElementFormEnctype val = constructObjectPropertyString "form-enctype" val

data DOMHTMLButtonElementFormEnctypePropertyInfo
instance AttrInfo DOMHTMLButtonElementFormEnctypePropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementFormEnctypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementFormEnctypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLButtonElementFormEnctypePropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementFormEnctypePropertyInfo = T.Text
    type AttrLabel DOMHTMLButtonElementFormEnctypePropertyInfo = "DOMHTMLButtonElement::form-enctype"
    attrGet _ = getDOMHTMLButtonElementFormEnctype
    attrSet _ = setDOMHTMLButtonElementFormEnctype
    attrConstruct _ = constructDOMHTMLButtonElementFormEnctype

-- VVV Prop "form-method"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLButtonElementFormMethod :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m T.Text
getDOMHTMLButtonElementFormMethod obj = liftIO $ getObjectPropertyString obj "form-method"

setDOMHTMLButtonElementFormMethod :: (MonadIO m, DOMHTMLButtonElementK o) => o -> T.Text -> m ()
setDOMHTMLButtonElementFormMethod obj val = liftIO $ setObjectPropertyString obj "form-method" val

constructDOMHTMLButtonElementFormMethod :: T.Text -> IO ([Char], GValue)
constructDOMHTMLButtonElementFormMethod val = constructObjectPropertyString "form-method" val

data DOMHTMLButtonElementFormMethodPropertyInfo
instance AttrInfo DOMHTMLButtonElementFormMethodPropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementFormMethodPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementFormMethodPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLButtonElementFormMethodPropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementFormMethodPropertyInfo = T.Text
    type AttrLabel DOMHTMLButtonElementFormMethodPropertyInfo = "DOMHTMLButtonElement::form-method"
    attrGet _ = getDOMHTMLButtonElementFormMethod
    attrSet _ = setDOMHTMLButtonElementFormMethod
    attrConstruct _ = constructDOMHTMLButtonElementFormMethod

-- VVV Prop "form-no-validate"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLButtonElementFormNoValidate :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m Bool
getDOMHTMLButtonElementFormNoValidate obj = liftIO $ getObjectPropertyBool obj "form-no-validate"

setDOMHTMLButtonElementFormNoValidate :: (MonadIO m, DOMHTMLButtonElementK o) => o -> Bool -> m ()
setDOMHTMLButtonElementFormNoValidate obj val = liftIO $ setObjectPropertyBool obj "form-no-validate" val

constructDOMHTMLButtonElementFormNoValidate :: Bool -> IO ([Char], GValue)
constructDOMHTMLButtonElementFormNoValidate val = constructObjectPropertyBool "form-no-validate" val

data DOMHTMLButtonElementFormNoValidatePropertyInfo
instance AttrInfo DOMHTMLButtonElementFormNoValidatePropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementFormNoValidatePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementFormNoValidatePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLButtonElementFormNoValidatePropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementFormNoValidatePropertyInfo = Bool
    type AttrLabel DOMHTMLButtonElementFormNoValidatePropertyInfo = "DOMHTMLButtonElement::form-no-validate"
    attrGet _ = getDOMHTMLButtonElementFormNoValidate
    attrSet _ = setDOMHTMLButtonElementFormNoValidate
    attrConstruct _ = constructDOMHTMLButtonElementFormNoValidate

-- VVV Prop "form-target"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLButtonElementFormTarget :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m T.Text
getDOMHTMLButtonElementFormTarget obj = liftIO $ getObjectPropertyString obj "form-target"

setDOMHTMLButtonElementFormTarget :: (MonadIO m, DOMHTMLButtonElementK o) => o -> T.Text -> m ()
setDOMHTMLButtonElementFormTarget obj val = liftIO $ setObjectPropertyString obj "form-target" val

constructDOMHTMLButtonElementFormTarget :: T.Text -> IO ([Char], GValue)
constructDOMHTMLButtonElementFormTarget val = constructObjectPropertyString "form-target" val

data DOMHTMLButtonElementFormTargetPropertyInfo
instance AttrInfo DOMHTMLButtonElementFormTargetPropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementFormTargetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementFormTargetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLButtonElementFormTargetPropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementFormTargetPropertyInfo = T.Text
    type AttrLabel DOMHTMLButtonElementFormTargetPropertyInfo = "DOMHTMLButtonElement::form-target"
    attrGet _ = getDOMHTMLButtonElementFormTarget
    attrSet _ = setDOMHTMLButtonElementFormTarget
    attrConstruct _ = constructDOMHTMLButtonElementFormTarget

-- VVV Prop "labels"
   -- Type: TInterface "WebKit" "DOMNodeList"
   -- Flags: [PropertyReadable]

getDOMHTMLButtonElementLabels :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m DOMNodeList
getDOMHTMLButtonElementLabels obj = liftIO $ getObjectPropertyObject obj "labels" DOMNodeList

data DOMHTMLButtonElementLabelsPropertyInfo
instance AttrInfo DOMHTMLButtonElementLabelsPropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementLabelsPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementLabelsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLButtonElementLabelsPropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementLabelsPropertyInfo = DOMNodeList
    type AttrLabel DOMHTMLButtonElementLabelsPropertyInfo = "DOMHTMLButtonElement::labels"
    attrGet _ = getDOMHTMLButtonElementLabels
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLButtonElementName :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m T.Text
getDOMHTMLButtonElementName obj = liftIO $ getObjectPropertyString obj "name"

setDOMHTMLButtonElementName :: (MonadIO m, DOMHTMLButtonElementK o) => o -> T.Text -> m ()
setDOMHTMLButtonElementName obj val = liftIO $ setObjectPropertyString obj "name" val

constructDOMHTMLButtonElementName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLButtonElementName val = constructObjectPropertyString "name" val

data DOMHTMLButtonElementNamePropertyInfo
instance AttrInfo DOMHTMLButtonElementNamePropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLButtonElementNamePropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLButtonElementNamePropertyInfo = "DOMHTMLButtonElement::name"
    attrGet _ = getDOMHTMLButtonElementName
    attrSet _ = setDOMHTMLButtonElementName
    attrConstruct _ = constructDOMHTMLButtonElementName

-- VVV Prop "type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLButtonElementType :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m T.Text
getDOMHTMLButtonElementType obj = liftIO $ getObjectPropertyString obj "type"

setDOMHTMLButtonElementType :: (MonadIO m, DOMHTMLButtonElementK o) => o -> T.Text -> m ()
setDOMHTMLButtonElementType obj val = liftIO $ setObjectPropertyString obj "type" val

constructDOMHTMLButtonElementType :: T.Text -> IO ([Char], GValue)
constructDOMHTMLButtonElementType val = constructObjectPropertyString "type" val

data DOMHTMLButtonElementTypePropertyInfo
instance AttrInfo DOMHTMLButtonElementTypePropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementTypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementTypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLButtonElementTypePropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLButtonElementTypePropertyInfo = "DOMHTMLButtonElement::type"
    attrGet _ = getDOMHTMLButtonElementType
    attrSet _ = setDOMHTMLButtonElementType
    attrConstruct _ = constructDOMHTMLButtonElementType

-- VVV Prop "validation-message"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLButtonElementValidationMessage :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m T.Text
getDOMHTMLButtonElementValidationMessage obj = liftIO $ getObjectPropertyString obj "validation-message"

data DOMHTMLButtonElementValidationMessagePropertyInfo
instance AttrInfo DOMHTMLButtonElementValidationMessagePropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementValidationMessagePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementValidationMessagePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLButtonElementValidationMessagePropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementValidationMessagePropertyInfo = T.Text
    type AttrLabel DOMHTMLButtonElementValidationMessagePropertyInfo = "DOMHTMLButtonElement::validation-message"
    attrGet _ = getDOMHTMLButtonElementValidationMessage
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "validity"
   -- Type: TInterface "WebKit" "DOMValidityState"
   -- Flags: [PropertyReadable]

getDOMHTMLButtonElementValidity :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m DOMValidityState
getDOMHTMLButtonElementValidity obj = liftIO $ getObjectPropertyObject obj "validity" DOMValidityState

data DOMHTMLButtonElementValidityPropertyInfo
instance AttrInfo DOMHTMLButtonElementValidityPropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementValidityPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementValidityPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLButtonElementValidityPropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementValidityPropertyInfo = DOMValidityState
    type AttrLabel DOMHTMLButtonElementValidityPropertyInfo = "DOMHTMLButtonElement::validity"
    attrGet _ = getDOMHTMLButtonElementValidity
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "value"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLButtonElementValue :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m T.Text
getDOMHTMLButtonElementValue obj = liftIO $ getObjectPropertyString obj "value"

setDOMHTMLButtonElementValue :: (MonadIO m, DOMHTMLButtonElementK o) => o -> T.Text -> m ()
setDOMHTMLButtonElementValue obj val = liftIO $ setObjectPropertyString obj "value" val

constructDOMHTMLButtonElementValue :: T.Text -> IO ([Char], GValue)
constructDOMHTMLButtonElementValue val = constructObjectPropertyString "value" val

data DOMHTMLButtonElementValuePropertyInfo
instance AttrInfo DOMHTMLButtonElementValuePropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementValuePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementValuePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLButtonElementValuePropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementValuePropertyInfo = T.Text
    type AttrLabel DOMHTMLButtonElementValuePropertyInfo = "DOMHTMLButtonElement::value"
    attrGet _ = getDOMHTMLButtonElementValue
    attrSet _ = setDOMHTMLButtonElementValue
    attrConstruct _ = constructDOMHTMLButtonElementValue

-- VVV Prop "will-validate"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMHTMLButtonElementWillValidate :: (MonadIO m, DOMHTMLButtonElementK o) => o -> m Bool
getDOMHTMLButtonElementWillValidate obj = liftIO $ getObjectPropertyBool obj "will-validate"

data DOMHTMLButtonElementWillValidatePropertyInfo
instance AttrInfo DOMHTMLButtonElementWillValidatePropertyInfo where
    type AttrAllowedOps DOMHTMLButtonElementWillValidatePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLButtonElementWillValidatePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLButtonElementWillValidatePropertyInfo = DOMHTMLButtonElementK
    type AttrGetType DOMHTMLButtonElementWillValidatePropertyInfo = Bool
    type AttrLabel DOMHTMLButtonElementWillValidatePropertyInfo = "DOMHTMLButtonElement::will-validate"
    attrGet _ = getDOMHTMLButtonElementWillValidate
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMHTMLButtonElement = DOMHTMLButtonElementAttributeList
type DOMHTMLButtonElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("autofocus", DOMHTMLButtonElementAutofocusPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("disabled", DOMHTMLButtonElementDisabledPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("form", DOMHTMLButtonElementFormPropertyInfo), '("form-action", DOMHTMLButtonElementFormActionPropertyInfo), '("form-enctype", DOMHTMLButtonElementFormEnctypePropertyInfo), '("form-method", DOMHTMLButtonElementFormMethodPropertyInfo), '("form-no-validate", DOMHTMLButtonElementFormNoValidatePropertyInfo), '("form-target", DOMHTMLButtonElementFormTargetPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("labels", DOMHTMLButtonElementLabelsPropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("name", DOMHTMLButtonElementNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("type", DOMHTMLButtonElementTypePropertyInfo), '("validation-message", DOMHTMLButtonElementValidationMessagePropertyInfo), '("validity", DOMHTMLButtonElementValidityPropertyInfo), '("value", DOMHTMLButtonElementValuePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("will-validate", DOMHTMLButtonElementWillValidatePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLButtonElement = DOMHTMLButtonElementSignalList
type DOMHTMLButtonElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLButtonElement::check_validity
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_check_validity" webkit_dom_html_button_element_check_validity :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO CInt


dOMHTMLButtonElementCheckValidity ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLButtonElementCheckValidity _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_check_validity _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_autofocus
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_autofocus" webkit_dom_html_button_element_get_autofocus :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO CInt


dOMHTMLButtonElementGetAutofocus ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLButtonElementGetAutofocus _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_autofocus _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_disabled" webkit_dom_html_button_element_get_disabled :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO CInt


dOMHTMLButtonElementGetDisabled ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLButtonElementGetDisabled _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_disabled _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_form
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLFormElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_form" webkit_dom_html_button_element_get_form :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO (Ptr DOMHTMLFormElement)


dOMHTMLButtonElementGetForm ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLFormElement
dOMHTMLButtonElementGetForm _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_form _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_button_element_get_form" result
    result' <- (newObject DOMHTMLFormElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_form_action
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_form_action" webkit_dom_html_button_element_get_form_action :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO CString


dOMHTMLButtonElementGetFormAction ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLButtonElementGetFormAction _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_form_action _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_button_element_get_form_action" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_form_enctype
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_form_enctype" webkit_dom_html_button_element_get_form_enctype :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO CString


dOMHTMLButtonElementGetFormEnctype ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLButtonElementGetFormEnctype _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_form_enctype _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_button_element_get_form_enctype" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_form_method
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_form_method" webkit_dom_html_button_element_get_form_method :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO CString


dOMHTMLButtonElementGetFormMethod ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLButtonElementGetFormMethod _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_form_method _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_button_element_get_form_method" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_form_no_validate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_form_no_validate" webkit_dom_html_button_element_get_form_no_validate :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO CInt


dOMHTMLButtonElementGetFormNoValidate ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLButtonElementGetFormNoValidate _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_form_no_validate _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_form_target
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_form_target" webkit_dom_html_button_element_get_form_target :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO CString


dOMHTMLButtonElementGetFormTarget ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLButtonElementGetFormTarget _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_form_target _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_button_element_get_form_target" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_labels
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNodeList"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_labels" webkit_dom_html_button_element_get_labels :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO (Ptr DOMNodeList)


dOMHTMLButtonElementGetLabels ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m DOMNodeList
dOMHTMLButtonElementGetLabels _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_labels _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_button_element_get_labels" result
    result' <- (wrapObject DOMNodeList) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_name" webkit_dom_html_button_element_get_name :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO CString


dOMHTMLButtonElementGetName ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLButtonElementGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_button_element_get_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_validation_message
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_validation_message" webkit_dom_html_button_element_get_validation_message :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO CString


dOMHTMLButtonElementGetValidationMessage ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLButtonElementGetValidationMessage _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_validation_message _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_button_element_get_validation_message" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_validity
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMValidityState"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_validity" webkit_dom_html_button_element_get_validity :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO (Ptr DOMValidityState)


dOMHTMLButtonElementGetValidity ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m DOMValidityState
dOMHTMLButtonElementGetValidity _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_validity _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_button_element_get_validity" result
    result' <- (wrapObject DOMValidityState) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_value" webkit_dom_html_button_element_get_value :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO CString


dOMHTMLButtonElementGetValue ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLButtonElementGetValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_value _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_button_element_get_value" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::get_will_validate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_get_will_validate" webkit_dom_html_button_element_get_will_validate :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    IO CInt


dOMHTMLButtonElementGetWillValidate ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLButtonElementGetWillValidate _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_button_element_get_will_validate _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLButtonElement::set_autofocus
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_set_autofocus" webkit_dom_html_button_element_set_autofocus :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLButtonElementSetAutofocus ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLButtonElementSetAutofocus _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_button_element_set_autofocus _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLButtonElement::set_custom_validity
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "error", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "error", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_set_custom_validity" webkit_dom_html_button_element_set_custom_validity :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    CString ->                              -- error : TBasicType TUTF8
    IO ()


dOMHTMLButtonElementSetCustomValidity ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- error
    m ()
dOMHTMLButtonElementSetCustomValidity _obj error_ = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    error_' <- textToCString error_
    webkit_dom_html_button_element_set_custom_validity _obj' error_'
    touchManagedPtr _obj
    freeMem error_'
    return ()

-- method DOMHTMLButtonElement::set_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_set_disabled" webkit_dom_html_button_element_set_disabled :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLButtonElementSetDisabled ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLButtonElementSetDisabled _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_button_element_set_disabled _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLButtonElement::set_form_action
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_set_form_action" webkit_dom_html_button_element_set_form_action :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLButtonElementSetFormAction ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLButtonElementSetFormAction _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_button_element_set_form_action _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLButtonElement::set_form_enctype
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_set_form_enctype" webkit_dom_html_button_element_set_form_enctype :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLButtonElementSetFormEnctype ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLButtonElementSetFormEnctype _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_button_element_set_form_enctype _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLButtonElement::set_form_method
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_set_form_method" webkit_dom_html_button_element_set_form_method :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLButtonElementSetFormMethod ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLButtonElementSetFormMethod _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_button_element_set_form_method _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLButtonElement::set_form_no_validate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_set_form_no_validate" webkit_dom_html_button_element_set_form_no_validate :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLButtonElementSetFormNoValidate ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLButtonElementSetFormNoValidate _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_button_element_set_form_no_validate _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLButtonElement::set_form_target
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_set_form_target" webkit_dom_html_button_element_set_form_target :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLButtonElementSetFormTarget ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLButtonElementSetFormTarget _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_button_element_set_form_target _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLButtonElement::set_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_set_name" webkit_dom_html_button_element_set_name :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLButtonElementSetName ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLButtonElementSetName _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_button_element_set_name _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLButtonElement::set_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLButtonElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_button_element_set_value" webkit_dom_html_button_element_set_value :: 
    Ptr DOMHTMLButtonElement ->             -- _obj : TInterface "WebKit" "DOMHTMLButtonElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLButtonElementSetValue ::
    (MonadIO m, DOMHTMLButtonElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLButtonElementSetValue _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_button_element_set_value _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


