
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLCanvasElement
    ( 

-- * Exported types
    DOMHTMLCanvasElement(..)                ,
    DOMHTMLCanvasElementK                   ,
    toDOMHTMLCanvasElement                  ,
    noDOMHTMLCanvasElement                  ,


 -- * Methods
-- ** dOMHTMLCanvasElementGetHeight
    dOMHTMLCanvasElementGetHeight           ,


-- ** dOMHTMLCanvasElementGetWidth
    dOMHTMLCanvasElementGetWidth            ,


-- ** dOMHTMLCanvasElementSetHeight
    dOMHTMLCanvasElementSetHeight           ,


-- ** dOMHTMLCanvasElementSetWidth
    dOMHTMLCanvasElementSetWidth            ,




 -- * Properties
-- ** Height
    DOMHTMLCanvasElementHeightPropertyInfo  ,
    constructDOMHTMLCanvasElementHeight     ,
    getDOMHTMLCanvasElementHeight           ,
    setDOMHTMLCanvasElementHeight           ,


-- ** Width
    DOMHTMLCanvasElementWidthPropertyInfo   ,
    constructDOMHTMLCanvasElementWidth      ,
    getDOMHTMLCanvasElementWidth            ,
    setDOMHTMLCanvasElementWidth            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLCanvasElement = DOMHTMLCanvasElement (ForeignPtr DOMHTMLCanvasElement)
foreign import ccall "webkit_dom_html_canvas_element_get_type"
    c_webkit_dom_html_canvas_element_get_type :: IO GType

type instance ParentTypes DOMHTMLCanvasElement = DOMHTMLCanvasElementParentTypes
type DOMHTMLCanvasElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLCanvasElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_canvas_element_get_type
    

class GObject o => DOMHTMLCanvasElementK o
instance (GObject o, IsDescendantOf DOMHTMLCanvasElement o) => DOMHTMLCanvasElementK o

toDOMHTMLCanvasElement :: DOMHTMLCanvasElementK o => o -> IO DOMHTMLCanvasElement
toDOMHTMLCanvasElement = unsafeCastTo DOMHTMLCanvasElement

noDOMHTMLCanvasElement :: Maybe DOMHTMLCanvasElement
noDOMHTMLCanvasElement = Nothing

-- VVV Prop "height"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLCanvasElementHeight :: (MonadIO m, DOMHTMLCanvasElementK o) => o -> m Int64
getDOMHTMLCanvasElementHeight obj = liftIO $ getObjectPropertyInt64 obj "height"

setDOMHTMLCanvasElementHeight :: (MonadIO m, DOMHTMLCanvasElementK o) => o -> Int64 -> m ()
setDOMHTMLCanvasElementHeight obj val = liftIO $ setObjectPropertyInt64 obj "height" val

constructDOMHTMLCanvasElementHeight :: Int64 -> IO ([Char], GValue)
constructDOMHTMLCanvasElementHeight val = constructObjectPropertyInt64 "height" val

data DOMHTMLCanvasElementHeightPropertyInfo
instance AttrInfo DOMHTMLCanvasElementHeightPropertyInfo where
    type AttrAllowedOps DOMHTMLCanvasElementHeightPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLCanvasElementHeightPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLCanvasElementHeightPropertyInfo = DOMHTMLCanvasElementK
    type AttrGetType DOMHTMLCanvasElementHeightPropertyInfo = Int64
    type AttrLabel DOMHTMLCanvasElementHeightPropertyInfo = "DOMHTMLCanvasElement::height"
    attrGet _ = getDOMHTMLCanvasElementHeight
    attrSet _ = setDOMHTMLCanvasElementHeight
    attrConstruct _ = constructDOMHTMLCanvasElementHeight

-- VVV Prop "width"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLCanvasElementWidth :: (MonadIO m, DOMHTMLCanvasElementK o) => o -> m Int64
getDOMHTMLCanvasElementWidth obj = liftIO $ getObjectPropertyInt64 obj "width"

setDOMHTMLCanvasElementWidth :: (MonadIO m, DOMHTMLCanvasElementK o) => o -> Int64 -> m ()
setDOMHTMLCanvasElementWidth obj val = liftIO $ setObjectPropertyInt64 obj "width" val

constructDOMHTMLCanvasElementWidth :: Int64 -> IO ([Char], GValue)
constructDOMHTMLCanvasElementWidth val = constructObjectPropertyInt64 "width" val

data DOMHTMLCanvasElementWidthPropertyInfo
instance AttrInfo DOMHTMLCanvasElementWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLCanvasElementWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLCanvasElementWidthPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLCanvasElementWidthPropertyInfo = DOMHTMLCanvasElementK
    type AttrGetType DOMHTMLCanvasElementWidthPropertyInfo = Int64
    type AttrLabel DOMHTMLCanvasElementWidthPropertyInfo = "DOMHTMLCanvasElement::width"
    attrGet _ = getDOMHTMLCanvasElementWidth
    attrSet _ = setDOMHTMLCanvasElementWidth
    attrConstruct _ = constructDOMHTMLCanvasElementWidth

type instance AttributeList DOMHTMLCanvasElement = DOMHTMLCanvasElementAttributeList
type DOMHTMLCanvasElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("height", DOMHTMLCanvasElementHeightPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("width", DOMHTMLCanvasElementWidthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLCanvasElement = DOMHTMLCanvasElementSignalList
type DOMHTMLCanvasElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLCanvasElement::get_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLCanvasElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLCanvasElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_canvas_element_get_height" webkit_dom_html_canvas_element_get_height :: 
    Ptr DOMHTMLCanvasElement ->             -- _obj : TInterface "WebKit" "DOMHTMLCanvasElement"
    IO Int64


dOMHTMLCanvasElementGetHeight ::
    (MonadIO m, DOMHTMLCanvasElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLCanvasElementGetHeight _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_canvas_element_get_height _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLCanvasElement::get_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLCanvasElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLCanvasElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_canvas_element_get_width" webkit_dom_html_canvas_element_get_width :: 
    Ptr DOMHTMLCanvasElement ->             -- _obj : TInterface "WebKit" "DOMHTMLCanvasElement"
    IO Int64


dOMHTMLCanvasElementGetWidth ::
    (MonadIO m, DOMHTMLCanvasElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLCanvasElementGetWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_canvas_element_get_width _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLCanvasElement::set_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLCanvasElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLCanvasElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_canvas_element_set_height" webkit_dom_html_canvas_element_set_height :: 
    Ptr DOMHTMLCanvasElement ->             -- _obj : TInterface "WebKit" "DOMHTMLCanvasElement"
    Int64 ->                                -- value : TBasicType TInt64
    IO ()


dOMHTMLCanvasElementSetHeight ::
    (MonadIO m, DOMHTMLCanvasElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLCanvasElementSetHeight _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_canvas_element_set_height _obj' value
    touchManagedPtr _obj
    return ()

-- method DOMHTMLCanvasElement::set_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLCanvasElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLCanvasElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_canvas_element_set_width" webkit_dom_html_canvas_element_set_width :: 
    Ptr DOMHTMLCanvasElement ->             -- _obj : TInterface "WebKit" "DOMHTMLCanvasElement"
    Int64 ->                                -- value : TBasicType TInt64
    IO ()


dOMHTMLCanvasElementSetWidth ::
    (MonadIO m, DOMHTMLCanvasElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLCanvasElementSetWidth _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_canvas_element_set_width _obj' value
    touchManagedPtr _obj
    return ()


