
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLDetailsElement
    ( 

-- * Exported types
    DOMHTMLDetailsElement(..)               ,
    DOMHTMLDetailsElementK                  ,
    toDOMHTMLDetailsElement                 ,
    noDOMHTMLDetailsElement                 ,


 -- * Methods
-- ** dOMHTMLDetailsElementGetOpen
    dOMHTMLDetailsElementGetOpen            ,


-- ** dOMHTMLDetailsElementSetOpen
    dOMHTMLDetailsElementSetOpen            ,




 -- * Properties
-- ** Open
    DOMHTMLDetailsElementOpenPropertyInfo   ,
    constructDOMHTMLDetailsElementOpen      ,
    getDOMHTMLDetailsElementOpen            ,
    setDOMHTMLDetailsElementOpen            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLDetailsElement = DOMHTMLDetailsElement (ForeignPtr DOMHTMLDetailsElement)
foreign import ccall "webkit_dom_html_details_element_get_type"
    c_webkit_dom_html_details_element_get_type :: IO GType

type instance ParentTypes DOMHTMLDetailsElement = DOMHTMLDetailsElementParentTypes
type DOMHTMLDetailsElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLDetailsElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_details_element_get_type
    

class GObject o => DOMHTMLDetailsElementK o
instance (GObject o, IsDescendantOf DOMHTMLDetailsElement o) => DOMHTMLDetailsElementK o

toDOMHTMLDetailsElement :: DOMHTMLDetailsElementK o => o -> IO DOMHTMLDetailsElement
toDOMHTMLDetailsElement = unsafeCastTo DOMHTMLDetailsElement

noDOMHTMLDetailsElement :: Maybe DOMHTMLDetailsElement
noDOMHTMLDetailsElement = Nothing

-- VVV Prop "open"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLDetailsElementOpen :: (MonadIO m, DOMHTMLDetailsElementK o) => o -> m Bool
getDOMHTMLDetailsElementOpen obj = liftIO $ getObjectPropertyBool obj "open"

setDOMHTMLDetailsElementOpen :: (MonadIO m, DOMHTMLDetailsElementK o) => o -> Bool -> m ()
setDOMHTMLDetailsElementOpen obj val = liftIO $ setObjectPropertyBool obj "open" val

constructDOMHTMLDetailsElementOpen :: Bool -> IO ([Char], GValue)
constructDOMHTMLDetailsElementOpen val = constructObjectPropertyBool "open" val

data DOMHTMLDetailsElementOpenPropertyInfo
instance AttrInfo DOMHTMLDetailsElementOpenPropertyInfo where
    type AttrAllowedOps DOMHTMLDetailsElementOpenPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDetailsElementOpenPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLDetailsElementOpenPropertyInfo = DOMHTMLDetailsElementK
    type AttrGetType DOMHTMLDetailsElementOpenPropertyInfo = Bool
    type AttrLabel DOMHTMLDetailsElementOpenPropertyInfo = "DOMHTMLDetailsElement::open"
    attrGet _ = getDOMHTMLDetailsElementOpen
    attrSet _ = setDOMHTMLDetailsElementOpen
    attrConstruct _ = constructDOMHTMLDetailsElementOpen

type instance AttributeList DOMHTMLDetailsElement = DOMHTMLDetailsElementAttributeList
type DOMHTMLDetailsElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("open", DOMHTMLDetailsElementOpenPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLDetailsElement = DOMHTMLDetailsElementSignalList
type DOMHTMLDetailsElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLDetailsElement::get_open
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDetailsElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDetailsElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_details_element_get_open" webkit_dom_html_details_element_get_open :: 
    Ptr DOMHTMLDetailsElement ->            -- _obj : TInterface "WebKit" "DOMHTMLDetailsElement"
    IO CInt


dOMHTMLDetailsElementGetOpen ::
    (MonadIO m, DOMHTMLDetailsElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLDetailsElementGetOpen _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_details_element_get_open _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDetailsElement::set_open
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDetailsElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDetailsElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_details_element_set_open" webkit_dom_html_details_element_set_open :: 
    Ptr DOMHTMLDetailsElement ->            -- _obj : TInterface "WebKit" "DOMHTMLDetailsElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLDetailsElementSetOpen ::
    (MonadIO m, DOMHTMLDetailsElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLDetailsElementSetOpen _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_details_element_set_open _obj' value'
    touchManagedPtr _obj
    return ()


