
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLDivElement
    ( 

-- * Exported types
    DOMHTMLDivElement(..)                   ,
    DOMHTMLDivElementK                      ,
    toDOMHTMLDivElement                     ,
    noDOMHTMLDivElement                     ,


 -- * Methods
-- ** dOMHTMLDivElementGetAlign
    dOMHTMLDivElementGetAlign               ,


-- ** dOMHTMLDivElementSetAlign
    dOMHTMLDivElementSetAlign               ,




 -- * Properties
-- ** Align
    DOMHTMLDivElementAlignPropertyInfo      ,
    constructDOMHTMLDivElementAlign         ,
    getDOMHTMLDivElementAlign               ,
    setDOMHTMLDivElementAlign               ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLDivElement = DOMHTMLDivElement (ForeignPtr DOMHTMLDivElement)
foreign import ccall "webkit_dom_html_div_element_get_type"
    c_webkit_dom_html_div_element_get_type :: IO GType

type instance ParentTypes DOMHTMLDivElement = DOMHTMLDivElementParentTypes
type DOMHTMLDivElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLDivElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_div_element_get_type
    

class GObject o => DOMHTMLDivElementK o
instance (GObject o, IsDescendantOf DOMHTMLDivElement o) => DOMHTMLDivElementK o

toDOMHTMLDivElement :: DOMHTMLDivElementK o => o -> IO DOMHTMLDivElement
toDOMHTMLDivElement = unsafeCastTo DOMHTMLDivElement

noDOMHTMLDivElement :: Maybe DOMHTMLDivElement
noDOMHTMLDivElement = Nothing

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLDivElementAlign :: (MonadIO m, DOMHTMLDivElementK o) => o -> m T.Text
getDOMHTMLDivElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLDivElementAlign :: (MonadIO m, DOMHTMLDivElementK o) => o -> T.Text -> m ()
setDOMHTMLDivElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLDivElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLDivElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLDivElementAlignPropertyInfo
instance AttrInfo DOMHTMLDivElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLDivElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDivElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLDivElementAlignPropertyInfo = DOMHTMLDivElementK
    type AttrGetType DOMHTMLDivElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLDivElementAlignPropertyInfo = "DOMHTMLDivElement::align"
    attrGet _ = getDOMHTMLDivElementAlign
    attrSet _ = setDOMHTMLDivElementAlign
    attrConstruct _ = constructDOMHTMLDivElementAlign

type instance AttributeList DOMHTMLDivElement = DOMHTMLDivElementAttributeList
type DOMHTMLDivElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLDivElementAlignPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLDivElement = DOMHTMLDivElementSignalList
type DOMHTMLDivElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLDivElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDivElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDivElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_div_element_get_align" webkit_dom_html_div_element_get_align :: 
    Ptr DOMHTMLDivElement ->                -- _obj : TInterface "WebKit" "DOMHTMLDivElement"
    IO CString


dOMHTMLDivElementGetAlign ::
    (MonadIO m, DOMHTMLDivElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLDivElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_div_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_div_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDivElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDivElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDivElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_div_element_set_align" webkit_dom_html_div_element_set_align :: 
    Ptr DOMHTMLDivElement ->                -- _obj : TInterface "WebKit" "DOMHTMLDivElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLDivElementSetAlign ::
    (MonadIO m, DOMHTMLDivElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLDivElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_div_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


