
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLDocument
    ( 

-- * Exported types
    DOMHTMLDocument(..)                     ,
    DOMHTMLDocumentK                        ,
    toDOMHTMLDocument                       ,
    noDOMHTMLDocument                       ,


 -- * Methods
-- ** dOMHTMLDocumentCaptureEvents
    dOMHTMLDocumentCaptureEvents            ,


-- ** dOMHTMLDocumentClear
    dOMHTMLDocumentClear                    ,


-- ** dOMHTMLDocumentClose
    dOMHTMLDocumentClose                    ,


-- ** dOMHTMLDocumentGetActiveElement
    dOMHTMLDocumentGetActiveElement         ,


-- ** dOMHTMLDocumentGetAlinkColor
    dOMHTMLDocumentGetAlinkColor            ,


-- ** dOMHTMLDocumentGetBgColor
    dOMHTMLDocumentGetBgColor               ,


-- ** dOMHTMLDocumentGetCompatMode
    dOMHTMLDocumentGetCompatMode            ,


-- ** dOMHTMLDocumentGetDesignMode
    dOMHTMLDocumentGetDesignMode            ,


-- ** dOMHTMLDocumentGetDir
    dOMHTMLDocumentGetDir                   ,


-- ** dOMHTMLDocumentGetEmbeds
    dOMHTMLDocumentGetEmbeds                ,


-- ** dOMHTMLDocumentGetFgColor
    dOMHTMLDocumentGetFgColor               ,


-- ** dOMHTMLDocumentGetHeight
    dOMHTMLDocumentGetHeight                ,


-- ** dOMHTMLDocumentGetLinkColor
    dOMHTMLDocumentGetLinkColor             ,


-- ** dOMHTMLDocumentGetPlugins
    dOMHTMLDocumentGetPlugins               ,


-- ** dOMHTMLDocumentGetScripts
    dOMHTMLDocumentGetScripts               ,


-- ** dOMHTMLDocumentGetVlinkColor
    dOMHTMLDocumentGetVlinkColor            ,


-- ** dOMHTMLDocumentGetWidth
    dOMHTMLDocumentGetWidth                 ,


-- ** dOMHTMLDocumentHasFocus
    dOMHTMLDocumentHasFocus                 ,


-- ** dOMHTMLDocumentOpen
    dOMHTMLDocumentOpen                     ,


-- ** dOMHTMLDocumentReleaseEvents
    dOMHTMLDocumentReleaseEvents            ,


-- ** dOMHTMLDocumentSetAlinkColor
    dOMHTMLDocumentSetAlinkColor            ,


-- ** dOMHTMLDocumentSetBgColor
    dOMHTMLDocumentSetBgColor               ,


-- ** dOMHTMLDocumentSetDesignMode
    dOMHTMLDocumentSetDesignMode            ,


-- ** dOMHTMLDocumentSetDir
    dOMHTMLDocumentSetDir                   ,


-- ** dOMHTMLDocumentSetFgColor
    dOMHTMLDocumentSetFgColor               ,


-- ** dOMHTMLDocumentSetLinkColor
    dOMHTMLDocumentSetLinkColor             ,


-- ** dOMHTMLDocumentSetVlinkColor
    dOMHTMLDocumentSetVlinkColor            ,




 -- * Properties
-- ** ActiveElement
    DOMHTMLDocumentActiveElementPropertyInfo,
    getDOMHTMLDocumentActiveElement         ,


-- ** AlinkColor
    DOMHTMLDocumentAlinkColorPropertyInfo   ,
    constructDOMHTMLDocumentAlinkColor      ,
    getDOMHTMLDocumentAlinkColor            ,
    setDOMHTMLDocumentAlinkColor            ,


-- ** BgColor
    DOMHTMLDocumentBgColorPropertyInfo      ,
    constructDOMHTMLDocumentBgColor         ,
    getDOMHTMLDocumentBgColor               ,
    setDOMHTMLDocumentBgColor               ,


-- ** CompatMode
    DOMHTMLDocumentCompatModePropertyInfo   ,
    getDOMHTMLDocumentCompatMode            ,


-- ** DesignMode
    DOMHTMLDocumentDesignModePropertyInfo   ,
    constructDOMHTMLDocumentDesignMode      ,
    getDOMHTMLDocumentDesignMode            ,
    setDOMHTMLDocumentDesignMode            ,


-- ** Dir
    DOMHTMLDocumentDirPropertyInfo          ,
    constructDOMHTMLDocumentDir             ,
    getDOMHTMLDocumentDir                   ,
    setDOMHTMLDocumentDir                   ,


-- ** Embeds
    DOMHTMLDocumentEmbedsPropertyInfo       ,
    getDOMHTMLDocumentEmbeds                ,


-- ** FgColor
    DOMHTMLDocumentFgColorPropertyInfo      ,
    constructDOMHTMLDocumentFgColor         ,
    getDOMHTMLDocumentFgColor               ,
    setDOMHTMLDocumentFgColor               ,


-- ** Height
    DOMHTMLDocumentHeightPropertyInfo       ,
    getDOMHTMLDocumentHeight                ,


-- ** LinkColor
    DOMHTMLDocumentLinkColorPropertyInfo    ,
    constructDOMHTMLDocumentLinkColor       ,
    getDOMHTMLDocumentLinkColor             ,
    setDOMHTMLDocumentLinkColor             ,


-- ** Plugins
    DOMHTMLDocumentPluginsPropertyInfo      ,
    getDOMHTMLDocumentPlugins               ,


-- ** Scripts
    DOMHTMLDocumentScriptsPropertyInfo      ,
    getDOMHTMLDocumentScripts               ,


-- ** VlinkColor
    DOMHTMLDocumentVlinkColorPropertyInfo   ,
    constructDOMHTMLDocumentVlinkColor      ,
    getDOMHTMLDocumentVlinkColor            ,
    setDOMHTMLDocumentVlinkColor            ,


-- ** Width
    DOMHTMLDocumentWidthPropertyInfo        ,
    getDOMHTMLDocumentWidth                 ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLDocument = DOMHTMLDocument (ForeignPtr DOMHTMLDocument)
foreign import ccall "webkit_dom_html_document_get_type"
    c_webkit_dom_html_document_get_type :: IO GType

type instance ParentTypes DOMHTMLDocument = DOMHTMLDocumentParentTypes
type DOMHTMLDocumentParentTypes = '[DOMDocument, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLDocument where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_document_get_type
    

class GObject o => DOMHTMLDocumentK o
instance (GObject o, IsDescendantOf DOMHTMLDocument o) => DOMHTMLDocumentK o

toDOMHTMLDocument :: DOMHTMLDocumentK o => o -> IO DOMHTMLDocument
toDOMHTMLDocument = unsafeCastTo DOMHTMLDocument

noDOMHTMLDocument :: Maybe DOMHTMLDocument
noDOMHTMLDocument = Nothing

-- VVV Prop "active-element"
   -- Type: TInterface "WebKit" "DOMElement"
   -- Flags: [PropertyReadable]

getDOMHTMLDocumentActiveElement :: (MonadIO m, DOMHTMLDocumentK o) => o -> m DOMElement
getDOMHTMLDocumentActiveElement obj = liftIO $ getObjectPropertyObject obj "active-element" DOMElement

data DOMHTMLDocumentActiveElementPropertyInfo
instance AttrInfo DOMHTMLDocumentActiveElementPropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentActiveElementPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentActiveElementPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLDocumentActiveElementPropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentActiveElementPropertyInfo = DOMElement
    type AttrLabel DOMHTMLDocumentActiveElementPropertyInfo = "DOMHTMLDocument::active-element"
    attrGet _ = getDOMHTMLDocumentActiveElement
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "alink-color"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLDocumentAlinkColor :: (MonadIO m, DOMHTMLDocumentK o) => o -> m T.Text
getDOMHTMLDocumentAlinkColor obj = liftIO $ getObjectPropertyString obj "alink-color"

setDOMHTMLDocumentAlinkColor :: (MonadIO m, DOMHTMLDocumentK o) => o -> T.Text -> m ()
setDOMHTMLDocumentAlinkColor obj val = liftIO $ setObjectPropertyString obj "alink-color" val

constructDOMHTMLDocumentAlinkColor :: T.Text -> IO ([Char], GValue)
constructDOMHTMLDocumentAlinkColor val = constructObjectPropertyString "alink-color" val

data DOMHTMLDocumentAlinkColorPropertyInfo
instance AttrInfo DOMHTMLDocumentAlinkColorPropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentAlinkColorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentAlinkColorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLDocumentAlinkColorPropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentAlinkColorPropertyInfo = T.Text
    type AttrLabel DOMHTMLDocumentAlinkColorPropertyInfo = "DOMHTMLDocument::alink-color"
    attrGet _ = getDOMHTMLDocumentAlinkColor
    attrSet _ = setDOMHTMLDocumentAlinkColor
    attrConstruct _ = constructDOMHTMLDocumentAlinkColor

-- VVV Prop "bg-color"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLDocumentBgColor :: (MonadIO m, DOMHTMLDocumentK o) => o -> m T.Text
getDOMHTMLDocumentBgColor obj = liftIO $ getObjectPropertyString obj "bg-color"

setDOMHTMLDocumentBgColor :: (MonadIO m, DOMHTMLDocumentK o) => o -> T.Text -> m ()
setDOMHTMLDocumentBgColor obj val = liftIO $ setObjectPropertyString obj "bg-color" val

constructDOMHTMLDocumentBgColor :: T.Text -> IO ([Char], GValue)
constructDOMHTMLDocumentBgColor val = constructObjectPropertyString "bg-color" val

data DOMHTMLDocumentBgColorPropertyInfo
instance AttrInfo DOMHTMLDocumentBgColorPropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentBgColorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentBgColorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLDocumentBgColorPropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentBgColorPropertyInfo = T.Text
    type AttrLabel DOMHTMLDocumentBgColorPropertyInfo = "DOMHTMLDocument::bg-color"
    attrGet _ = getDOMHTMLDocumentBgColor
    attrSet _ = setDOMHTMLDocumentBgColor
    attrConstruct _ = constructDOMHTMLDocumentBgColor

-- VVV Prop "compat-mode"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLDocumentCompatMode :: (MonadIO m, DOMHTMLDocumentK o) => o -> m T.Text
getDOMHTMLDocumentCompatMode obj = liftIO $ getObjectPropertyString obj "compat-mode"

data DOMHTMLDocumentCompatModePropertyInfo
instance AttrInfo DOMHTMLDocumentCompatModePropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentCompatModePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentCompatModePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLDocumentCompatModePropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentCompatModePropertyInfo = T.Text
    type AttrLabel DOMHTMLDocumentCompatModePropertyInfo = "DOMHTMLDocument::compat-mode"
    attrGet _ = getDOMHTMLDocumentCompatMode
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "design-mode"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLDocumentDesignMode :: (MonadIO m, DOMHTMLDocumentK o) => o -> m T.Text
getDOMHTMLDocumentDesignMode obj = liftIO $ getObjectPropertyString obj "design-mode"

setDOMHTMLDocumentDesignMode :: (MonadIO m, DOMHTMLDocumentK o) => o -> T.Text -> m ()
setDOMHTMLDocumentDesignMode obj val = liftIO $ setObjectPropertyString obj "design-mode" val

constructDOMHTMLDocumentDesignMode :: T.Text -> IO ([Char], GValue)
constructDOMHTMLDocumentDesignMode val = constructObjectPropertyString "design-mode" val

data DOMHTMLDocumentDesignModePropertyInfo
instance AttrInfo DOMHTMLDocumentDesignModePropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentDesignModePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentDesignModePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLDocumentDesignModePropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentDesignModePropertyInfo = T.Text
    type AttrLabel DOMHTMLDocumentDesignModePropertyInfo = "DOMHTMLDocument::design-mode"
    attrGet _ = getDOMHTMLDocumentDesignMode
    attrSet _ = setDOMHTMLDocumentDesignMode
    attrConstruct _ = constructDOMHTMLDocumentDesignMode

-- VVV Prop "dir"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLDocumentDir :: (MonadIO m, DOMHTMLDocumentK o) => o -> m T.Text
getDOMHTMLDocumentDir obj = liftIO $ getObjectPropertyString obj "dir"

setDOMHTMLDocumentDir :: (MonadIO m, DOMHTMLDocumentK o) => o -> T.Text -> m ()
setDOMHTMLDocumentDir obj val = liftIO $ setObjectPropertyString obj "dir" val

constructDOMHTMLDocumentDir :: T.Text -> IO ([Char], GValue)
constructDOMHTMLDocumentDir val = constructObjectPropertyString "dir" val

data DOMHTMLDocumentDirPropertyInfo
instance AttrInfo DOMHTMLDocumentDirPropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentDirPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentDirPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLDocumentDirPropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentDirPropertyInfo = T.Text
    type AttrLabel DOMHTMLDocumentDirPropertyInfo = "DOMHTMLDocument::dir"
    attrGet _ = getDOMHTMLDocumentDir
    attrSet _ = setDOMHTMLDocumentDir
    attrConstruct _ = constructDOMHTMLDocumentDir

-- VVV Prop "embeds"
   -- Type: TInterface "WebKit" "DOMHTMLCollection"
   -- Flags: [PropertyReadable]

getDOMHTMLDocumentEmbeds :: (MonadIO m, DOMHTMLDocumentK o) => o -> m DOMHTMLCollection
getDOMHTMLDocumentEmbeds obj = liftIO $ getObjectPropertyObject obj "embeds" DOMHTMLCollection

data DOMHTMLDocumentEmbedsPropertyInfo
instance AttrInfo DOMHTMLDocumentEmbedsPropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentEmbedsPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentEmbedsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLDocumentEmbedsPropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentEmbedsPropertyInfo = DOMHTMLCollection
    type AttrLabel DOMHTMLDocumentEmbedsPropertyInfo = "DOMHTMLDocument::embeds"
    attrGet _ = getDOMHTMLDocumentEmbeds
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "fg-color"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLDocumentFgColor :: (MonadIO m, DOMHTMLDocumentK o) => o -> m T.Text
getDOMHTMLDocumentFgColor obj = liftIO $ getObjectPropertyString obj "fg-color"

setDOMHTMLDocumentFgColor :: (MonadIO m, DOMHTMLDocumentK o) => o -> T.Text -> m ()
setDOMHTMLDocumentFgColor obj val = liftIO $ setObjectPropertyString obj "fg-color" val

constructDOMHTMLDocumentFgColor :: T.Text -> IO ([Char], GValue)
constructDOMHTMLDocumentFgColor val = constructObjectPropertyString "fg-color" val

data DOMHTMLDocumentFgColorPropertyInfo
instance AttrInfo DOMHTMLDocumentFgColorPropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentFgColorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentFgColorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLDocumentFgColorPropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentFgColorPropertyInfo = T.Text
    type AttrLabel DOMHTMLDocumentFgColorPropertyInfo = "DOMHTMLDocument::fg-color"
    attrGet _ = getDOMHTMLDocumentFgColor
    attrSet _ = setDOMHTMLDocumentFgColor
    attrConstruct _ = constructDOMHTMLDocumentFgColor

-- VVV Prop "height"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable]

getDOMHTMLDocumentHeight :: (MonadIO m, DOMHTMLDocumentK o) => o -> m Int64
getDOMHTMLDocumentHeight obj = liftIO $ getObjectPropertyInt64 obj "height"

data DOMHTMLDocumentHeightPropertyInfo
instance AttrInfo DOMHTMLDocumentHeightPropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentHeightPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentHeightPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLDocumentHeightPropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentHeightPropertyInfo = Int64
    type AttrLabel DOMHTMLDocumentHeightPropertyInfo = "DOMHTMLDocument::height"
    attrGet _ = getDOMHTMLDocumentHeight
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "link-color"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLDocumentLinkColor :: (MonadIO m, DOMHTMLDocumentK o) => o -> m T.Text
getDOMHTMLDocumentLinkColor obj = liftIO $ getObjectPropertyString obj "link-color"

setDOMHTMLDocumentLinkColor :: (MonadIO m, DOMHTMLDocumentK o) => o -> T.Text -> m ()
setDOMHTMLDocumentLinkColor obj val = liftIO $ setObjectPropertyString obj "link-color" val

constructDOMHTMLDocumentLinkColor :: T.Text -> IO ([Char], GValue)
constructDOMHTMLDocumentLinkColor val = constructObjectPropertyString "link-color" val

data DOMHTMLDocumentLinkColorPropertyInfo
instance AttrInfo DOMHTMLDocumentLinkColorPropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentLinkColorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentLinkColorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLDocumentLinkColorPropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentLinkColorPropertyInfo = T.Text
    type AttrLabel DOMHTMLDocumentLinkColorPropertyInfo = "DOMHTMLDocument::link-color"
    attrGet _ = getDOMHTMLDocumentLinkColor
    attrSet _ = setDOMHTMLDocumentLinkColor
    attrConstruct _ = constructDOMHTMLDocumentLinkColor

-- VVV Prop "plugins"
   -- Type: TInterface "WebKit" "DOMHTMLCollection"
   -- Flags: [PropertyReadable]

getDOMHTMLDocumentPlugins :: (MonadIO m, DOMHTMLDocumentK o) => o -> m DOMHTMLCollection
getDOMHTMLDocumentPlugins obj = liftIO $ getObjectPropertyObject obj "plugins" DOMHTMLCollection

data DOMHTMLDocumentPluginsPropertyInfo
instance AttrInfo DOMHTMLDocumentPluginsPropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentPluginsPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentPluginsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLDocumentPluginsPropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentPluginsPropertyInfo = DOMHTMLCollection
    type AttrLabel DOMHTMLDocumentPluginsPropertyInfo = "DOMHTMLDocument::plugins"
    attrGet _ = getDOMHTMLDocumentPlugins
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "scripts"
   -- Type: TInterface "WebKit" "DOMHTMLCollection"
   -- Flags: [PropertyReadable]

getDOMHTMLDocumentScripts :: (MonadIO m, DOMHTMLDocumentK o) => o -> m DOMHTMLCollection
getDOMHTMLDocumentScripts obj = liftIO $ getObjectPropertyObject obj "scripts" DOMHTMLCollection

data DOMHTMLDocumentScriptsPropertyInfo
instance AttrInfo DOMHTMLDocumentScriptsPropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentScriptsPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentScriptsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLDocumentScriptsPropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentScriptsPropertyInfo = DOMHTMLCollection
    type AttrLabel DOMHTMLDocumentScriptsPropertyInfo = "DOMHTMLDocument::scripts"
    attrGet _ = getDOMHTMLDocumentScripts
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "vlink-color"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLDocumentVlinkColor :: (MonadIO m, DOMHTMLDocumentK o) => o -> m T.Text
getDOMHTMLDocumentVlinkColor obj = liftIO $ getObjectPropertyString obj "vlink-color"

setDOMHTMLDocumentVlinkColor :: (MonadIO m, DOMHTMLDocumentK o) => o -> T.Text -> m ()
setDOMHTMLDocumentVlinkColor obj val = liftIO $ setObjectPropertyString obj "vlink-color" val

constructDOMHTMLDocumentVlinkColor :: T.Text -> IO ([Char], GValue)
constructDOMHTMLDocumentVlinkColor val = constructObjectPropertyString "vlink-color" val

data DOMHTMLDocumentVlinkColorPropertyInfo
instance AttrInfo DOMHTMLDocumentVlinkColorPropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentVlinkColorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentVlinkColorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLDocumentVlinkColorPropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentVlinkColorPropertyInfo = T.Text
    type AttrLabel DOMHTMLDocumentVlinkColorPropertyInfo = "DOMHTMLDocument::vlink-color"
    attrGet _ = getDOMHTMLDocumentVlinkColor
    attrSet _ = setDOMHTMLDocumentVlinkColor
    attrConstruct _ = constructDOMHTMLDocumentVlinkColor

-- VVV Prop "width"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable]

getDOMHTMLDocumentWidth :: (MonadIO m, DOMHTMLDocumentK o) => o -> m Int64
getDOMHTMLDocumentWidth obj = liftIO $ getObjectPropertyInt64 obj "width"

data DOMHTMLDocumentWidthPropertyInfo
instance AttrInfo DOMHTMLDocumentWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLDocumentWidthPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLDocumentWidthPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLDocumentWidthPropertyInfo = DOMHTMLDocumentK
    type AttrGetType DOMHTMLDocumentWidthPropertyInfo = Int64
    type AttrLabel DOMHTMLDocumentWidthPropertyInfo = "DOMHTMLDocument::width"
    attrGet _ = getDOMHTMLDocumentWidth
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMHTMLDocument = DOMHTMLDocumentAttributeList
type DOMHTMLDocumentAttributeList = ('[ '("active-element", DOMHTMLDocumentActiveElementPropertyInfo), '("alink-color", DOMHTMLDocumentAlinkColorPropertyInfo), '("anchors", DOMDocumentAnchorsPropertyInfo), '("applets", DOMDocumentAppletsPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("bg-color", DOMHTMLDocumentBgColorPropertyInfo), '("body", DOMDocumentBodyPropertyInfo), '("character-set", DOMDocumentCharacterSetPropertyInfo), '("charset", DOMDocumentCharsetPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("compat-mode", DOMHTMLDocumentCompatModePropertyInfo), '("cookie", DOMDocumentCookiePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("current-script", DOMDocumentCurrentScriptPropertyInfo), '("default-charset", DOMDocumentDefaultCharsetPropertyInfo), '("default-view", DOMDocumentDefaultViewPropertyInfo), '("design-mode", DOMHTMLDocumentDesignModePropertyInfo), '("dir", DOMHTMLDocumentDirPropertyInfo), '("doctype", DOMDocumentDoctypePropertyInfo), '("document-element", DOMDocumentDocumentElementPropertyInfo), '("document-uri", DOMDocumentDocumentUriPropertyInfo), '("domain", DOMDocumentDomainPropertyInfo), '("embeds", DOMHTMLDocumentEmbedsPropertyInfo), '("fg-color", DOMHTMLDocumentFgColorPropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("forms", DOMDocumentFormsPropertyInfo), '("head", DOMDocumentHeadPropertyInfo), '("height", DOMHTMLDocumentHeightPropertyInfo), '("hidden", DOMDocumentHiddenPropertyInfo), '("images", DOMDocumentImagesPropertyInfo), '("implementation", DOMDocumentImplementationPropertyInfo), '("input-encoding", DOMDocumentInputEncodingPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-modified", DOMDocumentLastModifiedPropertyInfo), '("link-color", DOMHTMLDocumentLinkColorPropertyInfo), '("links", DOMDocumentLinksPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("plugins", DOMHTMLDocumentPluginsPropertyInfo), '("preferred-stylesheet-set", DOMDocumentPreferredStylesheetSetPropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("ready-state", DOMDocumentReadyStatePropertyInfo), '("referrer", DOMDocumentReferrerPropertyInfo), '("scripts", DOMHTMLDocumentScriptsPropertyInfo), '("security-policy", DOMDocumentSecurityPolicyPropertyInfo), '("selected-stylesheet-set", DOMDocumentSelectedStylesheetSetPropertyInfo), '("style-sheets", DOMDocumentStyleSheetsPropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMDocumentTitlePropertyInfo), '("url", DOMDocumentUrlPropertyInfo), '("visibility-state", DOMDocumentVisibilityStatePropertyInfo), '("vlink-color", DOMHTMLDocumentVlinkColorPropertyInfo), '("webkit-current-full-screen-element", DOMDocumentWebkitCurrentFullScreenElementPropertyInfo), '("webkit-full-screen-keyboard-input-allowed", DOMDocumentWebkitFullScreenKeyboardInputAllowedPropertyInfo), '("webkit-fullscreen-element", DOMDocumentWebkitFullscreenElementPropertyInfo), '("webkit-fullscreen-enabled", DOMDocumentWebkitFullscreenEnabledPropertyInfo), '("webkit-is-full-screen", DOMDocumentWebkitIsFullScreenPropertyInfo), '("webkit-pointer-lock-element", DOMDocumentWebkitPointerLockElementPropertyInfo), '("width", DOMHTMLDocumentWidthPropertyInfo), '("xml-encoding", DOMDocumentXmlEncodingPropertyInfo), '("xml-standalone", DOMDocumentXmlStandalonePropertyInfo), '("xml-version", DOMDocumentXmlVersionPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLDocument = DOMHTMLDocumentSignalList
type DOMHTMLDocumentSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLDocument::capture_events
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_capture_events" webkit_dom_html_document_capture_events :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO ()


dOMHTMLDocumentCaptureEvents ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLDocumentCaptureEvents _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_document_capture_events _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLDocument::clear
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_clear" webkit_dom_html_document_clear :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO ()


dOMHTMLDocumentClear ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLDocumentClear _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_document_clear _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLDocument::close
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_close" webkit_dom_html_document_close :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO ()


dOMHTMLDocumentClose ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLDocumentClose _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_document_close _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLDocument::get_active_element
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_active_element" webkit_dom_html_document_get_active_element :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO (Ptr DOMElement)


dOMHTMLDocumentGetActiveElement ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m DOMElement
dOMHTMLDocumentGetActiveElement _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_active_element _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_document_get_active_element" result
    result' <- (newObject DOMElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::get_alink_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_alink_color" webkit_dom_html_document_get_alink_color :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO CString


dOMHTMLDocumentGetAlinkColor ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLDocumentGetAlinkColor _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_alink_color _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_document_get_alink_color" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::get_bg_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_bg_color" webkit_dom_html_document_get_bg_color :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO CString


dOMHTMLDocumentGetBgColor ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLDocumentGetBgColor _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_bg_color _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_document_get_bg_color" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::get_compat_mode
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_compat_mode" webkit_dom_html_document_get_compat_mode :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO CString


dOMHTMLDocumentGetCompatMode ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLDocumentGetCompatMode _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_compat_mode _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_document_get_compat_mode" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::get_design_mode
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_design_mode" webkit_dom_html_document_get_design_mode :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO CString


dOMHTMLDocumentGetDesignMode ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLDocumentGetDesignMode _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_design_mode _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_document_get_design_mode" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::get_dir
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_dir" webkit_dom_html_document_get_dir :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO CString


dOMHTMLDocumentGetDir ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLDocumentGetDir _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_dir _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_document_get_dir" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::get_embeds
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLCollection"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_embeds" webkit_dom_html_document_get_embeds :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO (Ptr DOMHTMLCollection)


dOMHTMLDocumentGetEmbeds ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m DOMHTMLCollection
dOMHTMLDocumentGetEmbeds _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_embeds _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_document_get_embeds" result
    result' <- (wrapObject DOMHTMLCollection) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::get_fg_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_fg_color" webkit_dom_html_document_get_fg_color :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO CString


dOMHTMLDocumentGetFgColor ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLDocumentGetFgColor _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_fg_color _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_document_get_fg_color" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::get_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_height" webkit_dom_html_document_get_height :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO Int64


dOMHTMLDocumentGetHeight ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLDocumentGetHeight _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_height _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLDocument::get_link_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_link_color" webkit_dom_html_document_get_link_color :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO CString


dOMHTMLDocumentGetLinkColor ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLDocumentGetLinkColor _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_link_color _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_document_get_link_color" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::get_plugins
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLCollection"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_plugins" webkit_dom_html_document_get_plugins :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO (Ptr DOMHTMLCollection)


dOMHTMLDocumentGetPlugins ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m DOMHTMLCollection
dOMHTMLDocumentGetPlugins _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_plugins _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_document_get_plugins" result
    result' <- (wrapObject DOMHTMLCollection) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::get_scripts
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLCollection"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_scripts" webkit_dom_html_document_get_scripts :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO (Ptr DOMHTMLCollection)


dOMHTMLDocumentGetScripts ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m DOMHTMLCollection
dOMHTMLDocumentGetScripts _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_scripts _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_document_get_scripts" result
    result' <- (wrapObject DOMHTMLCollection) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::get_vlink_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_vlink_color" webkit_dom_html_document_get_vlink_color :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO CString


dOMHTMLDocumentGetVlinkColor ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLDocumentGetVlinkColor _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_vlink_color _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_document_get_vlink_color" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::get_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_get_width" webkit_dom_html_document_get_width :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO Int64


dOMHTMLDocumentGetWidth ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLDocumentGetWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_get_width _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLDocument::has_focus
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_has_focus" webkit_dom_html_document_has_focus :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO CInt


dOMHTMLDocumentHasFocus ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLDocumentHasFocus _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_document_has_focus _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLDocument::open
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_open" webkit_dom_html_document_open :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO ()

{-# DEPRECATED dOMHTMLDocumentOpen ["(Since version 2.2)"]#-}
dOMHTMLDocumentOpen ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLDocumentOpen _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_document_open _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLDocument::release_events
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_release_events" webkit_dom_html_document_release_events :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    IO ()


dOMHTMLDocumentReleaseEvents ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLDocumentReleaseEvents _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_document_release_events _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLDocument::set_alink_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_set_alink_color" webkit_dom_html_document_set_alink_color :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLDocumentSetAlinkColor ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLDocumentSetAlinkColor _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_document_set_alink_color _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLDocument::set_bg_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_set_bg_color" webkit_dom_html_document_set_bg_color :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLDocumentSetBgColor ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLDocumentSetBgColor _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_document_set_bg_color _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLDocument::set_design_mode
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_set_design_mode" webkit_dom_html_document_set_design_mode :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLDocumentSetDesignMode ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLDocumentSetDesignMode _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_document_set_design_mode _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLDocument::set_dir
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_set_dir" webkit_dom_html_document_set_dir :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLDocumentSetDir ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLDocumentSetDir _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_document_set_dir _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLDocument::set_fg_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_set_fg_color" webkit_dom_html_document_set_fg_color :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLDocumentSetFgColor ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLDocumentSetFgColor _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_document_set_fg_color _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLDocument::set_link_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_set_link_color" webkit_dom_html_document_set_link_color :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLDocumentSetLinkColor ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLDocumentSetLinkColor _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_document_set_link_color _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLDocument::set_vlink_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLDocument", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_document_set_vlink_color" webkit_dom_html_document_set_vlink_color :: 
    Ptr DOMHTMLDocument ->                  -- _obj : TInterface "WebKit" "DOMHTMLDocument"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLDocumentSetVlinkColor ::
    (MonadIO m, DOMHTMLDocumentK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLDocumentSetVlinkColor _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_document_set_vlink_color _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


