
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLElement
    ( 

-- * Exported types
    DOMHTMLElement(..)                      ,
    DOMHTMLElementK                         ,
    toDOMHTMLElement                        ,
    noDOMHTMLElement                        ,


 -- * Methods
-- ** dOMHTMLElementClick
    dOMHTMLElementClick                     ,


-- ** dOMHTMLElementGetAccessKey
    dOMHTMLElementGetAccessKey              ,


-- ** dOMHTMLElementGetChildren
    dOMHTMLElementGetChildren               ,


-- ** dOMHTMLElementGetClassList
    dOMHTMLElementGetClassList              ,


-- ** dOMHTMLElementGetClassName
    dOMHTMLElementGetClassName              ,


-- ** dOMHTMLElementGetContentEditable
    dOMHTMLElementGetContentEditable        ,


-- ** dOMHTMLElementGetDir
    dOMHTMLElementGetDir                    ,


-- ** dOMHTMLElementGetDraggable
    dOMHTMLElementGetDraggable              ,


-- ** dOMHTMLElementGetHidden
    dOMHTMLElementGetHidden                 ,


-- ** dOMHTMLElementGetId
    dOMHTMLElementGetId                     ,


-- ** dOMHTMLElementGetInnerHtml
    dOMHTMLElementGetInnerHtml              ,


-- ** dOMHTMLElementGetInnerText
    dOMHTMLElementGetInnerText              ,


-- ** dOMHTMLElementGetIsContentEditable
    dOMHTMLElementGetIsContentEditable      ,


-- ** dOMHTMLElementGetItemId
    dOMHTMLElementGetItemId                 ,


-- ** dOMHTMLElementGetItemProp
    dOMHTMLElementGetItemProp               ,


-- ** dOMHTMLElementGetItemRef
    dOMHTMLElementGetItemRef                ,


-- ** dOMHTMLElementGetItemScope
    dOMHTMLElementGetItemScope              ,


-- ** dOMHTMLElementGetItemType
    dOMHTMLElementGetItemType               ,


-- ** dOMHTMLElementGetLang
    dOMHTMLElementGetLang                   ,


-- ** dOMHTMLElementGetOuterHtml
    dOMHTMLElementGetOuterHtml              ,


-- ** dOMHTMLElementGetOuterText
    dOMHTMLElementGetOuterText              ,


-- ** dOMHTMLElementGetSpellcheck
    dOMHTMLElementGetSpellcheck             ,


-- ** dOMHTMLElementGetTabIndex
    dOMHTMLElementGetTabIndex               ,


-- ** dOMHTMLElementGetTitle
    dOMHTMLElementGetTitle                  ,


-- ** dOMHTMLElementGetTranslate
    dOMHTMLElementGetTranslate              ,


-- ** dOMHTMLElementGetWebkitdropzone
    dOMHTMLElementGetWebkitdropzone         ,


-- ** dOMHTMLElementInsertAdjacentElement
    dOMHTMLElementInsertAdjacentElement     ,


-- ** dOMHTMLElementInsertAdjacentHtml
    dOMHTMLElementInsertAdjacentHtml        ,


-- ** dOMHTMLElementInsertAdjacentText
    dOMHTMLElementInsertAdjacentText        ,


-- ** dOMHTMLElementSetAccessKey
    dOMHTMLElementSetAccessKey              ,


-- ** dOMHTMLElementSetClassName
    dOMHTMLElementSetClassName              ,


-- ** dOMHTMLElementSetContentEditable
    dOMHTMLElementSetContentEditable        ,


-- ** dOMHTMLElementSetDir
    dOMHTMLElementSetDir                    ,


-- ** dOMHTMLElementSetDraggable
    dOMHTMLElementSetDraggable              ,


-- ** dOMHTMLElementSetHidden
    dOMHTMLElementSetHidden                 ,


-- ** dOMHTMLElementSetId
    dOMHTMLElementSetId                     ,


-- ** dOMHTMLElementSetInnerHtml
    dOMHTMLElementSetInnerHtml              ,


-- ** dOMHTMLElementSetInnerText
    dOMHTMLElementSetInnerText              ,


-- ** dOMHTMLElementSetItemId
    dOMHTMLElementSetItemId                 ,


-- ** dOMHTMLElementSetItemScope
    dOMHTMLElementSetItemScope              ,


-- ** dOMHTMLElementSetLang
    dOMHTMLElementSetLang                   ,


-- ** dOMHTMLElementSetOuterHtml
    dOMHTMLElementSetOuterHtml              ,


-- ** dOMHTMLElementSetOuterText
    dOMHTMLElementSetOuterText              ,


-- ** dOMHTMLElementSetSpellcheck
    dOMHTMLElementSetSpellcheck             ,


-- ** dOMHTMLElementSetTabIndex
    dOMHTMLElementSetTabIndex               ,


-- ** dOMHTMLElementSetTitle
    dOMHTMLElementSetTitle                  ,


-- ** dOMHTMLElementSetTranslate
    dOMHTMLElementSetTranslate              ,


-- ** dOMHTMLElementSetWebkitdropzone
    dOMHTMLElementSetWebkitdropzone         ,




 -- * Properties
-- ** AccessKey
    DOMHTMLElementAccessKeyPropertyInfo     ,
    constructDOMHTMLElementAccessKey        ,
    getDOMHTMLElementAccessKey              ,
    setDOMHTMLElementAccessKey              ,


-- ** Children
    DOMHTMLElementChildrenPropertyInfo      ,
    getDOMHTMLElementChildren               ,


-- ** ContentEditable
    DOMHTMLElementContentEditablePropertyInfo,
    constructDOMHTMLElementContentEditable  ,
    getDOMHTMLElementContentEditable        ,
    setDOMHTMLElementContentEditable        ,


-- ** Dir
    DOMHTMLElementDirPropertyInfo           ,
    constructDOMHTMLElementDir              ,
    getDOMHTMLElementDir                    ,
    setDOMHTMLElementDir                    ,


-- ** Draggable
    DOMHTMLElementDraggablePropertyInfo     ,
    constructDOMHTMLElementDraggable        ,
    getDOMHTMLElementDraggable              ,
    setDOMHTMLElementDraggable              ,


-- ** Hidden
    DOMHTMLElementHiddenPropertyInfo        ,
    constructDOMHTMLElementHidden           ,
    getDOMHTMLElementHidden                 ,
    setDOMHTMLElementHidden                 ,


-- ** InnerHtml
    DOMHTMLElementInnerHtmlPropertyInfo     ,
    constructDOMHTMLElementInnerHtml        ,
    getDOMHTMLElementInnerHtml              ,
    setDOMHTMLElementInnerHtml              ,


-- ** InnerText
    DOMHTMLElementInnerTextPropertyInfo     ,
    constructDOMHTMLElementInnerText        ,
    getDOMHTMLElementInnerText              ,
    setDOMHTMLElementInnerText              ,


-- ** IsContentEditable
    DOMHTMLElementIsContentEditablePropertyInfo,
    getDOMHTMLElementIsContentEditable      ,


-- ** Lang
    DOMHTMLElementLangPropertyInfo          ,
    constructDOMHTMLElementLang             ,
    getDOMHTMLElementLang                   ,
    setDOMHTMLElementLang                   ,


-- ** OuterHtml
    DOMHTMLElementOuterHtmlPropertyInfo     ,
    constructDOMHTMLElementOuterHtml        ,
    getDOMHTMLElementOuterHtml              ,
    setDOMHTMLElementOuterHtml              ,


-- ** OuterText
    DOMHTMLElementOuterTextPropertyInfo     ,
    constructDOMHTMLElementOuterText        ,
    getDOMHTMLElementOuterText              ,
    setDOMHTMLElementOuterText              ,


-- ** Spellcheck
    DOMHTMLElementSpellcheckPropertyInfo    ,
    constructDOMHTMLElementSpellcheck       ,
    getDOMHTMLElementSpellcheck             ,
    setDOMHTMLElementSpellcheck             ,


-- ** TabIndex
    DOMHTMLElementTabIndexPropertyInfo      ,
    constructDOMHTMLElementTabIndex         ,
    getDOMHTMLElementTabIndex               ,
    setDOMHTMLElementTabIndex               ,


-- ** Title
    DOMHTMLElementTitlePropertyInfo         ,
    constructDOMHTMLElementTitle            ,
    getDOMHTMLElementTitle                  ,
    setDOMHTMLElementTitle                  ,


-- ** Translate
    DOMHTMLElementTranslatePropertyInfo     ,
    constructDOMHTMLElementTranslate        ,
    getDOMHTMLElementTranslate              ,
    setDOMHTMLElementTranslate              ,


-- ** Webkitdropzone
    DOMHTMLElementWebkitdropzonePropertyInfo,
    constructDOMHTMLElementWebkitdropzone   ,
    getDOMHTMLElementWebkitdropzone         ,
    setDOMHTMLElementWebkitdropzone         ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLElement = DOMHTMLElement (ForeignPtr DOMHTMLElement)
foreign import ccall "webkit_dom_html_element_get_type"
    c_webkit_dom_html_element_get_type :: IO GType

type instance ParentTypes DOMHTMLElement = DOMHTMLElementParentTypes
type DOMHTMLElementParentTypes = '[DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_element_get_type
    

class GObject o => DOMHTMLElementK o
instance (GObject o, IsDescendantOf DOMHTMLElement o) => DOMHTMLElementK o

toDOMHTMLElement :: DOMHTMLElementK o => o -> IO DOMHTMLElement
toDOMHTMLElement = unsafeCastTo DOMHTMLElement

noDOMHTMLElement :: Maybe DOMHTMLElement
noDOMHTMLElement = Nothing

-- VVV Prop "access-key"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementAccessKey :: (MonadIO m, DOMHTMLElementK o) => o -> m T.Text
getDOMHTMLElementAccessKey obj = liftIO $ getObjectPropertyString obj "access-key"

setDOMHTMLElementAccessKey :: (MonadIO m, DOMHTMLElementK o) => o -> T.Text -> m ()
setDOMHTMLElementAccessKey obj val = liftIO $ setObjectPropertyString obj "access-key" val

constructDOMHTMLElementAccessKey :: T.Text -> IO ([Char], GValue)
constructDOMHTMLElementAccessKey val = constructObjectPropertyString "access-key" val

data DOMHTMLElementAccessKeyPropertyInfo
instance AttrInfo DOMHTMLElementAccessKeyPropertyInfo where
    type AttrAllowedOps DOMHTMLElementAccessKeyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementAccessKeyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLElementAccessKeyPropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementAccessKeyPropertyInfo = T.Text
    type AttrLabel DOMHTMLElementAccessKeyPropertyInfo = "DOMHTMLElement::access-key"
    attrGet _ = getDOMHTMLElementAccessKey
    attrSet _ = setDOMHTMLElementAccessKey
    attrConstruct _ = constructDOMHTMLElementAccessKey

-- VVV Prop "children"
   -- Type: TInterface "WebKit" "DOMHTMLCollection"
   -- Flags: [PropertyReadable]

getDOMHTMLElementChildren :: (MonadIO m, DOMHTMLElementK o) => o -> m DOMHTMLCollection
getDOMHTMLElementChildren obj = liftIO $ getObjectPropertyObject obj "children" DOMHTMLCollection

data DOMHTMLElementChildrenPropertyInfo
instance AttrInfo DOMHTMLElementChildrenPropertyInfo where
    type AttrAllowedOps DOMHTMLElementChildrenPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementChildrenPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLElementChildrenPropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementChildrenPropertyInfo = DOMHTMLCollection
    type AttrLabel DOMHTMLElementChildrenPropertyInfo = "DOMHTMLElement::children"
    attrGet _ = getDOMHTMLElementChildren
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "content-editable"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementContentEditable :: (MonadIO m, DOMHTMLElementK o) => o -> m T.Text
getDOMHTMLElementContentEditable obj = liftIO $ getObjectPropertyString obj "content-editable"

setDOMHTMLElementContentEditable :: (MonadIO m, DOMHTMLElementK o) => o -> T.Text -> m ()
setDOMHTMLElementContentEditable obj val = liftIO $ setObjectPropertyString obj "content-editable" val

constructDOMHTMLElementContentEditable :: T.Text -> IO ([Char], GValue)
constructDOMHTMLElementContentEditable val = constructObjectPropertyString "content-editable" val

data DOMHTMLElementContentEditablePropertyInfo
instance AttrInfo DOMHTMLElementContentEditablePropertyInfo where
    type AttrAllowedOps DOMHTMLElementContentEditablePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementContentEditablePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLElementContentEditablePropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementContentEditablePropertyInfo = T.Text
    type AttrLabel DOMHTMLElementContentEditablePropertyInfo = "DOMHTMLElement::content-editable"
    attrGet _ = getDOMHTMLElementContentEditable
    attrSet _ = setDOMHTMLElementContentEditable
    attrConstruct _ = constructDOMHTMLElementContentEditable

-- VVV Prop "dir"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementDir :: (MonadIO m, DOMHTMLElementK o) => o -> m T.Text
getDOMHTMLElementDir obj = liftIO $ getObjectPropertyString obj "dir"

setDOMHTMLElementDir :: (MonadIO m, DOMHTMLElementK o) => o -> T.Text -> m ()
setDOMHTMLElementDir obj val = liftIO $ setObjectPropertyString obj "dir" val

constructDOMHTMLElementDir :: T.Text -> IO ([Char], GValue)
constructDOMHTMLElementDir val = constructObjectPropertyString "dir" val

data DOMHTMLElementDirPropertyInfo
instance AttrInfo DOMHTMLElementDirPropertyInfo where
    type AttrAllowedOps DOMHTMLElementDirPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementDirPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLElementDirPropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementDirPropertyInfo = T.Text
    type AttrLabel DOMHTMLElementDirPropertyInfo = "DOMHTMLElement::dir"
    attrGet _ = getDOMHTMLElementDir
    attrSet _ = setDOMHTMLElementDir
    attrConstruct _ = constructDOMHTMLElementDir

-- VVV Prop "draggable"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementDraggable :: (MonadIO m, DOMHTMLElementK o) => o -> m Bool
getDOMHTMLElementDraggable obj = liftIO $ getObjectPropertyBool obj "draggable"

setDOMHTMLElementDraggable :: (MonadIO m, DOMHTMLElementK o) => o -> Bool -> m ()
setDOMHTMLElementDraggable obj val = liftIO $ setObjectPropertyBool obj "draggable" val

constructDOMHTMLElementDraggable :: Bool -> IO ([Char], GValue)
constructDOMHTMLElementDraggable val = constructObjectPropertyBool "draggable" val

data DOMHTMLElementDraggablePropertyInfo
instance AttrInfo DOMHTMLElementDraggablePropertyInfo where
    type AttrAllowedOps DOMHTMLElementDraggablePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementDraggablePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLElementDraggablePropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementDraggablePropertyInfo = Bool
    type AttrLabel DOMHTMLElementDraggablePropertyInfo = "DOMHTMLElement::draggable"
    attrGet _ = getDOMHTMLElementDraggable
    attrSet _ = setDOMHTMLElementDraggable
    attrConstruct _ = constructDOMHTMLElementDraggable

-- VVV Prop "hidden"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementHidden :: (MonadIO m, DOMHTMLElementK o) => o -> m Bool
getDOMHTMLElementHidden obj = liftIO $ getObjectPropertyBool obj "hidden"

setDOMHTMLElementHidden :: (MonadIO m, DOMHTMLElementK o) => o -> Bool -> m ()
setDOMHTMLElementHidden obj val = liftIO $ setObjectPropertyBool obj "hidden" val

constructDOMHTMLElementHidden :: Bool -> IO ([Char], GValue)
constructDOMHTMLElementHidden val = constructObjectPropertyBool "hidden" val

data DOMHTMLElementHiddenPropertyInfo
instance AttrInfo DOMHTMLElementHiddenPropertyInfo where
    type AttrAllowedOps DOMHTMLElementHiddenPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementHiddenPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLElementHiddenPropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementHiddenPropertyInfo = Bool
    type AttrLabel DOMHTMLElementHiddenPropertyInfo = "DOMHTMLElement::hidden"
    attrGet _ = getDOMHTMLElementHidden
    attrSet _ = setDOMHTMLElementHidden
    attrConstruct _ = constructDOMHTMLElementHidden

-- VVV Prop "inner-html"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementInnerHtml :: (MonadIO m, DOMHTMLElementK o) => o -> m T.Text
getDOMHTMLElementInnerHtml obj = liftIO $ getObjectPropertyString obj "inner-html"

setDOMHTMLElementInnerHtml :: (MonadIO m, DOMHTMLElementK o) => o -> T.Text -> m ()
setDOMHTMLElementInnerHtml obj val = liftIO $ setObjectPropertyString obj "inner-html" val

constructDOMHTMLElementInnerHtml :: T.Text -> IO ([Char], GValue)
constructDOMHTMLElementInnerHtml val = constructObjectPropertyString "inner-html" val

data DOMHTMLElementInnerHtmlPropertyInfo
instance AttrInfo DOMHTMLElementInnerHtmlPropertyInfo where
    type AttrAllowedOps DOMHTMLElementInnerHtmlPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementInnerHtmlPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLElementInnerHtmlPropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementInnerHtmlPropertyInfo = T.Text
    type AttrLabel DOMHTMLElementInnerHtmlPropertyInfo = "DOMHTMLElement::inner-html"
    attrGet _ = getDOMHTMLElementInnerHtml
    attrSet _ = setDOMHTMLElementInnerHtml
    attrConstruct _ = constructDOMHTMLElementInnerHtml

-- VVV Prop "inner-text"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementInnerText :: (MonadIO m, DOMHTMLElementK o) => o -> m T.Text
getDOMHTMLElementInnerText obj = liftIO $ getObjectPropertyString obj "inner-text"

setDOMHTMLElementInnerText :: (MonadIO m, DOMHTMLElementK o) => o -> T.Text -> m ()
setDOMHTMLElementInnerText obj val = liftIO $ setObjectPropertyString obj "inner-text" val

constructDOMHTMLElementInnerText :: T.Text -> IO ([Char], GValue)
constructDOMHTMLElementInnerText val = constructObjectPropertyString "inner-text" val

data DOMHTMLElementInnerTextPropertyInfo
instance AttrInfo DOMHTMLElementInnerTextPropertyInfo where
    type AttrAllowedOps DOMHTMLElementInnerTextPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementInnerTextPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLElementInnerTextPropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementInnerTextPropertyInfo = T.Text
    type AttrLabel DOMHTMLElementInnerTextPropertyInfo = "DOMHTMLElement::inner-text"
    attrGet _ = getDOMHTMLElementInnerText
    attrSet _ = setDOMHTMLElementInnerText
    attrConstruct _ = constructDOMHTMLElementInnerText

-- VVV Prop "is-content-editable"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMHTMLElementIsContentEditable :: (MonadIO m, DOMHTMLElementK o) => o -> m Bool
getDOMHTMLElementIsContentEditable obj = liftIO $ getObjectPropertyBool obj "is-content-editable"

data DOMHTMLElementIsContentEditablePropertyInfo
instance AttrInfo DOMHTMLElementIsContentEditablePropertyInfo where
    type AttrAllowedOps DOMHTMLElementIsContentEditablePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementIsContentEditablePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLElementIsContentEditablePropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementIsContentEditablePropertyInfo = Bool
    type AttrLabel DOMHTMLElementIsContentEditablePropertyInfo = "DOMHTMLElement::is-content-editable"
    attrGet _ = getDOMHTMLElementIsContentEditable
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "lang"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementLang :: (MonadIO m, DOMHTMLElementK o) => o -> m T.Text
getDOMHTMLElementLang obj = liftIO $ getObjectPropertyString obj "lang"

setDOMHTMLElementLang :: (MonadIO m, DOMHTMLElementK o) => o -> T.Text -> m ()
setDOMHTMLElementLang obj val = liftIO $ setObjectPropertyString obj "lang" val

constructDOMHTMLElementLang :: T.Text -> IO ([Char], GValue)
constructDOMHTMLElementLang val = constructObjectPropertyString "lang" val

data DOMHTMLElementLangPropertyInfo
instance AttrInfo DOMHTMLElementLangPropertyInfo where
    type AttrAllowedOps DOMHTMLElementLangPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementLangPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLElementLangPropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementLangPropertyInfo = T.Text
    type AttrLabel DOMHTMLElementLangPropertyInfo = "DOMHTMLElement::lang"
    attrGet _ = getDOMHTMLElementLang
    attrSet _ = setDOMHTMLElementLang
    attrConstruct _ = constructDOMHTMLElementLang

-- VVV Prop "outer-html"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementOuterHtml :: (MonadIO m, DOMHTMLElementK o) => o -> m T.Text
getDOMHTMLElementOuterHtml obj = liftIO $ getObjectPropertyString obj "outer-html"

setDOMHTMLElementOuterHtml :: (MonadIO m, DOMHTMLElementK o) => o -> T.Text -> m ()
setDOMHTMLElementOuterHtml obj val = liftIO $ setObjectPropertyString obj "outer-html" val

constructDOMHTMLElementOuterHtml :: T.Text -> IO ([Char], GValue)
constructDOMHTMLElementOuterHtml val = constructObjectPropertyString "outer-html" val

data DOMHTMLElementOuterHtmlPropertyInfo
instance AttrInfo DOMHTMLElementOuterHtmlPropertyInfo where
    type AttrAllowedOps DOMHTMLElementOuterHtmlPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementOuterHtmlPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLElementOuterHtmlPropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementOuterHtmlPropertyInfo = T.Text
    type AttrLabel DOMHTMLElementOuterHtmlPropertyInfo = "DOMHTMLElement::outer-html"
    attrGet _ = getDOMHTMLElementOuterHtml
    attrSet _ = setDOMHTMLElementOuterHtml
    attrConstruct _ = constructDOMHTMLElementOuterHtml

-- VVV Prop "outer-text"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementOuterText :: (MonadIO m, DOMHTMLElementK o) => o -> m T.Text
getDOMHTMLElementOuterText obj = liftIO $ getObjectPropertyString obj "outer-text"

setDOMHTMLElementOuterText :: (MonadIO m, DOMHTMLElementK o) => o -> T.Text -> m ()
setDOMHTMLElementOuterText obj val = liftIO $ setObjectPropertyString obj "outer-text" val

constructDOMHTMLElementOuterText :: T.Text -> IO ([Char], GValue)
constructDOMHTMLElementOuterText val = constructObjectPropertyString "outer-text" val

data DOMHTMLElementOuterTextPropertyInfo
instance AttrInfo DOMHTMLElementOuterTextPropertyInfo where
    type AttrAllowedOps DOMHTMLElementOuterTextPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementOuterTextPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLElementOuterTextPropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementOuterTextPropertyInfo = T.Text
    type AttrLabel DOMHTMLElementOuterTextPropertyInfo = "DOMHTMLElement::outer-text"
    attrGet _ = getDOMHTMLElementOuterText
    attrSet _ = setDOMHTMLElementOuterText
    attrConstruct _ = constructDOMHTMLElementOuterText

-- VVV Prop "spellcheck"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementSpellcheck :: (MonadIO m, DOMHTMLElementK o) => o -> m Bool
getDOMHTMLElementSpellcheck obj = liftIO $ getObjectPropertyBool obj "spellcheck"

setDOMHTMLElementSpellcheck :: (MonadIO m, DOMHTMLElementK o) => o -> Bool -> m ()
setDOMHTMLElementSpellcheck obj val = liftIO $ setObjectPropertyBool obj "spellcheck" val

constructDOMHTMLElementSpellcheck :: Bool -> IO ([Char], GValue)
constructDOMHTMLElementSpellcheck val = constructObjectPropertyBool "spellcheck" val

data DOMHTMLElementSpellcheckPropertyInfo
instance AttrInfo DOMHTMLElementSpellcheckPropertyInfo where
    type AttrAllowedOps DOMHTMLElementSpellcheckPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementSpellcheckPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLElementSpellcheckPropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementSpellcheckPropertyInfo = Bool
    type AttrLabel DOMHTMLElementSpellcheckPropertyInfo = "DOMHTMLElement::spellcheck"
    attrGet _ = getDOMHTMLElementSpellcheck
    attrSet _ = setDOMHTMLElementSpellcheck
    attrConstruct _ = constructDOMHTMLElementSpellcheck

-- VVV Prop "tab-index"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementTabIndex :: (MonadIO m, DOMHTMLElementK o) => o -> m Int64
getDOMHTMLElementTabIndex obj = liftIO $ getObjectPropertyInt64 obj "tab-index"

setDOMHTMLElementTabIndex :: (MonadIO m, DOMHTMLElementK o) => o -> Int64 -> m ()
setDOMHTMLElementTabIndex obj val = liftIO $ setObjectPropertyInt64 obj "tab-index" val

constructDOMHTMLElementTabIndex :: Int64 -> IO ([Char], GValue)
constructDOMHTMLElementTabIndex val = constructObjectPropertyInt64 "tab-index" val

data DOMHTMLElementTabIndexPropertyInfo
instance AttrInfo DOMHTMLElementTabIndexPropertyInfo where
    type AttrAllowedOps DOMHTMLElementTabIndexPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementTabIndexPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLElementTabIndexPropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementTabIndexPropertyInfo = Int64
    type AttrLabel DOMHTMLElementTabIndexPropertyInfo = "DOMHTMLElement::tab-index"
    attrGet _ = getDOMHTMLElementTabIndex
    attrSet _ = setDOMHTMLElementTabIndex
    attrConstruct _ = constructDOMHTMLElementTabIndex

-- VVV Prop "title"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementTitle :: (MonadIO m, DOMHTMLElementK o) => o -> m T.Text
getDOMHTMLElementTitle obj = liftIO $ getObjectPropertyString obj "title"

setDOMHTMLElementTitle :: (MonadIO m, DOMHTMLElementK o) => o -> T.Text -> m ()
setDOMHTMLElementTitle obj val = liftIO $ setObjectPropertyString obj "title" val

constructDOMHTMLElementTitle :: T.Text -> IO ([Char], GValue)
constructDOMHTMLElementTitle val = constructObjectPropertyString "title" val

data DOMHTMLElementTitlePropertyInfo
instance AttrInfo DOMHTMLElementTitlePropertyInfo where
    type AttrAllowedOps DOMHTMLElementTitlePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementTitlePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLElementTitlePropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementTitlePropertyInfo = T.Text
    type AttrLabel DOMHTMLElementTitlePropertyInfo = "DOMHTMLElement::title"
    attrGet _ = getDOMHTMLElementTitle
    attrSet _ = setDOMHTMLElementTitle
    attrConstruct _ = constructDOMHTMLElementTitle

-- VVV Prop "translate"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementTranslate :: (MonadIO m, DOMHTMLElementK o) => o -> m Bool
getDOMHTMLElementTranslate obj = liftIO $ getObjectPropertyBool obj "translate"

setDOMHTMLElementTranslate :: (MonadIO m, DOMHTMLElementK o) => o -> Bool -> m ()
setDOMHTMLElementTranslate obj val = liftIO $ setObjectPropertyBool obj "translate" val

constructDOMHTMLElementTranslate :: Bool -> IO ([Char], GValue)
constructDOMHTMLElementTranslate val = constructObjectPropertyBool "translate" val

data DOMHTMLElementTranslatePropertyInfo
instance AttrInfo DOMHTMLElementTranslatePropertyInfo where
    type AttrAllowedOps DOMHTMLElementTranslatePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementTranslatePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLElementTranslatePropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementTranslatePropertyInfo = Bool
    type AttrLabel DOMHTMLElementTranslatePropertyInfo = "DOMHTMLElement::translate"
    attrGet _ = getDOMHTMLElementTranslate
    attrSet _ = setDOMHTMLElementTranslate
    attrConstruct _ = constructDOMHTMLElementTranslate

-- VVV Prop "webkitdropzone"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLElementWebkitdropzone :: (MonadIO m, DOMHTMLElementK o) => o -> m T.Text
getDOMHTMLElementWebkitdropzone obj = liftIO $ getObjectPropertyString obj "webkitdropzone"

setDOMHTMLElementWebkitdropzone :: (MonadIO m, DOMHTMLElementK o) => o -> T.Text -> m ()
setDOMHTMLElementWebkitdropzone obj val = liftIO $ setObjectPropertyString obj "webkitdropzone" val

constructDOMHTMLElementWebkitdropzone :: T.Text -> IO ([Char], GValue)
constructDOMHTMLElementWebkitdropzone val = constructObjectPropertyString "webkitdropzone" val

data DOMHTMLElementWebkitdropzonePropertyInfo
instance AttrInfo DOMHTMLElementWebkitdropzonePropertyInfo where
    type AttrAllowedOps DOMHTMLElementWebkitdropzonePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLElementWebkitdropzonePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLElementWebkitdropzonePropertyInfo = DOMHTMLElementK
    type AttrGetType DOMHTMLElementWebkitdropzonePropertyInfo = T.Text
    type AttrLabel DOMHTMLElementWebkitdropzonePropertyInfo = "DOMHTMLElement::webkitdropzone"
    attrGet _ = getDOMHTMLElementWebkitdropzone
    attrSet _ = setDOMHTMLElementWebkitdropzone
    attrConstruct _ = constructDOMHTMLElementWebkitdropzone

type instance AttributeList DOMHTMLElement = DOMHTMLElementAttributeList
type DOMHTMLElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLElement = DOMHTMLElementSignalList
type DOMHTMLElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLElement::click
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_click" webkit_dom_html_element_click :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO ()


dOMHTMLElementClick ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLElementClick _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_element_click _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLElement::get_access_key
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_access_key" webkit_dom_html_element_get_access_key :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString


dOMHTMLElementGetAccessKey ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetAccessKey _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_access_key _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_access_key" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_children
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLCollection"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_children" webkit_dom_html_element_get_children :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO (Ptr DOMHTMLCollection)


dOMHTMLElementGetChildren ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLCollection
dOMHTMLElementGetChildren _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_children _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_children" result
    result' <- (wrapObject DOMHTMLCollection) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_class_list
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMDOMTokenList"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_class_list" webkit_dom_html_element_get_class_list :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO (Ptr DOMDOMTokenList)

{-# DEPRECATED dOMHTMLElementGetClassList ["(Since version 1.10)","Use webkit_dom_element_get_class_list() instead."]#-}
dOMHTMLElementGetClassList ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m DOMDOMTokenList
dOMHTMLElementGetClassList _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_class_list _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_class_list" result
    result' <- (newObject DOMDOMTokenList) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_class_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_class_name" webkit_dom_html_element_get_class_name :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString

{-# DEPRECATED dOMHTMLElementGetClassName ["(Since version 1.10)","Use webkit_dom_element_get_class_name() instead."]#-}
dOMHTMLElementGetClassName ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetClassName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_class_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_class_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_content_editable
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_content_editable" webkit_dom_html_element_get_content_editable :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString


dOMHTMLElementGetContentEditable ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetContentEditable _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_content_editable _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_content_editable" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_dir
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_dir" webkit_dom_html_element_get_dir :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString


dOMHTMLElementGetDir ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetDir _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_dir _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_dir" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_draggable
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_draggable" webkit_dom_html_element_get_draggable :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CInt


dOMHTMLElementGetDraggable ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLElementGetDraggable _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_draggable _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_hidden
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_hidden" webkit_dom_html_element_get_hidden :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CInt


dOMHTMLElementGetHidden ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLElementGetHidden _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_hidden _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_id
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_id" webkit_dom_html_element_get_id :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString

{-# DEPRECATED dOMHTMLElementGetId ["(Since version 2.2)","Use webkit_dom_element_get_id() instead."]#-}
dOMHTMLElementGetId ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetId _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_id _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_id" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_inner_html
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_inner_html" webkit_dom_html_element_get_inner_html :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString


dOMHTMLElementGetInnerHtml ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetInnerHtml _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_inner_html _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_inner_html" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_inner_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_inner_text" webkit_dom_html_element_get_inner_text :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString


dOMHTMLElementGetInnerText ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetInnerText _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_inner_text _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_inner_text" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_is_content_editable
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_is_content_editable" webkit_dom_html_element_get_is_content_editable :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CInt


dOMHTMLElementGetIsContentEditable ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLElementGetIsContentEditable _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_is_content_editable _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_item_id
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_item_id" webkit_dom_html_element_get_item_id :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString

{-# DEPRECATED dOMHTMLElementGetItemId ["(Since version 2.2)"]#-}
dOMHTMLElementGetItemId ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetItemId _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_item_id _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_item_id" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_item_prop
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMDOMSettableTokenList"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_item_prop" webkit_dom_html_element_get_item_prop :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO (Ptr DOMDOMSettableTokenList)

{-# DEPRECATED dOMHTMLElementGetItemProp ["(Since version 2.2)"]#-}
dOMHTMLElementGetItemProp ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m DOMDOMSettableTokenList
dOMHTMLElementGetItemProp _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_item_prop _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_item_prop" result
    result' <- (newObject DOMDOMSettableTokenList) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_item_ref
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMDOMSettableTokenList"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_item_ref" webkit_dom_html_element_get_item_ref :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO (Ptr DOMDOMSettableTokenList)

{-# DEPRECATED dOMHTMLElementGetItemRef ["(Since version 2.2)"]#-}
dOMHTMLElementGetItemRef ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m DOMDOMSettableTokenList
dOMHTMLElementGetItemRef _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_item_ref _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_item_ref" result
    result' <- (newObject DOMDOMSettableTokenList) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_item_scope
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_item_scope" webkit_dom_html_element_get_item_scope :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CInt

{-# DEPRECATED dOMHTMLElementGetItemScope ["(Since version 2.2)"]#-}
dOMHTMLElementGetItemScope ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLElementGetItemScope _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_item_scope _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_item_type
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_item_type" webkit_dom_html_element_get_item_type :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO ()

{-# DEPRECATED dOMHTMLElementGetItemType ["(Since version 2.2)"]#-}
dOMHTMLElementGetItemType ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLElementGetItemType _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_element_get_item_type _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLElement::get_lang
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_lang" webkit_dom_html_element_get_lang :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString


dOMHTMLElementGetLang ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetLang _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_lang _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_lang" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_outer_html
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_outer_html" webkit_dom_html_element_get_outer_html :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString


dOMHTMLElementGetOuterHtml ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetOuterHtml _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_outer_html _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_outer_html" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_outer_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_outer_text" webkit_dom_html_element_get_outer_text :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString


dOMHTMLElementGetOuterText ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetOuterText _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_outer_text _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_outer_text" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_spellcheck
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_spellcheck" webkit_dom_html_element_get_spellcheck :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CInt


dOMHTMLElementGetSpellcheck ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLElementGetSpellcheck _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_spellcheck _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_tab_index
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_tab_index" webkit_dom_html_element_get_tab_index :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO Int64


dOMHTMLElementGetTabIndex ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLElementGetTabIndex _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_tab_index _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLElement::get_title
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_title" webkit_dom_html_element_get_title :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString


dOMHTMLElementGetTitle ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetTitle _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_title _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_title" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_translate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_translate" webkit_dom_html_element_get_translate :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CInt


dOMHTMLElementGetTranslate ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLElementGetTranslate _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_translate _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::get_webkitdropzone
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_get_webkitdropzone" webkit_dom_html_element_get_webkitdropzone :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    IO CString


dOMHTMLElementGetWebkitdropzone ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLElementGetWebkitdropzone _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_element_get_webkitdropzone _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_element_get_webkitdropzone" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLElement::insert_adjacent_element
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "where", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "element", argType = TInterface "WebKit" "DOMElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "where", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "element", argType = TInterface "WebKit" "DOMElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMElement"
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_element_insert_adjacent_element" webkit_dom_html_element_insert_adjacent_element :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- where : TBasicType TUTF8
    Ptr DOMElement ->                       -- element : TInterface "WebKit" "DOMElement"
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr DOMElement)


dOMHTMLElementInsertAdjacentElement ::
    (MonadIO m, DOMHTMLElementK a, DOMElementK b) =>
    a ->                                    -- _obj
    T.Text ->                               -- where
    b ->                                    -- element
    m DOMElement
dOMHTMLElementInsertAdjacentElement _obj where_ element = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    where_' <- textToCString where_
    let element' = unsafeManagedPtrCastPtr element
    onException (do
        result <- propagateGError $ webkit_dom_html_element_insert_adjacent_element _obj' where_' element'
        checkUnexpectedReturnNULL "webkit_dom_html_element_insert_adjacent_element" result
        result' <- (newObject DOMElement) result
        touchManagedPtr _obj
        touchManagedPtr element
        freeMem where_'
        return result'
     ) (do
        freeMem where_'
     )

-- method DOMHTMLElement::insert_adjacent_html
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "where", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "html", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "where", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "html", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_element_insert_adjacent_html" webkit_dom_html_element_insert_adjacent_html :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- where : TBasicType TUTF8
    CString ->                              -- html : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLElementInsertAdjacentHtml ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- where
    T.Text ->                               -- html
    m ()
dOMHTMLElementInsertAdjacentHtml _obj where_ html = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    where_' <- textToCString where_
    html' <- textToCString html
    onException (do
        propagateGError $ webkit_dom_html_element_insert_adjacent_html _obj' where_' html'
        touchManagedPtr _obj
        freeMem where_'
        freeMem html'
        return ()
     ) (do
        freeMem where_'
        freeMem html'
     )

-- method DOMHTMLElement::insert_adjacent_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "where", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "text", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "where", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "text", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_element_insert_adjacent_text" webkit_dom_html_element_insert_adjacent_text :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- where : TBasicType TUTF8
    CString ->                              -- text : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLElementInsertAdjacentText ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- where
    T.Text ->                               -- text
    m ()
dOMHTMLElementInsertAdjacentText _obj where_ text = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    where_' <- textToCString where_
    text' <- textToCString text
    onException (do
        propagateGError $ webkit_dom_html_element_insert_adjacent_text _obj' where_' text'
        touchManagedPtr _obj
        freeMem where_'
        freeMem text'
        return ()
     ) (do
        freeMem where_'
        freeMem text'
     )

-- method DOMHTMLElement::set_access_key
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_access_key" webkit_dom_html_element_set_access_key :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLElementSetAccessKey ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetAccessKey _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_element_set_access_key _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLElement::set_class_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_class_name" webkit_dom_html_element_set_class_name :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()

{-# DEPRECATED dOMHTMLElementSetClassName ["(Since version 1.10)","Use webkit_dom_element_set_class_name() instead."]#-}
dOMHTMLElementSetClassName ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetClassName _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_element_set_class_name _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLElement::set_content_editable
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_content_editable" webkit_dom_html_element_set_content_editable :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLElementSetContentEditable ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetContentEditable _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    onException (do
        propagateGError $ webkit_dom_html_element_set_content_editable _obj' value'
        touchManagedPtr _obj
        freeMem value'
        return ()
     ) (do
        freeMem value'
     )

-- method DOMHTMLElement::set_dir
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_dir" webkit_dom_html_element_set_dir :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLElementSetDir ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetDir _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_element_set_dir _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLElement::set_draggable
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_draggable" webkit_dom_html_element_set_draggable :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLElementSetDraggable ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLElementSetDraggable _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_element_set_draggable _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLElement::set_hidden
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_hidden" webkit_dom_html_element_set_hidden :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLElementSetHidden ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLElementSetHidden _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_element_set_hidden _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLElement::set_id
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_id" webkit_dom_html_element_set_id :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()

{-# DEPRECATED dOMHTMLElementSetId ["(Since version 2.2)","Use webkit_dom_element_set_id() instead."]#-}
dOMHTMLElementSetId ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetId _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_element_set_id _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLElement::set_inner_html
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_inner_html" webkit_dom_html_element_set_inner_html :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLElementSetInnerHtml ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetInnerHtml _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    onException (do
        propagateGError $ webkit_dom_html_element_set_inner_html _obj' value'
        touchManagedPtr _obj
        freeMem value'
        return ()
     ) (do
        freeMem value'
     )

-- method DOMHTMLElement::set_inner_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_inner_text" webkit_dom_html_element_set_inner_text :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLElementSetInnerText ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetInnerText _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    onException (do
        propagateGError $ webkit_dom_html_element_set_inner_text _obj' value'
        touchManagedPtr _obj
        freeMem value'
        return ()
     ) (do
        freeMem value'
     )

-- method DOMHTMLElement::set_item_id
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_item_id" webkit_dom_html_element_set_item_id :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()

{-# DEPRECATED dOMHTMLElementSetItemId ["(Since version 2.2)"]#-}
dOMHTMLElementSetItemId ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetItemId _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_element_set_item_id _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLElement::set_item_scope
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_item_scope" webkit_dom_html_element_set_item_scope :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()

{-# DEPRECATED dOMHTMLElementSetItemScope ["(Since version 2.2)"]#-}
dOMHTMLElementSetItemScope ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLElementSetItemScope _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_element_set_item_scope _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLElement::set_lang
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_lang" webkit_dom_html_element_set_lang :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLElementSetLang ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetLang _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_element_set_lang _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLElement::set_outer_html
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_outer_html" webkit_dom_html_element_set_outer_html :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLElementSetOuterHtml ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetOuterHtml _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    onException (do
        propagateGError $ webkit_dom_html_element_set_outer_html _obj' value'
        touchManagedPtr _obj
        freeMem value'
        return ()
     ) (do
        freeMem value'
     )

-- method DOMHTMLElement::set_outer_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_outer_text" webkit_dom_html_element_set_outer_text :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLElementSetOuterText ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetOuterText _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    onException (do
        propagateGError $ webkit_dom_html_element_set_outer_text _obj' value'
        touchManagedPtr _obj
        freeMem value'
        return ()
     ) (do
        freeMem value'
     )

-- method DOMHTMLElement::set_spellcheck
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_spellcheck" webkit_dom_html_element_set_spellcheck :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLElementSetSpellcheck ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLElementSetSpellcheck _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_element_set_spellcheck _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLElement::set_tab_index
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_tab_index" webkit_dom_html_element_set_tab_index :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    Int64 ->                                -- value : TBasicType TInt64
    IO ()


dOMHTMLElementSetTabIndex ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLElementSetTabIndex _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_element_set_tab_index _obj' value
    touchManagedPtr _obj
    return ()

-- method DOMHTMLElement::set_title
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_title" webkit_dom_html_element_set_title :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLElementSetTitle ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetTitle _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_element_set_title _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLElement::set_translate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_translate" webkit_dom_html_element_set_translate :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLElementSetTranslate ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLElementSetTranslate _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_element_set_translate _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLElement::set_webkitdropzone
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_element_set_webkitdropzone" webkit_dom_html_element_set_webkitdropzone :: 
    Ptr DOMHTMLElement ->                   -- _obj : TInterface "WebKit" "DOMHTMLElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLElementSetWebkitdropzone ::
    (MonadIO m, DOMHTMLElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLElementSetWebkitdropzone _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_element_set_webkitdropzone _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


