
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLFontElement
    ( 

-- * Exported types
    DOMHTMLFontElement(..)                  ,
    DOMHTMLFontElementK                     ,
    toDOMHTMLFontElement                    ,
    noDOMHTMLFontElement                    ,


 -- * Methods
-- ** dOMHTMLFontElementGetColor
    dOMHTMLFontElementGetColor              ,


-- ** dOMHTMLFontElementGetFace
    dOMHTMLFontElementGetFace               ,


-- ** dOMHTMLFontElementGetSize
    dOMHTMLFontElementGetSize               ,


-- ** dOMHTMLFontElementSetColor
    dOMHTMLFontElementSetColor              ,


-- ** dOMHTMLFontElementSetFace
    dOMHTMLFontElementSetFace               ,


-- ** dOMHTMLFontElementSetSize
    dOMHTMLFontElementSetSize               ,




 -- * Properties
-- ** Color
    DOMHTMLFontElementColorPropertyInfo     ,
    constructDOMHTMLFontElementColor        ,
    getDOMHTMLFontElementColor              ,
    setDOMHTMLFontElementColor              ,


-- ** Face
    DOMHTMLFontElementFacePropertyInfo      ,
    constructDOMHTMLFontElementFace         ,
    getDOMHTMLFontElementFace               ,
    setDOMHTMLFontElementFace               ,


-- ** Size
    DOMHTMLFontElementSizePropertyInfo      ,
    constructDOMHTMLFontElementSize         ,
    getDOMHTMLFontElementSize               ,
    setDOMHTMLFontElementSize               ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLFontElement = DOMHTMLFontElement (ForeignPtr DOMHTMLFontElement)
foreign import ccall "webkit_dom_html_font_element_get_type"
    c_webkit_dom_html_font_element_get_type :: IO GType

type instance ParentTypes DOMHTMLFontElement = DOMHTMLFontElementParentTypes
type DOMHTMLFontElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLFontElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_font_element_get_type
    

class GObject o => DOMHTMLFontElementK o
instance (GObject o, IsDescendantOf DOMHTMLFontElement o) => DOMHTMLFontElementK o

toDOMHTMLFontElement :: DOMHTMLFontElementK o => o -> IO DOMHTMLFontElement
toDOMHTMLFontElement = unsafeCastTo DOMHTMLFontElement

noDOMHTMLFontElement :: Maybe DOMHTMLFontElement
noDOMHTMLFontElement = Nothing

-- VVV Prop "color"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFontElementColor :: (MonadIO m, DOMHTMLFontElementK o) => o -> m T.Text
getDOMHTMLFontElementColor obj = liftIO $ getObjectPropertyString obj "color"

setDOMHTMLFontElementColor :: (MonadIO m, DOMHTMLFontElementK o) => o -> T.Text -> m ()
setDOMHTMLFontElementColor obj val = liftIO $ setObjectPropertyString obj "color" val

constructDOMHTMLFontElementColor :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFontElementColor val = constructObjectPropertyString "color" val

data DOMHTMLFontElementColorPropertyInfo
instance AttrInfo DOMHTMLFontElementColorPropertyInfo where
    type AttrAllowedOps DOMHTMLFontElementColorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFontElementColorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFontElementColorPropertyInfo = DOMHTMLFontElementK
    type AttrGetType DOMHTMLFontElementColorPropertyInfo = T.Text
    type AttrLabel DOMHTMLFontElementColorPropertyInfo = "DOMHTMLFontElement::color"
    attrGet _ = getDOMHTMLFontElementColor
    attrSet _ = setDOMHTMLFontElementColor
    attrConstruct _ = constructDOMHTMLFontElementColor

-- VVV Prop "face"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFontElementFace :: (MonadIO m, DOMHTMLFontElementK o) => o -> m T.Text
getDOMHTMLFontElementFace obj = liftIO $ getObjectPropertyString obj "face"

setDOMHTMLFontElementFace :: (MonadIO m, DOMHTMLFontElementK o) => o -> T.Text -> m ()
setDOMHTMLFontElementFace obj val = liftIO $ setObjectPropertyString obj "face" val

constructDOMHTMLFontElementFace :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFontElementFace val = constructObjectPropertyString "face" val

data DOMHTMLFontElementFacePropertyInfo
instance AttrInfo DOMHTMLFontElementFacePropertyInfo where
    type AttrAllowedOps DOMHTMLFontElementFacePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFontElementFacePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFontElementFacePropertyInfo = DOMHTMLFontElementK
    type AttrGetType DOMHTMLFontElementFacePropertyInfo = T.Text
    type AttrLabel DOMHTMLFontElementFacePropertyInfo = "DOMHTMLFontElement::face"
    attrGet _ = getDOMHTMLFontElementFace
    attrSet _ = setDOMHTMLFontElementFace
    attrConstruct _ = constructDOMHTMLFontElementFace

-- VVV Prop "size"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFontElementSize :: (MonadIO m, DOMHTMLFontElementK o) => o -> m T.Text
getDOMHTMLFontElementSize obj = liftIO $ getObjectPropertyString obj "size"

setDOMHTMLFontElementSize :: (MonadIO m, DOMHTMLFontElementK o) => o -> T.Text -> m ()
setDOMHTMLFontElementSize obj val = liftIO $ setObjectPropertyString obj "size" val

constructDOMHTMLFontElementSize :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFontElementSize val = constructObjectPropertyString "size" val

data DOMHTMLFontElementSizePropertyInfo
instance AttrInfo DOMHTMLFontElementSizePropertyInfo where
    type AttrAllowedOps DOMHTMLFontElementSizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFontElementSizePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFontElementSizePropertyInfo = DOMHTMLFontElementK
    type AttrGetType DOMHTMLFontElementSizePropertyInfo = T.Text
    type AttrLabel DOMHTMLFontElementSizePropertyInfo = "DOMHTMLFontElement::size"
    attrGet _ = getDOMHTMLFontElementSize
    attrSet _ = setDOMHTMLFontElementSize
    attrConstruct _ = constructDOMHTMLFontElementSize

type instance AttributeList DOMHTMLFontElement = DOMHTMLFontElementAttributeList
type DOMHTMLFontElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("color", DOMHTMLFontElementColorPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("face", DOMHTMLFontElementFacePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("size", DOMHTMLFontElementSizePropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLFontElement = DOMHTMLFontElementSignalList
type DOMHTMLFontElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLFontElement::get_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_font_element_get_color" webkit_dom_html_font_element_get_color :: 
    Ptr DOMHTMLFontElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFontElement"
    IO CString


dOMHTMLFontElementGetColor ::
    (MonadIO m, DOMHTMLFontElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFontElementGetColor _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_font_element_get_color _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_font_element_get_color" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFontElement::get_face
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_font_element_get_face" webkit_dom_html_font_element_get_face :: 
    Ptr DOMHTMLFontElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFontElement"
    IO CString


dOMHTMLFontElementGetFace ::
    (MonadIO m, DOMHTMLFontElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFontElementGetFace _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_font_element_get_face _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_font_element_get_face" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFontElement::get_size
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_font_element_get_size" webkit_dom_html_font_element_get_size :: 
    Ptr DOMHTMLFontElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFontElement"
    IO CString


dOMHTMLFontElementGetSize ::
    (MonadIO m, DOMHTMLFontElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFontElementGetSize _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_font_element_get_size _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_font_element_get_size" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFontElement::set_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_font_element_set_color" webkit_dom_html_font_element_set_color :: 
    Ptr DOMHTMLFontElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFontElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFontElementSetColor ::
    (MonadIO m, DOMHTMLFontElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFontElementSetColor _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_font_element_set_color _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFontElement::set_face
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_font_element_set_face" webkit_dom_html_font_element_set_face :: 
    Ptr DOMHTMLFontElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFontElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFontElementSetFace ::
    (MonadIO m, DOMHTMLFontElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFontElementSetFace _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_font_element_set_face _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFontElement::set_size
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFontElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_font_element_set_size" webkit_dom_html_font_element_set_size :: 
    Ptr DOMHTMLFontElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFontElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFontElementSetSize ::
    (MonadIO m, DOMHTMLFontElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFontElementSetSize _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_font_element_set_size _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


