
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLFormElement
    ( 

-- * Exported types
    DOMHTMLFormElement(..)                  ,
    DOMHTMLFormElementK                     ,
    toDOMHTMLFormElement                    ,
    noDOMHTMLFormElement                    ,


 -- * Methods
-- ** dOMHTMLFormElementCheckValidity
    dOMHTMLFormElementCheckValidity         ,


-- ** dOMHTMLFormElementDispatchFormChange
    dOMHTMLFormElementDispatchFormChange    ,


-- ** dOMHTMLFormElementDispatchFormInput
    dOMHTMLFormElementDispatchFormInput     ,


-- ** dOMHTMLFormElementGetAcceptCharset
    dOMHTMLFormElementGetAcceptCharset      ,


-- ** dOMHTMLFormElementGetAction
    dOMHTMLFormElementGetAction             ,


-- ** dOMHTMLFormElementGetAutocapitalize
    dOMHTMLFormElementGetAutocapitalize     ,


-- ** dOMHTMLFormElementGetAutocomplete
    dOMHTMLFormElementGetAutocomplete       ,


-- ** dOMHTMLFormElementGetAutocorrect
    dOMHTMLFormElementGetAutocorrect        ,


-- ** dOMHTMLFormElementGetElements
    dOMHTMLFormElementGetElements           ,


-- ** dOMHTMLFormElementGetEncoding
    dOMHTMLFormElementGetEncoding           ,


-- ** dOMHTMLFormElementGetEnctype
    dOMHTMLFormElementGetEnctype            ,


-- ** dOMHTMLFormElementGetLength
    dOMHTMLFormElementGetLength             ,


-- ** dOMHTMLFormElementGetMethod
    dOMHTMLFormElementGetMethod             ,


-- ** dOMHTMLFormElementGetName
    dOMHTMLFormElementGetName               ,


-- ** dOMHTMLFormElementGetNoValidate
    dOMHTMLFormElementGetNoValidate         ,


-- ** dOMHTMLFormElementGetTarget
    dOMHTMLFormElementGetTarget             ,


-- ** dOMHTMLFormElementReset
    dOMHTMLFormElementReset                 ,


-- ** dOMHTMLFormElementSetAcceptCharset
    dOMHTMLFormElementSetAcceptCharset      ,


-- ** dOMHTMLFormElementSetAction
    dOMHTMLFormElementSetAction             ,


-- ** dOMHTMLFormElementSetAutocapitalize
    dOMHTMLFormElementSetAutocapitalize     ,


-- ** dOMHTMLFormElementSetAutocomplete
    dOMHTMLFormElementSetAutocomplete       ,


-- ** dOMHTMLFormElementSetAutocorrect
    dOMHTMLFormElementSetAutocorrect        ,


-- ** dOMHTMLFormElementSetEncoding
    dOMHTMLFormElementSetEncoding           ,


-- ** dOMHTMLFormElementSetEnctype
    dOMHTMLFormElementSetEnctype            ,


-- ** dOMHTMLFormElementSetMethod
    dOMHTMLFormElementSetMethod             ,


-- ** dOMHTMLFormElementSetName
    dOMHTMLFormElementSetName               ,


-- ** dOMHTMLFormElementSetNoValidate
    dOMHTMLFormElementSetNoValidate         ,


-- ** dOMHTMLFormElementSetTarget
    dOMHTMLFormElementSetTarget             ,


-- ** dOMHTMLFormElementSubmit
    dOMHTMLFormElementSubmit                ,




 -- * Properties
-- ** AcceptCharset
    DOMHTMLFormElementAcceptCharsetPropertyInfo,
    constructDOMHTMLFormElementAcceptCharset,
    getDOMHTMLFormElementAcceptCharset      ,
    setDOMHTMLFormElementAcceptCharset      ,


-- ** Action
    DOMHTMLFormElementActionPropertyInfo    ,
    constructDOMHTMLFormElementAction       ,
    getDOMHTMLFormElementAction             ,
    setDOMHTMLFormElementAction             ,


-- ** Autocapitalize
    DOMHTMLFormElementAutocapitalizePropertyInfo,
    constructDOMHTMLFormElementAutocapitalize,
    getDOMHTMLFormElementAutocapitalize     ,
    setDOMHTMLFormElementAutocapitalize     ,


-- ** Autocomplete
    DOMHTMLFormElementAutocompletePropertyInfo,
    constructDOMHTMLFormElementAutocomplete ,
    getDOMHTMLFormElementAutocomplete       ,
    setDOMHTMLFormElementAutocomplete       ,


-- ** Autocorrect
    DOMHTMLFormElementAutocorrectPropertyInfo,
    constructDOMHTMLFormElementAutocorrect  ,
    getDOMHTMLFormElementAutocorrect        ,
    setDOMHTMLFormElementAutocorrect        ,


-- ** Elements
    DOMHTMLFormElementElementsPropertyInfo  ,
    getDOMHTMLFormElementElements           ,


-- ** Encoding
    DOMHTMLFormElementEncodingPropertyInfo  ,
    constructDOMHTMLFormElementEncoding     ,
    getDOMHTMLFormElementEncoding           ,
    setDOMHTMLFormElementEncoding           ,


-- ** Enctype
    DOMHTMLFormElementEnctypePropertyInfo   ,
    constructDOMHTMLFormElementEnctype      ,
    getDOMHTMLFormElementEnctype            ,
    setDOMHTMLFormElementEnctype            ,


-- ** Length
    DOMHTMLFormElementLengthPropertyInfo    ,
    getDOMHTMLFormElementLength             ,


-- ** Method
    DOMHTMLFormElementMethodPropertyInfo    ,
    constructDOMHTMLFormElementMethod       ,
    getDOMHTMLFormElementMethod             ,
    setDOMHTMLFormElementMethod             ,


-- ** Name
    DOMHTMLFormElementNamePropertyInfo      ,
    constructDOMHTMLFormElementName         ,
    getDOMHTMLFormElementName               ,
    setDOMHTMLFormElementName               ,


-- ** NoValidate
    DOMHTMLFormElementNoValidatePropertyInfo,
    constructDOMHTMLFormElementNoValidate   ,
    getDOMHTMLFormElementNoValidate         ,
    setDOMHTMLFormElementNoValidate         ,


-- ** Target
    DOMHTMLFormElementTargetPropertyInfo    ,
    constructDOMHTMLFormElementTarget       ,
    getDOMHTMLFormElementTarget             ,
    setDOMHTMLFormElementTarget             ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLFormElement = DOMHTMLFormElement (ForeignPtr DOMHTMLFormElement)
foreign import ccall "webkit_dom_html_form_element_get_type"
    c_webkit_dom_html_form_element_get_type :: IO GType

type instance ParentTypes DOMHTMLFormElement = DOMHTMLFormElementParentTypes
type DOMHTMLFormElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLFormElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_form_element_get_type
    

class GObject o => DOMHTMLFormElementK o
instance (GObject o, IsDescendantOf DOMHTMLFormElement o) => DOMHTMLFormElementK o

toDOMHTMLFormElement :: DOMHTMLFormElementK o => o -> IO DOMHTMLFormElement
toDOMHTMLFormElement = unsafeCastTo DOMHTMLFormElement

noDOMHTMLFormElement :: Maybe DOMHTMLFormElement
noDOMHTMLFormElement = Nothing

-- VVV Prop "accept-charset"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFormElementAcceptCharset :: (MonadIO m, DOMHTMLFormElementK o) => o -> m T.Text
getDOMHTMLFormElementAcceptCharset obj = liftIO $ getObjectPropertyString obj "accept-charset"

setDOMHTMLFormElementAcceptCharset :: (MonadIO m, DOMHTMLFormElementK o) => o -> T.Text -> m ()
setDOMHTMLFormElementAcceptCharset obj val = liftIO $ setObjectPropertyString obj "accept-charset" val

constructDOMHTMLFormElementAcceptCharset :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFormElementAcceptCharset val = constructObjectPropertyString "accept-charset" val

data DOMHTMLFormElementAcceptCharsetPropertyInfo
instance AttrInfo DOMHTMLFormElementAcceptCharsetPropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementAcceptCharsetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementAcceptCharsetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFormElementAcceptCharsetPropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementAcceptCharsetPropertyInfo = T.Text
    type AttrLabel DOMHTMLFormElementAcceptCharsetPropertyInfo = "DOMHTMLFormElement::accept-charset"
    attrGet _ = getDOMHTMLFormElementAcceptCharset
    attrSet _ = setDOMHTMLFormElementAcceptCharset
    attrConstruct _ = constructDOMHTMLFormElementAcceptCharset

-- VVV Prop "action"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFormElementAction :: (MonadIO m, DOMHTMLFormElementK o) => o -> m T.Text
getDOMHTMLFormElementAction obj = liftIO $ getObjectPropertyString obj "action"

setDOMHTMLFormElementAction :: (MonadIO m, DOMHTMLFormElementK o) => o -> T.Text -> m ()
setDOMHTMLFormElementAction obj val = liftIO $ setObjectPropertyString obj "action" val

constructDOMHTMLFormElementAction :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFormElementAction val = constructObjectPropertyString "action" val

data DOMHTMLFormElementActionPropertyInfo
instance AttrInfo DOMHTMLFormElementActionPropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementActionPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementActionPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFormElementActionPropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementActionPropertyInfo = T.Text
    type AttrLabel DOMHTMLFormElementActionPropertyInfo = "DOMHTMLFormElement::action"
    attrGet _ = getDOMHTMLFormElementAction
    attrSet _ = setDOMHTMLFormElementAction
    attrConstruct _ = constructDOMHTMLFormElementAction

-- VVV Prop "autocapitalize"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFormElementAutocapitalize :: (MonadIO m, DOMHTMLFormElementK o) => o -> m T.Text
getDOMHTMLFormElementAutocapitalize obj = liftIO $ getObjectPropertyString obj "autocapitalize"

setDOMHTMLFormElementAutocapitalize :: (MonadIO m, DOMHTMLFormElementK o) => o -> T.Text -> m ()
setDOMHTMLFormElementAutocapitalize obj val = liftIO $ setObjectPropertyString obj "autocapitalize" val

constructDOMHTMLFormElementAutocapitalize :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFormElementAutocapitalize val = constructObjectPropertyString "autocapitalize" val

data DOMHTMLFormElementAutocapitalizePropertyInfo
instance AttrInfo DOMHTMLFormElementAutocapitalizePropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementAutocapitalizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementAutocapitalizePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFormElementAutocapitalizePropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementAutocapitalizePropertyInfo = T.Text
    type AttrLabel DOMHTMLFormElementAutocapitalizePropertyInfo = "DOMHTMLFormElement::autocapitalize"
    attrGet _ = getDOMHTMLFormElementAutocapitalize
    attrSet _ = setDOMHTMLFormElementAutocapitalize
    attrConstruct _ = constructDOMHTMLFormElementAutocapitalize

-- VVV Prop "autocomplete"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFormElementAutocomplete :: (MonadIO m, DOMHTMLFormElementK o) => o -> m T.Text
getDOMHTMLFormElementAutocomplete obj = liftIO $ getObjectPropertyString obj "autocomplete"

setDOMHTMLFormElementAutocomplete :: (MonadIO m, DOMHTMLFormElementK o) => o -> T.Text -> m ()
setDOMHTMLFormElementAutocomplete obj val = liftIO $ setObjectPropertyString obj "autocomplete" val

constructDOMHTMLFormElementAutocomplete :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFormElementAutocomplete val = constructObjectPropertyString "autocomplete" val

data DOMHTMLFormElementAutocompletePropertyInfo
instance AttrInfo DOMHTMLFormElementAutocompletePropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementAutocompletePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementAutocompletePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFormElementAutocompletePropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementAutocompletePropertyInfo = T.Text
    type AttrLabel DOMHTMLFormElementAutocompletePropertyInfo = "DOMHTMLFormElement::autocomplete"
    attrGet _ = getDOMHTMLFormElementAutocomplete
    attrSet _ = setDOMHTMLFormElementAutocomplete
    attrConstruct _ = constructDOMHTMLFormElementAutocomplete

-- VVV Prop "autocorrect"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFormElementAutocorrect :: (MonadIO m, DOMHTMLFormElementK o) => o -> m Bool
getDOMHTMLFormElementAutocorrect obj = liftIO $ getObjectPropertyBool obj "autocorrect"

setDOMHTMLFormElementAutocorrect :: (MonadIO m, DOMHTMLFormElementK o) => o -> Bool -> m ()
setDOMHTMLFormElementAutocorrect obj val = liftIO $ setObjectPropertyBool obj "autocorrect" val

constructDOMHTMLFormElementAutocorrect :: Bool -> IO ([Char], GValue)
constructDOMHTMLFormElementAutocorrect val = constructObjectPropertyBool "autocorrect" val

data DOMHTMLFormElementAutocorrectPropertyInfo
instance AttrInfo DOMHTMLFormElementAutocorrectPropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementAutocorrectPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementAutocorrectPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLFormElementAutocorrectPropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementAutocorrectPropertyInfo = Bool
    type AttrLabel DOMHTMLFormElementAutocorrectPropertyInfo = "DOMHTMLFormElement::autocorrect"
    attrGet _ = getDOMHTMLFormElementAutocorrect
    attrSet _ = setDOMHTMLFormElementAutocorrect
    attrConstruct _ = constructDOMHTMLFormElementAutocorrect

-- VVV Prop "elements"
   -- Type: TInterface "WebKit" "DOMHTMLCollection"
   -- Flags: [PropertyReadable]

getDOMHTMLFormElementElements :: (MonadIO m, DOMHTMLFormElementK o) => o -> m DOMHTMLCollection
getDOMHTMLFormElementElements obj = liftIO $ getObjectPropertyObject obj "elements" DOMHTMLCollection

data DOMHTMLFormElementElementsPropertyInfo
instance AttrInfo DOMHTMLFormElementElementsPropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementElementsPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementElementsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLFormElementElementsPropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementElementsPropertyInfo = DOMHTMLCollection
    type AttrLabel DOMHTMLFormElementElementsPropertyInfo = "DOMHTMLFormElement::elements"
    attrGet _ = getDOMHTMLFormElementElements
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "encoding"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFormElementEncoding :: (MonadIO m, DOMHTMLFormElementK o) => o -> m T.Text
getDOMHTMLFormElementEncoding obj = liftIO $ getObjectPropertyString obj "encoding"

setDOMHTMLFormElementEncoding :: (MonadIO m, DOMHTMLFormElementK o) => o -> T.Text -> m ()
setDOMHTMLFormElementEncoding obj val = liftIO $ setObjectPropertyString obj "encoding" val

constructDOMHTMLFormElementEncoding :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFormElementEncoding val = constructObjectPropertyString "encoding" val

data DOMHTMLFormElementEncodingPropertyInfo
instance AttrInfo DOMHTMLFormElementEncodingPropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementEncodingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementEncodingPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFormElementEncodingPropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementEncodingPropertyInfo = T.Text
    type AttrLabel DOMHTMLFormElementEncodingPropertyInfo = "DOMHTMLFormElement::encoding"
    attrGet _ = getDOMHTMLFormElementEncoding
    attrSet _ = setDOMHTMLFormElementEncoding
    attrConstruct _ = constructDOMHTMLFormElementEncoding

-- VVV Prop "enctype"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFormElementEnctype :: (MonadIO m, DOMHTMLFormElementK o) => o -> m T.Text
getDOMHTMLFormElementEnctype obj = liftIO $ getObjectPropertyString obj "enctype"

setDOMHTMLFormElementEnctype :: (MonadIO m, DOMHTMLFormElementK o) => o -> T.Text -> m ()
setDOMHTMLFormElementEnctype obj val = liftIO $ setObjectPropertyString obj "enctype" val

constructDOMHTMLFormElementEnctype :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFormElementEnctype val = constructObjectPropertyString "enctype" val

data DOMHTMLFormElementEnctypePropertyInfo
instance AttrInfo DOMHTMLFormElementEnctypePropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementEnctypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementEnctypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFormElementEnctypePropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementEnctypePropertyInfo = T.Text
    type AttrLabel DOMHTMLFormElementEnctypePropertyInfo = "DOMHTMLFormElement::enctype"
    attrGet _ = getDOMHTMLFormElementEnctype
    attrSet _ = setDOMHTMLFormElementEnctype
    attrConstruct _ = constructDOMHTMLFormElementEnctype

-- VVV Prop "length"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable]

getDOMHTMLFormElementLength :: (MonadIO m, DOMHTMLFormElementK o) => o -> m Int64
getDOMHTMLFormElementLength obj = liftIO $ getObjectPropertyInt64 obj "length"

data DOMHTMLFormElementLengthPropertyInfo
instance AttrInfo DOMHTMLFormElementLengthPropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementLengthPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementLengthPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLFormElementLengthPropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementLengthPropertyInfo = Int64
    type AttrLabel DOMHTMLFormElementLengthPropertyInfo = "DOMHTMLFormElement::length"
    attrGet _ = getDOMHTMLFormElementLength
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "method"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFormElementMethod :: (MonadIO m, DOMHTMLFormElementK o) => o -> m T.Text
getDOMHTMLFormElementMethod obj = liftIO $ getObjectPropertyString obj "method"

setDOMHTMLFormElementMethod :: (MonadIO m, DOMHTMLFormElementK o) => o -> T.Text -> m ()
setDOMHTMLFormElementMethod obj val = liftIO $ setObjectPropertyString obj "method" val

constructDOMHTMLFormElementMethod :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFormElementMethod val = constructObjectPropertyString "method" val

data DOMHTMLFormElementMethodPropertyInfo
instance AttrInfo DOMHTMLFormElementMethodPropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementMethodPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementMethodPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFormElementMethodPropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementMethodPropertyInfo = T.Text
    type AttrLabel DOMHTMLFormElementMethodPropertyInfo = "DOMHTMLFormElement::method"
    attrGet _ = getDOMHTMLFormElementMethod
    attrSet _ = setDOMHTMLFormElementMethod
    attrConstruct _ = constructDOMHTMLFormElementMethod

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFormElementName :: (MonadIO m, DOMHTMLFormElementK o) => o -> m T.Text
getDOMHTMLFormElementName obj = liftIO $ getObjectPropertyString obj "name"

setDOMHTMLFormElementName :: (MonadIO m, DOMHTMLFormElementK o) => o -> T.Text -> m ()
setDOMHTMLFormElementName obj val = liftIO $ setObjectPropertyString obj "name" val

constructDOMHTMLFormElementName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFormElementName val = constructObjectPropertyString "name" val

data DOMHTMLFormElementNamePropertyInfo
instance AttrInfo DOMHTMLFormElementNamePropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFormElementNamePropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLFormElementNamePropertyInfo = "DOMHTMLFormElement::name"
    attrGet _ = getDOMHTMLFormElementName
    attrSet _ = setDOMHTMLFormElementName
    attrConstruct _ = constructDOMHTMLFormElementName

-- VVV Prop "no-validate"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFormElementNoValidate :: (MonadIO m, DOMHTMLFormElementK o) => o -> m Bool
getDOMHTMLFormElementNoValidate obj = liftIO $ getObjectPropertyBool obj "no-validate"

setDOMHTMLFormElementNoValidate :: (MonadIO m, DOMHTMLFormElementK o) => o -> Bool -> m ()
setDOMHTMLFormElementNoValidate obj val = liftIO $ setObjectPropertyBool obj "no-validate" val

constructDOMHTMLFormElementNoValidate :: Bool -> IO ([Char], GValue)
constructDOMHTMLFormElementNoValidate val = constructObjectPropertyBool "no-validate" val

data DOMHTMLFormElementNoValidatePropertyInfo
instance AttrInfo DOMHTMLFormElementNoValidatePropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementNoValidatePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementNoValidatePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLFormElementNoValidatePropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementNoValidatePropertyInfo = Bool
    type AttrLabel DOMHTMLFormElementNoValidatePropertyInfo = "DOMHTMLFormElement::no-validate"
    attrGet _ = getDOMHTMLFormElementNoValidate
    attrSet _ = setDOMHTMLFormElementNoValidate
    attrConstruct _ = constructDOMHTMLFormElementNoValidate

-- VVV Prop "target"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFormElementTarget :: (MonadIO m, DOMHTMLFormElementK o) => o -> m T.Text
getDOMHTMLFormElementTarget obj = liftIO $ getObjectPropertyString obj "target"

setDOMHTMLFormElementTarget :: (MonadIO m, DOMHTMLFormElementK o) => o -> T.Text -> m ()
setDOMHTMLFormElementTarget obj val = liftIO $ setObjectPropertyString obj "target" val

constructDOMHTMLFormElementTarget :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFormElementTarget val = constructObjectPropertyString "target" val

data DOMHTMLFormElementTargetPropertyInfo
instance AttrInfo DOMHTMLFormElementTargetPropertyInfo where
    type AttrAllowedOps DOMHTMLFormElementTargetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFormElementTargetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFormElementTargetPropertyInfo = DOMHTMLFormElementK
    type AttrGetType DOMHTMLFormElementTargetPropertyInfo = T.Text
    type AttrLabel DOMHTMLFormElementTargetPropertyInfo = "DOMHTMLFormElement::target"
    attrGet _ = getDOMHTMLFormElementTarget
    attrSet _ = setDOMHTMLFormElementTarget
    attrConstruct _ = constructDOMHTMLFormElementTarget

type instance AttributeList DOMHTMLFormElement = DOMHTMLFormElementAttributeList
type DOMHTMLFormElementAttributeList = ('[ '("accept-charset", DOMHTMLFormElementAcceptCharsetPropertyInfo), '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("action", DOMHTMLFormElementActionPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("autocapitalize", DOMHTMLFormElementAutocapitalizePropertyInfo), '("autocomplete", DOMHTMLFormElementAutocompletePropertyInfo), '("autocorrect", DOMHTMLFormElementAutocorrectPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("elements", DOMHTMLFormElementElementsPropertyInfo), '("encoding", DOMHTMLFormElementEncodingPropertyInfo), '("enctype", DOMHTMLFormElementEnctypePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("length", DOMHTMLFormElementLengthPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("method", DOMHTMLFormElementMethodPropertyInfo), '("name", DOMHTMLFormElementNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("no-validate", DOMHTMLFormElementNoValidatePropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("target", DOMHTMLFormElementTargetPropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLFormElement = DOMHTMLFormElementSignalList
type DOMHTMLFormElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLFormElement::check_validity
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_check_validity" webkit_dom_html_form_element_check_validity :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO CInt


dOMHTMLFormElementCheckValidity ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLFormElementCheckValidity _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_check_validity _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::dispatch_form_change
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_dispatch_form_change" webkit_dom_html_form_element_dispatch_form_change :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO ()

{-# DEPRECATED dOMHTMLFormElementDispatchFormChange ["(Since version 1.6)"]#-}
dOMHTMLFormElementDispatchFormChange ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLFormElementDispatchFormChange _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_form_element_dispatch_form_change _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLFormElement::dispatch_form_input
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_dispatch_form_input" webkit_dom_html_form_element_dispatch_form_input :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO ()

{-# DEPRECATED dOMHTMLFormElementDispatchFormInput ["(Since version 1.6)"]#-}
dOMHTMLFormElementDispatchFormInput ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLFormElementDispatchFormInput _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_form_element_dispatch_form_input _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLFormElement::get_accept_charset
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_accept_charset" webkit_dom_html_form_element_get_accept_charset :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO CString


dOMHTMLFormElementGetAcceptCharset ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFormElementGetAcceptCharset _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_accept_charset _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_form_element_get_accept_charset" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::get_action
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_action" webkit_dom_html_form_element_get_action :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO CString


dOMHTMLFormElementGetAction ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFormElementGetAction _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_action _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_form_element_get_action" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::get_autocapitalize
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_autocapitalize" webkit_dom_html_form_element_get_autocapitalize :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO CString


dOMHTMLFormElementGetAutocapitalize ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFormElementGetAutocapitalize _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_autocapitalize _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_form_element_get_autocapitalize" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::get_autocomplete
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_autocomplete" webkit_dom_html_form_element_get_autocomplete :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO CString


dOMHTMLFormElementGetAutocomplete ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFormElementGetAutocomplete _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_autocomplete _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_form_element_get_autocomplete" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::get_autocorrect
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_autocorrect" webkit_dom_html_form_element_get_autocorrect :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO CInt


dOMHTMLFormElementGetAutocorrect ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLFormElementGetAutocorrect _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_autocorrect _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::get_elements
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLCollection"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_elements" webkit_dom_html_form_element_get_elements :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO (Ptr DOMHTMLCollection)


dOMHTMLFormElementGetElements ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLCollection
dOMHTMLFormElementGetElements _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_elements _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_form_element_get_elements" result
    result' <- (wrapObject DOMHTMLCollection) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::get_encoding
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_encoding" webkit_dom_html_form_element_get_encoding :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO CString


dOMHTMLFormElementGetEncoding ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFormElementGetEncoding _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_encoding _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_form_element_get_encoding" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::get_enctype
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_enctype" webkit_dom_html_form_element_get_enctype :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO CString


dOMHTMLFormElementGetEnctype ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFormElementGetEnctype _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_enctype _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_form_element_get_enctype" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::get_length
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_length" webkit_dom_html_form_element_get_length :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO Int64


dOMHTMLFormElementGetLength ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLFormElementGetLength _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_length _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLFormElement::get_method
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_method" webkit_dom_html_form_element_get_method :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO CString


dOMHTMLFormElementGetMethod ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFormElementGetMethod _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_method _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_form_element_get_method" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_name" webkit_dom_html_form_element_get_name :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO CString


dOMHTMLFormElementGetName ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFormElementGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_form_element_get_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::get_no_validate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_no_validate" webkit_dom_html_form_element_get_no_validate :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO CInt


dOMHTMLFormElementGetNoValidate ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLFormElementGetNoValidate _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_no_validate _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::get_target
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_get_target" webkit_dom_html_form_element_get_target :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO CString


dOMHTMLFormElementGetTarget ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFormElementGetTarget _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_form_element_get_target _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_form_element_get_target" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFormElement::reset
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_reset" webkit_dom_html_form_element_reset :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO ()


dOMHTMLFormElementReset ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLFormElementReset _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_form_element_reset _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLFormElement::set_accept_charset
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_set_accept_charset" webkit_dom_html_form_element_set_accept_charset :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFormElementSetAcceptCharset ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFormElementSetAcceptCharset _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_form_element_set_accept_charset _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFormElement::set_action
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_set_action" webkit_dom_html_form_element_set_action :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFormElementSetAction ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFormElementSetAction _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_form_element_set_action _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFormElement::set_autocapitalize
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_set_autocapitalize" webkit_dom_html_form_element_set_autocapitalize :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFormElementSetAutocapitalize ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFormElementSetAutocapitalize _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_form_element_set_autocapitalize _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFormElement::set_autocomplete
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_set_autocomplete" webkit_dom_html_form_element_set_autocomplete :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFormElementSetAutocomplete ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFormElementSetAutocomplete _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_form_element_set_autocomplete _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFormElement::set_autocorrect
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_set_autocorrect" webkit_dom_html_form_element_set_autocorrect :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLFormElementSetAutocorrect ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLFormElementSetAutocorrect _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_form_element_set_autocorrect _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLFormElement::set_encoding
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_set_encoding" webkit_dom_html_form_element_set_encoding :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFormElementSetEncoding ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFormElementSetEncoding _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_form_element_set_encoding _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFormElement::set_enctype
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_set_enctype" webkit_dom_html_form_element_set_enctype :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFormElementSetEnctype ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFormElementSetEnctype _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_form_element_set_enctype _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFormElement::set_method
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_set_method" webkit_dom_html_form_element_set_method :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFormElementSetMethod ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFormElementSetMethod _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_form_element_set_method _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFormElement::set_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_set_name" webkit_dom_html_form_element_set_name :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFormElementSetName ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFormElementSetName _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_form_element_set_name _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFormElement::set_no_validate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_set_no_validate" webkit_dom_html_form_element_set_no_validate :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLFormElementSetNoValidate ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLFormElementSetNoValidate _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_form_element_set_no_validate _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLFormElement::set_target
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_set_target" webkit_dom_html_form_element_set_target :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFormElementSetTarget ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFormElementSetTarget _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_form_element_set_target _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFormElement::submit
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFormElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_form_element_submit" webkit_dom_html_form_element_submit :: 
    Ptr DOMHTMLFormElement ->               -- _obj : TInterface "WebKit" "DOMHTMLFormElement"
    IO ()


dOMHTMLFormElementSubmit ::
    (MonadIO m, DOMHTMLFormElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLFormElementSubmit _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_form_element_submit _obj'
    touchManagedPtr _obj
    return ()


