
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLFrameElement
    ( 

-- * Exported types
    DOMHTMLFrameElement(..)                 ,
    DOMHTMLFrameElementK                    ,
    toDOMHTMLFrameElement                   ,
    noDOMHTMLFrameElement                   ,


 -- * Methods
-- ** dOMHTMLFrameElementGetContentDocument
    dOMHTMLFrameElementGetContentDocument   ,


-- ** dOMHTMLFrameElementGetContentWindow
    dOMHTMLFrameElementGetContentWindow     ,


-- ** dOMHTMLFrameElementGetFrameBorder
    dOMHTMLFrameElementGetFrameBorder       ,


-- ** dOMHTMLFrameElementGetHeight
    dOMHTMLFrameElementGetHeight            ,


-- ** dOMHTMLFrameElementGetLongDesc
    dOMHTMLFrameElementGetLongDesc          ,


-- ** dOMHTMLFrameElementGetMarginHeight
    dOMHTMLFrameElementGetMarginHeight      ,


-- ** dOMHTMLFrameElementGetMarginWidth
    dOMHTMLFrameElementGetMarginWidth       ,


-- ** dOMHTMLFrameElementGetName
    dOMHTMLFrameElementGetName              ,


-- ** dOMHTMLFrameElementGetNoResize
    dOMHTMLFrameElementGetNoResize          ,


-- ** dOMHTMLFrameElementGetScrolling
    dOMHTMLFrameElementGetScrolling         ,


-- ** dOMHTMLFrameElementGetSrc
    dOMHTMLFrameElementGetSrc               ,


-- ** dOMHTMLFrameElementGetWidth
    dOMHTMLFrameElementGetWidth             ,


-- ** dOMHTMLFrameElementSetFrameBorder
    dOMHTMLFrameElementSetFrameBorder       ,


-- ** dOMHTMLFrameElementSetLongDesc
    dOMHTMLFrameElementSetLongDesc          ,


-- ** dOMHTMLFrameElementSetMarginHeight
    dOMHTMLFrameElementSetMarginHeight      ,


-- ** dOMHTMLFrameElementSetMarginWidth
    dOMHTMLFrameElementSetMarginWidth       ,


-- ** dOMHTMLFrameElementSetName
    dOMHTMLFrameElementSetName              ,


-- ** dOMHTMLFrameElementSetNoResize
    dOMHTMLFrameElementSetNoResize          ,


-- ** dOMHTMLFrameElementSetScrolling
    dOMHTMLFrameElementSetScrolling         ,


-- ** dOMHTMLFrameElementSetSrc
    dOMHTMLFrameElementSetSrc               ,




 -- * Properties
-- ** ContentDocument
    DOMHTMLFrameElementContentDocumentPropertyInfo,
    getDOMHTMLFrameElementContentDocument   ,


-- ** ContentWindow
    DOMHTMLFrameElementContentWindowPropertyInfo,
    getDOMHTMLFrameElementContentWindow     ,


-- ** FrameBorder
    DOMHTMLFrameElementFrameBorderPropertyInfo,
    constructDOMHTMLFrameElementFrameBorder ,
    getDOMHTMLFrameElementFrameBorder       ,
    setDOMHTMLFrameElementFrameBorder       ,


-- ** Height
    DOMHTMLFrameElementHeightPropertyInfo   ,
    getDOMHTMLFrameElementHeight            ,


-- ** LongDesc
    DOMHTMLFrameElementLongDescPropertyInfo ,
    constructDOMHTMLFrameElementLongDesc    ,
    getDOMHTMLFrameElementLongDesc          ,
    setDOMHTMLFrameElementLongDesc          ,


-- ** MarginHeight
    DOMHTMLFrameElementMarginHeightPropertyInfo,
    constructDOMHTMLFrameElementMarginHeight,
    getDOMHTMLFrameElementMarginHeight      ,
    setDOMHTMLFrameElementMarginHeight      ,


-- ** MarginWidth
    DOMHTMLFrameElementMarginWidthPropertyInfo,
    constructDOMHTMLFrameElementMarginWidth ,
    getDOMHTMLFrameElementMarginWidth       ,
    setDOMHTMLFrameElementMarginWidth       ,


-- ** Name
    DOMHTMLFrameElementNamePropertyInfo     ,
    constructDOMHTMLFrameElementName        ,
    getDOMHTMLFrameElementName              ,
    setDOMHTMLFrameElementName              ,


-- ** NoResize
    DOMHTMLFrameElementNoResizePropertyInfo ,
    constructDOMHTMLFrameElementNoResize    ,
    getDOMHTMLFrameElementNoResize          ,
    setDOMHTMLFrameElementNoResize          ,


-- ** Scrolling
    DOMHTMLFrameElementScrollingPropertyInfo,
    constructDOMHTMLFrameElementScrolling   ,
    getDOMHTMLFrameElementScrolling         ,
    setDOMHTMLFrameElementScrolling         ,


-- ** Src
    DOMHTMLFrameElementSrcPropertyInfo      ,
    constructDOMHTMLFrameElementSrc         ,
    getDOMHTMLFrameElementSrc               ,
    setDOMHTMLFrameElementSrc               ,


-- ** Width
    DOMHTMLFrameElementWidthPropertyInfo    ,
    getDOMHTMLFrameElementWidth             ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLFrameElement = DOMHTMLFrameElement (ForeignPtr DOMHTMLFrameElement)
foreign import ccall "webkit_dom_html_frame_element_get_type"
    c_webkit_dom_html_frame_element_get_type :: IO GType

type instance ParentTypes DOMHTMLFrameElement = DOMHTMLFrameElementParentTypes
type DOMHTMLFrameElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLFrameElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_frame_element_get_type
    

class GObject o => DOMHTMLFrameElementK o
instance (GObject o, IsDescendantOf DOMHTMLFrameElement o) => DOMHTMLFrameElementK o

toDOMHTMLFrameElement :: DOMHTMLFrameElementK o => o -> IO DOMHTMLFrameElement
toDOMHTMLFrameElement = unsafeCastTo DOMHTMLFrameElement

noDOMHTMLFrameElement :: Maybe DOMHTMLFrameElement
noDOMHTMLFrameElement = Nothing

-- VVV Prop "content-document"
   -- Type: TInterface "WebKit" "DOMDocument"
   -- Flags: [PropertyReadable]

getDOMHTMLFrameElementContentDocument :: (MonadIO m, DOMHTMLFrameElementK o) => o -> m DOMDocument
getDOMHTMLFrameElementContentDocument obj = liftIO $ getObjectPropertyObject obj "content-document" DOMDocument

data DOMHTMLFrameElementContentDocumentPropertyInfo
instance AttrInfo DOMHTMLFrameElementContentDocumentPropertyInfo where
    type AttrAllowedOps DOMHTMLFrameElementContentDocumentPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameElementContentDocumentPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLFrameElementContentDocumentPropertyInfo = DOMHTMLFrameElementK
    type AttrGetType DOMHTMLFrameElementContentDocumentPropertyInfo = DOMDocument
    type AttrLabel DOMHTMLFrameElementContentDocumentPropertyInfo = "DOMHTMLFrameElement::content-document"
    attrGet _ = getDOMHTMLFrameElementContentDocument
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "content-window"
   -- Type: TInterface "WebKit" "DOMDOMWindow"
   -- Flags: [PropertyReadable]

getDOMHTMLFrameElementContentWindow :: (MonadIO m, DOMHTMLFrameElementK o) => o -> m DOMDOMWindow
getDOMHTMLFrameElementContentWindow obj = liftIO $ getObjectPropertyObject obj "content-window" DOMDOMWindow

data DOMHTMLFrameElementContentWindowPropertyInfo
instance AttrInfo DOMHTMLFrameElementContentWindowPropertyInfo where
    type AttrAllowedOps DOMHTMLFrameElementContentWindowPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameElementContentWindowPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLFrameElementContentWindowPropertyInfo = DOMHTMLFrameElementK
    type AttrGetType DOMHTMLFrameElementContentWindowPropertyInfo = DOMDOMWindow
    type AttrLabel DOMHTMLFrameElementContentWindowPropertyInfo = "DOMHTMLFrameElement::content-window"
    attrGet _ = getDOMHTMLFrameElementContentWindow
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "frame-border"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFrameElementFrameBorder :: (MonadIO m, DOMHTMLFrameElementK o) => o -> m T.Text
getDOMHTMLFrameElementFrameBorder obj = liftIO $ getObjectPropertyString obj "frame-border"

setDOMHTMLFrameElementFrameBorder :: (MonadIO m, DOMHTMLFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLFrameElementFrameBorder obj val = liftIO $ setObjectPropertyString obj "frame-border" val

constructDOMHTMLFrameElementFrameBorder :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFrameElementFrameBorder val = constructObjectPropertyString "frame-border" val

data DOMHTMLFrameElementFrameBorderPropertyInfo
instance AttrInfo DOMHTMLFrameElementFrameBorderPropertyInfo where
    type AttrAllowedOps DOMHTMLFrameElementFrameBorderPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameElementFrameBorderPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFrameElementFrameBorderPropertyInfo = DOMHTMLFrameElementK
    type AttrGetType DOMHTMLFrameElementFrameBorderPropertyInfo = T.Text
    type AttrLabel DOMHTMLFrameElementFrameBorderPropertyInfo = "DOMHTMLFrameElement::frame-border"
    attrGet _ = getDOMHTMLFrameElementFrameBorder
    attrSet _ = setDOMHTMLFrameElementFrameBorder
    attrConstruct _ = constructDOMHTMLFrameElementFrameBorder

-- VVV Prop "height"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable]

getDOMHTMLFrameElementHeight :: (MonadIO m, DOMHTMLFrameElementK o) => o -> m Int64
getDOMHTMLFrameElementHeight obj = liftIO $ getObjectPropertyInt64 obj "height"

data DOMHTMLFrameElementHeightPropertyInfo
instance AttrInfo DOMHTMLFrameElementHeightPropertyInfo where
    type AttrAllowedOps DOMHTMLFrameElementHeightPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameElementHeightPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLFrameElementHeightPropertyInfo = DOMHTMLFrameElementK
    type AttrGetType DOMHTMLFrameElementHeightPropertyInfo = Int64
    type AttrLabel DOMHTMLFrameElementHeightPropertyInfo = "DOMHTMLFrameElement::height"
    attrGet _ = getDOMHTMLFrameElementHeight
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "long-desc"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFrameElementLongDesc :: (MonadIO m, DOMHTMLFrameElementK o) => o -> m T.Text
getDOMHTMLFrameElementLongDesc obj = liftIO $ getObjectPropertyString obj "long-desc"

setDOMHTMLFrameElementLongDesc :: (MonadIO m, DOMHTMLFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLFrameElementLongDesc obj val = liftIO $ setObjectPropertyString obj "long-desc" val

constructDOMHTMLFrameElementLongDesc :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFrameElementLongDesc val = constructObjectPropertyString "long-desc" val

data DOMHTMLFrameElementLongDescPropertyInfo
instance AttrInfo DOMHTMLFrameElementLongDescPropertyInfo where
    type AttrAllowedOps DOMHTMLFrameElementLongDescPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameElementLongDescPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFrameElementLongDescPropertyInfo = DOMHTMLFrameElementK
    type AttrGetType DOMHTMLFrameElementLongDescPropertyInfo = T.Text
    type AttrLabel DOMHTMLFrameElementLongDescPropertyInfo = "DOMHTMLFrameElement::long-desc"
    attrGet _ = getDOMHTMLFrameElementLongDesc
    attrSet _ = setDOMHTMLFrameElementLongDesc
    attrConstruct _ = constructDOMHTMLFrameElementLongDesc

-- VVV Prop "margin-height"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFrameElementMarginHeight :: (MonadIO m, DOMHTMLFrameElementK o) => o -> m T.Text
getDOMHTMLFrameElementMarginHeight obj = liftIO $ getObjectPropertyString obj "margin-height"

setDOMHTMLFrameElementMarginHeight :: (MonadIO m, DOMHTMLFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLFrameElementMarginHeight obj val = liftIO $ setObjectPropertyString obj "margin-height" val

constructDOMHTMLFrameElementMarginHeight :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFrameElementMarginHeight val = constructObjectPropertyString "margin-height" val

data DOMHTMLFrameElementMarginHeightPropertyInfo
instance AttrInfo DOMHTMLFrameElementMarginHeightPropertyInfo where
    type AttrAllowedOps DOMHTMLFrameElementMarginHeightPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameElementMarginHeightPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFrameElementMarginHeightPropertyInfo = DOMHTMLFrameElementK
    type AttrGetType DOMHTMLFrameElementMarginHeightPropertyInfo = T.Text
    type AttrLabel DOMHTMLFrameElementMarginHeightPropertyInfo = "DOMHTMLFrameElement::margin-height"
    attrGet _ = getDOMHTMLFrameElementMarginHeight
    attrSet _ = setDOMHTMLFrameElementMarginHeight
    attrConstruct _ = constructDOMHTMLFrameElementMarginHeight

-- VVV Prop "margin-width"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFrameElementMarginWidth :: (MonadIO m, DOMHTMLFrameElementK o) => o -> m T.Text
getDOMHTMLFrameElementMarginWidth obj = liftIO $ getObjectPropertyString obj "margin-width"

setDOMHTMLFrameElementMarginWidth :: (MonadIO m, DOMHTMLFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLFrameElementMarginWidth obj val = liftIO $ setObjectPropertyString obj "margin-width" val

constructDOMHTMLFrameElementMarginWidth :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFrameElementMarginWidth val = constructObjectPropertyString "margin-width" val

data DOMHTMLFrameElementMarginWidthPropertyInfo
instance AttrInfo DOMHTMLFrameElementMarginWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLFrameElementMarginWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameElementMarginWidthPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFrameElementMarginWidthPropertyInfo = DOMHTMLFrameElementK
    type AttrGetType DOMHTMLFrameElementMarginWidthPropertyInfo = T.Text
    type AttrLabel DOMHTMLFrameElementMarginWidthPropertyInfo = "DOMHTMLFrameElement::margin-width"
    attrGet _ = getDOMHTMLFrameElementMarginWidth
    attrSet _ = setDOMHTMLFrameElementMarginWidth
    attrConstruct _ = constructDOMHTMLFrameElementMarginWidth

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFrameElementName :: (MonadIO m, DOMHTMLFrameElementK o) => o -> m T.Text
getDOMHTMLFrameElementName obj = liftIO $ getObjectPropertyString obj "name"

setDOMHTMLFrameElementName :: (MonadIO m, DOMHTMLFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLFrameElementName obj val = liftIO $ setObjectPropertyString obj "name" val

constructDOMHTMLFrameElementName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFrameElementName val = constructObjectPropertyString "name" val

data DOMHTMLFrameElementNamePropertyInfo
instance AttrInfo DOMHTMLFrameElementNamePropertyInfo where
    type AttrAllowedOps DOMHTMLFrameElementNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameElementNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFrameElementNamePropertyInfo = DOMHTMLFrameElementK
    type AttrGetType DOMHTMLFrameElementNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLFrameElementNamePropertyInfo = "DOMHTMLFrameElement::name"
    attrGet _ = getDOMHTMLFrameElementName
    attrSet _ = setDOMHTMLFrameElementName
    attrConstruct _ = constructDOMHTMLFrameElementName

-- VVV Prop "no-resize"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFrameElementNoResize :: (MonadIO m, DOMHTMLFrameElementK o) => o -> m Bool
getDOMHTMLFrameElementNoResize obj = liftIO $ getObjectPropertyBool obj "no-resize"

setDOMHTMLFrameElementNoResize :: (MonadIO m, DOMHTMLFrameElementK o) => o -> Bool -> m ()
setDOMHTMLFrameElementNoResize obj val = liftIO $ setObjectPropertyBool obj "no-resize" val

constructDOMHTMLFrameElementNoResize :: Bool -> IO ([Char], GValue)
constructDOMHTMLFrameElementNoResize val = constructObjectPropertyBool "no-resize" val

data DOMHTMLFrameElementNoResizePropertyInfo
instance AttrInfo DOMHTMLFrameElementNoResizePropertyInfo where
    type AttrAllowedOps DOMHTMLFrameElementNoResizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameElementNoResizePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLFrameElementNoResizePropertyInfo = DOMHTMLFrameElementK
    type AttrGetType DOMHTMLFrameElementNoResizePropertyInfo = Bool
    type AttrLabel DOMHTMLFrameElementNoResizePropertyInfo = "DOMHTMLFrameElement::no-resize"
    attrGet _ = getDOMHTMLFrameElementNoResize
    attrSet _ = setDOMHTMLFrameElementNoResize
    attrConstruct _ = constructDOMHTMLFrameElementNoResize

-- VVV Prop "scrolling"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFrameElementScrolling :: (MonadIO m, DOMHTMLFrameElementK o) => o -> m T.Text
getDOMHTMLFrameElementScrolling obj = liftIO $ getObjectPropertyString obj "scrolling"

setDOMHTMLFrameElementScrolling :: (MonadIO m, DOMHTMLFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLFrameElementScrolling obj val = liftIO $ setObjectPropertyString obj "scrolling" val

constructDOMHTMLFrameElementScrolling :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFrameElementScrolling val = constructObjectPropertyString "scrolling" val

data DOMHTMLFrameElementScrollingPropertyInfo
instance AttrInfo DOMHTMLFrameElementScrollingPropertyInfo where
    type AttrAllowedOps DOMHTMLFrameElementScrollingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameElementScrollingPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFrameElementScrollingPropertyInfo = DOMHTMLFrameElementK
    type AttrGetType DOMHTMLFrameElementScrollingPropertyInfo = T.Text
    type AttrLabel DOMHTMLFrameElementScrollingPropertyInfo = "DOMHTMLFrameElement::scrolling"
    attrGet _ = getDOMHTMLFrameElementScrolling
    attrSet _ = setDOMHTMLFrameElementScrolling
    attrConstruct _ = constructDOMHTMLFrameElementScrolling

-- VVV Prop "src"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFrameElementSrc :: (MonadIO m, DOMHTMLFrameElementK o) => o -> m T.Text
getDOMHTMLFrameElementSrc obj = liftIO $ getObjectPropertyString obj "src"

setDOMHTMLFrameElementSrc :: (MonadIO m, DOMHTMLFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLFrameElementSrc obj val = liftIO $ setObjectPropertyString obj "src" val

constructDOMHTMLFrameElementSrc :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFrameElementSrc val = constructObjectPropertyString "src" val

data DOMHTMLFrameElementSrcPropertyInfo
instance AttrInfo DOMHTMLFrameElementSrcPropertyInfo where
    type AttrAllowedOps DOMHTMLFrameElementSrcPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameElementSrcPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFrameElementSrcPropertyInfo = DOMHTMLFrameElementK
    type AttrGetType DOMHTMLFrameElementSrcPropertyInfo = T.Text
    type AttrLabel DOMHTMLFrameElementSrcPropertyInfo = "DOMHTMLFrameElement::src"
    attrGet _ = getDOMHTMLFrameElementSrc
    attrSet _ = setDOMHTMLFrameElementSrc
    attrConstruct _ = constructDOMHTMLFrameElementSrc

-- VVV Prop "width"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable]

getDOMHTMLFrameElementWidth :: (MonadIO m, DOMHTMLFrameElementK o) => o -> m Int64
getDOMHTMLFrameElementWidth obj = liftIO $ getObjectPropertyInt64 obj "width"

data DOMHTMLFrameElementWidthPropertyInfo
instance AttrInfo DOMHTMLFrameElementWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLFrameElementWidthPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameElementWidthPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLFrameElementWidthPropertyInfo = DOMHTMLFrameElementK
    type AttrGetType DOMHTMLFrameElementWidthPropertyInfo = Int64
    type AttrLabel DOMHTMLFrameElementWidthPropertyInfo = "DOMHTMLFrameElement::width"
    attrGet _ = getDOMHTMLFrameElementWidth
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMHTMLFrameElement = DOMHTMLFrameElementAttributeList
type DOMHTMLFrameElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-document", DOMHTMLFrameElementContentDocumentPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("content-window", DOMHTMLFrameElementContentWindowPropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("frame-border", DOMHTMLFrameElementFrameBorderPropertyInfo), '("height", DOMHTMLFrameElementHeightPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("long-desc", DOMHTMLFrameElementLongDescPropertyInfo), '("margin-height", DOMHTMLFrameElementMarginHeightPropertyInfo), '("margin-width", DOMHTMLFrameElementMarginWidthPropertyInfo), '("name", DOMHTMLFrameElementNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("no-resize", DOMHTMLFrameElementNoResizePropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("scrolling", DOMHTMLFrameElementScrollingPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("src", DOMHTMLFrameElementSrcPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("width", DOMHTMLFrameElementWidthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLFrameElement = DOMHTMLFrameElementSignalList
type DOMHTMLFrameElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLFrameElement::get_content_document
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMDocument"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_get_content_document" webkit_dom_html_frame_element_get_content_document :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    IO (Ptr DOMDocument)


dOMHTMLFrameElementGetContentDocument ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    m DOMDocument
dOMHTMLFrameElementGetContentDocument _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_element_get_content_document _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_frame_element_get_content_document" result
    result' <- (newObject DOMDocument) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFrameElement::get_content_window
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMDOMWindow"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_get_content_window" webkit_dom_html_frame_element_get_content_window :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    IO (Ptr DOMDOMWindow)


dOMHTMLFrameElementGetContentWindow ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    m DOMDOMWindow
dOMHTMLFrameElementGetContentWindow _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_element_get_content_window _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_frame_element_get_content_window" result
    result' <- (wrapObject DOMDOMWindow) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFrameElement::get_frame_border
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_get_frame_border" webkit_dom_html_frame_element_get_frame_border :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    IO CString


dOMHTMLFrameElementGetFrameBorder ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFrameElementGetFrameBorder _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_element_get_frame_border _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_frame_element_get_frame_border" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFrameElement::get_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_get_height" webkit_dom_html_frame_element_get_height :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    IO Int64


dOMHTMLFrameElementGetHeight ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLFrameElementGetHeight _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_element_get_height _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLFrameElement::get_long_desc
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_get_long_desc" webkit_dom_html_frame_element_get_long_desc :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    IO CString


dOMHTMLFrameElementGetLongDesc ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFrameElementGetLongDesc _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_element_get_long_desc _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_frame_element_get_long_desc" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFrameElement::get_margin_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_get_margin_height" webkit_dom_html_frame_element_get_margin_height :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    IO CString


dOMHTMLFrameElementGetMarginHeight ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFrameElementGetMarginHeight _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_element_get_margin_height _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_frame_element_get_margin_height" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFrameElement::get_margin_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_get_margin_width" webkit_dom_html_frame_element_get_margin_width :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    IO CString


dOMHTMLFrameElementGetMarginWidth ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFrameElementGetMarginWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_element_get_margin_width _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_frame_element_get_margin_width" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFrameElement::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_get_name" webkit_dom_html_frame_element_get_name :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    IO CString


dOMHTMLFrameElementGetName ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFrameElementGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_element_get_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_frame_element_get_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFrameElement::get_no_resize
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_get_no_resize" webkit_dom_html_frame_element_get_no_resize :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    IO CInt


dOMHTMLFrameElementGetNoResize ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLFrameElementGetNoResize _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_element_get_no_resize _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFrameElement::get_scrolling
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_get_scrolling" webkit_dom_html_frame_element_get_scrolling :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    IO CString


dOMHTMLFrameElementGetScrolling ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFrameElementGetScrolling _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_element_get_scrolling _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_frame_element_get_scrolling" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFrameElement::get_src
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_get_src" webkit_dom_html_frame_element_get_src :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    IO CString


dOMHTMLFrameElementGetSrc ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFrameElementGetSrc _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_element_get_src _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_frame_element_get_src" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFrameElement::get_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_get_width" webkit_dom_html_frame_element_get_width :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    IO Int64


dOMHTMLFrameElementGetWidth ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLFrameElementGetWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_element_get_width _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLFrameElement::set_frame_border
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_set_frame_border" webkit_dom_html_frame_element_set_frame_border :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFrameElementSetFrameBorder ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFrameElementSetFrameBorder _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_frame_element_set_frame_border _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFrameElement::set_long_desc
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_set_long_desc" webkit_dom_html_frame_element_set_long_desc :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFrameElementSetLongDesc ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFrameElementSetLongDesc _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_frame_element_set_long_desc _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFrameElement::set_margin_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_set_margin_height" webkit_dom_html_frame_element_set_margin_height :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFrameElementSetMarginHeight ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFrameElementSetMarginHeight _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_frame_element_set_margin_height _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFrameElement::set_margin_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_set_margin_width" webkit_dom_html_frame_element_set_margin_width :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFrameElementSetMarginWidth ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFrameElementSetMarginWidth _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_frame_element_set_margin_width _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFrameElement::set_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_set_name" webkit_dom_html_frame_element_set_name :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFrameElementSetName ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFrameElementSetName _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_frame_element_set_name _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFrameElement::set_no_resize
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_set_no_resize" webkit_dom_html_frame_element_set_no_resize :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLFrameElementSetNoResize ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLFrameElementSetNoResize _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_frame_element_set_no_resize _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLFrameElement::set_scrolling
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_set_scrolling" webkit_dom_html_frame_element_set_scrolling :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFrameElementSetScrolling ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFrameElementSetScrolling _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_frame_element_set_scrolling _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFrameElement::set_src
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_element_set_src" webkit_dom_html_frame_element_set_src :: 
    Ptr DOMHTMLFrameElement ->              -- _obj : TInterface "WebKit" "DOMHTMLFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFrameElementSetSrc ::
    (MonadIO m, DOMHTMLFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFrameElementSetSrc _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_frame_element_set_src _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


