
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLFrameSetElement
    ( 

-- * Exported types
    DOMHTMLFrameSetElement(..)              ,
    DOMHTMLFrameSetElementK                 ,
    toDOMHTMLFrameSetElement                ,
    noDOMHTMLFrameSetElement                ,


 -- * Methods
-- ** dOMHTMLFrameSetElementGetCols
    dOMHTMLFrameSetElementGetCols           ,


-- ** dOMHTMLFrameSetElementGetRows
    dOMHTMLFrameSetElementGetRows           ,


-- ** dOMHTMLFrameSetElementSetCols
    dOMHTMLFrameSetElementSetCols           ,


-- ** dOMHTMLFrameSetElementSetRows
    dOMHTMLFrameSetElementSetRows           ,




 -- * Properties
-- ** Cols
    DOMHTMLFrameSetElementColsPropertyInfo  ,
    constructDOMHTMLFrameSetElementCols     ,
    getDOMHTMLFrameSetElementCols           ,
    setDOMHTMLFrameSetElementCols           ,


-- ** Rows
    DOMHTMLFrameSetElementRowsPropertyInfo  ,
    constructDOMHTMLFrameSetElementRows     ,
    getDOMHTMLFrameSetElementRows           ,
    setDOMHTMLFrameSetElementRows           ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLFrameSetElement = DOMHTMLFrameSetElement (ForeignPtr DOMHTMLFrameSetElement)
foreign import ccall "webkit_dom_html_frame_set_element_get_type"
    c_webkit_dom_html_frame_set_element_get_type :: IO GType

type instance ParentTypes DOMHTMLFrameSetElement = DOMHTMLFrameSetElementParentTypes
type DOMHTMLFrameSetElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLFrameSetElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_frame_set_element_get_type
    

class GObject o => DOMHTMLFrameSetElementK o
instance (GObject o, IsDescendantOf DOMHTMLFrameSetElement o) => DOMHTMLFrameSetElementK o

toDOMHTMLFrameSetElement :: DOMHTMLFrameSetElementK o => o -> IO DOMHTMLFrameSetElement
toDOMHTMLFrameSetElement = unsafeCastTo DOMHTMLFrameSetElement

noDOMHTMLFrameSetElement :: Maybe DOMHTMLFrameSetElement
noDOMHTMLFrameSetElement = Nothing

-- VVV Prop "cols"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFrameSetElementCols :: (MonadIO m, DOMHTMLFrameSetElementK o) => o -> m T.Text
getDOMHTMLFrameSetElementCols obj = liftIO $ getObjectPropertyString obj "cols"

setDOMHTMLFrameSetElementCols :: (MonadIO m, DOMHTMLFrameSetElementK o) => o -> T.Text -> m ()
setDOMHTMLFrameSetElementCols obj val = liftIO $ setObjectPropertyString obj "cols" val

constructDOMHTMLFrameSetElementCols :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFrameSetElementCols val = constructObjectPropertyString "cols" val

data DOMHTMLFrameSetElementColsPropertyInfo
instance AttrInfo DOMHTMLFrameSetElementColsPropertyInfo where
    type AttrAllowedOps DOMHTMLFrameSetElementColsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameSetElementColsPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFrameSetElementColsPropertyInfo = DOMHTMLFrameSetElementK
    type AttrGetType DOMHTMLFrameSetElementColsPropertyInfo = T.Text
    type AttrLabel DOMHTMLFrameSetElementColsPropertyInfo = "DOMHTMLFrameSetElement::cols"
    attrGet _ = getDOMHTMLFrameSetElementCols
    attrSet _ = setDOMHTMLFrameSetElementCols
    attrConstruct _ = constructDOMHTMLFrameSetElementCols

-- VVV Prop "rows"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLFrameSetElementRows :: (MonadIO m, DOMHTMLFrameSetElementK o) => o -> m T.Text
getDOMHTMLFrameSetElementRows obj = liftIO $ getObjectPropertyString obj "rows"

setDOMHTMLFrameSetElementRows :: (MonadIO m, DOMHTMLFrameSetElementK o) => o -> T.Text -> m ()
setDOMHTMLFrameSetElementRows obj val = liftIO $ setObjectPropertyString obj "rows" val

constructDOMHTMLFrameSetElementRows :: T.Text -> IO ([Char], GValue)
constructDOMHTMLFrameSetElementRows val = constructObjectPropertyString "rows" val

data DOMHTMLFrameSetElementRowsPropertyInfo
instance AttrInfo DOMHTMLFrameSetElementRowsPropertyInfo where
    type AttrAllowedOps DOMHTMLFrameSetElementRowsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLFrameSetElementRowsPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLFrameSetElementRowsPropertyInfo = DOMHTMLFrameSetElementK
    type AttrGetType DOMHTMLFrameSetElementRowsPropertyInfo = T.Text
    type AttrLabel DOMHTMLFrameSetElementRowsPropertyInfo = "DOMHTMLFrameSetElement::rows"
    attrGet _ = getDOMHTMLFrameSetElementRows
    attrSet _ = setDOMHTMLFrameSetElementRows
    attrConstruct _ = constructDOMHTMLFrameSetElementRows

type instance AttributeList DOMHTMLFrameSetElement = DOMHTMLFrameSetElementAttributeList
type DOMHTMLFrameSetElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("cols", DOMHTMLFrameSetElementColsPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("rows", DOMHTMLFrameSetElementRowsPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLFrameSetElement = DOMHTMLFrameSetElementSignalList
type DOMHTMLFrameSetElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLFrameSetElement::get_cols
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameSetElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameSetElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_set_element_get_cols" webkit_dom_html_frame_set_element_get_cols :: 
    Ptr DOMHTMLFrameSetElement ->           -- _obj : TInterface "WebKit" "DOMHTMLFrameSetElement"
    IO CString


dOMHTMLFrameSetElementGetCols ::
    (MonadIO m, DOMHTMLFrameSetElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFrameSetElementGetCols _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_set_element_get_cols _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_frame_set_element_get_cols" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFrameSetElement::get_rows
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameSetElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameSetElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_set_element_get_rows" webkit_dom_html_frame_set_element_get_rows :: 
    Ptr DOMHTMLFrameSetElement ->           -- _obj : TInterface "WebKit" "DOMHTMLFrameSetElement"
    IO CString


dOMHTMLFrameSetElementGetRows ::
    (MonadIO m, DOMHTMLFrameSetElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLFrameSetElementGetRows _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_frame_set_element_get_rows _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_frame_set_element_get_rows" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLFrameSetElement::set_cols
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameSetElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameSetElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_set_element_set_cols" webkit_dom_html_frame_set_element_set_cols :: 
    Ptr DOMHTMLFrameSetElement ->           -- _obj : TInterface "WebKit" "DOMHTMLFrameSetElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFrameSetElementSetCols ::
    (MonadIO m, DOMHTMLFrameSetElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFrameSetElementSetCols _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_frame_set_element_set_cols _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLFrameSetElement::set_rows
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameSetElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLFrameSetElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_frame_set_element_set_rows" webkit_dom_html_frame_set_element_set_rows :: 
    Ptr DOMHTMLFrameSetElement ->           -- _obj : TInterface "WebKit" "DOMHTMLFrameSetElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLFrameSetElementSetRows ::
    (MonadIO m, DOMHTMLFrameSetElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLFrameSetElementSetRows _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_frame_set_element_set_rows _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


