
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLHRElement
    ( 

-- * Exported types
    DOMHTMLHRElement(..)                    ,
    DOMHTMLHRElementK                       ,
    toDOMHTMLHRElement                      ,
    noDOMHTMLHRElement                      ,


 -- * Methods
-- ** dOMHTMLHRElementGetAlign
    dOMHTMLHRElementGetAlign                ,


-- ** dOMHTMLHRElementGetNoShade
    dOMHTMLHRElementGetNoShade              ,


-- ** dOMHTMLHRElementGetSize
    dOMHTMLHRElementGetSize                 ,


-- ** dOMHTMLHRElementGetWidth
    dOMHTMLHRElementGetWidth                ,


-- ** dOMHTMLHRElementSetAlign
    dOMHTMLHRElementSetAlign                ,


-- ** dOMHTMLHRElementSetNoShade
    dOMHTMLHRElementSetNoShade              ,


-- ** dOMHTMLHRElementSetSize
    dOMHTMLHRElementSetSize                 ,


-- ** dOMHTMLHRElementSetWidth
    dOMHTMLHRElementSetWidth                ,




 -- * Properties
-- ** Align
    DOMHTMLHRElementAlignPropertyInfo       ,
    constructDOMHTMLHRElementAlign          ,
    getDOMHTMLHRElementAlign                ,
    setDOMHTMLHRElementAlign                ,


-- ** NoShade
    DOMHTMLHRElementNoShadePropertyInfo     ,
    constructDOMHTMLHRElementNoShade        ,
    getDOMHTMLHRElementNoShade              ,
    setDOMHTMLHRElementNoShade              ,


-- ** Size
    DOMHTMLHRElementSizePropertyInfo        ,
    constructDOMHTMLHRElementSize           ,
    getDOMHTMLHRElementSize                 ,
    setDOMHTMLHRElementSize                 ,


-- ** Width
    DOMHTMLHRElementWidthPropertyInfo       ,
    constructDOMHTMLHRElementWidth          ,
    getDOMHTMLHRElementWidth                ,
    setDOMHTMLHRElementWidth                ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLHRElement = DOMHTMLHRElement (ForeignPtr DOMHTMLHRElement)
foreign import ccall "webkit_dom_htmlhr_element_get_type"
    c_webkit_dom_htmlhr_element_get_type :: IO GType

type instance ParentTypes DOMHTMLHRElement = DOMHTMLHRElementParentTypes
type DOMHTMLHRElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLHRElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_htmlhr_element_get_type
    

class GObject o => DOMHTMLHRElementK o
instance (GObject o, IsDescendantOf DOMHTMLHRElement o) => DOMHTMLHRElementK o

toDOMHTMLHRElement :: DOMHTMLHRElementK o => o -> IO DOMHTMLHRElement
toDOMHTMLHRElement = unsafeCastTo DOMHTMLHRElement

noDOMHTMLHRElement :: Maybe DOMHTMLHRElement
noDOMHTMLHRElement = Nothing

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLHRElementAlign :: (MonadIO m, DOMHTMLHRElementK o) => o -> m T.Text
getDOMHTMLHRElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLHRElementAlign :: (MonadIO m, DOMHTMLHRElementK o) => o -> T.Text -> m ()
setDOMHTMLHRElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLHRElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLHRElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLHRElementAlignPropertyInfo
instance AttrInfo DOMHTMLHRElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLHRElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLHRElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLHRElementAlignPropertyInfo = DOMHTMLHRElementK
    type AttrGetType DOMHTMLHRElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLHRElementAlignPropertyInfo = "DOMHTMLHRElement::align"
    attrGet _ = getDOMHTMLHRElementAlign
    attrSet _ = setDOMHTMLHRElementAlign
    attrConstruct _ = constructDOMHTMLHRElementAlign

-- VVV Prop "no-shade"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLHRElementNoShade :: (MonadIO m, DOMHTMLHRElementK o) => o -> m Bool
getDOMHTMLHRElementNoShade obj = liftIO $ getObjectPropertyBool obj "no-shade"

setDOMHTMLHRElementNoShade :: (MonadIO m, DOMHTMLHRElementK o) => o -> Bool -> m ()
setDOMHTMLHRElementNoShade obj val = liftIO $ setObjectPropertyBool obj "no-shade" val

constructDOMHTMLHRElementNoShade :: Bool -> IO ([Char], GValue)
constructDOMHTMLHRElementNoShade val = constructObjectPropertyBool "no-shade" val

data DOMHTMLHRElementNoShadePropertyInfo
instance AttrInfo DOMHTMLHRElementNoShadePropertyInfo where
    type AttrAllowedOps DOMHTMLHRElementNoShadePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLHRElementNoShadePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLHRElementNoShadePropertyInfo = DOMHTMLHRElementK
    type AttrGetType DOMHTMLHRElementNoShadePropertyInfo = Bool
    type AttrLabel DOMHTMLHRElementNoShadePropertyInfo = "DOMHTMLHRElement::no-shade"
    attrGet _ = getDOMHTMLHRElementNoShade
    attrSet _ = setDOMHTMLHRElementNoShade
    attrConstruct _ = constructDOMHTMLHRElementNoShade

-- VVV Prop "size"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLHRElementSize :: (MonadIO m, DOMHTMLHRElementK o) => o -> m T.Text
getDOMHTMLHRElementSize obj = liftIO $ getObjectPropertyString obj "size"

setDOMHTMLHRElementSize :: (MonadIO m, DOMHTMLHRElementK o) => o -> T.Text -> m ()
setDOMHTMLHRElementSize obj val = liftIO $ setObjectPropertyString obj "size" val

constructDOMHTMLHRElementSize :: T.Text -> IO ([Char], GValue)
constructDOMHTMLHRElementSize val = constructObjectPropertyString "size" val

data DOMHTMLHRElementSizePropertyInfo
instance AttrInfo DOMHTMLHRElementSizePropertyInfo where
    type AttrAllowedOps DOMHTMLHRElementSizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLHRElementSizePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLHRElementSizePropertyInfo = DOMHTMLHRElementK
    type AttrGetType DOMHTMLHRElementSizePropertyInfo = T.Text
    type AttrLabel DOMHTMLHRElementSizePropertyInfo = "DOMHTMLHRElement::size"
    attrGet _ = getDOMHTMLHRElementSize
    attrSet _ = setDOMHTMLHRElementSize
    attrConstruct _ = constructDOMHTMLHRElementSize

-- VVV Prop "width"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLHRElementWidth :: (MonadIO m, DOMHTMLHRElementK o) => o -> m T.Text
getDOMHTMLHRElementWidth obj = liftIO $ getObjectPropertyString obj "width"

setDOMHTMLHRElementWidth :: (MonadIO m, DOMHTMLHRElementK o) => o -> T.Text -> m ()
setDOMHTMLHRElementWidth obj val = liftIO $ setObjectPropertyString obj "width" val

constructDOMHTMLHRElementWidth :: T.Text -> IO ([Char], GValue)
constructDOMHTMLHRElementWidth val = constructObjectPropertyString "width" val

data DOMHTMLHRElementWidthPropertyInfo
instance AttrInfo DOMHTMLHRElementWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLHRElementWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLHRElementWidthPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLHRElementWidthPropertyInfo = DOMHTMLHRElementK
    type AttrGetType DOMHTMLHRElementWidthPropertyInfo = T.Text
    type AttrLabel DOMHTMLHRElementWidthPropertyInfo = "DOMHTMLHRElement::width"
    attrGet _ = getDOMHTMLHRElementWidth
    attrSet _ = setDOMHTMLHRElementWidth
    attrConstruct _ = constructDOMHTMLHRElementWidth

type instance AttributeList DOMHTMLHRElement = DOMHTMLHRElementAttributeList
type DOMHTMLHRElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLHRElementAlignPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("no-shade", DOMHTMLHRElementNoShadePropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("size", DOMHTMLHRElementSizePropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("width", DOMHTMLHRElementWidthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLHRElement = DOMHTMLHRElementSignalList
type DOMHTMLHRElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLHRElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlhr_element_get_align" webkit_dom_htmlhr_element_get_align :: 
    Ptr DOMHTMLHRElement ->                 -- _obj : TInterface "WebKit" "DOMHTMLHRElement"
    IO CString


dOMHTMLHRElementGetAlign ::
    (MonadIO m, DOMHTMLHRElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLHRElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_htmlhr_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_htmlhr_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLHRElement::get_no_shade
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlhr_element_get_no_shade" webkit_dom_htmlhr_element_get_no_shade :: 
    Ptr DOMHTMLHRElement ->                 -- _obj : TInterface "WebKit" "DOMHTMLHRElement"
    IO CInt


dOMHTMLHRElementGetNoShade ::
    (MonadIO m, DOMHTMLHRElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLHRElementGetNoShade _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_htmlhr_element_get_no_shade _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLHRElement::get_size
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlhr_element_get_size" webkit_dom_htmlhr_element_get_size :: 
    Ptr DOMHTMLHRElement ->                 -- _obj : TInterface "WebKit" "DOMHTMLHRElement"
    IO CString


dOMHTMLHRElementGetSize ::
    (MonadIO m, DOMHTMLHRElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLHRElementGetSize _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_htmlhr_element_get_size _obj'
    checkUnexpectedReturnNULL "webkit_dom_htmlhr_element_get_size" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLHRElement::get_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlhr_element_get_width" webkit_dom_htmlhr_element_get_width :: 
    Ptr DOMHTMLHRElement ->                 -- _obj : TInterface "WebKit" "DOMHTMLHRElement"
    IO CString


dOMHTMLHRElementGetWidth ::
    (MonadIO m, DOMHTMLHRElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLHRElementGetWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_htmlhr_element_get_width _obj'
    checkUnexpectedReturnNULL "webkit_dom_htmlhr_element_get_width" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLHRElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlhr_element_set_align" webkit_dom_htmlhr_element_set_align :: 
    Ptr DOMHTMLHRElement ->                 -- _obj : TInterface "WebKit" "DOMHTMLHRElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLHRElementSetAlign ::
    (MonadIO m, DOMHTMLHRElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLHRElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_htmlhr_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLHRElement::set_no_shade
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlhr_element_set_no_shade" webkit_dom_htmlhr_element_set_no_shade :: 
    Ptr DOMHTMLHRElement ->                 -- _obj : TInterface "WebKit" "DOMHTMLHRElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLHRElementSetNoShade ::
    (MonadIO m, DOMHTMLHRElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLHRElementSetNoShade _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_htmlhr_element_set_no_shade _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLHRElement::set_size
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlhr_element_set_size" webkit_dom_htmlhr_element_set_size :: 
    Ptr DOMHTMLHRElement ->                 -- _obj : TInterface "WebKit" "DOMHTMLHRElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLHRElementSetSize ::
    (MonadIO m, DOMHTMLHRElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLHRElementSetSize _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_htmlhr_element_set_size _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLHRElement::set_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHRElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlhr_element_set_width" webkit_dom_htmlhr_element_set_width :: 
    Ptr DOMHTMLHRElement ->                 -- _obj : TInterface "WebKit" "DOMHTMLHRElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLHRElementSetWidth ::
    (MonadIO m, DOMHTMLHRElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLHRElementSetWidth _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_htmlhr_element_set_width _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


