
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLHeadElement
    ( 

-- * Exported types
    DOMHTMLHeadElement(..)                  ,
    DOMHTMLHeadElementK                     ,
    toDOMHTMLHeadElement                    ,
    noDOMHTMLHeadElement                    ,


 -- * Methods
-- ** dOMHTMLHeadElementGetProfile
    dOMHTMLHeadElementGetProfile            ,


-- ** dOMHTMLHeadElementSetProfile
    dOMHTMLHeadElementSetProfile            ,




 -- * Properties
-- ** Profile
    DOMHTMLHeadElementProfilePropertyInfo   ,
    constructDOMHTMLHeadElementProfile      ,
    getDOMHTMLHeadElementProfile            ,
    setDOMHTMLHeadElementProfile            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLHeadElement = DOMHTMLHeadElement (ForeignPtr DOMHTMLHeadElement)
foreign import ccall "webkit_dom_html_head_element_get_type"
    c_webkit_dom_html_head_element_get_type :: IO GType

type instance ParentTypes DOMHTMLHeadElement = DOMHTMLHeadElementParentTypes
type DOMHTMLHeadElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLHeadElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_head_element_get_type
    

class GObject o => DOMHTMLHeadElementK o
instance (GObject o, IsDescendantOf DOMHTMLHeadElement o) => DOMHTMLHeadElementK o

toDOMHTMLHeadElement :: DOMHTMLHeadElementK o => o -> IO DOMHTMLHeadElement
toDOMHTMLHeadElement = unsafeCastTo DOMHTMLHeadElement

noDOMHTMLHeadElement :: Maybe DOMHTMLHeadElement
noDOMHTMLHeadElement = Nothing

-- VVV Prop "profile"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLHeadElementProfile :: (MonadIO m, DOMHTMLHeadElementK o) => o -> m T.Text
getDOMHTMLHeadElementProfile obj = liftIO $ getObjectPropertyString obj "profile"

setDOMHTMLHeadElementProfile :: (MonadIO m, DOMHTMLHeadElementK o) => o -> T.Text -> m ()
setDOMHTMLHeadElementProfile obj val = liftIO $ setObjectPropertyString obj "profile" val

constructDOMHTMLHeadElementProfile :: T.Text -> IO ([Char], GValue)
constructDOMHTMLHeadElementProfile val = constructObjectPropertyString "profile" val

data DOMHTMLHeadElementProfilePropertyInfo
instance AttrInfo DOMHTMLHeadElementProfilePropertyInfo where
    type AttrAllowedOps DOMHTMLHeadElementProfilePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLHeadElementProfilePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLHeadElementProfilePropertyInfo = DOMHTMLHeadElementK
    type AttrGetType DOMHTMLHeadElementProfilePropertyInfo = T.Text
    type AttrLabel DOMHTMLHeadElementProfilePropertyInfo = "DOMHTMLHeadElement::profile"
    attrGet _ = getDOMHTMLHeadElementProfile
    attrSet _ = setDOMHTMLHeadElementProfile
    attrConstruct _ = constructDOMHTMLHeadElementProfile

type instance AttributeList DOMHTMLHeadElement = DOMHTMLHeadElementAttributeList
type DOMHTMLHeadElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("profile", DOMHTMLHeadElementProfilePropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLHeadElement = DOMHTMLHeadElementSignalList
type DOMHTMLHeadElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLHeadElement::get_profile
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHeadElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHeadElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_head_element_get_profile" webkit_dom_html_head_element_get_profile :: 
    Ptr DOMHTMLHeadElement ->               -- _obj : TInterface "WebKit" "DOMHTMLHeadElement"
    IO CString


dOMHTMLHeadElementGetProfile ::
    (MonadIO m, DOMHTMLHeadElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLHeadElementGetProfile _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_head_element_get_profile _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_head_element_get_profile" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLHeadElement::set_profile
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHeadElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHeadElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_head_element_set_profile" webkit_dom_html_head_element_set_profile :: 
    Ptr DOMHTMLHeadElement ->               -- _obj : TInterface "WebKit" "DOMHTMLHeadElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLHeadElementSetProfile ::
    (MonadIO m, DOMHTMLHeadElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLHeadElementSetProfile _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_head_element_set_profile _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


