
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLHtmlElement
    ( 

-- * Exported types
    DOMHTMLHtmlElement(..)                  ,
    DOMHTMLHtmlElementK                     ,
    toDOMHTMLHtmlElement                    ,
    noDOMHTMLHtmlElement                    ,


 -- * Methods
-- ** dOMHTMLHtmlElementGetManifest
    dOMHTMLHtmlElementGetManifest           ,


-- ** dOMHTMLHtmlElementGetVersion
    dOMHTMLHtmlElementGetVersion            ,


-- ** dOMHTMLHtmlElementSetManifest
    dOMHTMLHtmlElementSetManifest           ,


-- ** dOMHTMLHtmlElementSetVersion
    dOMHTMLHtmlElementSetVersion            ,




 -- * Properties
-- ** Manifest
    DOMHTMLHtmlElementManifestPropertyInfo  ,
    constructDOMHTMLHtmlElementManifest     ,
    getDOMHTMLHtmlElementManifest           ,
    setDOMHTMLHtmlElementManifest           ,


-- ** Version
    DOMHTMLHtmlElementVersionPropertyInfo   ,
    constructDOMHTMLHtmlElementVersion      ,
    getDOMHTMLHtmlElementVersion            ,
    setDOMHTMLHtmlElementVersion            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLHtmlElement = DOMHTMLHtmlElement (ForeignPtr DOMHTMLHtmlElement)
foreign import ccall "webkit_dom_html_html_element_get_type"
    c_webkit_dom_html_html_element_get_type :: IO GType

type instance ParentTypes DOMHTMLHtmlElement = DOMHTMLHtmlElementParentTypes
type DOMHTMLHtmlElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLHtmlElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_html_element_get_type
    

class GObject o => DOMHTMLHtmlElementK o
instance (GObject o, IsDescendantOf DOMHTMLHtmlElement o) => DOMHTMLHtmlElementK o

toDOMHTMLHtmlElement :: DOMHTMLHtmlElementK o => o -> IO DOMHTMLHtmlElement
toDOMHTMLHtmlElement = unsafeCastTo DOMHTMLHtmlElement

noDOMHTMLHtmlElement :: Maybe DOMHTMLHtmlElement
noDOMHTMLHtmlElement = Nothing

-- VVV Prop "manifest"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLHtmlElementManifest :: (MonadIO m, DOMHTMLHtmlElementK o) => o -> m T.Text
getDOMHTMLHtmlElementManifest obj = liftIO $ getObjectPropertyString obj "manifest"

setDOMHTMLHtmlElementManifest :: (MonadIO m, DOMHTMLHtmlElementK o) => o -> T.Text -> m ()
setDOMHTMLHtmlElementManifest obj val = liftIO $ setObjectPropertyString obj "manifest" val

constructDOMHTMLHtmlElementManifest :: T.Text -> IO ([Char], GValue)
constructDOMHTMLHtmlElementManifest val = constructObjectPropertyString "manifest" val

data DOMHTMLHtmlElementManifestPropertyInfo
instance AttrInfo DOMHTMLHtmlElementManifestPropertyInfo where
    type AttrAllowedOps DOMHTMLHtmlElementManifestPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLHtmlElementManifestPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLHtmlElementManifestPropertyInfo = DOMHTMLHtmlElementK
    type AttrGetType DOMHTMLHtmlElementManifestPropertyInfo = T.Text
    type AttrLabel DOMHTMLHtmlElementManifestPropertyInfo = "DOMHTMLHtmlElement::manifest"
    attrGet _ = getDOMHTMLHtmlElementManifest
    attrSet _ = setDOMHTMLHtmlElementManifest
    attrConstruct _ = constructDOMHTMLHtmlElementManifest

-- VVV Prop "version"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLHtmlElementVersion :: (MonadIO m, DOMHTMLHtmlElementK o) => o -> m T.Text
getDOMHTMLHtmlElementVersion obj = liftIO $ getObjectPropertyString obj "version"

setDOMHTMLHtmlElementVersion :: (MonadIO m, DOMHTMLHtmlElementK o) => o -> T.Text -> m ()
setDOMHTMLHtmlElementVersion obj val = liftIO $ setObjectPropertyString obj "version" val

constructDOMHTMLHtmlElementVersion :: T.Text -> IO ([Char], GValue)
constructDOMHTMLHtmlElementVersion val = constructObjectPropertyString "version" val

data DOMHTMLHtmlElementVersionPropertyInfo
instance AttrInfo DOMHTMLHtmlElementVersionPropertyInfo where
    type AttrAllowedOps DOMHTMLHtmlElementVersionPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLHtmlElementVersionPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLHtmlElementVersionPropertyInfo = DOMHTMLHtmlElementK
    type AttrGetType DOMHTMLHtmlElementVersionPropertyInfo = T.Text
    type AttrLabel DOMHTMLHtmlElementVersionPropertyInfo = "DOMHTMLHtmlElement::version"
    attrGet _ = getDOMHTMLHtmlElementVersion
    attrSet _ = setDOMHTMLHtmlElementVersion
    attrConstruct _ = constructDOMHTMLHtmlElementVersion

type instance AttributeList DOMHTMLHtmlElement = DOMHTMLHtmlElementAttributeList
type DOMHTMLHtmlElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("manifest", DOMHTMLHtmlElementManifestPropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("version", DOMHTMLHtmlElementVersionPropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLHtmlElement = DOMHTMLHtmlElementSignalList
type DOMHTMLHtmlElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLHtmlElement::get_manifest
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHtmlElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHtmlElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_html_element_get_manifest" webkit_dom_html_html_element_get_manifest :: 
    Ptr DOMHTMLHtmlElement ->               -- _obj : TInterface "WebKit" "DOMHTMLHtmlElement"
    IO CString


dOMHTMLHtmlElementGetManifest ::
    (MonadIO m, DOMHTMLHtmlElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLHtmlElementGetManifest _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_html_element_get_manifest _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_html_element_get_manifest" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLHtmlElement::get_version
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHtmlElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHtmlElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_html_element_get_version" webkit_dom_html_html_element_get_version :: 
    Ptr DOMHTMLHtmlElement ->               -- _obj : TInterface "WebKit" "DOMHTMLHtmlElement"
    IO CString


dOMHTMLHtmlElementGetVersion ::
    (MonadIO m, DOMHTMLHtmlElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLHtmlElementGetVersion _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_html_element_get_version _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_html_element_get_version" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLHtmlElement::set_manifest
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHtmlElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHtmlElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_html_element_set_manifest" webkit_dom_html_html_element_set_manifest :: 
    Ptr DOMHTMLHtmlElement ->               -- _obj : TInterface "WebKit" "DOMHTMLHtmlElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLHtmlElementSetManifest ::
    (MonadIO m, DOMHTMLHtmlElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLHtmlElementSetManifest _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_html_element_set_manifest _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLHtmlElement::set_version
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHtmlElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLHtmlElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_html_element_set_version" webkit_dom_html_html_element_set_version :: 
    Ptr DOMHTMLHtmlElement ->               -- _obj : TInterface "WebKit" "DOMHTMLHtmlElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLHtmlElementSetVersion ::
    (MonadIO m, DOMHTMLHtmlElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLHtmlElementSetVersion _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_html_element_set_version _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


