
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLIFrameElement
    ( 

-- * Exported types
    DOMHTMLIFrameElement(..)                ,
    DOMHTMLIFrameElementK                   ,
    toDOMHTMLIFrameElement                  ,
    noDOMHTMLIFrameElement                  ,


 -- * Methods
-- ** dOMHTMLIFrameElementGetAlign
    dOMHTMLIFrameElementGetAlign            ,


-- ** dOMHTMLIFrameElementGetContentDocument
    dOMHTMLIFrameElementGetContentDocument  ,


-- ** dOMHTMLIFrameElementGetContentWindow
    dOMHTMLIFrameElementGetContentWindow    ,


-- ** dOMHTMLIFrameElementGetFrameBorder
    dOMHTMLIFrameElementGetFrameBorder      ,


-- ** dOMHTMLIFrameElementGetHeight
    dOMHTMLIFrameElementGetHeight           ,


-- ** dOMHTMLIFrameElementGetLongDesc
    dOMHTMLIFrameElementGetLongDesc         ,


-- ** dOMHTMLIFrameElementGetMarginHeight
    dOMHTMLIFrameElementGetMarginHeight     ,


-- ** dOMHTMLIFrameElementGetMarginWidth
    dOMHTMLIFrameElementGetMarginWidth      ,


-- ** dOMHTMLIFrameElementGetName
    dOMHTMLIFrameElementGetName             ,


-- ** dOMHTMLIFrameElementGetSandbox
    dOMHTMLIFrameElementGetSandbox          ,


-- ** dOMHTMLIFrameElementGetScrolling
    dOMHTMLIFrameElementGetScrolling        ,


-- ** dOMHTMLIFrameElementGetSeamless
    dOMHTMLIFrameElementGetSeamless         ,


-- ** dOMHTMLIFrameElementGetSrc
    dOMHTMLIFrameElementGetSrc              ,


-- ** dOMHTMLIFrameElementGetSrcdoc
    dOMHTMLIFrameElementGetSrcdoc           ,


-- ** dOMHTMLIFrameElementGetWidth
    dOMHTMLIFrameElementGetWidth            ,


-- ** dOMHTMLIFrameElementSetAlign
    dOMHTMLIFrameElementSetAlign            ,


-- ** dOMHTMLIFrameElementSetFrameBorder
    dOMHTMLIFrameElementSetFrameBorder      ,


-- ** dOMHTMLIFrameElementSetHeight
    dOMHTMLIFrameElementSetHeight           ,


-- ** dOMHTMLIFrameElementSetLongDesc
    dOMHTMLIFrameElementSetLongDesc         ,


-- ** dOMHTMLIFrameElementSetMarginHeight
    dOMHTMLIFrameElementSetMarginHeight     ,


-- ** dOMHTMLIFrameElementSetMarginWidth
    dOMHTMLIFrameElementSetMarginWidth      ,


-- ** dOMHTMLIFrameElementSetName
    dOMHTMLIFrameElementSetName             ,


-- ** dOMHTMLIFrameElementSetSandbox
    dOMHTMLIFrameElementSetSandbox          ,


-- ** dOMHTMLIFrameElementSetScrolling
    dOMHTMLIFrameElementSetScrolling        ,


-- ** dOMHTMLIFrameElementSetSeamless
    dOMHTMLIFrameElementSetSeamless         ,


-- ** dOMHTMLIFrameElementSetSrc
    dOMHTMLIFrameElementSetSrc              ,


-- ** dOMHTMLIFrameElementSetSrcdoc
    dOMHTMLIFrameElementSetSrcdoc           ,


-- ** dOMHTMLIFrameElementSetWidth
    dOMHTMLIFrameElementSetWidth            ,




 -- * Properties
-- ** Align
    DOMHTMLIFrameElementAlignPropertyInfo   ,
    constructDOMHTMLIFrameElementAlign      ,
    getDOMHTMLIFrameElementAlign            ,
    setDOMHTMLIFrameElementAlign            ,


-- ** ContentDocument
    DOMHTMLIFrameElementContentDocumentPropertyInfo,
    getDOMHTMLIFrameElementContentDocument  ,


-- ** ContentWindow
    DOMHTMLIFrameElementContentWindowPropertyInfo,
    getDOMHTMLIFrameElementContentWindow    ,


-- ** FrameBorder
    DOMHTMLIFrameElementFrameBorderPropertyInfo,
    constructDOMHTMLIFrameElementFrameBorder,
    getDOMHTMLIFrameElementFrameBorder      ,
    setDOMHTMLIFrameElementFrameBorder      ,


-- ** Height
    DOMHTMLIFrameElementHeightPropertyInfo  ,
    constructDOMHTMLIFrameElementHeight     ,
    getDOMHTMLIFrameElementHeight           ,
    setDOMHTMLIFrameElementHeight           ,


-- ** LongDesc
    DOMHTMLIFrameElementLongDescPropertyInfo,
    constructDOMHTMLIFrameElementLongDesc   ,
    getDOMHTMLIFrameElementLongDesc         ,
    setDOMHTMLIFrameElementLongDesc         ,


-- ** MarginHeight
    DOMHTMLIFrameElementMarginHeightPropertyInfo,
    constructDOMHTMLIFrameElementMarginHeight,
    getDOMHTMLIFrameElementMarginHeight     ,
    setDOMHTMLIFrameElementMarginHeight     ,


-- ** MarginWidth
    DOMHTMLIFrameElementMarginWidthPropertyInfo,
    constructDOMHTMLIFrameElementMarginWidth,
    getDOMHTMLIFrameElementMarginWidth      ,
    setDOMHTMLIFrameElementMarginWidth      ,


-- ** Name
    DOMHTMLIFrameElementNamePropertyInfo    ,
    constructDOMHTMLIFrameElementName       ,
    getDOMHTMLIFrameElementName             ,
    setDOMHTMLIFrameElementName             ,


-- ** Sandbox
    DOMHTMLIFrameElementSandboxPropertyInfo ,
    constructDOMHTMLIFrameElementSandbox    ,
    getDOMHTMLIFrameElementSandbox          ,
    setDOMHTMLIFrameElementSandbox          ,


-- ** Scrolling
    DOMHTMLIFrameElementScrollingPropertyInfo,
    constructDOMHTMLIFrameElementScrolling  ,
    getDOMHTMLIFrameElementScrolling        ,
    setDOMHTMLIFrameElementScrolling        ,


-- ** Seamless
    DOMHTMLIFrameElementSeamlessPropertyInfo,
    constructDOMHTMLIFrameElementSeamless   ,
    getDOMHTMLIFrameElementSeamless         ,
    setDOMHTMLIFrameElementSeamless         ,


-- ** Src
    DOMHTMLIFrameElementSrcPropertyInfo     ,
    constructDOMHTMLIFrameElementSrc        ,
    getDOMHTMLIFrameElementSrc              ,
    setDOMHTMLIFrameElementSrc              ,


-- ** Srcdoc
    DOMHTMLIFrameElementSrcdocPropertyInfo  ,
    constructDOMHTMLIFrameElementSrcdoc     ,
    getDOMHTMLIFrameElementSrcdoc           ,
    setDOMHTMLIFrameElementSrcdoc           ,


-- ** Width
    DOMHTMLIFrameElementWidthPropertyInfo   ,
    constructDOMHTMLIFrameElementWidth      ,
    getDOMHTMLIFrameElementWidth            ,
    setDOMHTMLIFrameElementWidth            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLIFrameElement = DOMHTMLIFrameElement (ForeignPtr DOMHTMLIFrameElement)
foreign import ccall "webkit_dom_html_iframe_element_get_type"
    c_webkit_dom_html_iframe_element_get_type :: IO GType

type instance ParentTypes DOMHTMLIFrameElement = DOMHTMLIFrameElementParentTypes
type DOMHTMLIFrameElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLIFrameElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_iframe_element_get_type
    

class GObject o => DOMHTMLIFrameElementK o
instance (GObject o, IsDescendantOf DOMHTMLIFrameElement o) => DOMHTMLIFrameElementK o

toDOMHTMLIFrameElement :: DOMHTMLIFrameElementK o => o -> IO DOMHTMLIFrameElement
toDOMHTMLIFrameElement = unsafeCastTo DOMHTMLIFrameElement

noDOMHTMLIFrameElement :: Maybe DOMHTMLIFrameElement
noDOMHTMLIFrameElement = Nothing

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementAlign :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m T.Text
getDOMHTMLIFrameElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLIFrameElementAlign :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLIFrameElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLIFrameElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLIFrameElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLIFrameElementAlignPropertyInfo
instance AttrInfo DOMHTMLIFrameElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLIFrameElementAlignPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLIFrameElementAlignPropertyInfo = "DOMHTMLIFrameElement::align"
    attrGet _ = getDOMHTMLIFrameElementAlign
    attrSet _ = setDOMHTMLIFrameElementAlign
    attrConstruct _ = constructDOMHTMLIFrameElementAlign

-- VVV Prop "content-document"
   -- Type: TInterface "WebKit" "DOMDocument"
   -- Flags: [PropertyReadable]

getDOMHTMLIFrameElementContentDocument :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m DOMDocument
getDOMHTMLIFrameElementContentDocument obj = liftIO $ getObjectPropertyObject obj "content-document" DOMDocument

data DOMHTMLIFrameElementContentDocumentPropertyInfo
instance AttrInfo DOMHTMLIFrameElementContentDocumentPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementContentDocumentPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementContentDocumentPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLIFrameElementContentDocumentPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementContentDocumentPropertyInfo = DOMDocument
    type AttrLabel DOMHTMLIFrameElementContentDocumentPropertyInfo = "DOMHTMLIFrameElement::content-document"
    attrGet _ = getDOMHTMLIFrameElementContentDocument
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "content-window"
   -- Type: TInterface "WebKit" "DOMDOMWindow"
   -- Flags: [PropertyReadable]

getDOMHTMLIFrameElementContentWindow :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m DOMDOMWindow
getDOMHTMLIFrameElementContentWindow obj = liftIO $ getObjectPropertyObject obj "content-window" DOMDOMWindow

data DOMHTMLIFrameElementContentWindowPropertyInfo
instance AttrInfo DOMHTMLIFrameElementContentWindowPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementContentWindowPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementContentWindowPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLIFrameElementContentWindowPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementContentWindowPropertyInfo = DOMDOMWindow
    type AttrLabel DOMHTMLIFrameElementContentWindowPropertyInfo = "DOMHTMLIFrameElement::content-window"
    attrGet _ = getDOMHTMLIFrameElementContentWindow
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "frame-border"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementFrameBorder :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m T.Text
getDOMHTMLIFrameElementFrameBorder obj = liftIO $ getObjectPropertyString obj "frame-border"

setDOMHTMLIFrameElementFrameBorder :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLIFrameElementFrameBorder obj val = liftIO $ setObjectPropertyString obj "frame-border" val

constructDOMHTMLIFrameElementFrameBorder :: T.Text -> IO ([Char], GValue)
constructDOMHTMLIFrameElementFrameBorder val = constructObjectPropertyString "frame-border" val

data DOMHTMLIFrameElementFrameBorderPropertyInfo
instance AttrInfo DOMHTMLIFrameElementFrameBorderPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementFrameBorderPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementFrameBorderPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLIFrameElementFrameBorderPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementFrameBorderPropertyInfo = T.Text
    type AttrLabel DOMHTMLIFrameElementFrameBorderPropertyInfo = "DOMHTMLIFrameElement::frame-border"
    attrGet _ = getDOMHTMLIFrameElementFrameBorder
    attrSet _ = setDOMHTMLIFrameElementFrameBorder
    attrConstruct _ = constructDOMHTMLIFrameElementFrameBorder

-- VVV Prop "height"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementHeight :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m T.Text
getDOMHTMLIFrameElementHeight obj = liftIO $ getObjectPropertyString obj "height"

setDOMHTMLIFrameElementHeight :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLIFrameElementHeight obj val = liftIO $ setObjectPropertyString obj "height" val

constructDOMHTMLIFrameElementHeight :: T.Text -> IO ([Char], GValue)
constructDOMHTMLIFrameElementHeight val = constructObjectPropertyString "height" val

data DOMHTMLIFrameElementHeightPropertyInfo
instance AttrInfo DOMHTMLIFrameElementHeightPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementHeightPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementHeightPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLIFrameElementHeightPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementHeightPropertyInfo = T.Text
    type AttrLabel DOMHTMLIFrameElementHeightPropertyInfo = "DOMHTMLIFrameElement::height"
    attrGet _ = getDOMHTMLIFrameElementHeight
    attrSet _ = setDOMHTMLIFrameElementHeight
    attrConstruct _ = constructDOMHTMLIFrameElementHeight

-- VVV Prop "long-desc"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementLongDesc :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m T.Text
getDOMHTMLIFrameElementLongDesc obj = liftIO $ getObjectPropertyString obj "long-desc"

setDOMHTMLIFrameElementLongDesc :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLIFrameElementLongDesc obj val = liftIO $ setObjectPropertyString obj "long-desc" val

constructDOMHTMLIFrameElementLongDesc :: T.Text -> IO ([Char], GValue)
constructDOMHTMLIFrameElementLongDesc val = constructObjectPropertyString "long-desc" val

data DOMHTMLIFrameElementLongDescPropertyInfo
instance AttrInfo DOMHTMLIFrameElementLongDescPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementLongDescPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementLongDescPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLIFrameElementLongDescPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementLongDescPropertyInfo = T.Text
    type AttrLabel DOMHTMLIFrameElementLongDescPropertyInfo = "DOMHTMLIFrameElement::long-desc"
    attrGet _ = getDOMHTMLIFrameElementLongDesc
    attrSet _ = setDOMHTMLIFrameElementLongDesc
    attrConstruct _ = constructDOMHTMLIFrameElementLongDesc

-- VVV Prop "margin-height"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementMarginHeight :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m T.Text
getDOMHTMLIFrameElementMarginHeight obj = liftIO $ getObjectPropertyString obj "margin-height"

setDOMHTMLIFrameElementMarginHeight :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLIFrameElementMarginHeight obj val = liftIO $ setObjectPropertyString obj "margin-height" val

constructDOMHTMLIFrameElementMarginHeight :: T.Text -> IO ([Char], GValue)
constructDOMHTMLIFrameElementMarginHeight val = constructObjectPropertyString "margin-height" val

data DOMHTMLIFrameElementMarginHeightPropertyInfo
instance AttrInfo DOMHTMLIFrameElementMarginHeightPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementMarginHeightPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementMarginHeightPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLIFrameElementMarginHeightPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementMarginHeightPropertyInfo = T.Text
    type AttrLabel DOMHTMLIFrameElementMarginHeightPropertyInfo = "DOMHTMLIFrameElement::margin-height"
    attrGet _ = getDOMHTMLIFrameElementMarginHeight
    attrSet _ = setDOMHTMLIFrameElementMarginHeight
    attrConstruct _ = constructDOMHTMLIFrameElementMarginHeight

-- VVV Prop "margin-width"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementMarginWidth :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m T.Text
getDOMHTMLIFrameElementMarginWidth obj = liftIO $ getObjectPropertyString obj "margin-width"

setDOMHTMLIFrameElementMarginWidth :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLIFrameElementMarginWidth obj val = liftIO $ setObjectPropertyString obj "margin-width" val

constructDOMHTMLIFrameElementMarginWidth :: T.Text -> IO ([Char], GValue)
constructDOMHTMLIFrameElementMarginWidth val = constructObjectPropertyString "margin-width" val

data DOMHTMLIFrameElementMarginWidthPropertyInfo
instance AttrInfo DOMHTMLIFrameElementMarginWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementMarginWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementMarginWidthPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLIFrameElementMarginWidthPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementMarginWidthPropertyInfo = T.Text
    type AttrLabel DOMHTMLIFrameElementMarginWidthPropertyInfo = "DOMHTMLIFrameElement::margin-width"
    attrGet _ = getDOMHTMLIFrameElementMarginWidth
    attrSet _ = setDOMHTMLIFrameElementMarginWidth
    attrConstruct _ = constructDOMHTMLIFrameElementMarginWidth

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementName :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m T.Text
getDOMHTMLIFrameElementName obj = liftIO $ getObjectPropertyString obj "name"

setDOMHTMLIFrameElementName :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLIFrameElementName obj val = liftIO $ setObjectPropertyString obj "name" val

constructDOMHTMLIFrameElementName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLIFrameElementName val = constructObjectPropertyString "name" val

data DOMHTMLIFrameElementNamePropertyInfo
instance AttrInfo DOMHTMLIFrameElementNamePropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLIFrameElementNamePropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLIFrameElementNamePropertyInfo = "DOMHTMLIFrameElement::name"
    attrGet _ = getDOMHTMLIFrameElementName
    attrSet _ = setDOMHTMLIFrameElementName
    attrConstruct _ = constructDOMHTMLIFrameElementName

-- VVV Prop "sandbox"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementSandbox :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m T.Text
getDOMHTMLIFrameElementSandbox obj = liftIO $ getObjectPropertyString obj "sandbox"

setDOMHTMLIFrameElementSandbox :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLIFrameElementSandbox obj val = liftIO $ setObjectPropertyString obj "sandbox" val

constructDOMHTMLIFrameElementSandbox :: T.Text -> IO ([Char], GValue)
constructDOMHTMLIFrameElementSandbox val = constructObjectPropertyString "sandbox" val

data DOMHTMLIFrameElementSandboxPropertyInfo
instance AttrInfo DOMHTMLIFrameElementSandboxPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementSandboxPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementSandboxPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLIFrameElementSandboxPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementSandboxPropertyInfo = T.Text
    type AttrLabel DOMHTMLIFrameElementSandboxPropertyInfo = "DOMHTMLIFrameElement::sandbox"
    attrGet _ = getDOMHTMLIFrameElementSandbox
    attrSet _ = setDOMHTMLIFrameElementSandbox
    attrConstruct _ = constructDOMHTMLIFrameElementSandbox

-- VVV Prop "scrolling"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementScrolling :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m T.Text
getDOMHTMLIFrameElementScrolling obj = liftIO $ getObjectPropertyString obj "scrolling"

setDOMHTMLIFrameElementScrolling :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLIFrameElementScrolling obj val = liftIO $ setObjectPropertyString obj "scrolling" val

constructDOMHTMLIFrameElementScrolling :: T.Text -> IO ([Char], GValue)
constructDOMHTMLIFrameElementScrolling val = constructObjectPropertyString "scrolling" val

data DOMHTMLIFrameElementScrollingPropertyInfo
instance AttrInfo DOMHTMLIFrameElementScrollingPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementScrollingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementScrollingPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLIFrameElementScrollingPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementScrollingPropertyInfo = T.Text
    type AttrLabel DOMHTMLIFrameElementScrollingPropertyInfo = "DOMHTMLIFrameElement::scrolling"
    attrGet _ = getDOMHTMLIFrameElementScrolling
    attrSet _ = setDOMHTMLIFrameElementScrolling
    attrConstruct _ = constructDOMHTMLIFrameElementScrolling

-- VVV Prop "seamless"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementSeamless :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m Bool
getDOMHTMLIFrameElementSeamless obj = liftIO $ getObjectPropertyBool obj "seamless"

setDOMHTMLIFrameElementSeamless :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> Bool -> m ()
setDOMHTMLIFrameElementSeamless obj val = liftIO $ setObjectPropertyBool obj "seamless" val

constructDOMHTMLIFrameElementSeamless :: Bool -> IO ([Char], GValue)
constructDOMHTMLIFrameElementSeamless val = constructObjectPropertyBool "seamless" val

data DOMHTMLIFrameElementSeamlessPropertyInfo
instance AttrInfo DOMHTMLIFrameElementSeamlessPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementSeamlessPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementSeamlessPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLIFrameElementSeamlessPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementSeamlessPropertyInfo = Bool
    type AttrLabel DOMHTMLIFrameElementSeamlessPropertyInfo = "DOMHTMLIFrameElement::seamless"
    attrGet _ = getDOMHTMLIFrameElementSeamless
    attrSet _ = setDOMHTMLIFrameElementSeamless
    attrConstruct _ = constructDOMHTMLIFrameElementSeamless

-- VVV Prop "src"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementSrc :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m T.Text
getDOMHTMLIFrameElementSrc obj = liftIO $ getObjectPropertyString obj "src"

setDOMHTMLIFrameElementSrc :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLIFrameElementSrc obj val = liftIO $ setObjectPropertyString obj "src" val

constructDOMHTMLIFrameElementSrc :: T.Text -> IO ([Char], GValue)
constructDOMHTMLIFrameElementSrc val = constructObjectPropertyString "src" val

data DOMHTMLIFrameElementSrcPropertyInfo
instance AttrInfo DOMHTMLIFrameElementSrcPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementSrcPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementSrcPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLIFrameElementSrcPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementSrcPropertyInfo = T.Text
    type AttrLabel DOMHTMLIFrameElementSrcPropertyInfo = "DOMHTMLIFrameElement::src"
    attrGet _ = getDOMHTMLIFrameElementSrc
    attrSet _ = setDOMHTMLIFrameElementSrc
    attrConstruct _ = constructDOMHTMLIFrameElementSrc

-- VVV Prop "srcdoc"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementSrcdoc :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m T.Text
getDOMHTMLIFrameElementSrcdoc obj = liftIO $ getObjectPropertyString obj "srcdoc"

setDOMHTMLIFrameElementSrcdoc :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLIFrameElementSrcdoc obj val = liftIO $ setObjectPropertyString obj "srcdoc" val

constructDOMHTMLIFrameElementSrcdoc :: T.Text -> IO ([Char], GValue)
constructDOMHTMLIFrameElementSrcdoc val = constructObjectPropertyString "srcdoc" val

data DOMHTMLIFrameElementSrcdocPropertyInfo
instance AttrInfo DOMHTMLIFrameElementSrcdocPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementSrcdocPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementSrcdocPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLIFrameElementSrcdocPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementSrcdocPropertyInfo = T.Text
    type AttrLabel DOMHTMLIFrameElementSrcdocPropertyInfo = "DOMHTMLIFrameElement::srcdoc"
    attrGet _ = getDOMHTMLIFrameElementSrcdoc
    attrSet _ = setDOMHTMLIFrameElementSrcdoc
    attrConstruct _ = constructDOMHTMLIFrameElementSrcdoc

-- VVV Prop "width"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLIFrameElementWidth :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> m T.Text
getDOMHTMLIFrameElementWidth obj = liftIO $ getObjectPropertyString obj "width"

setDOMHTMLIFrameElementWidth :: (MonadIO m, DOMHTMLIFrameElementK o) => o -> T.Text -> m ()
setDOMHTMLIFrameElementWidth obj val = liftIO $ setObjectPropertyString obj "width" val

constructDOMHTMLIFrameElementWidth :: T.Text -> IO ([Char], GValue)
constructDOMHTMLIFrameElementWidth val = constructObjectPropertyString "width" val

data DOMHTMLIFrameElementWidthPropertyInfo
instance AttrInfo DOMHTMLIFrameElementWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLIFrameElementWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLIFrameElementWidthPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLIFrameElementWidthPropertyInfo = DOMHTMLIFrameElementK
    type AttrGetType DOMHTMLIFrameElementWidthPropertyInfo = T.Text
    type AttrLabel DOMHTMLIFrameElementWidthPropertyInfo = "DOMHTMLIFrameElement::width"
    attrGet _ = getDOMHTMLIFrameElementWidth
    attrSet _ = setDOMHTMLIFrameElementWidth
    attrConstruct _ = constructDOMHTMLIFrameElementWidth

type instance AttributeList DOMHTMLIFrameElement = DOMHTMLIFrameElementAttributeList
type DOMHTMLIFrameElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLIFrameElementAlignPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-document", DOMHTMLIFrameElementContentDocumentPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("content-window", DOMHTMLIFrameElementContentWindowPropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("frame-border", DOMHTMLIFrameElementFrameBorderPropertyInfo), '("height", DOMHTMLIFrameElementHeightPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("long-desc", DOMHTMLIFrameElementLongDescPropertyInfo), '("margin-height", DOMHTMLIFrameElementMarginHeightPropertyInfo), '("margin-width", DOMHTMLIFrameElementMarginWidthPropertyInfo), '("name", DOMHTMLIFrameElementNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("sandbox", DOMHTMLIFrameElementSandboxPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("scrolling", DOMHTMLIFrameElementScrollingPropertyInfo), '("seamless", DOMHTMLIFrameElementSeamlessPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("src", DOMHTMLIFrameElementSrcPropertyInfo), '("srcdoc", DOMHTMLIFrameElementSrcdocPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("width", DOMHTMLIFrameElementWidthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLIFrameElement = DOMHTMLIFrameElementSignalList
type DOMHTMLIFrameElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLIFrameElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_align" webkit_dom_html_iframe_element_get_align :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CString


dOMHTMLIFrameElementGetAlign ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLIFrameElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_content_document
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMDocument"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_content_document" webkit_dom_html_iframe_element_get_content_document :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO (Ptr DOMDocument)


dOMHTMLIFrameElementGetContentDocument ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m DOMDocument
dOMHTMLIFrameElementGetContentDocument _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_content_document _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_content_document" result
    result' <- (newObject DOMDocument) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_content_window
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMDOMWindow"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_content_window" webkit_dom_html_iframe_element_get_content_window :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO (Ptr DOMDOMWindow)


dOMHTMLIFrameElementGetContentWindow ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m DOMDOMWindow
dOMHTMLIFrameElementGetContentWindow _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_content_window _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_content_window" result
    result' <- (wrapObject DOMDOMWindow) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_frame_border
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_frame_border" webkit_dom_html_iframe_element_get_frame_border :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CString


dOMHTMLIFrameElementGetFrameBorder ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLIFrameElementGetFrameBorder _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_frame_border _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_frame_border" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_height" webkit_dom_html_iframe_element_get_height :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CString


dOMHTMLIFrameElementGetHeight ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLIFrameElementGetHeight _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_height _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_height" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_long_desc
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_long_desc" webkit_dom_html_iframe_element_get_long_desc :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CString


dOMHTMLIFrameElementGetLongDesc ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLIFrameElementGetLongDesc _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_long_desc _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_long_desc" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_margin_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_margin_height" webkit_dom_html_iframe_element_get_margin_height :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CString


dOMHTMLIFrameElementGetMarginHeight ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLIFrameElementGetMarginHeight _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_margin_height _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_margin_height" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_margin_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_margin_width" webkit_dom_html_iframe_element_get_margin_width :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CString


dOMHTMLIFrameElementGetMarginWidth ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLIFrameElementGetMarginWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_margin_width _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_margin_width" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_name" webkit_dom_html_iframe_element_get_name :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CString


dOMHTMLIFrameElementGetName ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLIFrameElementGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_sandbox
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_sandbox" webkit_dom_html_iframe_element_get_sandbox :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CString


dOMHTMLIFrameElementGetSandbox ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLIFrameElementGetSandbox _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_sandbox _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_sandbox" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_scrolling
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_scrolling" webkit_dom_html_iframe_element_get_scrolling :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CString


dOMHTMLIFrameElementGetScrolling ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLIFrameElementGetScrolling _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_scrolling _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_scrolling" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_seamless
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_seamless" webkit_dom_html_iframe_element_get_seamless :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CInt


dOMHTMLIFrameElementGetSeamless ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLIFrameElementGetSeamless _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_seamless _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_src
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_src" webkit_dom_html_iframe_element_get_src :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CString


dOMHTMLIFrameElementGetSrc ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLIFrameElementGetSrc _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_src _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_src" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_srcdoc
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_srcdoc" webkit_dom_html_iframe_element_get_srcdoc :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CString


dOMHTMLIFrameElementGetSrcdoc ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLIFrameElementGetSrcdoc _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_srcdoc _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_srcdoc" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::get_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_get_width" webkit_dom_html_iframe_element_get_width :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    IO CString


dOMHTMLIFrameElementGetWidth ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLIFrameElementGetWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_iframe_element_get_width _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_iframe_element_get_width" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLIFrameElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_align" webkit_dom_html_iframe_element_set_align :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLIFrameElementSetAlign ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLIFrameElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_iframe_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLIFrameElement::set_frame_border
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_frame_border" webkit_dom_html_iframe_element_set_frame_border :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLIFrameElementSetFrameBorder ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLIFrameElementSetFrameBorder _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_iframe_element_set_frame_border _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLIFrameElement::set_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_height" webkit_dom_html_iframe_element_set_height :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLIFrameElementSetHeight ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLIFrameElementSetHeight _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_iframe_element_set_height _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLIFrameElement::set_long_desc
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_long_desc" webkit_dom_html_iframe_element_set_long_desc :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLIFrameElementSetLongDesc ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLIFrameElementSetLongDesc _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_iframe_element_set_long_desc _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLIFrameElement::set_margin_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_margin_height" webkit_dom_html_iframe_element_set_margin_height :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLIFrameElementSetMarginHeight ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLIFrameElementSetMarginHeight _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_iframe_element_set_margin_height _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLIFrameElement::set_margin_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_margin_width" webkit_dom_html_iframe_element_set_margin_width :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLIFrameElementSetMarginWidth ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLIFrameElementSetMarginWidth _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_iframe_element_set_margin_width _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLIFrameElement::set_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_name" webkit_dom_html_iframe_element_set_name :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLIFrameElementSetName ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLIFrameElementSetName _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_iframe_element_set_name _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLIFrameElement::set_sandbox
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_sandbox" webkit_dom_html_iframe_element_set_sandbox :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLIFrameElementSetSandbox ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLIFrameElementSetSandbox _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_iframe_element_set_sandbox _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLIFrameElement::set_scrolling
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_scrolling" webkit_dom_html_iframe_element_set_scrolling :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLIFrameElementSetScrolling ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLIFrameElementSetScrolling _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_iframe_element_set_scrolling _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLIFrameElement::set_seamless
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_seamless" webkit_dom_html_iframe_element_set_seamless :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLIFrameElementSetSeamless ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLIFrameElementSetSeamless _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_iframe_element_set_seamless _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLIFrameElement::set_src
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_src" webkit_dom_html_iframe_element_set_src :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLIFrameElementSetSrc ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLIFrameElementSetSrc _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_iframe_element_set_src _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLIFrameElement::set_srcdoc
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_srcdoc" webkit_dom_html_iframe_element_set_srcdoc :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLIFrameElementSetSrcdoc ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLIFrameElementSetSrcdoc _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_iframe_element_set_srcdoc _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLIFrameElement::set_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLIFrameElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_iframe_element_set_width" webkit_dom_html_iframe_element_set_width :: 
    Ptr DOMHTMLIFrameElement ->             -- _obj : TInterface "WebKit" "DOMHTMLIFrameElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLIFrameElementSetWidth ::
    (MonadIO m, DOMHTMLIFrameElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLIFrameElementSetWidth _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_iframe_element_set_width _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


