
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLKeygenElement
    ( 

-- * Exported types
    DOMHTMLKeygenElement(..)                ,
    DOMHTMLKeygenElementK                   ,
    toDOMHTMLKeygenElement                  ,
    noDOMHTMLKeygenElement                  ,


 -- * Methods
-- ** dOMHTMLKeygenElementCheckValidity
    dOMHTMLKeygenElementCheckValidity       ,


-- ** dOMHTMLKeygenElementGetAutofocus
    dOMHTMLKeygenElementGetAutofocus        ,


-- ** dOMHTMLKeygenElementGetChallenge
    dOMHTMLKeygenElementGetChallenge        ,


-- ** dOMHTMLKeygenElementGetDisabled
    dOMHTMLKeygenElementGetDisabled         ,


-- ** dOMHTMLKeygenElementGetForm
    dOMHTMLKeygenElementGetForm             ,


-- ** dOMHTMLKeygenElementGetKeytype
    dOMHTMLKeygenElementGetKeytype          ,


-- ** dOMHTMLKeygenElementGetLabels
    dOMHTMLKeygenElementGetLabels           ,


-- ** dOMHTMLKeygenElementGetName
    dOMHTMLKeygenElementGetName             ,


-- ** dOMHTMLKeygenElementGetValidationMessage
    dOMHTMLKeygenElementGetValidationMessage,


-- ** dOMHTMLKeygenElementGetValidity
    dOMHTMLKeygenElementGetValidity         ,


-- ** dOMHTMLKeygenElementGetWillValidate
    dOMHTMLKeygenElementGetWillValidate     ,


-- ** dOMHTMLKeygenElementSetAutofocus
    dOMHTMLKeygenElementSetAutofocus        ,


-- ** dOMHTMLKeygenElementSetChallenge
    dOMHTMLKeygenElementSetChallenge        ,


-- ** dOMHTMLKeygenElementSetCustomValidity
    dOMHTMLKeygenElementSetCustomValidity   ,


-- ** dOMHTMLKeygenElementSetDisabled
    dOMHTMLKeygenElementSetDisabled         ,


-- ** dOMHTMLKeygenElementSetKeytype
    dOMHTMLKeygenElementSetKeytype          ,


-- ** dOMHTMLKeygenElementSetName
    dOMHTMLKeygenElementSetName             ,




 -- * Properties
-- ** Autofocus
    DOMHTMLKeygenElementAutofocusPropertyInfo,
    constructDOMHTMLKeygenElementAutofocus  ,
    getDOMHTMLKeygenElementAutofocus        ,
    setDOMHTMLKeygenElementAutofocus        ,


-- ** Challenge
    DOMHTMLKeygenElementChallengePropertyInfo,
    constructDOMHTMLKeygenElementChallenge  ,
    getDOMHTMLKeygenElementChallenge        ,
    setDOMHTMLKeygenElementChallenge        ,


-- ** Disabled
    DOMHTMLKeygenElementDisabledPropertyInfo,
    constructDOMHTMLKeygenElementDisabled   ,
    getDOMHTMLKeygenElementDisabled         ,
    setDOMHTMLKeygenElementDisabled         ,


-- ** Form
    DOMHTMLKeygenElementFormPropertyInfo    ,
    getDOMHTMLKeygenElementForm             ,


-- ** Keytype
    DOMHTMLKeygenElementKeytypePropertyInfo ,
    constructDOMHTMLKeygenElementKeytype    ,
    getDOMHTMLKeygenElementKeytype          ,
    setDOMHTMLKeygenElementKeytype          ,


-- ** Labels
    DOMHTMLKeygenElementLabelsPropertyInfo  ,
    getDOMHTMLKeygenElementLabels           ,


-- ** Name
    DOMHTMLKeygenElementNamePropertyInfo    ,
    constructDOMHTMLKeygenElementName       ,
    getDOMHTMLKeygenElementName             ,
    setDOMHTMLKeygenElementName             ,


-- ** Type
    DOMHTMLKeygenElementTypePropertyInfo    ,
    getDOMHTMLKeygenElementType             ,


-- ** ValidationMessage
    DOMHTMLKeygenElementValidationMessagePropertyInfo,
    getDOMHTMLKeygenElementValidationMessage,


-- ** Validity
    DOMHTMLKeygenElementValidityPropertyInfo,
    getDOMHTMLKeygenElementValidity         ,


-- ** WillValidate
    DOMHTMLKeygenElementWillValidatePropertyInfo,
    getDOMHTMLKeygenElementWillValidate     ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLKeygenElement = DOMHTMLKeygenElement (ForeignPtr DOMHTMLKeygenElement)
foreign import ccall "webkit_dom_html_keygen_element_get_type"
    c_webkit_dom_html_keygen_element_get_type :: IO GType

type instance ParentTypes DOMHTMLKeygenElement = DOMHTMLKeygenElementParentTypes
type DOMHTMLKeygenElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLKeygenElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_keygen_element_get_type
    

class GObject o => DOMHTMLKeygenElementK o
instance (GObject o, IsDescendantOf DOMHTMLKeygenElement o) => DOMHTMLKeygenElementK o

toDOMHTMLKeygenElement :: DOMHTMLKeygenElementK o => o -> IO DOMHTMLKeygenElement
toDOMHTMLKeygenElement = unsafeCastTo DOMHTMLKeygenElement

noDOMHTMLKeygenElement :: Maybe DOMHTMLKeygenElement
noDOMHTMLKeygenElement = Nothing

-- VVV Prop "autofocus"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLKeygenElementAutofocus :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> m Bool
getDOMHTMLKeygenElementAutofocus obj = liftIO $ getObjectPropertyBool obj "autofocus"

setDOMHTMLKeygenElementAutofocus :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> Bool -> m ()
setDOMHTMLKeygenElementAutofocus obj val = liftIO $ setObjectPropertyBool obj "autofocus" val

constructDOMHTMLKeygenElementAutofocus :: Bool -> IO ([Char], GValue)
constructDOMHTMLKeygenElementAutofocus val = constructObjectPropertyBool "autofocus" val

data DOMHTMLKeygenElementAutofocusPropertyInfo
instance AttrInfo DOMHTMLKeygenElementAutofocusPropertyInfo where
    type AttrAllowedOps DOMHTMLKeygenElementAutofocusPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLKeygenElementAutofocusPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLKeygenElementAutofocusPropertyInfo = DOMHTMLKeygenElementK
    type AttrGetType DOMHTMLKeygenElementAutofocusPropertyInfo = Bool
    type AttrLabel DOMHTMLKeygenElementAutofocusPropertyInfo = "DOMHTMLKeygenElement::autofocus"
    attrGet _ = getDOMHTMLKeygenElementAutofocus
    attrSet _ = setDOMHTMLKeygenElementAutofocus
    attrConstruct _ = constructDOMHTMLKeygenElementAutofocus

-- VVV Prop "challenge"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLKeygenElementChallenge :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> m T.Text
getDOMHTMLKeygenElementChallenge obj = liftIO $ getObjectPropertyString obj "challenge"

setDOMHTMLKeygenElementChallenge :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> T.Text -> m ()
setDOMHTMLKeygenElementChallenge obj val = liftIO $ setObjectPropertyString obj "challenge" val

constructDOMHTMLKeygenElementChallenge :: T.Text -> IO ([Char], GValue)
constructDOMHTMLKeygenElementChallenge val = constructObjectPropertyString "challenge" val

data DOMHTMLKeygenElementChallengePropertyInfo
instance AttrInfo DOMHTMLKeygenElementChallengePropertyInfo where
    type AttrAllowedOps DOMHTMLKeygenElementChallengePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLKeygenElementChallengePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLKeygenElementChallengePropertyInfo = DOMHTMLKeygenElementK
    type AttrGetType DOMHTMLKeygenElementChallengePropertyInfo = T.Text
    type AttrLabel DOMHTMLKeygenElementChallengePropertyInfo = "DOMHTMLKeygenElement::challenge"
    attrGet _ = getDOMHTMLKeygenElementChallenge
    attrSet _ = setDOMHTMLKeygenElementChallenge
    attrConstruct _ = constructDOMHTMLKeygenElementChallenge

-- VVV Prop "disabled"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLKeygenElementDisabled :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> m Bool
getDOMHTMLKeygenElementDisabled obj = liftIO $ getObjectPropertyBool obj "disabled"

setDOMHTMLKeygenElementDisabled :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> Bool -> m ()
setDOMHTMLKeygenElementDisabled obj val = liftIO $ setObjectPropertyBool obj "disabled" val

constructDOMHTMLKeygenElementDisabled :: Bool -> IO ([Char], GValue)
constructDOMHTMLKeygenElementDisabled val = constructObjectPropertyBool "disabled" val

data DOMHTMLKeygenElementDisabledPropertyInfo
instance AttrInfo DOMHTMLKeygenElementDisabledPropertyInfo where
    type AttrAllowedOps DOMHTMLKeygenElementDisabledPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLKeygenElementDisabledPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLKeygenElementDisabledPropertyInfo = DOMHTMLKeygenElementK
    type AttrGetType DOMHTMLKeygenElementDisabledPropertyInfo = Bool
    type AttrLabel DOMHTMLKeygenElementDisabledPropertyInfo = "DOMHTMLKeygenElement::disabled"
    attrGet _ = getDOMHTMLKeygenElementDisabled
    attrSet _ = setDOMHTMLKeygenElementDisabled
    attrConstruct _ = constructDOMHTMLKeygenElementDisabled

-- VVV Prop "form"
   -- Type: TInterface "WebKit" "DOMHTMLFormElement"
   -- Flags: [PropertyReadable]

getDOMHTMLKeygenElementForm :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> m DOMHTMLFormElement
getDOMHTMLKeygenElementForm obj = liftIO $ getObjectPropertyObject obj "form" DOMHTMLFormElement

data DOMHTMLKeygenElementFormPropertyInfo
instance AttrInfo DOMHTMLKeygenElementFormPropertyInfo where
    type AttrAllowedOps DOMHTMLKeygenElementFormPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLKeygenElementFormPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLKeygenElementFormPropertyInfo = DOMHTMLKeygenElementK
    type AttrGetType DOMHTMLKeygenElementFormPropertyInfo = DOMHTMLFormElement
    type AttrLabel DOMHTMLKeygenElementFormPropertyInfo = "DOMHTMLKeygenElement::form"
    attrGet _ = getDOMHTMLKeygenElementForm
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "keytype"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLKeygenElementKeytype :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> m T.Text
getDOMHTMLKeygenElementKeytype obj = liftIO $ getObjectPropertyString obj "keytype"

setDOMHTMLKeygenElementKeytype :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> T.Text -> m ()
setDOMHTMLKeygenElementKeytype obj val = liftIO $ setObjectPropertyString obj "keytype" val

constructDOMHTMLKeygenElementKeytype :: T.Text -> IO ([Char], GValue)
constructDOMHTMLKeygenElementKeytype val = constructObjectPropertyString "keytype" val

data DOMHTMLKeygenElementKeytypePropertyInfo
instance AttrInfo DOMHTMLKeygenElementKeytypePropertyInfo where
    type AttrAllowedOps DOMHTMLKeygenElementKeytypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLKeygenElementKeytypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLKeygenElementKeytypePropertyInfo = DOMHTMLKeygenElementK
    type AttrGetType DOMHTMLKeygenElementKeytypePropertyInfo = T.Text
    type AttrLabel DOMHTMLKeygenElementKeytypePropertyInfo = "DOMHTMLKeygenElement::keytype"
    attrGet _ = getDOMHTMLKeygenElementKeytype
    attrSet _ = setDOMHTMLKeygenElementKeytype
    attrConstruct _ = constructDOMHTMLKeygenElementKeytype

-- VVV Prop "labels"
   -- Type: TInterface "WebKit" "DOMNodeList"
   -- Flags: [PropertyReadable]

getDOMHTMLKeygenElementLabels :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> m DOMNodeList
getDOMHTMLKeygenElementLabels obj = liftIO $ getObjectPropertyObject obj "labels" DOMNodeList

data DOMHTMLKeygenElementLabelsPropertyInfo
instance AttrInfo DOMHTMLKeygenElementLabelsPropertyInfo where
    type AttrAllowedOps DOMHTMLKeygenElementLabelsPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLKeygenElementLabelsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLKeygenElementLabelsPropertyInfo = DOMHTMLKeygenElementK
    type AttrGetType DOMHTMLKeygenElementLabelsPropertyInfo = DOMNodeList
    type AttrLabel DOMHTMLKeygenElementLabelsPropertyInfo = "DOMHTMLKeygenElement::labels"
    attrGet _ = getDOMHTMLKeygenElementLabels
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLKeygenElementName :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> m T.Text
getDOMHTMLKeygenElementName obj = liftIO $ getObjectPropertyString obj "name"

setDOMHTMLKeygenElementName :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> T.Text -> m ()
setDOMHTMLKeygenElementName obj val = liftIO $ setObjectPropertyString obj "name" val

constructDOMHTMLKeygenElementName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLKeygenElementName val = constructObjectPropertyString "name" val

data DOMHTMLKeygenElementNamePropertyInfo
instance AttrInfo DOMHTMLKeygenElementNamePropertyInfo where
    type AttrAllowedOps DOMHTMLKeygenElementNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLKeygenElementNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLKeygenElementNamePropertyInfo = DOMHTMLKeygenElementK
    type AttrGetType DOMHTMLKeygenElementNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLKeygenElementNamePropertyInfo = "DOMHTMLKeygenElement::name"
    attrGet _ = getDOMHTMLKeygenElementName
    attrSet _ = setDOMHTMLKeygenElementName
    attrConstruct _ = constructDOMHTMLKeygenElementName

-- VVV Prop "type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLKeygenElementType :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> m T.Text
getDOMHTMLKeygenElementType obj = liftIO $ getObjectPropertyString obj "type"

data DOMHTMLKeygenElementTypePropertyInfo
instance AttrInfo DOMHTMLKeygenElementTypePropertyInfo where
    type AttrAllowedOps DOMHTMLKeygenElementTypePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLKeygenElementTypePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLKeygenElementTypePropertyInfo = DOMHTMLKeygenElementK
    type AttrGetType DOMHTMLKeygenElementTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLKeygenElementTypePropertyInfo = "DOMHTMLKeygenElement::type"
    attrGet _ = getDOMHTMLKeygenElementType
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "validation-message"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLKeygenElementValidationMessage :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> m T.Text
getDOMHTMLKeygenElementValidationMessage obj = liftIO $ getObjectPropertyString obj "validation-message"

data DOMHTMLKeygenElementValidationMessagePropertyInfo
instance AttrInfo DOMHTMLKeygenElementValidationMessagePropertyInfo where
    type AttrAllowedOps DOMHTMLKeygenElementValidationMessagePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLKeygenElementValidationMessagePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLKeygenElementValidationMessagePropertyInfo = DOMHTMLKeygenElementK
    type AttrGetType DOMHTMLKeygenElementValidationMessagePropertyInfo = T.Text
    type AttrLabel DOMHTMLKeygenElementValidationMessagePropertyInfo = "DOMHTMLKeygenElement::validation-message"
    attrGet _ = getDOMHTMLKeygenElementValidationMessage
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "validity"
   -- Type: TInterface "WebKit" "DOMValidityState"
   -- Flags: [PropertyReadable]

getDOMHTMLKeygenElementValidity :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> m DOMValidityState
getDOMHTMLKeygenElementValidity obj = liftIO $ getObjectPropertyObject obj "validity" DOMValidityState

data DOMHTMLKeygenElementValidityPropertyInfo
instance AttrInfo DOMHTMLKeygenElementValidityPropertyInfo where
    type AttrAllowedOps DOMHTMLKeygenElementValidityPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLKeygenElementValidityPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLKeygenElementValidityPropertyInfo = DOMHTMLKeygenElementK
    type AttrGetType DOMHTMLKeygenElementValidityPropertyInfo = DOMValidityState
    type AttrLabel DOMHTMLKeygenElementValidityPropertyInfo = "DOMHTMLKeygenElement::validity"
    attrGet _ = getDOMHTMLKeygenElementValidity
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "will-validate"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMHTMLKeygenElementWillValidate :: (MonadIO m, DOMHTMLKeygenElementK o) => o -> m Bool
getDOMHTMLKeygenElementWillValidate obj = liftIO $ getObjectPropertyBool obj "will-validate"

data DOMHTMLKeygenElementWillValidatePropertyInfo
instance AttrInfo DOMHTMLKeygenElementWillValidatePropertyInfo where
    type AttrAllowedOps DOMHTMLKeygenElementWillValidatePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLKeygenElementWillValidatePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLKeygenElementWillValidatePropertyInfo = DOMHTMLKeygenElementK
    type AttrGetType DOMHTMLKeygenElementWillValidatePropertyInfo = Bool
    type AttrLabel DOMHTMLKeygenElementWillValidatePropertyInfo = "DOMHTMLKeygenElement::will-validate"
    attrGet _ = getDOMHTMLKeygenElementWillValidate
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMHTMLKeygenElement = DOMHTMLKeygenElementAttributeList
type DOMHTMLKeygenElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("autofocus", DOMHTMLKeygenElementAutofocusPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("challenge", DOMHTMLKeygenElementChallengePropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("disabled", DOMHTMLKeygenElementDisabledPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("form", DOMHTMLKeygenElementFormPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("keytype", DOMHTMLKeygenElementKeytypePropertyInfo), '("labels", DOMHTMLKeygenElementLabelsPropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("name", DOMHTMLKeygenElementNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("type", DOMHTMLKeygenElementTypePropertyInfo), '("validation-message", DOMHTMLKeygenElementValidationMessagePropertyInfo), '("validity", DOMHTMLKeygenElementValidityPropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("will-validate", DOMHTMLKeygenElementWillValidatePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLKeygenElement = DOMHTMLKeygenElementSignalList
type DOMHTMLKeygenElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLKeygenElement::check_validity
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_check_validity" webkit_dom_html_keygen_element_check_validity :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    IO CInt


dOMHTMLKeygenElementCheckValidity ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLKeygenElementCheckValidity _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_keygen_element_check_validity _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLKeygenElement::get_autofocus
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_get_autofocus" webkit_dom_html_keygen_element_get_autofocus :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    IO CInt


dOMHTMLKeygenElementGetAutofocus ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLKeygenElementGetAutofocus _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_keygen_element_get_autofocus _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLKeygenElement::get_challenge
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_get_challenge" webkit_dom_html_keygen_element_get_challenge :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    IO CString


dOMHTMLKeygenElementGetChallenge ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLKeygenElementGetChallenge _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_keygen_element_get_challenge _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_keygen_element_get_challenge" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLKeygenElement::get_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_get_disabled" webkit_dom_html_keygen_element_get_disabled :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    IO CInt


dOMHTMLKeygenElementGetDisabled ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLKeygenElementGetDisabled _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_keygen_element_get_disabled _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLKeygenElement::get_form
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLFormElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_get_form" webkit_dom_html_keygen_element_get_form :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    IO (Ptr DOMHTMLFormElement)


dOMHTMLKeygenElementGetForm ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLFormElement
dOMHTMLKeygenElementGetForm _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_keygen_element_get_form _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_keygen_element_get_form" result
    result' <- (newObject DOMHTMLFormElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLKeygenElement::get_keytype
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_get_keytype" webkit_dom_html_keygen_element_get_keytype :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    IO CString


dOMHTMLKeygenElementGetKeytype ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLKeygenElementGetKeytype _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_keygen_element_get_keytype _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_keygen_element_get_keytype" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLKeygenElement::get_labels
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNodeList"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_get_labels" webkit_dom_html_keygen_element_get_labels :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    IO (Ptr DOMNodeList)


dOMHTMLKeygenElementGetLabels ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    m DOMNodeList
dOMHTMLKeygenElementGetLabels _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_keygen_element_get_labels _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_keygen_element_get_labels" result
    result' <- (wrapObject DOMNodeList) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLKeygenElement::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_get_name" webkit_dom_html_keygen_element_get_name :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    IO CString


dOMHTMLKeygenElementGetName ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLKeygenElementGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_keygen_element_get_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_keygen_element_get_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLKeygenElement::get_validation_message
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_get_validation_message" webkit_dom_html_keygen_element_get_validation_message :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    IO CString


dOMHTMLKeygenElementGetValidationMessage ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLKeygenElementGetValidationMessage _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_keygen_element_get_validation_message _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_keygen_element_get_validation_message" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLKeygenElement::get_validity
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMValidityState"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_get_validity" webkit_dom_html_keygen_element_get_validity :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    IO (Ptr DOMValidityState)


dOMHTMLKeygenElementGetValidity ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    m DOMValidityState
dOMHTMLKeygenElementGetValidity _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_keygen_element_get_validity _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_keygen_element_get_validity" result
    result' <- (wrapObject DOMValidityState) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLKeygenElement::get_will_validate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_get_will_validate" webkit_dom_html_keygen_element_get_will_validate :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    IO CInt


dOMHTMLKeygenElementGetWillValidate ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLKeygenElementGetWillValidate _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_keygen_element_get_will_validate _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLKeygenElement::set_autofocus
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_set_autofocus" webkit_dom_html_keygen_element_set_autofocus :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLKeygenElementSetAutofocus ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLKeygenElementSetAutofocus _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_keygen_element_set_autofocus _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLKeygenElement::set_challenge
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_set_challenge" webkit_dom_html_keygen_element_set_challenge :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLKeygenElementSetChallenge ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLKeygenElementSetChallenge _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_keygen_element_set_challenge _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLKeygenElement::set_custom_validity
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "error", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "error", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_set_custom_validity" webkit_dom_html_keygen_element_set_custom_validity :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    CString ->                              -- error : TBasicType TUTF8
    IO ()


dOMHTMLKeygenElementSetCustomValidity ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- error
    m ()
dOMHTMLKeygenElementSetCustomValidity _obj error_ = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    error_' <- textToCString error_
    webkit_dom_html_keygen_element_set_custom_validity _obj' error_'
    touchManagedPtr _obj
    freeMem error_'
    return ()

-- method DOMHTMLKeygenElement::set_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_set_disabled" webkit_dom_html_keygen_element_set_disabled :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLKeygenElementSetDisabled ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLKeygenElementSetDisabled _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_keygen_element_set_disabled _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLKeygenElement::set_keytype
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_set_keytype" webkit_dom_html_keygen_element_set_keytype :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLKeygenElementSetKeytype ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLKeygenElementSetKeytype _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_keygen_element_set_keytype _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLKeygenElement::set_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLKeygenElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_keygen_element_set_name" webkit_dom_html_keygen_element_set_name :: 
    Ptr DOMHTMLKeygenElement ->             -- _obj : TInterface "WebKit" "DOMHTMLKeygenElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLKeygenElementSetName ::
    (MonadIO m, DOMHTMLKeygenElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLKeygenElementSetName _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_keygen_element_set_name _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


