
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLLIElement
    ( 

-- * Exported types
    DOMHTMLLIElement(..)                    ,
    DOMHTMLLIElementK                       ,
    toDOMHTMLLIElement                      ,
    noDOMHTMLLIElement                      ,


 -- * Methods
-- ** dOMHTMLLIElementGetValue
    dOMHTMLLIElementGetValue                ,


-- ** dOMHTMLLIElementSetValue
    dOMHTMLLIElementSetValue                ,




 -- * Properties
-- ** Type
    DOMHTMLLIElementTypePropertyInfo        ,
    constructDOMHTMLLIElementType           ,
    getDOMHTMLLIElementType                 ,
    setDOMHTMLLIElementType                 ,


-- ** Value
    DOMHTMLLIElementValuePropertyInfo       ,
    constructDOMHTMLLIElementValue          ,
    getDOMHTMLLIElementValue                ,
    setDOMHTMLLIElementValue                ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLLIElement = DOMHTMLLIElement (ForeignPtr DOMHTMLLIElement)
foreign import ccall "webkit_dom_htmlli_element_get_type"
    c_webkit_dom_htmlli_element_get_type :: IO GType

type instance ParentTypes DOMHTMLLIElement = DOMHTMLLIElementParentTypes
type DOMHTMLLIElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLLIElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_htmlli_element_get_type
    

class GObject o => DOMHTMLLIElementK o
instance (GObject o, IsDescendantOf DOMHTMLLIElement o) => DOMHTMLLIElementK o

toDOMHTMLLIElement :: DOMHTMLLIElementK o => o -> IO DOMHTMLLIElement
toDOMHTMLLIElement = unsafeCastTo DOMHTMLLIElement

noDOMHTMLLIElement :: Maybe DOMHTMLLIElement
noDOMHTMLLIElement = Nothing

-- VVV Prop "type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLLIElementType :: (MonadIO m, DOMHTMLLIElementK o) => o -> m T.Text
getDOMHTMLLIElementType obj = liftIO $ getObjectPropertyString obj "type"

setDOMHTMLLIElementType :: (MonadIO m, DOMHTMLLIElementK o) => o -> T.Text -> m ()
setDOMHTMLLIElementType obj val = liftIO $ setObjectPropertyString obj "type" val

constructDOMHTMLLIElementType :: T.Text -> IO ([Char], GValue)
constructDOMHTMLLIElementType val = constructObjectPropertyString "type" val

data DOMHTMLLIElementTypePropertyInfo
instance AttrInfo DOMHTMLLIElementTypePropertyInfo where
    type AttrAllowedOps DOMHTMLLIElementTypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLIElementTypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLLIElementTypePropertyInfo = DOMHTMLLIElementK
    type AttrGetType DOMHTMLLIElementTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLLIElementTypePropertyInfo = "DOMHTMLLIElement::type"
    attrGet _ = getDOMHTMLLIElementType
    attrSet _ = setDOMHTMLLIElementType
    attrConstruct _ = constructDOMHTMLLIElementType

-- VVV Prop "value"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLLIElementValue :: (MonadIO m, DOMHTMLLIElementK o) => o -> m Int64
getDOMHTMLLIElementValue obj = liftIO $ getObjectPropertyInt64 obj "value"

setDOMHTMLLIElementValue :: (MonadIO m, DOMHTMLLIElementK o) => o -> Int64 -> m ()
setDOMHTMLLIElementValue obj val = liftIO $ setObjectPropertyInt64 obj "value" val

constructDOMHTMLLIElementValue :: Int64 -> IO ([Char], GValue)
constructDOMHTMLLIElementValue val = constructObjectPropertyInt64 "value" val

data DOMHTMLLIElementValuePropertyInfo
instance AttrInfo DOMHTMLLIElementValuePropertyInfo where
    type AttrAllowedOps DOMHTMLLIElementValuePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLIElementValuePropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLLIElementValuePropertyInfo = DOMHTMLLIElementK
    type AttrGetType DOMHTMLLIElementValuePropertyInfo = Int64
    type AttrLabel DOMHTMLLIElementValuePropertyInfo = "DOMHTMLLIElement::value"
    attrGet _ = getDOMHTMLLIElementValue
    attrSet _ = setDOMHTMLLIElementValue
    attrConstruct _ = constructDOMHTMLLIElementValue

type instance AttributeList DOMHTMLLIElement = DOMHTMLLIElementAttributeList
type DOMHTMLLIElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("type", DOMHTMLLIElementTypePropertyInfo), '("value", DOMHTMLLIElementValuePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLLIElement = DOMHTMLLIElementSignalList
type DOMHTMLLIElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLLIElement::get_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLIElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLIElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlli_element_get_value" webkit_dom_htmlli_element_get_value :: 
    Ptr DOMHTMLLIElement ->                 -- _obj : TInterface "WebKit" "DOMHTMLLIElement"
    IO Int64


dOMHTMLLIElementGetValue ::
    (MonadIO m, DOMHTMLLIElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLLIElementGetValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_htmlli_element_get_value _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLLIElement::set_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLIElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLIElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlli_element_set_value" webkit_dom_htmlli_element_set_value :: 
    Ptr DOMHTMLLIElement ->                 -- _obj : TInterface "WebKit" "DOMHTMLLIElement"
    Int64 ->                                -- value : TBasicType TInt64
    IO ()


dOMHTMLLIElementSetValue ::
    (MonadIO m, DOMHTMLLIElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLLIElementSetValue _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_htmlli_element_set_value _obj' value
    touchManagedPtr _obj
    return ()


