
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLLegendElement
    ( 

-- * Exported types
    DOMHTMLLegendElement(..)                ,
    DOMHTMLLegendElementK                   ,
    toDOMHTMLLegendElement                  ,
    noDOMHTMLLegendElement                  ,


 -- * Methods
-- ** dOMHTMLLegendElementGetAlign
    dOMHTMLLegendElementGetAlign            ,


-- ** dOMHTMLLegendElementGetForm
    dOMHTMLLegendElementGetForm             ,


-- ** dOMHTMLLegendElementSetAlign
    dOMHTMLLegendElementSetAlign            ,




 -- * Properties
-- ** Align
    DOMHTMLLegendElementAlignPropertyInfo   ,
    constructDOMHTMLLegendElementAlign      ,
    getDOMHTMLLegendElementAlign            ,
    setDOMHTMLLegendElementAlign            ,


-- ** Form
    DOMHTMLLegendElementFormPropertyInfo    ,
    getDOMHTMLLegendElementForm             ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLLegendElement = DOMHTMLLegendElement (ForeignPtr DOMHTMLLegendElement)
foreign import ccall "webkit_dom_html_legend_element_get_type"
    c_webkit_dom_html_legend_element_get_type :: IO GType

type instance ParentTypes DOMHTMLLegendElement = DOMHTMLLegendElementParentTypes
type DOMHTMLLegendElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLLegendElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_legend_element_get_type
    

class GObject o => DOMHTMLLegendElementK o
instance (GObject o, IsDescendantOf DOMHTMLLegendElement o) => DOMHTMLLegendElementK o

toDOMHTMLLegendElement :: DOMHTMLLegendElementK o => o -> IO DOMHTMLLegendElement
toDOMHTMLLegendElement = unsafeCastTo DOMHTMLLegendElement

noDOMHTMLLegendElement :: Maybe DOMHTMLLegendElement
noDOMHTMLLegendElement = Nothing

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLLegendElementAlign :: (MonadIO m, DOMHTMLLegendElementK o) => o -> m T.Text
getDOMHTMLLegendElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLLegendElementAlign :: (MonadIO m, DOMHTMLLegendElementK o) => o -> T.Text -> m ()
setDOMHTMLLegendElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLLegendElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLLegendElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLLegendElementAlignPropertyInfo
instance AttrInfo DOMHTMLLegendElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLLegendElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLegendElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLLegendElementAlignPropertyInfo = DOMHTMLLegendElementK
    type AttrGetType DOMHTMLLegendElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLLegendElementAlignPropertyInfo = "DOMHTMLLegendElement::align"
    attrGet _ = getDOMHTMLLegendElementAlign
    attrSet _ = setDOMHTMLLegendElementAlign
    attrConstruct _ = constructDOMHTMLLegendElementAlign

-- VVV Prop "form"
   -- Type: TInterface "WebKit" "DOMHTMLFormElement"
   -- Flags: [PropertyReadable]

getDOMHTMLLegendElementForm :: (MonadIO m, DOMHTMLLegendElementK o) => o -> m DOMHTMLFormElement
getDOMHTMLLegendElementForm obj = liftIO $ getObjectPropertyObject obj "form" DOMHTMLFormElement

data DOMHTMLLegendElementFormPropertyInfo
instance AttrInfo DOMHTMLLegendElementFormPropertyInfo where
    type AttrAllowedOps DOMHTMLLegendElementFormPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLegendElementFormPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLLegendElementFormPropertyInfo = DOMHTMLLegendElementK
    type AttrGetType DOMHTMLLegendElementFormPropertyInfo = DOMHTMLFormElement
    type AttrLabel DOMHTMLLegendElementFormPropertyInfo = "DOMHTMLLegendElement::form"
    attrGet _ = getDOMHTMLLegendElementForm
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMHTMLLegendElement = DOMHTMLLegendElementAttributeList
type DOMHTMLLegendElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLLegendElementAlignPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("form", DOMHTMLLegendElementFormPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLLegendElement = DOMHTMLLegendElementSignalList
type DOMHTMLLegendElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLLegendElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLegendElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLegendElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_legend_element_get_align" webkit_dom_html_legend_element_get_align :: 
    Ptr DOMHTMLLegendElement ->             -- _obj : TInterface "WebKit" "DOMHTMLLegendElement"
    IO CString


dOMHTMLLegendElementGetAlign ::
    (MonadIO m, DOMHTMLLegendElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLLegendElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_legend_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_legend_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLLegendElement::get_form
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLegendElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLegendElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLFormElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_legend_element_get_form" webkit_dom_html_legend_element_get_form :: 
    Ptr DOMHTMLLegendElement ->             -- _obj : TInterface "WebKit" "DOMHTMLLegendElement"
    IO (Ptr DOMHTMLFormElement)


dOMHTMLLegendElementGetForm ::
    (MonadIO m, DOMHTMLLegendElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLFormElement
dOMHTMLLegendElementGetForm _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_legend_element_get_form _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_legend_element_get_form" result
    result' <- (newObject DOMHTMLFormElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLLegendElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLegendElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLegendElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_legend_element_set_align" webkit_dom_html_legend_element_set_align :: 
    Ptr DOMHTMLLegendElement ->             -- _obj : TInterface "WebKit" "DOMHTMLLegendElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLLegendElementSetAlign ::
    (MonadIO m, DOMHTMLLegendElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLLegendElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_legend_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


