
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLLinkElement
    ( 

-- * Exported types
    DOMHTMLLinkElement(..)                  ,
    DOMHTMLLinkElementK                     ,
    toDOMHTMLLinkElement                    ,
    noDOMHTMLLinkElement                    ,


 -- * Methods
-- ** dOMHTMLLinkElementGetCharset
    dOMHTMLLinkElementGetCharset            ,


-- ** dOMHTMLLinkElementGetDisabled
    dOMHTMLLinkElementGetDisabled           ,


-- ** dOMHTMLLinkElementGetHref
    dOMHTMLLinkElementGetHref               ,


-- ** dOMHTMLLinkElementGetHreflang
    dOMHTMLLinkElementGetHreflang           ,


-- ** dOMHTMLLinkElementGetMedia
    dOMHTMLLinkElementGetMedia              ,


-- ** dOMHTMLLinkElementGetRel
    dOMHTMLLinkElementGetRel                ,


-- ** dOMHTMLLinkElementGetRev
    dOMHTMLLinkElementGetRev                ,


-- ** dOMHTMLLinkElementGetSheet
    dOMHTMLLinkElementGetSheet              ,


-- ** dOMHTMLLinkElementGetTarget
    dOMHTMLLinkElementGetTarget             ,


-- ** dOMHTMLLinkElementSetCharset
    dOMHTMLLinkElementSetCharset            ,


-- ** dOMHTMLLinkElementSetDisabled
    dOMHTMLLinkElementSetDisabled           ,


-- ** dOMHTMLLinkElementSetHref
    dOMHTMLLinkElementSetHref               ,


-- ** dOMHTMLLinkElementSetHreflang
    dOMHTMLLinkElementSetHreflang           ,


-- ** dOMHTMLLinkElementSetMedia
    dOMHTMLLinkElementSetMedia              ,


-- ** dOMHTMLLinkElementSetRel
    dOMHTMLLinkElementSetRel                ,


-- ** dOMHTMLLinkElementSetRev
    dOMHTMLLinkElementSetRev                ,


-- ** dOMHTMLLinkElementSetTarget
    dOMHTMLLinkElementSetTarget             ,




 -- * Properties
-- ** Charset
    DOMHTMLLinkElementCharsetPropertyInfo   ,
    constructDOMHTMLLinkElementCharset      ,
    getDOMHTMLLinkElementCharset            ,
    setDOMHTMLLinkElementCharset            ,


-- ** Disabled
    DOMHTMLLinkElementDisabledPropertyInfo  ,
    constructDOMHTMLLinkElementDisabled     ,
    getDOMHTMLLinkElementDisabled           ,
    setDOMHTMLLinkElementDisabled           ,


-- ** Href
    DOMHTMLLinkElementHrefPropertyInfo      ,
    constructDOMHTMLLinkElementHref         ,
    getDOMHTMLLinkElementHref               ,
    setDOMHTMLLinkElementHref               ,


-- ** Hreflang
    DOMHTMLLinkElementHreflangPropertyInfo  ,
    constructDOMHTMLLinkElementHreflang     ,
    getDOMHTMLLinkElementHreflang           ,
    setDOMHTMLLinkElementHreflang           ,


-- ** Media
    DOMHTMLLinkElementMediaPropertyInfo     ,
    constructDOMHTMLLinkElementMedia        ,
    getDOMHTMLLinkElementMedia              ,
    setDOMHTMLLinkElementMedia              ,


-- ** Rel
    DOMHTMLLinkElementRelPropertyInfo       ,
    constructDOMHTMLLinkElementRel          ,
    getDOMHTMLLinkElementRel                ,
    setDOMHTMLLinkElementRel                ,


-- ** Rev
    DOMHTMLLinkElementRevPropertyInfo       ,
    constructDOMHTMLLinkElementRev          ,
    getDOMHTMLLinkElementRev                ,
    setDOMHTMLLinkElementRev                ,


-- ** Sheet
    DOMHTMLLinkElementSheetPropertyInfo     ,
    getDOMHTMLLinkElementSheet              ,


-- ** Target
    DOMHTMLLinkElementTargetPropertyInfo    ,
    constructDOMHTMLLinkElementTarget       ,
    getDOMHTMLLinkElementTarget             ,
    setDOMHTMLLinkElementTarget             ,


-- ** Type
    DOMHTMLLinkElementTypePropertyInfo      ,
    constructDOMHTMLLinkElementType         ,
    getDOMHTMLLinkElementType               ,
    setDOMHTMLLinkElementType               ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLLinkElement = DOMHTMLLinkElement (ForeignPtr DOMHTMLLinkElement)
foreign import ccall "webkit_dom_html_link_element_get_type"
    c_webkit_dom_html_link_element_get_type :: IO GType

type instance ParentTypes DOMHTMLLinkElement = DOMHTMLLinkElementParentTypes
type DOMHTMLLinkElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLLinkElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_link_element_get_type
    

class GObject o => DOMHTMLLinkElementK o
instance (GObject o, IsDescendantOf DOMHTMLLinkElement o) => DOMHTMLLinkElementK o

toDOMHTMLLinkElement :: DOMHTMLLinkElementK o => o -> IO DOMHTMLLinkElement
toDOMHTMLLinkElement = unsafeCastTo DOMHTMLLinkElement

noDOMHTMLLinkElement :: Maybe DOMHTMLLinkElement
noDOMHTMLLinkElement = Nothing

-- VVV Prop "charset"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLLinkElementCharset :: (MonadIO m, DOMHTMLLinkElementK o) => o -> m T.Text
getDOMHTMLLinkElementCharset obj = liftIO $ getObjectPropertyString obj "charset"

setDOMHTMLLinkElementCharset :: (MonadIO m, DOMHTMLLinkElementK o) => o -> T.Text -> m ()
setDOMHTMLLinkElementCharset obj val = liftIO $ setObjectPropertyString obj "charset" val

constructDOMHTMLLinkElementCharset :: T.Text -> IO ([Char], GValue)
constructDOMHTMLLinkElementCharset val = constructObjectPropertyString "charset" val

data DOMHTMLLinkElementCharsetPropertyInfo
instance AttrInfo DOMHTMLLinkElementCharsetPropertyInfo where
    type AttrAllowedOps DOMHTMLLinkElementCharsetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLinkElementCharsetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLLinkElementCharsetPropertyInfo = DOMHTMLLinkElementK
    type AttrGetType DOMHTMLLinkElementCharsetPropertyInfo = T.Text
    type AttrLabel DOMHTMLLinkElementCharsetPropertyInfo = "DOMHTMLLinkElement::charset"
    attrGet _ = getDOMHTMLLinkElementCharset
    attrSet _ = setDOMHTMLLinkElementCharset
    attrConstruct _ = constructDOMHTMLLinkElementCharset

-- VVV Prop "disabled"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLLinkElementDisabled :: (MonadIO m, DOMHTMLLinkElementK o) => o -> m Bool
getDOMHTMLLinkElementDisabled obj = liftIO $ getObjectPropertyBool obj "disabled"

setDOMHTMLLinkElementDisabled :: (MonadIO m, DOMHTMLLinkElementK o) => o -> Bool -> m ()
setDOMHTMLLinkElementDisabled obj val = liftIO $ setObjectPropertyBool obj "disabled" val

constructDOMHTMLLinkElementDisabled :: Bool -> IO ([Char], GValue)
constructDOMHTMLLinkElementDisabled val = constructObjectPropertyBool "disabled" val

data DOMHTMLLinkElementDisabledPropertyInfo
instance AttrInfo DOMHTMLLinkElementDisabledPropertyInfo where
    type AttrAllowedOps DOMHTMLLinkElementDisabledPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLinkElementDisabledPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLLinkElementDisabledPropertyInfo = DOMHTMLLinkElementK
    type AttrGetType DOMHTMLLinkElementDisabledPropertyInfo = Bool
    type AttrLabel DOMHTMLLinkElementDisabledPropertyInfo = "DOMHTMLLinkElement::disabled"
    attrGet _ = getDOMHTMLLinkElementDisabled
    attrSet _ = setDOMHTMLLinkElementDisabled
    attrConstruct _ = constructDOMHTMLLinkElementDisabled

-- VVV Prop "href"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLLinkElementHref :: (MonadIO m, DOMHTMLLinkElementK o) => o -> m T.Text
getDOMHTMLLinkElementHref obj = liftIO $ getObjectPropertyString obj "href"

setDOMHTMLLinkElementHref :: (MonadIO m, DOMHTMLLinkElementK o) => o -> T.Text -> m ()
setDOMHTMLLinkElementHref obj val = liftIO $ setObjectPropertyString obj "href" val

constructDOMHTMLLinkElementHref :: T.Text -> IO ([Char], GValue)
constructDOMHTMLLinkElementHref val = constructObjectPropertyString "href" val

data DOMHTMLLinkElementHrefPropertyInfo
instance AttrInfo DOMHTMLLinkElementHrefPropertyInfo where
    type AttrAllowedOps DOMHTMLLinkElementHrefPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLinkElementHrefPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLLinkElementHrefPropertyInfo = DOMHTMLLinkElementK
    type AttrGetType DOMHTMLLinkElementHrefPropertyInfo = T.Text
    type AttrLabel DOMHTMLLinkElementHrefPropertyInfo = "DOMHTMLLinkElement::href"
    attrGet _ = getDOMHTMLLinkElementHref
    attrSet _ = setDOMHTMLLinkElementHref
    attrConstruct _ = constructDOMHTMLLinkElementHref

-- VVV Prop "hreflang"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLLinkElementHreflang :: (MonadIO m, DOMHTMLLinkElementK o) => o -> m T.Text
getDOMHTMLLinkElementHreflang obj = liftIO $ getObjectPropertyString obj "hreflang"

setDOMHTMLLinkElementHreflang :: (MonadIO m, DOMHTMLLinkElementK o) => o -> T.Text -> m ()
setDOMHTMLLinkElementHreflang obj val = liftIO $ setObjectPropertyString obj "hreflang" val

constructDOMHTMLLinkElementHreflang :: T.Text -> IO ([Char], GValue)
constructDOMHTMLLinkElementHreflang val = constructObjectPropertyString "hreflang" val

data DOMHTMLLinkElementHreflangPropertyInfo
instance AttrInfo DOMHTMLLinkElementHreflangPropertyInfo where
    type AttrAllowedOps DOMHTMLLinkElementHreflangPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLinkElementHreflangPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLLinkElementHreflangPropertyInfo = DOMHTMLLinkElementK
    type AttrGetType DOMHTMLLinkElementHreflangPropertyInfo = T.Text
    type AttrLabel DOMHTMLLinkElementHreflangPropertyInfo = "DOMHTMLLinkElement::hreflang"
    attrGet _ = getDOMHTMLLinkElementHreflang
    attrSet _ = setDOMHTMLLinkElementHreflang
    attrConstruct _ = constructDOMHTMLLinkElementHreflang

-- VVV Prop "media"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLLinkElementMedia :: (MonadIO m, DOMHTMLLinkElementK o) => o -> m T.Text
getDOMHTMLLinkElementMedia obj = liftIO $ getObjectPropertyString obj "media"

setDOMHTMLLinkElementMedia :: (MonadIO m, DOMHTMLLinkElementK o) => o -> T.Text -> m ()
setDOMHTMLLinkElementMedia obj val = liftIO $ setObjectPropertyString obj "media" val

constructDOMHTMLLinkElementMedia :: T.Text -> IO ([Char], GValue)
constructDOMHTMLLinkElementMedia val = constructObjectPropertyString "media" val

data DOMHTMLLinkElementMediaPropertyInfo
instance AttrInfo DOMHTMLLinkElementMediaPropertyInfo where
    type AttrAllowedOps DOMHTMLLinkElementMediaPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLinkElementMediaPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLLinkElementMediaPropertyInfo = DOMHTMLLinkElementK
    type AttrGetType DOMHTMLLinkElementMediaPropertyInfo = T.Text
    type AttrLabel DOMHTMLLinkElementMediaPropertyInfo = "DOMHTMLLinkElement::media"
    attrGet _ = getDOMHTMLLinkElementMedia
    attrSet _ = setDOMHTMLLinkElementMedia
    attrConstruct _ = constructDOMHTMLLinkElementMedia

-- VVV Prop "rel"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLLinkElementRel :: (MonadIO m, DOMHTMLLinkElementK o) => o -> m T.Text
getDOMHTMLLinkElementRel obj = liftIO $ getObjectPropertyString obj "rel"

setDOMHTMLLinkElementRel :: (MonadIO m, DOMHTMLLinkElementK o) => o -> T.Text -> m ()
setDOMHTMLLinkElementRel obj val = liftIO $ setObjectPropertyString obj "rel" val

constructDOMHTMLLinkElementRel :: T.Text -> IO ([Char], GValue)
constructDOMHTMLLinkElementRel val = constructObjectPropertyString "rel" val

data DOMHTMLLinkElementRelPropertyInfo
instance AttrInfo DOMHTMLLinkElementRelPropertyInfo where
    type AttrAllowedOps DOMHTMLLinkElementRelPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLinkElementRelPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLLinkElementRelPropertyInfo = DOMHTMLLinkElementK
    type AttrGetType DOMHTMLLinkElementRelPropertyInfo = T.Text
    type AttrLabel DOMHTMLLinkElementRelPropertyInfo = "DOMHTMLLinkElement::rel"
    attrGet _ = getDOMHTMLLinkElementRel
    attrSet _ = setDOMHTMLLinkElementRel
    attrConstruct _ = constructDOMHTMLLinkElementRel

-- VVV Prop "rev"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLLinkElementRev :: (MonadIO m, DOMHTMLLinkElementK o) => o -> m T.Text
getDOMHTMLLinkElementRev obj = liftIO $ getObjectPropertyString obj "rev"

setDOMHTMLLinkElementRev :: (MonadIO m, DOMHTMLLinkElementK o) => o -> T.Text -> m ()
setDOMHTMLLinkElementRev obj val = liftIO $ setObjectPropertyString obj "rev" val

constructDOMHTMLLinkElementRev :: T.Text -> IO ([Char], GValue)
constructDOMHTMLLinkElementRev val = constructObjectPropertyString "rev" val

data DOMHTMLLinkElementRevPropertyInfo
instance AttrInfo DOMHTMLLinkElementRevPropertyInfo where
    type AttrAllowedOps DOMHTMLLinkElementRevPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLinkElementRevPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLLinkElementRevPropertyInfo = DOMHTMLLinkElementK
    type AttrGetType DOMHTMLLinkElementRevPropertyInfo = T.Text
    type AttrLabel DOMHTMLLinkElementRevPropertyInfo = "DOMHTMLLinkElement::rev"
    attrGet _ = getDOMHTMLLinkElementRev
    attrSet _ = setDOMHTMLLinkElementRev
    attrConstruct _ = constructDOMHTMLLinkElementRev

-- VVV Prop "sheet"
   -- Type: TInterface "WebKit" "DOMStyleSheet"
   -- Flags: [PropertyReadable]

getDOMHTMLLinkElementSheet :: (MonadIO m, DOMHTMLLinkElementK o) => o -> m DOMStyleSheet
getDOMHTMLLinkElementSheet obj = liftIO $ getObjectPropertyObject obj "sheet" DOMStyleSheet

data DOMHTMLLinkElementSheetPropertyInfo
instance AttrInfo DOMHTMLLinkElementSheetPropertyInfo where
    type AttrAllowedOps DOMHTMLLinkElementSheetPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLinkElementSheetPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLLinkElementSheetPropertyInfo = DOMHTMLLinkElementK
    type AttrGetType DOMHTMLLinkElementSheetPropertyInfo = DOMStyleSheet
    type AttrLabel DOMHTMLLinkElementSheetPropertyInfo = "DOMHTMLLinkElement::sheet"
    attrGet _ = getDOMHTMLLinkElementSheet
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "target"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLLinkElementTarget :: (MonadIO m, DOMHTMLLinkElementK o) => o -> m T.Text
getDOMHTMLLinkElementTarget obj = liftIO $ getObjectPropertyString obj "target"

setDOMHTMLLinkElementTarget :: (MonadIO m, DOMHTMLLinkElementK o) => o -> T.Text -> m ()
setDOMHTMLLinkElementTarget obj val = liftIO $ setObjectPropertyString obj "target" val

constructDOMHTMLLinkElementTarget :: T.Text -> IO ([Char], GValue)
constructDOMHTMLLinkElementTarget val = constructObjectPropertyString "target" val

data DOMHTMLLinkElementTargetPropertyInfo
instance AttrInfo DOMHTMLLinkElementTargetPropertyInfo where
    type AttrAllowedOps DOMHTMLLinkElementTargetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLinkElementTargetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLLinkElementTargetPropertyInfo = DOMHTMLLinkElementK
    type AttrGetType DOMHTMLLinkElementTargetPropertyInfo = T.Text
    type AttrLabel DOMHTMLLinkElementTargetPropertyInfo = "DOMHTMLLinkElement::target"
    attrGet _ = getDOMHTMLLinkElementTarget
    attrSet _ = setDOMHTMLLinkElementTarget
    attrConstruct _ = constructDOMHTMLLinkElementTarget

-- VVV Prop "type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLLinkElementType :: (MonadIO m, DOMHTMLLinkElementK o) => o -> m T.Text
getDOMHTMLLinkElementType obj = liftIO $ getObjectPropertyString obj "type"

setDOMHTMLLinkElementType :: (MonadIO m, DOMHTMLLinkElementK o) => o -> T.Text -> m ()
setDOMHTMLLinkElementType obj val = liftIO $ setObjectPropertyString obj "type" val

constructDOMHTMLLinkElementType :: T.Text -> IO ([Char], GValue)
constructDOMHTMLLinkElementType val = constructObjectPropertyString "type" val

data DOMHTMLLinkElementTypePropertyInfo
instance AttrInfo DOMHTMLLinkElementTypePropertyInfo where
    type AttrAllowedOps DOMHTMLLinkElementTypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLLinkElementTypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLLinkElementTypePropertyInfo = DOMHTMLLinkElementK
    type AttrGetType DOMHTMLLinkElementTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLLinkElementTypePropertyInfo = "DOMHTMLLinkElement::type"
    attrGet _ = getDOMHTMLLinkElementType
    attrSet _ = setDOMHTMLLinkElementType
    attrConstruct _ = constructDOMHTMLLinkElementType

type instance AttributeList DOMHTMLLinkElement = DOMHTMLLinkElementAttributeList
type DOMHTMLLinkElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("charset", DOMHTMLLinkElementCharsetPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("disabled", DOMHTMLLinkElementDisabledPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("href", DOMHTMLLinkElementHrefPropertyInfo), '("hreflang", DOMHTMLLinkElementHreflangPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("media", DOMHTMLLinkElementMediaPropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("rel", DOMHTMLLinkElementRelPropertyInfo), '("rev", DOMHTMLLinkElementRevPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("sheet", DOMHTMLLinkElementSheetPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("target", DOMHTMLLinkElementTargetPropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("type", DOMHTMLLinkElementTypePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLLinkElement = DOMHTMLLinkElementSignalList
type DOMHTMLLinkElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLLinkElement::get_charset
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_get_charset" webkit_dom_html_link_element_get_charset :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    IO CString


dOMHTMLLinkElementGetCharset ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLLinkElementGetCharset _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_link_element_get_charset _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_link_element_get_charset" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLLinkElement::get_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_get_disabled" webkit_dom_html_link_element_get_disabled :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    IO CInt


dOMHTMLLinkElementGetDisabled ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLLinkElementGetDisabled _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_link_element_get_disabled _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLLinkElement::get_href
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_get_href" webkit_dom_html_link_element_get_href :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    IO CString


dOMHTMLLinkElementGetHref ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLLinkElementGetHref _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_link_element_get_href _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_link_element_get_href" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLLinkElement::get_hreflang
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_get_hreflang" webkit_dom_html_link_element_get_hreflang :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    IO CString


dOMHTMLLinkElementGetHreflang ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLLinkElementGetHreflang _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_link_element_get_hreflang _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_link_element_get_hreflang" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLLinkElement::get_media
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_get_media" webkit_dom_html_link_element_get_media :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    IO CString


dOMHTMLLinkElementGetMedia ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLLinkElementGetMedia _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_link_element_get_media _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_link_element_get_media" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLLinkElement::get_rel
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_get_rel" webkit_dom_html_link_element_get_rel :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    IO CString


dOMHTMLLinkElementGetRel ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLLinkElementGetRel _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_link_element_get_rel _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_link_element_get_rel" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLLinkElement::get_rev
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_get_rev" webkit_dom_html_link_element_get_rev :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    IO CString


dOMHTMLLinkElementGetRev ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLLinkElementGetRev _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_link_element_get_rev _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_link_element_get_rev" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLLinkElement::get_sheet
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMStyleSheet"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_get_sheet" webkit_dom_html_link_element_get_sheet :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    IO (Ptr DOMStyleSheet)


dOMHTMLLinkElementGetSheet ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    m DOMStyleSheet
dOMHTMLLinkElementGetSheet _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_link_element_get_sheet _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_link_element_get_sheet" result
    result' <- (wrapObject DOMStyleSheet) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLLinkElement::get_target
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_get_target" webkit_dom_html_link_element_get_target :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    IO CString


dOMHTMLLinkElementGetTarget ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLLinkElementGetTarget _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_link_element_get_target _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_link_element_get_target" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLLinkElement::set_charset
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_set_charset" webkit_dom_html_link_element_set_charset :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLLinkElementSetCharset ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLLinkElementSetCharset _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_link_element_set_charset _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLLinkElement::set_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_set_disabled" webkit_dom_html_link_element_set_disabled :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLLinkElementSetDisabled ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLLinkElementSetDisabled _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_link_element_set_disabled _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLLinkElement::set_href
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_set_href" webkit_dom_html_link_element_set_href :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLLinkElementSetHref ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLLinkElementSetHref _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_link_element_set_href _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLLinkElement::set_hreflang
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_set_hreflang" webkit_dom_html_link_element_set_hreflang :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLLinkElementSetHreflang ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLLinkElementSetHreflang _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_link_element_set_hreflang _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLLinkElement::set_media
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_set_media" webkit_dom_html_link_element_set_media :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLLinkElementSetMedia ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLLinkElementSetMedia _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_link_element_set_media _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLLinkElement::set_rel
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_set_rel" webkit_dom_html_link_element_set_rel :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLLinkElementSetRel ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLLinkElementSetRel _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_link_element_set_rel _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLLinkElement::set_rev
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_set_rev" webkit_dom_html_link_element_set_rev :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLLinkElementSetRev ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLLinkElementSetRev _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_link_element_set_rev _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLLinkElement::set_target
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLLinkElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_link_element_set_target" webkit_dom_html_link_element_set_target :: 
    Ptr DOMHTMLLinkElement ->               -- _obj : TInterface "WebKit" "DOMHTMLLinkElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLLinkElementSetTarget ::
    (MonadIO m, DOMHTMLLinkElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLLinkElementSetTarget _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_link_element_set_target _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


