
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLMarqueeElement
    ( 

-- * Exported types
    DOMHTMLMarqueeElement(..)               ,
    DOMHTMLMarqueeElementK                  ,
    toDOMHTMLMarqueeElement                 ,
    noDOMHTMLMarqueeElement                 ,


 -- * Methods
-- ** dOMHTMLMarqueeElementGetBehavior
    dOMHTMLMarqueeElementGetBehavior        ,


-- ** dOMHTMLMarqueeElementGetBgColor
    dOMHTMLMarqueeElementGetBgColor         ,


-- ** dOMHTMLMarqueeElementGetDirection
    dOMHTMLMarqueeElementGetDirection       ,


-- ** dOMHTMLMarqueeElementGetHeight
    dOMHTMLMarqueeElementGetHeight          ,


-- ** dOMHTMLMarqueeElementGetHspace
    dOMHTMLMarqueeElementGetHspace          ,


-- ** dOMHTMLMarqueeElementGetLoop
    dOMHTMLMarqueeElementGetLoop            ,


-- ** dOMHTMLMarqueeElementGetScrollAmount
    dOMHTMLMarqueeElementGetScrollAmount    ,


-- ** dOMHTMLMarqueeElementGetScrollDelay
    dOMHTMLMarqueeElementGetScrollDelay     ,


-- ** dOMHTMLMarqueeElementGetTrueSpeed
    dOMHTMLMarqueeElementGetTrueSpeed       ,


-- ** dOMHTMLMarqueeElementGetVspace
    dOMHTMLMarqueeElementGetVspace          ,


-- ** dOMHTMLMarqueeElementGetWidth
    dOMHTMLMarqueeElementGetWidth           ,


-- ** dOMHTMLMarqueeElementSetBehavior
    dOMHTMLMarqueeElementSetBehavior        ,


-- ** dOMHTMLMarqueeElementSetBgColor
    dOMHTMLMarqueeElementSetBgColor         ,


-- ** dOMHTMLMarqueeElementSetDirection
    dOMHTMLMarqueeElementSetDirection       ,


-- ** dOMHTMLMarqueeElementSetHeight
    dOMHTMLMarqueeElementSetHeight          ,


-- ** dOMHTMLMarqueeElementSetHspace
    dOMHTMLMarqueeElementSetHspace          ,


-- ** dOMHTMLMarqueeElementSetLoop
    dOMHTMLMarqueeElementSetLoop            ,


-- ** dOMHTMLMarqueeElementSetScrollAmount
    dOMHTMLMarqueeElementSetScrollAmount    ,


-- ** dOMHTMLMarqueeElementSetScrollDelay
    dOMHTMLMarqueeElementSetScrollDelay     ,


-- ** dOMHTMLMarqueeElementSetTrueSpeed
    dOMHTMLMarqueeElementSetTrueSpeed       ,


-- ** dOMHTMLMarqueeElementSetVspace
    dOMHTMLMarqueeElementSetVspace          ,


-- ** dOMHTMLMarqueeElementSetWidth
    dOMHTMLMarqueeElementSetWidth           ,


-- ** dOMHTMLMarqueeElementStart
    dOMHTMLMarqueeElementStart              ,


-- ** dOMHTMLMarqueeElementStop
    dOMHTMLMarqueeElementStop               ,




 -- * Properties
-- ** Behavior
    DOMHTMLMarqueeElementBehaviorPropertyInfo,
    constructDOMHTMLMarqueeElementBehavior  ,
    getDOMHTMLMarqueeElementBehavior        ,
    setDOMHTMLMarqueeElementBehavior        ,


-- ** BgColor
    DOMHTMLMarqueeElementBgColorPropertyInfo,
    constructDOMHTMLMarqueeElementBgColor   ,
    getDOMHTMLMarqueeElementBgColor         ,
    setDOMHTMLMarqueeElementBgColor         ,


-- ** Direction
    DOMHTMLMarqueeElementDirectionPropertyInfo,
    constructDOMHTMLMarqueeElementDirection ,
    getDOMHTMLMarqueeElementDirection       ,
    setDOMHTMLMarqueeElementDirection       ,


-- ** Height
    DOMHTMLMarqueeElementHeightPropertyInfo ,
    constructDOMHTMLMarqueeElementHeight    ,
    getDOMHTMLMarqueeElementHeight          ,
    setDOMHTMLMarqueeElementHeight          ,


-- ** Hspace
    DOMHTMLMarqueeElementHspacePropertyInfo ,
    constructDOMHTMLMarqueeElementHspace    ,
    getDOMHTMLMarqueeElementHspace          ,
    setDOMHTMLMarqueeElementHspace          ,


-- ** Loop
    DOMHTMLMarqueeElementLoopPropertyInfo   ,
    constructDOMHTMLMarqueeElementLoop      ,
    getDOMHTMLMarqueeElementLoop            ,
    setDOMHTMLMarqueeElementLoop            ,


-- ** ScrollAmount
    DOMHTMLMarqueeElementScrollAmountPropertyInfo,
    constructDOMHTMLMarqueeElementScrollAmount,
    getDOMHTMLMarqueeElementScrollAmount    ,
    setDOMHTMLMarqueeElementScrollAmount    ,


-- ** ScrollDelay
    DOMHTMLMarqueeElementScrollDelayPropertyInfo,
    constructDOMHTMLMarqueeElementScrollDelay,
    getDOMHTMLMarqueeElementScrollDelay     ,
    setDOMHTMLMarqueeElementScrollDelay     ,


-- ** TrueSpeed
    DOMHTMLMarqueeElementTrueSpeedPropertyInfo,
    constructDOMHTMLMarqueeElementTrueSpeed ,
    getDOMHTMLMarqueeElementTrueSpeed       ,
    setDOMHTMLMarqueeElementTrueSpeed       ,


-- ** Vspace
    DOMHTMLMarqueeElementVspacePropertyInfo ,
    constructDOMHTMLMarqueeElementVspace    ,
    getDOMHTMLMarqueeElementVspace          ,
    setDOMHTMLMarqueeElementVspace          ,


-- ** Width
    DOMHTMLMarqueeElementWidthPropertyInfo  ,
    constructDOMHTMLMarqueeElementWidth     ,
    getDOMHTMLMarqueeElementWidth           ,
    setDOMHTMLMarqueeElementWidth           ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLMarqueeElement = DOMHTMLMarqueeElement (ForeignPtr DOMHTMLMarqueeElement)
foreign import ccall "webkit_dom_html_marquee_element_get_type"
    c_webkit_dom_html_marquee_element_get_type :: IO GType

type instance ParentTypes DOMHTMLMarqueeElement = DOMHTMLMarqueeElementParentTypes
type DOMHTMLMarqueeElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLMarqueeElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_marquee_element_get_type
    

class GObject o => DOMHTMLMarqueeElementK o
instance (GObject o, IsDescendantOf DOMHTMLMarqueeElement o) => DOMHTMLMarqueeElementK o

toDOMHTMLMarqueeElement :: DOMHTMLMarqueeElementK o => o -> IO DOMHTMLMarqueeElement
toDOMHTMLMarqueeElement = unsafeCastTo DOMHTMLMarqueeElement

noDOMHTMLMarqueeElement :: Maybe DOMHTMLMarqueeElement
noDOMHTMLMarqueeElement = Nothing

-- VVV Prop "behavior"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementBehavior :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m T.Text
getDOMHTMLMarqueeElementBehavior obj = liftIO $ getObjectPropertyString obj "behavior"

setDOMHTMLMarqueeElementBehavior :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> T.Text -> m ()
setDOMHTMLMarqueeElementBehavior obj val = liftIO $ setObjectPropertyString obj "behavior" val

constructDOMHTMLMarqueeElementBehavior :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementBehavior val = constructObjectPropertyString "behavior" val

data DOMHTMLMarqueeElementBehaviorPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementBehaviorPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementBehaviorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementBehaviorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementBehaviorPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementBehaviorPropertyInfo = T.Text
    type AttrLabel DOMHTMLMarqueeElementBehaviorPropertyInfo = "DOMHTMLMarqueeElement::behavior"
    attrGet _ = getDOMHTMLMarqueeElementBehavior
    attrSet _ = setDOMHTMLMarqueeElementBehavior
    attrConstruct _ = constructDOMHTMLMarqueeElementBehavior

-- VVV Prop "bg-color"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementBgColor :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m T.Text
getDOMHTMLMarqueeElementBgColor obj = liftIO $ getObjectPropertyString obj "bg-color"

setDOMHTMLMarqueeElementBgColor :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> T.Text -> m ()
setDOMHTMLMarqueeElementBgColor obj val = liftIO $ setObjectPropertyString obj "bg-color" val

constructDOMHTMLMarqueeElementBgColor :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementBgColor val = constructObjectPropertyString "bg-color" val

data DOMHTMLMarqueeElementBgColorPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementBgColorPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementBgColorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementBgColorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementBgColorPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementBgColorPropertyInfo = T.Text
    type AttrLabel DOMHTMLMarqueeElementBgColorPropertyInfo = "DOMHTMLMarqueeElement::bg-color"
    attrGet _ = getDOMHTMLMarqueeElementBgColor
    attrSet _ = setDOMHTMLMarqueeElementBgColor
    attrConstruct _ = constructDOMHTMLMarqueeElementBgColor

-- VVV Prop "direction"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementDirection :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m T.Text
getDOMHTMLMarqueeElementDirection obj = liftIO $ getObjectPropertyString obj "direction"

setDOMHTMLMarqueeElementDirection :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> T.Text -> m ()
setDOMHTMLMarqueeElementDirection obj val = liftIO $ setObjectPropertyString obj "direction" val

constructDOMHTMLMarqueeElementDirection :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementDirection val = constructObjectPropertyString "direction" val

data DOMHTMLMarqueeElementDirectionPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementDirectionPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementDirectionPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementDirectionPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementDirectionPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementDirectionPropertyInfo = T.Text
    type AttrLabel DOMHTMLMarqueeElementDirectionPropertyInfo = "DOMHTMLMarqueeElement::direction"
    attrGet _ = getDOMHTMLMarqueeElementDirection
    attrSet _ = setDOMHTMLMarqueeElementDirection
    attrConstruct _ = constructDOMHTMLMarqueeElementDirection

-- VVV Prop "height"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementHeight :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m T.Text
getDOMHTMLMarqueeElementHeight obj = liftIO $ getObjectPropertyString obj "height"

setDOMHTMLMarqueeElementHeight :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> T.Text -> m ()
setDOMHTMLMarqueeElementHeight obj val = liftIO $ setObjectPropertyString obj "height" val

constructDOMHTMLMarqueeElementHeight :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementHeight val = constructObjectPropertyString "height" val

data DOMHTMLMarqueeElementHeightPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementHeightPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementHeightPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementHeightPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementHeightPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementHeightPropertyInfo = T.Text
    type AttrLabel DOMHTMLMarqueeElementHeightPropertyInfo = "DOMHTMLMarqueeElement::height"
    attrGet _ = getDOMHTMLMarqueeElementHeight
    attrSet _ = setDOMHTMLMarqueeElementHeight
    attrConstruct _ = constructDOMHTMLMarqueeElementHeight

-- VVV Prop "hspace"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementHspace :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m Word64
getDOMHTMLMarqueeElementHspace obj = liftIO $ getObjectPropertyUInt64 obj "hspace"

setDOMHTMLMarqueeElementHspace :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> Word64 -> m ()
setDOMHTMLMarqueeElementHspace obj val = liftIO $ setObjectPropertyUInt64 obj "hspace" val

constructDOMHTMLMarqueeElementHspace :: Word64 -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementHspace val = constructObjectPropertyUInt64 "hspace" val

data DOMHTMLMarqueeElementHspacePropertyInfo
instance AttrInfo DOMHTMLMarqueeElementHspacePropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementHspacePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementHspacePropertyInfo = (~) Word64
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementHspacePropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementHspacePropertyInfo = Word64
    type AttrLabel DOMHTMLMarqueeElementHspacePropertyInfo = "DOMHTMLMarqueeElement::hspace"
    attrGet _ = getDOMHTMLMarqueeElementHspace
    attrSet _ = setDOMHTMLMarqueeElementHspace
    attrConstruct _ = constructDOMHTMLMarqueeElementHspace

-- VVV Prop "loop"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementLoop :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m Int64
getDOMHTMLMarqueeElementLoop obj = liftIO $ getObjectPropertyInt64 obj "loop"

setDOMHTMLMarqueeElementLoop :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> Int64 -> m ()
setDOMHTMLMarqueeElementLoop obj val = liftIO $ setObjectPropertyInt64 obj "loop" val

constructDOMHTMLMarqueeElementLoop :: Int64 -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementLoop val = constructObjectPropertyInt64 "loop" val

data DOMHTMLMarqueeElementLoopPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementLoopPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementLoopPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementLoopPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementLoopPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementLoopPropertyInfo = Int64
    type AttrLabel DOMHTMLMarqueeElementLoopPropertyInfo = "DOMHTMLMarqueeElement::loop"
    attrGet _ = getDOMHTMLMarqueeElementLoop
    attrSet _ = setDOMHTMLMarqueeElementLoop
    attrConstruct _ = constructDOMHTMLMarqueeElementLoop

-- VVV Prop "scroll-amount"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementScrollAmount :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m Int64
getDOMHTMLMarqueeElementScrollAmount obj = liftIO $ getObjectPropertyInt64 obj "scroll-amount"

setDOMHTMLMarqueeElementScrollAmount :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> Int64 -> m ()
setDOMHTMLMarqueeElementScrollAmount obj val = liftIO $ setObjectPropertyInt64 obj "scroll-amount" val

constructDOMHTMLMarqueeElementScrollAmount :: Int64 -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementScrollAmount val = constructObjectPropertyInt64 "scroll-amount" val

data DOMHTMLMarqueeElementScrollAmountPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementScrollAmountPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementScrollAmountPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementScrollAmountPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementScrollAmountPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementScrollAmountPropertyInfo = Int64
    type AttrLabel DOMHTMLMarqueeElementScrollAmountPropertyInfo = "DOMHTMLMarqueeElement::scroll-amount"
    attrGet _ = getDOMHTMLMarqueeElementScrollAmount
    attrSet _ = setDOMHTMLMarqueeElementScrollAmount
    attrConstruct _ = constructDOMHTMLMarqueeElementScrollAmount

-- VVV Prop "scroll-delay"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementScrollDelay :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m Int64
getDOMHTMLMarqueeElementScrollDelay obj = liftIO $ getObjectPropertyInt64 obj "scroll-delay"

setDOMHTMLMarqueeElementScrollDelay :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> Int64 -> m ()
setDOMHTMLMarqueeElementScrollDelay obj val = liftIO $ setObjectPropertyInt64 obj "scroll-delay" val

constructDOMHTMLMarqueeElementScrollDelay :: Int64 -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementScrollDelay val = constructObjectPropertyInt64 "scroll-delay" val

data DOMHTMLMarqueeElementScrollDelayPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementScrollDelayPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementScrollDelayPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementScrollDelayPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementScrollDelayPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementScrollDelayPropertyInfo = Int64
    type AttrLabel DOMHTMLMarqueeElementScrollDelayPropertyInfo = "DOMHTMLMarqueeElement::scroll-delay"
    attrGet _ = getDOMHTMLMarqueeElementScrollDelay
    attrSet _ = setDOMHTMLMarqueeElementScrollDelay
    attrConstruct _ = constructDOMHTMLMarqueeElementScrollDelay

-- VVV Prop "true-speed"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementTrueSpeed :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m Bool
getDOMHTMLMarqueeElementTrueSpeed obj = liftIO $ getObjectPropertyBool obj "true-speed"

setDOMHTMLMarqueeElementTrueSpeed :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> Bool -> m ()
setDOMHTMLMarqueeElementTrueSpeed obj val = liftIO $ setObjectPropertyBool obj "true-speed" val

constructDOMHTMLMarqueeElementTrueSpeed :: Bool -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementTrueSpeed val = constructObjectPropertyBool "true-speed" val

data DOMHTMLMarqueeElementTrueSpeedPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementTrueSpeedPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementTrueSpeedPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementTrueSpeedPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementTrueSpeedPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementTrueSpeedPropertyInfo = Bool
    type AttrLabel DOMHTMLMarqueeElementTrueSpeedPropertyInfo = "DOMHTMLMarqueeElement::true-speed"
    attrGet _ = getDOMHTMLMarqueeElementTrueSpeed
    attrSet _ = setDOMHTMLMarqueeElementTrueSpeed
    attrConstruct _ = constructDOMHTMLMarqueeElementTrueSpeed

-- VVV Prop "vspace"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementVspace :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m Word64
getDOMHTMLMarqueeElementVspace obj = liftIO $ getObjectPropertyUInt64 obj "vspace"

setDOMHTMLMarqueeElementVspace :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> Word64 -> m ()
setDOMHTMLMarqueeElementVspace obj val = liftIO $ setObjectPropertyUInt64 obj "vspace" val

constructDOMHTMLMarqueeElementVspace :: Word64 -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementVspace val = constructObjectPropertyUInt64 "vspace" val

data DOMHTMLMarqueeElementVspacePropertyInfo
instance AttrInfo DOMHTMLMarqueeElementVspacePropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementVspacePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementVspacePropertyInfo = (~) Word64
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementVspacePropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementVspacePropertyInfo = Word64
    type AttrLabel DOMHTMLMarqueeElementVspacePropertyInfo = "DOMHTMLMarqueeElement::vspace"
    attrGet _ = getDOMHTMLMarqueeElementVspace
    attrSet _ = setDOMHTMLMarqueeElementVspace
    attrConstruct _ = constructDOMHTMLMarqueeElementVspace

-- VVV Prop "width"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementWidth :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m T.Text
getDOMHTMLMarqueeElementWidth obj = liftIO $ getObjectPropertyString obj "width"

setDOMHTMLMarqueeElementWidth :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> T.Text -> m ()
setDOMHTMLMarqueeElementWidth obj val = liftIO $ setObjectPropertyString obj "width" val

constructDOMHTMLMarqueeElementWidth :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementWidth val = constructObjectPropertyString "width" val

data DOMHTMLMarqueeElementWidthPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementWidthPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementWidthPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementWidthPropertyInfo = T.Text
    type AttrLabel DOMHTMLMarqueeElementWidthPropertyInfo = "DOMHTMLMarqueeElement::width"
    attrGet _ = getDOMHTMLMarqueeElementWidth
    attrSet _ = setDOMHTMLMarqueeElementWidth
    attrConstruct _ = constructDOMHTMLMarqueeElementWidth

type instance AttributeList DOMHTMLMarqueeElement = DOMHTMLMarqueeElementAttributeList
type DOMHTMLMarqueeElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("behavior", DOMHTMLMarqueeElementBehaviorPropertyInfo), '("bg-color", DOMHTMLMarqueeElementBgColorPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("direction", DOMHTMLMarqueeElementDirectionPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("height", DOMHTMLMarqueeElementHeightPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("hspace", DOMHTMLMarqueeElementHspacePropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("loop", DOMHTMLMarqueeElementLoopPropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-amount", DOMHTMLMarqueeElementScrollAmountPropertyInfo), '("scroll-delay", DOMHTMLMarqueeElementScrollDelayPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("true-speed", DOMHTMLMarqueeElementTrueSpeedPropertyInfo), '("vspace", DOMHTMLMarqueeElementVspacePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("width", DOMHTMLMarqueeElementWidthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLMarqueeElement = DOMHTMLMarqueeElementSignalList
type DOMHTMLMarqueeElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLMarqueeElement::get_behavior
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_get_behavior" webkit_dom_html_marquee_element_get_behavior :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO CString


dOMHTMLMarqueeElementGetBehavior ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLMarqueeElementGetBehavior _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_marquee_element_get_behavior _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_marquee_element_get_behavior" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLMarqueeElement::get_bg_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_get_bg_color" webkit_dom_html_marquee_element_get_bg_color :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO CString


dOMHTMLMarqueeElementGetBgColor ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLMarqueeElementGetBgColor _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_marquee_element_get_bg_color _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_marquee_element_get_bg_color" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLMarqueeElement::get_direction
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_get_direction" webkit_dom_html_marquee_element_get_direction :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO CString


dOMHTMLMarqueeElementGetDirection ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLMarqueeElementGetDirection _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_marquee_element_get_direction _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_marquee_element_get_direction" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLMarqueeElement::get_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_get_height" webkit_dom_html_marquee_element_get_height :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO CString


dOMHTMLMarqueeElementGetHeight ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLMarqueeElementGetHeight _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_marquee_element_get_height _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_marquee_element_get_height" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLMarqueeElement::get_hspace
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_get_hspace" webkit_dom_html_marquee_element_get_hspace :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO Word64


dOMHTMLMarqueeElementGetHspace ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m Word64
dOMHTMLMarqueeElementGetHspace _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_marquee_element_get_hspace _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLMarqueeElement::get_loop
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_get_loop" webkit_dom_html_marquee_element_get_loop :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO Int64


dOMHTMLMarqueeElementGetLoop ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLMarqueeElementGetLoop _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_marquee_element_get_loop _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLMarqueeElement::get_scroll_amount
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_get_scroll_amount" webkit_dom_html_marquee_element_get_scroll_amount :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO Int64


dOMHTMLMarqueeElementGetScrollAmount ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLMarqueeElementGetScrollAmount _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_marquee_element_get_scroll_amount _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLMarqueeElement::get_scroll_delay
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_get_scroll_delay" webkit_dom_html_marquee_element_get_scroll_delay :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO Int64


dOMHTMLMarqueeElementGetScrollDelay ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLMarqueeElementGetScrollDelay _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_marquee_element_get_scroll_delay _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLMarqueeElement::get_true_speed
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_get_true_speed" webkit_dom_html_marquee_element_get_true_speed :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO CInt


dOMHTMLMarqueeElementGetTrueSpeed ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLMarqueeElementGetTrueSpeed _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_marquee_element_get_true_speed _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLMarqueeElement::get_vspace
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_get_vspace" webkit_dom_html_marquee_element_get_vspace :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO Word64


dOMHTMLMarqueeElementGetVspace ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m Word64
dOMHTMLMarqueeElementGetVspace _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_marquee_element_get_vspace _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLMarqueeElement::get_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_get_width" webkit_dom_html_marquee_element_get_width :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO CString


dOMHTMLMarqueeElementGetWidth ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLMarqueeElementGetWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_marquee_element_get_width _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_marquee_element_get_width" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLMarqueeElement::set_behavior
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_set_behavior" webkit_dom_html_marquee_element_set_behavior :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLMarqueeElementSetBehavior ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLMarqueeElementSetBehavior _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_marquee_element_set_behavior _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLMarqueeElement::set_bg_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_set_bg_color" webkit_dom_html_marquee_element_set_bg_color :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLMarqueeElementSetBgColor ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLMarqueeElementSetBgColor _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_marquee_element_set_bg_color _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLMarqueeElement::set_direction
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_set_direction" webkit_dom_html_marquee_element_set_direction :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLMarqueeElementSetDirection ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLMarqueeElementSetDirection _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_marquee_element_set_direction _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLMarqueeElement::set_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_set_height" webkit_dom_html_marquee_element_set_height :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLMarqueeElementSetHeight ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLMarqueeElementSetHeight _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_marquee_element_set_height _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLMarqueeElement::set_hspace
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_set_hspace" webkit_dom_html_marquee_element_set_hspace :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    Word64 ->                               -- value : TBasicType TUInt64
    IO ()


dOMHTMLMarqueeElementSetHspace ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    Word64 ->                               -- value
    m ()
dOMHTMLMarqueeElementSetHspace _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_marquee_element_set_hspace _obj' value
    touchManagedPtr _obj
    return ()

-- method DOMHTMLMarqueeElement::set_loop
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_set_loop" webkit_dom_html_marquee_element_set_loop :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    Int64 ->                                -- value : TBasicType TInt64
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLMarqueeElementSetLoop ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLMarqueeElementSetLoop _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        propagateGError $ webkit_dom_html_marquee_element_set_loop _obj' value
        touchManagedPtr _obj
        return ()
     ) (do
        return ()
     )

-- method DOMHTMLMarqueeElement::set_scroll_amount
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_set_scroll_amount" webkit_dom_html_marquee_element_set_scroll_amount :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    Int64 ->                                -- value : TBasicType TInt64
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLMarqueeElementSetScrollAmount ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLMarqueeElementSetScrollAmount _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        propagateGError $ webkit_dom_html_marquee_element_set_scroll_amount _obj' value
        touchManagedPtr _obj
        return ()
     ) (do
        return ()
     )

-- method DOMHTMLMarqueeElement::set_scroll_delay
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_set_scroll_delay" webkit_dom_html_marquee_element_set_scroll_delay :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    Int64 ->                                -- value : TBasicType TInt64
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLMarqueeElementSetScrollDelay ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLMarqueeElementSetScrollDelay _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        propagateGError $ webkit_dom_html_marquee_element_set_scroll_delay _obj' value
        touchManagedPtr _obj
        return ()
     ) (do
        return ()
     )

-- method DOMHTMLMarqueeElement::set_true_speed
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_set_true_speed" webkit_dom_html_marquee_element_set_true_speed :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLMarqueeElementSetTrueSpeed ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLMarqueeElementSetTrueSpeed _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_marquee_element_set_true_speed _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLMarqueeElement::set_vspace
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_set_vspace" webkit_dom_html_marquee_element_set_vspace :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    Word64 ->                               -- value : TBasicType TUInt64
    IO ()


dOMHTMLMarqueeElementSetVspace ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    Word64 ->                               -- value
    m ()
dOMHTMLMarqueeElementSetVspace _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_marquee_element_set_vspace _obj' value
    touchManagedPtr _obj
    return ()

-- method DOMHTMLMarqueeElement::set_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_set_width" webkit_dom_html_marquee_element_set_width :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLMarqueeElementSetWidth ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLMarqueeElementSetWidth _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_marquee_element_set_width _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLMarqueeElement::start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_start" webkit_dom_html_marquee_element_start :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO ()


dOMHTMLMarqueeElementStart ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLMarqueeElementStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_marquee_element_start _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLMarqueeElement::stop
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_stop" webkit_dom_html_marquee_element_stop :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit" "DOMHTMLMarqueeElement"
    IO ()


dOMHTMLMarqueeElementStop ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLMarqueeElementStop _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_marquee_element_stop _obj'
    touchManagedPtr _obj
    return ()


