
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLMetaElement
    ( 

-- * Exported types
    DOMHTMLMetaElement(..)                  ,
    DOMHTMLMetaElementK                     ,
    toDOMHTMLMetaElement                    ,
    noDOMHTMLMetaElement                    ,


 -- * Methods
-- ** dOMHTMLMetaElementGetContent
    dOMHTMLMetaElementGetContent            ,


-- ** dOMHTMLMetaElementGetHttpEquiv
    dOMHTMLMetaElementGetHttpEquiv          ,


-- ** dOMHTMLMetaElementGetName
    dOMHTMLMetaElementGetName               ,


-- ** dOMHTMLMetaElementGetScheme
    dOMHTMLMetaElementGetScheme             ,


-- ** dOMHTMLMetaElementSetContent
    dOMHTMLMetaElementSetContent            ,


-- ** dOMHTMLMetaElementSetHttpEquiv
    dOMHTMLMetaElementSetHttpEquiv          ,


-- ** dOMHTMLMetaElementSetName
    dOMHTMLMetaElementSetName               ,


-- ** dOMHTMLMetaElementSetScheme
    dOMHTMLMetaElementSetScheme             ,




 -- * Properties
-- ** Content
    DOMHTMLMetaElementContentPropertyInfo   ,
    constructDOMHTMLMetaElementContent      ,
    getDOMHTMLMetaElementContent            ,
    setDOMHTMLMetaElementContent            ,


-- ** HttpEquiv
    DOMHTMLMetaElementHttpEquivPropertyInfo ,
    constructDOMHTMLMetaElementHttpEquiv    ,
    getDOMHTMLMetaElementHttpEquiv          ,
    setDOMHTMLMetaElementHttpEquiv          ,


-- ** Name
    DOMHTMLMetaElementNamePropertyInfo      ,
    constructDOMHTMLMetaElementName         ,
    getDOMHTMLMetaElementName               ,
    setDOMHTMLMetaElementName               ,


-- ** Scheme
    DOMHTMLMetaElementSchemePropertyInfo    ,
    constructDOMHTMLMetaElementScheme       ,
    getDOMHTMLMetaElementScheme             ,
    setDOMHTMLMetaElementScheme             ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLMetaElement = DOMHTMLMetaElement (ForeignPtr DOMHTMLMetaElement)
foreign import ccall "webkit_dom_html_meta_element_get_type"
    c_webkit_dom_html_meta_element_get_type :: IO GType

type instance ParentTypes DOMHTMLMetaElement = DOMHTMLMetaElementParentTypes
type DOMHTMLMetaElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLMetaElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_meta_element_get_type
    

class GObject o => DOMHTMLMetaElementK o
instance (GObject o, IsDescendantOf DOMHTMLMetaElement o) => DOMHTMLMetaElementK o

toDOMHTMLMetaElement :: DOMHTMLMetaElementK o => o -> IO DOMHTMLMetaElement
toDOMHTMLMetaElement = unsafeCastTo DOMHTMLMetaElement

noDOMHTMLMetaElement :: Maybe DOMHTMLMetaElement
noDOMHTMLMetaElement = Nothing

-- VVV Prop "content"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMetaElementContent :: (MonadIO m, DOMHTMLMetaElementK o) => o -> m T.Text
getDOMHTMLMetaElementContent obj = liftIO $ getObjectPropertyString obj "content"

setDOMHTMLMetaElementContent :: (MonadIO m, DOMHTMLMetaElementK o) => o -> T.Text -> m ()
setDOMHTMLMetaElementContent obj val = liftIO $ setObjectPropertyString obj "content" val

constructDOMHTMLMetaElementContent :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMetaElementContent val = constructObjectPropertyString "content" val

data DOMHTMLMetaElementContentPropertyInfo
instance AttrInfo DOMHTMLMetaElementContentPropertyInfo where
    type AttrAllowedOps DOMHTMLMetaElementContentPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMetaElementContentPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMetaElementContentPropertyInfo = DOMHTMLMetaElementK
    type AttrGetType DOMHTMLMetaElementContentPropertyInfo = T.Text
    type AttrLabel DOMHTMLMetaElementContentPropertyInfo = "DOMHTMLMetaElement::content"
    attrGet _ = getDOMHTMLMetaElementContent
    attrSet _ = setDOMHTMLMetaElementContent
    attrConstruct _ = constructDOMHTMLMetaElementContent

-- VVV Prop "http-equiv"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMetaElementHttpEquiv :: (MonadIO m, DOMHTMLMetaElementK o) => o -> m T.Text
getDOMHTMLMetaElementHttpEquiv obj = liftIO $ getObjectPropertyString obj "http-equiv"

setDOMHTMLMetaElementHttpEquiv :: (MonadIO m, DOMHTMLMetaElementK o) => o -> T.Text -> m ()
setDOMHTMLMetaElementHttpEquiv obj val = liftIO $ setObjectPropertyString obj "http-equiv" val

constructDOMHTMLMetaElementHttpEquiv :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMetaElementHttpEquiv val = constructObjectPropertyString "http-equiv" val

data DOMHTMLMetaElementHttpEquivPropertyInfo
instance AttrInfo DOMHTMLMetaElementHttpEquivPropertyInfo where
    type AttrAllowedOps DOMHTMLMetaElementHttpEquivPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMetaElementHttpEquivPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMetaElementHttpEquivPropertyInfo = DOMHTMLMetaElementK
    type AttrGetType DOMHTMLMetaElementHttpEquivPropertyInfo = T.Text
    type AttrLabel DOMHTMLMetaElementHttpEquivPropertyInfo = "DOMHTMLMetaElement::http-equiv"
    attrGet _ = getDOMHTMLMetaElementHttpEquiv
    attrSet _ = setDOMHTMLMetaElementHttpEquiv
    attrConstruct _ = constructDOMHTMLMetaElementHttpEquiv

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMetaElementName :: (MonadIO m, DOMHTMLMetaElementK o) => o -> m T.Text
getDOMHTMLMetaElementName obj = liftIO $ getObjectPropertyString obj "name"

setDOMHTMLMetaElementName :: (MonadIO m, DOMHTMLMetaElementK o) => o -> T.Text -> m ()
setDOMHTMLMetaElementName obj val = liftIO $ setObjectPropertyString obj "name" val

constructDOMHTMLMetaElementName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMetaElementName val = constructObjectPropertyString "name" val

data DOMHTMLMetaElementNamePropertyInfo
instance AttrInfo DOMHTMLMetaElementNamePropertyInfo where
    type AttrAllowedOps DOMHTMLMetaElementNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMetaElementNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMetaElementNamePropertyInfo = DOMHTMLMetaElementK
    type AttrGetType DOMHTMLMetaElementNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLMetaElementNamePropertyInfo = "DOMHTMLMetaElement::name"
    attrGet _ = getDOMHTMLMetaElementName
    attrSet _ = setDOMHTMLMetaElementName
    attrConstruct _ = constructDOMHTMLMetaElementName

-- VVV Prop "scheme"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMetaElementScheme :: (MonadIO m, DOMHTMLMetaElementK o) => o -> m T.Text
getDOMHTMLMetaElementScheme obj = liftIO $ getObjectPropertyString obj "scheme"

setDOMHTMLMetaElementScheme :: (MonadIO m, DOMHTMLMetaElementK o) => o -> T.Text -> m ()
setDOMHTMLMetaElementScheme obj val = liftIO $ setObjectPropertyString obj "scheme" val

constructDOMHTMLMetaElementScheme :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMetaElementScheme val = constructObjectPropertyString "scheme" val

data DOMHTMLMetaElementSchemePropertyInfo
instance AttrInfo DOMHTMLMetaElementSchemePropertyInfo where
    type AttrAllowedOps DOMHTMLMetaElementSchemePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMetaElementSchemePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMetaElementSchemePropertyInfo = DOMHTMLMetaElementK
    type AttrGetType DOMHTMLMetaElementSchemePropertyInfo = T.Text
    type AttrLabel DOMHTMLMetaElementSchemePropertyInfo = "DOMHTMLMetaElement::scheme"
    attrGet _ = getDOMHTMLMetaElementScheme
    attrSet _ = setDOMHTMLMetaElementScheme
    attrConstruct _ = constructDOMHTMLMetaElementScheme

type instance AttributeList DOMHTMLMetaElement = DOMHTMLMetaElementAttributeList
type DOMHTMLMetaElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content", DOMHTMLMetaElementContentPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("http-equiv", DOMHTMLMetaElementHttpEquivPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("name", DOMHTMLMetaElementNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scheme", DOMHTMLMetaElementSchemePropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLMetaElement = DOMHTMLMetaElementSignalList
type DOMHTMLMetaElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLMetaElement::get_content
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_meta_element_get_content" webkit_dom_html_meta_element_get_content :: 
    Ptr DOMHTMLMetaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLMetaElement"
    IO CString


dOMHTMLMetaElementGetContent ::
    (MonadIO m, DOMHTMLMetaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLMetaElementGetContent _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_meta_element_get_content _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_meta_element_get_content" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLMetaElement::get_http_equiv
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_meta_element_get_http_equiv" webkit_dom_html_meta_element_get_http_equiv :: 
    Ptr DOMHTMLMetaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLMetaElement"
    IO CString


dOMHTMLMetaElementGetHttpEquiv ::
    (MonadIO m, DOMHTMLMetaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLMetaElementGetHttpEquiv _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_meta_element_get_http_equiv _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_meta_element_get_http_equiv" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLMetaElement::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_meta_element_get_name" webkit_dom_html_meta_element_get_name :: 
    Ptr DOMHTMLMetaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLMetaElement"
    IO CString


dOMHTMLMetaElementGetName ::
    (MonadIO m, DOMHTMLMetaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLMetaElementGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_meta_element_get_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_meta_element_get_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLMetaElement::get_scheme
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_meta_element_get_scheme" webkit_dom_html_meta_element_get_scheme :: 
    Ptr DOMHTMLMetaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLMetaElement"
    IO CString


dOMHTMLMetaElementGetScheme ::
    (MonadIO m, DOMHTMLMetaElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLMetaElementGetScheme _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_meta_element_get_scheme _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_meta_element_get_scheme" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLMetaElement::set_content
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_meta_element_set_content" webkit_dom_html_meta_element_set_content :: 
    Ptr DOMHTMLMetaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLMetaElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLMetaElementSetContent ::
    (MonadIO m, DOMHTMLMetaElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLMetaElementSetContent _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_meta_element_set_content _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLMetaElement::set_http_equiv
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_meta_element_set_http_equiv" webkit_dom_html_meta_element_set_http_equiv :: 
    Ptr DOMHTMLMetaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLMetaElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLMetaElementSetHttpEquiv ::
    (MonadIO m, DOMHTMLMetaElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLMetaElementSetHttpEquiv _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_meta_element_set_http_equiv _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLMetaElement::set_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_meta_element_set_name" webkit_dom_html_meta_element_set_name :: 
    Ptr DOMHTMLMetaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLMetaElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLMetaElementSetName ::
    (MonadIO m, DOMHTMLMetaElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLMetaElementSetName _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_meta_element_set_name _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLMetaElement::set_scheme
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLMetaElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_meta_element_set_scheme" webkit_dom_html_meta_element_set_scheme :: 
    Ptr DOMHTMLMetaElement ->               -- _obj : TInterface "WebKit" "DOMHTMLMetaElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLMetaElementSetScheme ::
    (MonadIO m, DOMHTMLMetaElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLMetaElementSetScheme _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_meta_element_set_scheme _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


