
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLModElement
    ( 

-- * Exported types
    DOMHTMLModElement(..)                   ,
    DOMHTMLModElementK                      ,
    toDOMHTMLModElement                     ,
    noDOMHTMLModElement                     ,


 -- * Methods
-- ** dOMHTMLModElementGetCite
    dOMHTMLModElementGetCite                ,


-- ** dOMHTMLModElementGetDateTime
    dOMHTMLModElementGetDateTime            ,


-- ** dOMHTMLModElementSetCite
    dOMHTMLModElementSetCite                ,


-- ** dOMHTMLModElementSetDateTime
    dOMHTMLModElementSetDateTime            ,




 -- * Properties
-- ** Cite
    DOMHTMLModElementCitePropertyInfo       ,
    constructDOMHTMLModElementCite          ,
    getDOMHTMLModElementCite                ,
    setDOMHTMLModElementCite                ,


-- ** DateTime
    DOMHTMLModElementDateTimePropertyInfo   ,
    constructDOMHTMLModElementDateTime      ,
    getDOMHTMLModElementDateTime            ,
    setDOMHTMLModElementDateTime            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLModElement = DOMHTMLModElement (ForeignPtr DOMHTMLModElement)
foreign import ccall "webkit_dom_html_mod_element_get_type"
    c_webkit_dom_html_mod_element_get_type :: IO GType

type instance ParentTypes DOMHTMLModElement = DOMHTMLModElementParentTypes
type DOMHTMLModElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLModElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_mod_element_get_type
    

class GObject o => DOMHTMLModElementK o
instance (GObject o, IsDescendantOf DOMHTMLModElement o) => DOMHTMLModElementK o

toDOMHTMLModElement :: DOMHTMLModElementK o => o -> IO DOMHTMLModElement
toDOMHTMLModElement = unsafeCastTo DOMHTMLModElement

noDOMHTMLModElement :: Maybe DOMHTMLModElement
noDOMHTMLModElement = Nothing

-- VVV Prop "cite"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLModElementCite :: (MonadIO m, DOMHTMLModElementK o) => o -> m T.Text
getDOMHTMLModElementCite obj = liftIO $ getObjectPropertyString obj "cite"

setDOMHTMLModElementCite :: (MonadIO m, DOMHTMLModElementK o) => o -> T.Text -> m ()
setDOMHTMLModElementCite obj val = liftIO $ setObjectPropertyString obj "cite" val

constructDOMHTMLModElementCite :: T.Text -> IO ([Char], GValue)
constructDOMHTMLModElementCite val = constructObjectPropertyString "cite" val

data DOMHTMLModElementCitePropertyInfo
instance AttrInfo DOMHTMLModElementCitePropertyInfo where
    type AttrAllowedOps DOMHTMLModElementCitePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLModElementCitePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLModElementCitePropertyInfo = DOMHTMLModElementK
    type AttrGetType DOMHTMLModElementCitePropertyInfo = T.Text
    type AttrLabel DOMHTMLModElementCitePropertyInfo = "DOMHTMLModElement::cite"
    attrGet _ = getDOMHTMLModElementCite
    attrSet _ = setDOMHTMLModElementCite
    attrConstruct _ = constructDOMHTMLModElementCite

-- VVV Prop "date-time"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLModElementDateTime :: (MonadIO m, DOMHTMLModElementK o) => o -> m T.Text
getDOMHTMLModElementDateTime obj = liftIO $ getObjectPropertyString obj "date-time"

setDOMHTMLModElementDateTime :: (MonadIO m, DOMHTMLModElementK o) => o -> T.Text -> m ()
setDOMHTMLModElementDateTime obj val = liftIO $ setObjectPropertyString obj "date-time" val

constructDOMHTMLModElementDateTime :: T.Text -> IO ([Char], GValue)
constructDOMHTMLModElementDateTime val = constructObjectPropertyString "date-time" val

data DOMHTMLModElementDateTimePropertyInfo
instance AttrInfo DOMHTMLModElementDateTimePropertyInfo where
    type AttrAllowedOps DOMHTMLModElementDateTimePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLModElementDateTimePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLModElementDateTimePropertyInfo = DOMHTMLModElementK
    type AttrGetType DOMHTMLModElementDateTimePropertyInfo = T.Text
    type AttrLabel DOMHTMLModElementDateTimePropertyInfo = "DOMHTMLModElement::date-time"
    attrGet _ = getDOMHTMLModElementDateTime
    attrSet _ = setDOMHTMLModElementDateTime
    attrConstruct _ = constructDOMHTMLModElementDateTime

type instance AttributeList DOMHTMLModElement = DOMHTMLModElementAttributeList
type DOMHTMLModElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("cite", DOMHTMLModElementCitePropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("date-time", DOMHTMLModElementDateTimePropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLModElement = DOMHTMLModElementSignalList
type DOMHTMLModElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLModElement::get_cite
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLModElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLModElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_mod_element_get_cite" webkit_dom_html_mod_element_get_cite :: 
    Ptr DOMHTMLModElement ->                -- _obj : TInterface "WebKit" "DOMHTMLModElement"
    IO CString


dOMHTMLModElementGetCite ::
    (MonadIO m, DOMHTMLModElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLModElementGetCite _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_mod_element_get_cite _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_mod_element_get_cite" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLModElement::get_date_time
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLModElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLModElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_mod_element_get_date_time" webkit_dom_html_mod_element_get_date_time :: 
    Ptr DOMHTMLModElement ->                -- _obj : TInterface "WebKit" "DOMHTMLModElement"
    IO CString


dOMHTMLModElementGetDateTime ::
    (MonadIO m, DOMHTMLModElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLModElementGetDateTime _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_mod_element_get_date_time _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_mod_element_get_date_time" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLModElement::set_cite
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLModElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLModElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_mod_element_set_cite" webkit_dom_html_mod_element_set_cite :: 
    Ptr DOMHTMLModElement ->                -- _obj : TInterface "WebKit" "DOMHTMLModElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLModElementSetCite ::
    (MonadIO m, DOMHTMLModElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLModElementSetCite _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_mod_element_set_cite _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLModElement::set_date_time
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLModElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLModElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_mod_element_set_date_time" webkit_dom_html_mod_element_set_date_time :: 
    Ptr DOMHTMLModElement ->                -- _obj : TInterface "WebKit" "DOMHTMLModElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLModElementSetDateTime ::
    (MonadIO m, DOMHTMLModElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLModElementSetDateTime _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_mod_element_set_date_time _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


