
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLObjectElement
    ( 

-- * Exported types
    DOMHTMLObjectElement(..)                ,
    DOMHTMLObjectElementK                   ,
    toDOMHTMLObjectElement                  ,
    noDOMHTMLObjectElement                  ,


 -- * Methods
-- ** dOMHTMLObjectElementCheckValidity
    dOMHTMLObjectElementCheckValidity       ,


-- ** dOMHTMLObjectElementGetAlign
    dOMHTMLObjectElementGetAlign            ,


-- ** dOMHTMLObjectElementGetArchive
    dOMHTMLObjectElementGetArchive          ,


-- ** dOMHTMLObjectElementGetBorder
    dOMHTMLObjectElementGetBorder           ,


-- ** dOMHTMLObjectElementGetCode
    dOMHTMLObjectElementGetCode             ,


-- ** dOMHTMLObjectElementGetCodeBase
    dOMHTMLObjectElementGetCodeBase         ,


-- ** dOMHTMLObjectElementGetCodeType
    dOMHTMLObjectElementGetCodeType         ,


-- ** dOMHTMLObjectElementGetContentDocument
    dOMHTMLObjectElementGetContentDocument  ,


-- ** dOMHTMLObjectElementGetData
    dOMHTMLObjectElementGetData             ,


-- ** dOMHTMLObjectElementGetDeclare
    dOMHTMLObjectElementGetDeclare          ,


-- ** dOMHTMLObjectElementGetForm
    dOMHTMLObjectElementGetForm             ,


-- ** dOMHTMLObjectElementGetHeight
    dOMHTMLObjectElementGetHeight           ,


-- ** dOMHTMLObjectElementGetHspace
    dOMHTMLObjectElementGetHspace           ,


-- ** dOMHTMLObjectElementGetName
    dOMHTMLObjectElementGetName             ,


-- ** dOMHTMLObjectElementGetStandby
    dOMHTMLObjectElementGetStandby          ,


-- ** dOMHTMLObjectElementGetUseMap
    dOMHTMLObjectElementGetUseMap           ,


-- ** dOMHTMLObjectElementGetValidationMessage
    dOMHTMLObjectElementGetValidationMessage,


-- ** dOMHTMLObjectElementGetValidity
    dOMHTMLObjectElementGetValidity         ,


-- ** dOMHTMLObjectElementGetVspace
    dOMHTMLObjectElementGetVspace           ,


-- ** dOMHTMLObjectElementGetWidth
    dOMHTMLObjectElementGetWidth            ,


-- ** dOMHTMLObjectElementGetWillValidate
    dOMHTMLObjectElementGetWillValidate     ,


-- ** dOMHTMLObjectElementSetAlign
    dOMHTMLObjectElementSetAlign            ,


-- ** dOMHTMLObjectElementSetArchive
    dOMHTMLObjectElementSetArchive          ,


-- ** dOMHTMLObjectElementSetBorder
    dOMHTMLObjectElementSetBorder           ,


-- ** dOMHTMLObjectElementSetCode
    dOMHTMLObjectElementSetCode             ,


-- ** dOMHTMLObjectElementSetCodeBase
    dOMHTMLObjectElementSetCodeBase         ,


-- ** dOMHTMLObjectElementSetCodeType
    dOMHTMLObjectElementSetCodeType         ,


-- ** dOMHTMLObjectElementSetCustomValidity
    dOMHTMLObjectElementSetCustomValidity   ,


-- ** dOMHTMLObjectElementSetData
    dOMHTMLObjectElementSetData             ,


-- ** dOMHTMLObjectElementSetDeclare
    dOMHTMLObjectElementSetDeclare          ,


-- ** dOMHTMLObjectElementSetHeight
    dOMHTMLObjectElementSetHeight           ,


-- ** dOMHTMLObjectElementSetHspace
    dOMHTMLObjectElementSetHspace           ,


-- ** dOMHTMLObjectElementSetName
    dOMHTMLObjectElementSetName             ,


-- ** dOMHTMLObjectElementSetStandby
    dOMHTMLObjectElementSetStandby          ,


-- ** dOMHTMLObjectElementSetUseMap
    dOMHTMLObjectElementSetUseMap           ,


-- ** dOMHTMLObjectElementSetVspace
    dOMHTMLObjectElementSetVspace           ,


-- ** dOMHTMLObjectElementSetWidth
    dOMHTMLObjectElementSetWidth            ,




 -- * Properties
-- ** Align
    DOMHTMLObjectElementAlignPropertyInfo   ,
    constructDOMHTMLObjectElementAlign      ,
    getDOMHTMLObjectElementAlign            ,
    setDOMHTMLObjectElementAlign            ,


-- ** Archive
    DOMHTMLObjectElementArchivePropertyInfo ,
    constructDOMHTMLObjectElementArchive    ,
    getDOMHTMLObjectElementArchive          ,
    setDOMHTMLObjectElementArchive          ,


-- ** Border
    DOMHTMLObjectElementBorderPropertyInfo  ,
    constructDOMHTMLObjectElementBorder     ,
    getDOMHTMLObjectElementBorder           ,
    setDOMHTMLObjectElementBorder           ,


-- ** Code
    DOMHTMLObjectElementCodePropertyInfo    ,
    constructDOMHTMLObjectElementCode       ,
    getDOMHTMLObjectElementCode             ,
    setDOMHTMLObjectElementCode             ,


-- ** CodeBase
    DOMHTMLObjectElementCodeBasePropertyInfo,
    constructDOMHTMLObjectElementCodeBase   ,
    getDOMHTMLObjectElementCodeBase         ,
    setDOMHTMLObjectElementCodeBase         ,


-- ** CodeType
    DOMHTMLObjectElementCodeTypePropertyInfo,
    constructDOMHTMLObjectElementCodeType   ,
    getDOMHTMLObjectElementCodeType         ,
    setDOMHTMLObjectElementCodeType         ,


-- ** ContentDocument
    DOMHTMLObjectElementContentDocumentPropertyInfo,
    getDOMHTMLObjectElementContentDocument  ,


-- ** Data
    DOMHTMLObjectElementDataPropertyInfo    ,
    constructDOMHTMLObjectElementData       ,
    getDOMHTMLObjectElementData             ,
    setDOMHTMLObjectElementData             ,


-- ** Declare
    DOMHTMLObjectElementDeclarePropertyInfo ,
    constructDOMHTMLObjectElementDeclare    ,
    getDOMHTMLObjectElementDeclare          ,
    setDOMHTMLObjectElementDeclare          ,


-- ** Form
    DOMHTMLObjectElementFormPropertyInfo    ,
    getDOMHTMLObjectElementForm             ,


-- ** Height
    DOMHTMLObjectElementHeightPropertyInfo  ,
    constructDOMHTMLObjectElementHeight     ,
    getDOMHTMLObjectElementHeight           ,
    setDOMHTMLObjectElementHeight           ,


-- ** Hspace
    DOMHTMLObjectElementHspacePropertyInfo  ,
    constructDOMHTMLObjectElementHspace     ,
    getDOMHTMLObjectElementHspace           ,
    setDOMHTMLObjectElementHspace           ,


-- ** Name
    DOMHTMLObjectElementNamePropertyInfo    ,
    constructDOMHTMLObjectElementName       ,
    getDOMHTMLObjectElementName             ,
    setDOMHTMLObjectElementName             ,


-- ** Standby
    DOMHTMLObjectElementStandbyPropertyInfo ,
    constructDOMHTMLObjectElementStandby    ,
    getDOMHTMLObjectElementStandby          ,
    setDOMHTMLObjectElementStandby          ,


-- ** Type
    DOMHTMLObjectElementTypePropertyInfo    ,
    constructDOMHTMLObjectElementType       ,
    getDOMHTMLObjectElementType             ,
    setDOMHTMLObjectElementType             ,


-- ** UseMap
    DOMHTMLObjectElementUseMapPropertyInfo  ,
    constructDOMHTMLObjectElementUseMap     ,
    getDOMHTMLObjectElementUseMap           ,
    setDOMHTMLObjectElementUseMap           ,


-- ** ValidationMessage
    DOMHTMLObjectElementValidationMessagePropertyInfo,
    getDOMHTMLObjectElementValidationMessage,


-- ** Validity
    DOMHTMLObjectElementValidityPropertyInfo,
    getDOMHTMLObjectElementValidity         ,


-- ** Vspace
    DOMHTMLObjectElementVspacePropertyInfo  ,
    constructDOMHTMLObjectElementVspace     ,
    getDOMHTMLObjectElementVspace           ,
    setDOMHTMLObjectElementVspace           ,


-- ** Width
    DOMHTMLObjectElementWidthPropertyInfo   ,
    constructDOMHTMLObjectElementWidth      ,
    getDOMHTMLObjectElementWidth            ,
    setDOMHTMLObjectElementWidth            ,


-- ** WillValidate
    DOMHTMLObjectElementWillValidatePropertyInfo,
    getDOMHTMLObjectElementWillValidate     ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLObjectElement = DOMHTMLObjectElement (ForeignPtr DOMHTMLObjectElement)
foreign import ccall "webkit_dom_html_object_element_get_type"
    c_webkit_dom_html_object_element_get_type :: IO GType

type instance ParentTypes DOMHTMLObjectElement = DOMHTMLObjectElementParentTypes
type DOMHTMLObjectElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLObjectElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_object_element_get_type
    

class GObject o => DOMHTMLObjectElementK o
instance (GObject o, IsDescendantOf DOMHTMLObjectElement o) => DOMHTMLObjectElementK o

toDOMHTMLObjectElement :: DOMHTMLObjectElementK o => o -> IO DOMHTMLObjectElement
toDOMHTMLObjectElement = unsafeCastTo DOMHTMLObjectElement

noDOMHTMLObjectElement :: Maybe DOMHTMLObjectElement
noDOMHTMLObjectElement = Nothing

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementAlign :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLObjectElementAlign :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLObjectElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLObjectElementAlignPropertyInfo
instance AttrInfo DOMHTMLObjectElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementAlignPropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementAlignPropertyInfo = "DOMHTMLObjectElement::align"
    attrGet _ = getDOMHTMLObjectElementAlign
    attrSet _ = setDOMHTMLObjectElementAlign
    attrConstruct _ = constructDOMHTMLObjectElementAlign

-- VVV Prop "archive"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementArchive :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementArchive obj = liftIO $ getObjectPropertyString obj "archive"

setDOMHTMLObjectElementArchive :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementArchive obj val = liftIO $ setObjectPropertyString obj "archive" val

constructDOMHTMLObjectElementArchive :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementArchive val = constructObjectPropertyString "archive" val

data DOMHTMLObjectElementArchivePropertyInfo
instance AttrInfo DOMHTMLObjectElementArchivePropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementArchivePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementArchivePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementArchivePropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementArchivePropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementArchivePropertyInfo = "DOMHTMLObjectElement::archive"
    attrGet _ = getDOMHTMLObjectElementArchive
    attrSet _ = setDOMHTMLObjectElementArchive
    attrConstruct _ = constructDOMHTMLObjectElementArchive

-- VVV Prop "border"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementBorder :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementBorder obj = liftIO $ getObjectPropertyString obj "border"

setDOMHTMLObjectElementBorder :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementBorder obj val = liftIO $ setObjectPropertyString obj "border" val

constructDOMHTMLObjectElementBorder :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementBorder val = constructObjectPropertyString "border" val

data DOMHTMLObjectElementBorderPropertyInfo
instance AttrInfo DOMHTMLObjectElementBorderPropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementBorderPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementBorderPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementBorderPropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementBorderPropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementBorderPropertyInfo = "DOMHTMLObjectElement::border"
    attrGet _ = getDOMHTMLObjectElementBorder
    attrSet _ = setDOMHTMLObjectElementBorder
    attrConstruct _ = constructDOMHTMLObjectElementBorder

-- VVV Prop "code"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementCode :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementCode obj = liftIO $ getObjectPropertyString obj "code"

setDOMHTMLObjectElementCode :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementCode obj val = liftIO $ setObjectPropertyString obj "code" val

constructDOMHTMLObjectElementCode :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementCode val = constructObjectPropertyString "code" val

data DOMHTMLObjectElementCodePropertyInfo
instance AttrInfo DOMHTMLObjectElementCodePropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementCodePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementCodePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementCodePropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementCodePropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementCodePropertyInfo = "DOMHTMLObjectElement::code"
    attrGet _ = getDOMHTMLObjectElementCode
    attrSet _ = setDOMHTMLObjectElementCode
    attrConstruct _ = constructDOMHTMLObjectElementCode

-- VVV Prop "code-base"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementCodeBase :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementCodeBase obj = liftIO $ getObjectPropertyString obj "code-base"

setDOMHTMLObjectElementCodeBase :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementCodeBase obj val = liftIO $ setObjectPropertyString obj "code-base" val

constructDOMHTMLObjectElementCodeBase :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementCodeBase val = constructObjectPropertyString "code-base" val

data DOMHTMLObjectElementCodeBasePropertyInfo
instance AttrInfo DOMHTMLObjectElementCodeBasePropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementCodeBasePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementCodeBasePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementCodeBasePropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementCodeBasePropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementCodeBasePropertyInfo = "DOMHTMLObjectElement::code-base"
    attrGet _ = getDOMHTMLObjectElementCodeBase
    attrSet _ = setDOMHTMLObjectElementCodeBase
    attrConstruct _ = constructDOMHTMLObjectElementCodeBase

-- VVV Prop "code-type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementCodeType :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementCodeType obj = liftIO $ getObjectPropertyString obj "code-type"

setDOMHTMLObjectElementCodeType :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementCodeType obj val = liftIO $ setObjectPropertyString obj "code-type" val

constructDOMHTMLObjectElementCodeType :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementCodeType val = constructObjectPropertyString "code-type" val

data DOMHTMLObjectElementCodeTypePropertyInfo
instance AttrInfo DOMHTMLObjectElementCodeTypePropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementCodeTypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementCodeTypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementCodeTypePropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementCodeTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementCodeTypePropertyInfo = "DOMHTMLObjectElement::code-type"
    attrGet _ = getDOMHTMLObjectElementCodeType
    attrSet _ = setDOMHTMLObjectElementCodeType
    attrConstruct _ = constructDOMHTMLObjectElementCodeType

-- VVV Prop "content-document"
   -- Type: TInterface "WebKit" "DOMDocument"
   -- Flags: [PropertyReadable]

getDOMHTMLObjectElementContentDocument :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m DOMDocument
getDOMHTMLObjectElementContentDocument obj = liftIO $ getObjectPropertyObject obj "content-document" DOMDocument

data DOMHTMLObjectElementContentDocumentPropertyInfo
instance AttrInfo DOMHTMLObjectElementContentDocumentPropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementContentDocumentPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementContentDocumentPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLObjectElementContentDocumentPropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementContentDocumentPropertyInfo = DOMDocument
    type AttrLabel DOMHTMLObjectElementContentDocumentPropertyInfo = "DOMHTMLObjectElement::content-document"
    attrGet _ = getDOMHTMLObjectElementContentDocument
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "data"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementData :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementData obj = liftIO $ getObjectPropertyString obj "data"

setDOMHTMLObjectElementData :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementData obj val = liftIO $ setObjectPropertyString obj "data" val

constructDOMHTMLObjectElementData :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementData val = constructObjectPropertyString "data" val

data DOMHTMLObjectElementDataPropertyInfo
instance AttrInfo DOMHTMLObjectElementDataPropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementDataPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementDataPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementDataPropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementDataPropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementDataPropertyInfo = "DOMHTMLObjectElement::data"
    attrGet _ = getDOMHTMLObjectElementData
    attrSet _ = setDOMHTMLObjectElementData
    attrConstruct _ = constructDOMHTMLObjectElementData

-- VVV Prop "declare"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementDeclare :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m Bool
getDOMHTMLObjectElementDeclare obj = liftIO $ getObjectPropertyBool obj "declare"

setDOMHTMLObjectElementDeclare :: (MonadIO m, DOMHTMLObjectElementK o) => o -> Bool -> m ()
setDOMHTMLObjectElementDeclare obj val = liftIO $ setObjectPropertyBool obj "declare" val

constructDOMHTMLObjectElementDeclare :: Bool -> IO ([Char], GValue)
constructDOMHTMLObjectElementDeclare val = constructObjectPropertyBool "declare" val

data DOMHTMLObjectElementDeclarePropertyInfo
instance AttrInfo DOMHTMLObjectElementDeclarePropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementDeclarePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementDeclarePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLObjectElementDeclarePropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementDeclarePropertyInfo = Bool
    type AttrLabel DOMHTMLObjectElementDeclarePropertyInfo = "DOMHTMLObjectElement::declare"
    attrGet _ = getDOMHTMLObjectElementDeclare
    attrSet _ = setDOMHTMLObjectElementDeclare
    attrConstruct _ = constructDOMHTMLObjectElementDeclare

-- VVV Prop "form"
   -- Type: TInterface "WebKit" "DOMHTMLFormElement"
   -- Flags: [PropertyReadable]

getDOMHTMLObjectElementForm :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m DOMHTMLFormElement
getDOMHTMLObjectElementForm obj = liftIO $ getObjectPropertyObject obj "form" DOMHTMLFormElement

data DOMHTMLObjectElementFormPropertyInfo
instance AttrInfo DOMHTMLObjectElementFormPropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementFormPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementFormPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLObjectElementFormPropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementFormPropertyInfo = DOMHTMLFormElement
    type AttrLabel DOMHTMLObjectElementFormPropertyInfo = "DOMHTMLObjectElement::form"
    attrGet _ = getDOMHTMLObjectElementForm
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "height"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementHeight :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementHeight obj = liftIO $ getObjectPropertyString obj "height"

setDOMHTMLObjectElementHeight :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementHeight obj val = liftIO $ setObjectPropertyString obj "height" val

constructDOMHTMLObjectElementHeight :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementHeight val = constructObjectPropertyString "height" val

data DOMHTMLObjectElementHeightPropertyInfo
instance AttrInfo DOMHTMLObjectElementHeightPropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementHeightPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementHeightPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementHeightPropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementHeightPropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementHeightPropertyInfo = "DOMHTMLObjectElement::height"
    attrGet _ = getDOMHTMLObjectElementHeight
    attrSet _ = setDOMHTMLObjectElementHeight
    attrConstruct _ = constructDOMHTMLObjectElementHeight

-- VVV Prop "hspace"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementHspace :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m Int64
getDOMHTMLObjectElementHspace obj = liftIO $ getObjectPropertyInt64 obj "hspace"

setDOMHTMLObjectElementHspace :: (MonadIO m, DOMHTMLObjectElementK o) => o -> Int64 -> m ()
setDOMHTMLObjectElementHspace obj val = liftIO $ setObjectPropertyInt64 obj "hspace" val

constructDOMHTMLObjectElementHspace :: Int64 -> IO ([Char], GValue)
constructDOMHTMLObjectElementHspace val = constructObjectPropertyInt64 "hspace" val

data DOMHTMLObjectElementHspacePropertyInfo
instance AttrInfo DOMHTMLObjectElementHspacePropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementHspacePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementHspacePropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLObjectElementHspacePropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementHspacePropertyInfo = Int64
    type AttrLabel DOMHTMLObjectElementHspacePropertyInfo = "DOMHTMLObjectElement::hspace"
    attrGet _ = getDOMHTMLObjectElementHspace
    attrSet _ = setDOMHTMLObjectElementHspace
    attrConstruct _ = constructDOMHTMLObjectElementHspace

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementName :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementName obj = liftIO $ getObjectPropertyString obj "name"

setDOMHTMLObjectElementName :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementName obj val = liftIO $ setObjectPropertyString obj "name" val

constructDOMHTMLObjectElementName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementName val = constructObjectPropertyString "name" val

data DOMHTMLObjectElementNamePropertyInfo
instance AttrInfo DOMHTMLObjectElementNamePropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementNamePropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementNamePropertyInfo = "DOMHTMLObjectElement::name"
    attrGet _ = getDOMHTMLObjectElementName
    attrSet _ = setDOMHTMLObjectElementName
    attrConstruct _ = constructDOMHTMLObjectElementName

-- VVV Prop "standby"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementStandby :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementStandby obj = liftIO $ getObjectPropertyString obj "standby"

setDOMHTMLObjectElementStandby :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementStandby obj val = liftIO $ setObjectPropertyString obj "standby" val

constructDOMHTMLObjectElementStandby :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementStandby val = constructObjectPropertyString "standby" val

data DOMHTMLObjectElementStandbyPropertyInfo
instance AttrInfo DOMHTMLObjectElementStandbyPropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementStandbyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementStandbyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementStandbyPropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementStandbyPropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementStandbyPropertyInfo = "DOMHTMLObjectElement::standby"
    attrGet _ = getDOMHTMLObjectElementStandby
    attrSet _ = setDOMHTMLObjectElementStandby
    attrConstruct _ = constructDOMHTMLObjectElementStandby

-- VVV Prop "type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementType :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementType obj = liftIO $ getObjectPropertyString obj "type"

setDOMHTMLObjectElementType :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementType obj val = liftIO $ setObjectPropertyString obj "type" val

constructDOMHTMLObjectElementType :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementType val = constructObjectPropertyString "type" val

data DOMHTMLObjectElementTypePropertyInfo
instance AttrInfo DOMHTMLObjectElementTypePropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementTypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementTypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementTypePropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementTypePropertyInfo = "DOMHTMLObjectElement::type"
    attrGet _ = getDOMHTMLObjectElementType
    attrSet _ = setDOMHTMLObjectElementType
    attrConstruct _ = constructDOMHTMLObjectElementType

-- VVV Prop "use-map"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementUseMap :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementUseMap obj = liftIO $ getObjectPropertyString obj "use-map"

setDOMHTMLObjectElementUseMap :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementUseMap obj val = liftIO $ setObjectPropertyString obj "use-map" val

constructDOMHTMLObjectElementUseMap :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementUseMap val = constructObjectPropertyString "use-map" val

data DOMHTMLObjectElementUseMapPropertyInfo
instance AttrInfo DOMHTMLObjectElementUseMapPropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementUseMapPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementUseMapPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementUseMapPropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementUseMapPropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementUseMapPropertyInfo = "DOMHTMLObjectElement::use-map"
    attrGet _ = getDOMHTMLObjectElementUseMap
    attrSet _ = setDOMHTMLObjectElementUseMap
    attrConstruct _ = constructDOMHTMLObjectElementUseMap

-- VVV Prop "validation-message"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLObjectElementValidationMessage :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementValidationMessage obj = liftIO $ getObjectPropertyString obj "validation-message"

data DOMHTMLObjectElementValidationMessagePropertyInfo
instance AttrInfo DOMHTMLObjectElementValidationMessagePropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementValidationMessagePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementValidationMessagePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLObjectElementValidationMessagePropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementValidationMessagePropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementValidationMessagePropertyInfo = "DOMHTMLObjectElement::validation-message"
    attrGet _ = getDOMHTMLObjectElementValidationMessage
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "validity"
   -- Type: TInterface "WebKit" "DOMValidityState"
   -- Flags: [PropertyReadable]

getDOMHTMLObjectElementValidity :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m DOMValidityState
getDOMHTMLObjectElementValidity obj = liftIO $ getObjectPropertyObject obj "validity" DOMValidityState

data DOMHTMLObjectElementValidityPropertyInfo
instance AttrInfo DOMHTMLObjectElementValidityPropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementValidityPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementValidityPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLObjectElementValidityPropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementValidityPropertyInfo = DOMValidityState
    type AttrLabel DOMHTMLObjectElementValidityPropertyInfo = "DOMHTMLObjectElement::validity"
    attrGet _ = getDOMHTMLObjectElementValidity
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "vspace"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementVspace :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m Int64
getDOMHTMLObjectElementVspace obj = liftIO $ getObjectPropertyInt64 obj "vspace"

setDOMHTMLObjectElementVspace :: (MonadIO m, DOMHTMLObjectElementK o) => o -> Int64 -> m ()
setDOMHTMLObjectElementVspace obj val = liftIO $ setObjectPropertyInt64 obj "vspace" val

constructDOMHTMLObjectElementVspace :: Int64 -> IO ([Char], GValue)
constructDOMHTMLObjectElementVspace val = constructObjectPropertyInt64 "vspace" val

data DOMHTMLObjectElementVspacePropertyInfo
instance AttrInfo DOMHTMLObjectElementVspacePropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementVspacePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementVspacePropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLObjectElementVspacePropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementVspacePropertyInfo = Int64
    type AttrLabel DOMHTMLObjectElementVspacePropertyInfo = "DOMHTMLObjectElement::vspace"
    attrGet _ = getDOMHTMLObjectElementVspace
    attrSet _ = setDOMHTMLObjectElementVspace
    attrConstruct _ = constructDOMHTMLObjectElementVspace

-- VVV Prop "width"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLObjectElementWidth :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m T.Text
getDOMHTMLObjectElementWidth obj = liftIO $ getObjectPropertyString obj "width"

setDOMHTMLObjectElementWidth :: (MonadIO m, DOMHTMLObjectElementK o) => o -> T.Text -> m ()
setDOMHTMLObjectElementWidth obj val = liftIO $ setObjectPropertyString obj "width" val

constructDOMHTMLObjectElementWidth :: T.Text -> IO ([Char], GValue)
constructDOMHTMLObjectElementWidth val = constructObjectPropertyString "width" val

data DOMHTMLObjectElementWidthPropertyInfo
instance AttrInfo DOMHTMLObjectElementWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementWidthPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLObjectElementWidthPropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementWidthPropertyInfo = T.Text
    type AttrLabel DOMHTMLObjectElementWidthPropertyInfo = "DOMHTMLObjectElement::width"
    attrGet _ = getDOMHTMLObjectElementWidth
    attrSet _ = setDOMHTMLObjectElementWidth
    attrConstruct _ = constructDOMHTMLObjectElementWidth

-- VVV Prop "will-validate"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMHTMLObjectElementWillValidate :: (MonadIO m, DOMHTMLObjectElementK o) => o -> m Bool
getDOMHTMLObjectElementWillValidate obj = liftIO $ getObjectPropertyBool obj "will-validate"

data DOMHTMLObjectElementWillValidatePropertyInfo
instance AttrInfo DOMHTMLObjectElementWillValidatePropertyInfo where
    type AttrAllowedOps DOMHTMLObjectElementWillValidatePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLObjectElementWillValidatePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLObjectElementWillValidatePropertyInfo = DOMHTMLObjectElementK
    type AttrGetType DOMHTMLObjectElementWillValidatePropertyInfo = Bool
    type AttrLabel DOMHTMLObjectElementWillValidatePropertyInfo = "DOMHTMLObjectElement::will-validate"
    attrGet _ = getDOMHTMLObjectElementWillValidate
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMHTMLObjectElement = DOMHTMLObjectElementAttributeList
type DOMHTMLObjectElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLObjectElementAlignPropertyInfo), '("archive", DOMHTMLObjectElementArchivePropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("border", DOMHTMLObjectElementBorderPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("code", DOMHTMLObjectElementCodePropertyInfo), '("code-base", DOMHTMLObjectElementCodeBasePropertyInfo), '("code-type", DOMHTMLObjectElementCodeTypePropertyInfo), '("content-document", DOMHTMLObjectElementContentDocumentPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("data", DOMHTMLObjectElementDataPropertyInfo), '("declare", DOMHTMLObjectElementDeclarePropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("form", DOMHTMLObjectElementFormPropertyInfo), '("height", DOMHTMLObjectElementHeightPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("hspace", DOMHTMLObjectElementHspacePropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("name", DOMHTMLObjectElementNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("standby", DOMHTMLObjectElementStandbyPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("type", DOMHTMLObjectElementTypePropertyInfo), '("use-map", DOMHTMLObjectElementUseMapPropertyInfo), '("validation-message", DOMHTMLObjectElementValidationMessagePropertyInfo), '("validity", DOMHTMLObjectElementValidityPropertyInfo), '("vspace", DOMHTMLObjectElementVspacePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("width", DOMHTMLObjectElementWidthPropertyInfo), '("will-validate", DOMHTMLObjectElementWillValidatePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLObjectElement = DOMHTMLObjectElementSignalList
type DOMHTMLObjectElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLObjectElement::check_validity
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_check_validity" webkit_dom_html_object_element_check_validity :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CInt


dOMHTMLObjectElementCheckValidity ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLObjectElementCheckValidity _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_check_validity _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_align" webkit_dom_html_object_element_get_align :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetAlign ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_archive
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_archive" webkit_dom_html_object_element_get_archive :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetArchive ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetArchive _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_archive _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_archive" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_border
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_border" webkit_dom_html_object_element_get_border :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetBorder ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetBorder _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_border _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_border" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_code
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_code" webkit_dom_html_object_element_get_code :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetCode ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetCode _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_code _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_code" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_code_base
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_code_base" webkit_dom_html_object_element_get_code_base :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetCodeBase ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetCodeBase _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_code_base _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_code_base" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_code_type
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_code_type" webkit_dom_html_object_element_get_code_type :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetCodeType ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetCodeType _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_code_type _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_code_type" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_content_document
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMDocument"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_content_document" webkit_dom_html_object_element_get_content_document :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO (Ptr DOMDocument)


dOMHTMLObjectElementGetContentDocument ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m DOMDocument
dOMHTMLObjectElementGetContentDocument _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_content_document _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_content_document" result
    result' <- (newObject DOMDocument) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_data
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_data" webkit_dom_html_object_element_get_data :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetData ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetData _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_data _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_data" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_declare
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_declare" webkit_dom_html_object_element_get_declare :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CInt


dOMHTMLObjectElementGetDeclare ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLObjectElementGetDeclare _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_declare _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_form
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLFormElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_form" webkit_dom_html_object_element_get_form :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO (Ptr DOMHTMLFormElement)


dOMHTMLObjectElementGetForm ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLFormElement
dOMHTMLObjectElementGetForm _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_form _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_form" result
    result' <- (newObject DOMHTMLFormElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_height" webkit_dom_html_object_element_get_height :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetHeight ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetHeight _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_height _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_height" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_hspace
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_hspace" webkit_dom_html_object_element_get_hspace :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO Int64


dOMHTMLObjectElementGetHspace ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLObjectElementGetHspace _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_hspace _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLObjectElement::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_name" webkit_dom_html_object_element_get_name :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetName ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_standby
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_standby" webkit_dom_html_object_element_get_standby :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetStandby ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetStandby _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_standby _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_standby" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_use_map
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_use_map" webkit_dom_html_object_element_get_use_map :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetUseMap ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetUseMap _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_use_map _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_use_map" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_validation_message
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_validation_message" webkit_dom_html_object_element_get_validation_message :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetValidationMessage ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetValidationMessage _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_validation_message _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_validation_message" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_validity
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMValidityState"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_validity" webkit_dom_html_object_element_get_validity :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO (Ptr DOMValidityState)


dOMHTMLObjectElementGetValidity ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m DOMValidityState
dOMHTMLObjectElementGetValidity _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_validity _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_validity" result
    result' <- (wrapObject DOMValidityState) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_vspace
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_vspace" webkit_dom_html_object_element_get_vspace :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO Int64


dOMHTMLObjectElementGetVspace ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLObjectElementGetVspace _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_vspace _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLObjectElement::get_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_width" webkit_dom_html_object_element_get_width :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CString


dOMHTMLObjectElementGetWidth ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLObjectElementGetWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_width _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_object_element_get_width" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::get_will_validate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_get_will_validate" webkit_dom_html_object_element_get_will_validate :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    IO CInt


dOMHTMLObjectElementGetWillValidate ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLObjectElementGetWillValidate _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_object_element_get_will_validate _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLObjectElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_align" webkit_dom_html_object_element_set_align :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetAlign ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLObjectElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_object_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLObjectElement::set_archive
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_archive" webkit_dom_html_object_element_set_archive :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetArchive ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLObjectElementSetArchive _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_object_element_set_archive _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLObjectElement::set_border
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_border" webkit_dom_html_object_element_set_border :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetBorder ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLObjectElementSetBorder _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_object_element_set_border _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLObjectElement::set_code
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_code" webkit_dom_html_object_element_set_code :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetCode ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLObjectElementSetCode _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_object_element_set_code _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLObjectElement::set_code_base
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_code_base" webkit_dom_html_object_element_set_code_base :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetCodeBase ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLObjectElementSetCodeBase _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_object_element_set_code_base _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLObjectElement::set_code_type
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_code_type" webkit_dom_html_object_element_set_code_type :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetCodeType ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLObjectElementSetCodeType _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_object_element_set_code_type _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLObjectElement::set_custom_validity
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "error", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "error", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_custom_validity" webkit_dom_html_object_element_set_custom_validity :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- error : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetCustomValidity ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- error
    m ()
dOMHTMLObjectElementSetCustomValidity _obj error_ = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    error_' <- textToCString error_
    webkit_dom_html_object_element_set_custom_validity _obj' error_'
    touchManagedPtr _obj
    freeMem error_'
    return ()

-- method DOMHTMLObjectElement::set_data
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_data" webkit_dom_html_object_element_set_data :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetData ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLObjectElementSetData _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_object_element_set_data _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLObjectElement::set_declare
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_declare" webkit_dom_html_object_element_set_declare :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLObjectElementSetDeclare ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLObjectElementSetDeclare _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_object_element_set_declare _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLObjectElement::set_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_height" webkit_dom_html_object_element_set_height :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetHeight ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLObjectElementSetHeight _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_object_element_set_height _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLObjectElement::set_hspace
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_hspace" webkit_dom_html_object_element_set_hspace :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    Int64 ->                                -- value : TBasicType TInt64
    IO ()


dOMHTMLObjectElementSetHspace ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLObjectElementSetHspace _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_object_element_set_hspace _obj' value
    touchManagedPtr _obj
    return ()

-- method DOMHTMLObjectElement::set_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_name" webkit_dom_html_object_element_set_name :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetName ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLObjectElementSetName _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_object_element_set_name _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLObjectElement::set_standby
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_standby" webkit_dom_html_object_element_set_standby :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetStandby ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLObjectElementSetStandby _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_object_element_set_standby _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLObjectElement::set_use_map
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_use_map" webkit_dom_html_object_element_set_use_map :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetUseMap ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLObjectElementSetUseMap _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_object_element_set_use_map _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLObjectElement::set_vspace
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_vspace" webkit_dom_html_object_element_set_vspace :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    Int64 ->                                -- value : TBasicType TInt64
    IO ()


dOMHTMLObjectElementSetVspace ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLObjectElementSetVspace _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_object_element_set_vspace _obj' value
    touchManagedPtr _obj
    return ()

-- method DOMHTMLObjectElement::set_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLObjectElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_object_element_set_width" webkit_dom_html_object_element_set_width :: 
    Ptr DOMHTMLObjectElement ->             -- _obj : TInterface "WebKit" "DOMHTMLObjectElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLObjectElementSetWidth ::
    (MonadIO m, DOMHTMLObjectElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLObjectElementSetWidth _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_object_element_set_width _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


