
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLOptGroupElement
    ( 

-- * Exported types
    DOMHTMLOptGroupElement(..)              ,
    DOMHTMLOptGroupElementK                 ,
    toDOMHTMLOptGroupElement                ,
    noDOMHTMLOptGroupElement                ,


 -- * Methods
-- ** dOMHTMLOptGroupElementGetDisabled
    dOMHTMLOptGroupElementGetDisabled       ,


-- ** dOMHTMLOptGroupElementGetLabel
    dOMHTMLOptGroupElementGetLabel          ,


-- ** dOMHTMLOptGroupElementSetDisabled
    dOMHTMLOptGroupElementSetDisabled       ,


-- ** dOMHTMLOptGroupElementSetLabel
    dOMHTMLOptGroupElementSetLabel          ,




 -- * Properties
-- ** Disabled
    DOMHTMLOptGroupElementDisabledPropertyInfo,
    constructDOMHTMLOptGroupElementDisabled ,
    getDOMHTMLOptGroupElementDisabled       ,
    setDOMHTMLOptGroupElementDisabled       ,


-- ** Label
    DOMHTMLOptGroupElementLabelPropertyInfo ,
    constructDOMHTMLOptGroupElementLabel    ,
    getDOMHTMLOptGroupElementLabel          ,
    setDOMHTMLOptGroupElementLabel          ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLOptGroupElement = DOMHTMLOptGroupElement (ForeignPtr DOMHTMLOptGroupElement)
foreign import ccall "webkit_dom_html_opt_group_element_get_type"
    c_webkit_dom_html_opt_group_element_get_type :: IO GType

type instance ParentTypes DOMHTMLOptGroupElement = DOMHTMLOptGroupElementParentTypes
type DOMHTMLOptGroupElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLOptGroupElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_opt_group_element_get_type
    

class GObject o => DOMHTMLOptGroupElementK o
instance (GObject o, IsDescendantOf DOMHTMLOptGroupElement o) => DOMHTMLOptGroupElementK o

toDOMHTMLOptGroupElement :: DOMHTMLOptGroupElementK o => o -> IO DOMHTMLOptGroupElement
toDOMHTMLOptGroupElement = unsafeCastTo DOMHTMLOptGroupElement

noDOMHTMLOptGroupElement :: Maybe DOMHTMLOptGroupElement
noDOMHTMLOptGroupElement = Nothing

-- VVV Prop "disabled"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLOptGroupElementDisabled :: (MonadIO m, DOMHTMLOptGroupElementK o) => o -> m Bool
getDOMHTMLOptGroupElementDisabled obj = liftIO $ getObjectPropertyBool obj "disabled"

setDOMHTMLOptGroupElementDisabled :: (MonadIO m, DOMHTMLOptGroupElementK o) => o -> Bool -> m ()
setDOMHTMLOptGroupElementDisabled obj val = liftIO $ setObjectPropertyBool obj "disabled" val

constructDOMHTMLOptGroupElementDisabled :: Bool -> IO ([Char], GValue)
constructDOMHTMLOptGroupElementDisabled val = constructObjectPropertyBool "disabled" val

data DOMHTMLOptGroupElementDisabledPropertyInfo
instance AttrInfo DOMHTMLOptGroupElementDisabledPropertyInfo where
    type AttrAllowedOps DOMHTMLOptGroupElementDisabledPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLOptGroupElementDisabledPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLOptGroupElementDisabledPropertyInfo = DOMHTMLOptGroupElementK
    type AttrGetType DOMHTMLOptGroupElementDisabledPropertyInfo = Bool
    type AttrLabel DOMHTMLOptGroupElementDisabledPropertyInfo = "DOMHTMLOptGroupElement::disabled"
    attrGet _ = getDOMHTMLOptGroupElementDisabled
    attrSet _ = setDOMHTMLOptGroupElementDisabled
    attrConstruct _ = constructDOMHTMLOptGroupElementDisabled

-- VVV Prop "label"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLOptGroupElementLabel :: (MonadIO m, DOMHTMLOptGroupElementK o) => o -> m T.Text
getDOMHTMLOptGroupElementLabel obj = liftIO $ getObjectPropertyString obj "label"

setDOMHTMLOptGroupElementLabel :: (MonadIO m, DOMHTMLOptGroupElementK o) => o -> T.Text -> m ()
setDOMHTMLOptGroupElementLabel obj val = liftIO $ setObjectPropertyString obj "label" val

constructDOMHTMLOptGroupElementLabel :: T.Text -> IO ([Char], GValue)
constructDOMHTMLOptGroupElementLabel val = constructObjectPropertyString "label" val

data DOMHTMLOptGroupElementLabelPropertyInfo
instance AttrInfo DOMHTMLOptGroupElementLabelPropertyInfo where
    type AttrAllowedOps DOMHTMLOptGroupElementLabelPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLOptGroupElementLabelPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLOptGroupElementLabelPropertyInfo = DOMHTMLOptGroupElementK
    type AttrGetType DOMHTMLOptGroupElementLabelPropertyInfo = T.Text
    type AttrLabel DOMHTMLOptGroupElementLabelPropertyInfo = "DOMHTMLOptGroupElement::label"
    attrGet _ = getDOMHTMLOptGroupElementLabel
    attrSet _ = setDOMHTMLOptGroupElementLabel
    attrConstruct _ = constructDOMHTMLOptGroupElementLabel

type instance AttributeList DOMHTMLOptGroupElement = DOMHTMLOptGroupElementAttributeList
type DOMHTMLOptGroupElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("disabled", DOMHTMLOptGroupElementDisabledPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("label", DOMHTMLOptGroupElementLabelPropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLOptGroupElement = DOMHTMLOptGroupElementSignalList
type DOMHTMLOptGroupElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLOptGroupElement::get_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLOptGroupElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLOptGroupElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_opt_group_element_get_disabled" webkit_dom_html_opt_group_element_get_disabled :: 
    Ptr DOMHTMLOptGroupElement ->           -- _obj : TInterface "WebKit" "DOMHTMLOptGroupElement"
    IO CInt


dOMHTMLOptGroupElementGetDisabled ::
    (MonadIO m, DOMHTMLOptGroupElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLOptGroupElementGetDisabled _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_opt_group_element_get_disabled _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLOptGroupElement::get_label
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLOptGroupElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLOptGroupElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_opt_group_element_get_label" webkit_dom_html_opt_group_element_get_label :: 
    Ptr DOMHTMLOptGroupElement ->           -- _obj : TInterface "WebKit" "DOMHTMLOptGroupElement"
    IO CString


dOMHTMLOptGroupElementGetLabel ::
    (MonadIO m, DOMHTMLOptGroupElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLOptGroupElementGetLabel _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_opt_group_element_get_label _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_opt_group_element_get_label" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLOptGroupElement::set_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLOptGroupElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLOptGroupElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_opt_group_element_set_disabled" webkit_dom_html_opt_group_element_set_disabled :: 
    Ptr DOMHTMLOptGroupElement ->           -- _obj : TInterface "WebKit" "DOMHTMLOptGroupElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLOptGroupElementSetDisabled ::
    (MonadIO m, DOMHTMLOptGroupElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLOptGroupElementSetDisabled _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_opt_group_element_set_disabled _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLOptGroupElement::set_label
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLOptGroupElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLOptGroupElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_opt_group_element_set_label" webkit_dom_html_opt_group_element_set_label :: 
    Ptr DOMHTMLOptGroupElement ->           -- _obj : TInterface "WebKit" "DOMHTMLOptGroupElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLOptGroupElementSetLabel ::
    (MonadIO m, DOMHTMLOptGroupElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLOptGroupElementSetLabel _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_opt_group_element_set_label _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


