
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLParagraphElement
    ( 

-- * Exported types
    DOMHTMLParagraphElement(..)             ,
    DOMHTMLParagraphElementK                ,
    toDOMHTMLParagraphElement               ,
    noDOMHTMLParagraphElement               ,


 -- * Methods
-- ** dOMHTMLParagraphElementGetAlign
    dOMHTMLParagraphElementGetAlign         ,


-- ** dOMHTMLParagraphElementSetAlign
    dOMHTMLParagraphElementSetAlign         ,




 -- * Properties
-- ** Align
    DOMHTMLParagraphElementAlignPropertyInfo,
    constructDOMHTMLParagraphElementAlign   ,
    getDOMHTMLParagraphElementAlign         ,
    setDOMHTMLParagraphElementAlign         ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLParagraphElement = DOMHTMLParagraphElement (ForeignPtr DOMHTMLParagraphElement)
foreign import ccall "webkit_dom_html_paragraph_element_get_type"
    c_webkit_dom_html_paragraph_element_get_type :: IO GType

type instance ParentTypes DOMHTMLParagraphElement = DOMHTMLParagraphElementParentTypes
type DOMHTMLParagraphElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLParagraphElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_paragraph_element_get_type
    

class GObject o => DOMHTMLParagraphElementK o
instance (GObject o, IsDescendantOf DOMHTMLParagraphElement o) => DOMHTMLParagraphElementK o

toDOMHTMLParagraphElement :: DOMHTMLParagraphElementK o => o -> IO DOMHTMLParagraphElement
toDOMHTMLParagraphElement = unsafeCastTo DOMHTMLParagraphElement

noDOMHTMLParagraphElement :: Maybe DOMHTMLParagraphElement
noDOMHTMLParagraphElement = Nothing

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLParagraphElementAlign :: (MonadIO m, DOMHTMLParagraphElementK o) => o -> m T.Text
getDOMHTMLParagraphElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLParagraphElementAlign :: (MonadIO m, DOMHTMLParagraphElementK o) => o -> T.Text -> m ()
setDOMHTMLParagraphElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLParagraphElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLParagraphElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLParagraphElementAlignPropertyInfo
instance AttrInfo DOMHTMLParagraphElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLParagraphElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLParagraphElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLParagraphElementAlignPropertyInfo = DOMHTMLParagraphElementK
    type AttrGetType DOMHTMLParagraphElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLParagraphElementAlignPropertyInfo = "DOMHTMLParagraphElement::align"
    attrGet _ = getDOMHTMLParagraphElementAlign
    attrSet _ = setDOMHTMLParagraphElementAlign
    attrConstruct _ = constructDOMHTMLParagraphElementAlign

type instance AttributeList DOMHTMLParagraphElement = DOMHTMLParagraphElementAttributeList
type DOMHTMLParagraphElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLParagraphElementAlignPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLParagraphElement = DOMHTMLParagraphElementSignalList
type DOMHTMLParagraphElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLParagraphElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParagraphElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParagraphElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_paragraph_element_get_align" webkit_dom_html_paragraph_element_get_align :: 
    Ptr DOMHTMLParagraphElement ->          -- _obj : TInterface "WebKit" "DOMHTMLParagraphElement"
    IO CString


dOMHTMLParagraphElementGetAlign ::
    (MonadIO m, DOMHTMLParagraphElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLParagraphElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_paragraph_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_paragraph_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLParagraphElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParagraphElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParagraphElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_paragraph_element_set_align" webkit_dom_html_paragraph_element_set_align :: 
    Ptr DOMHTMLParagraphElement ->          -- _obj : TInterface "WebKit" "DOMHTMLParagraphElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLParagraphElementSetAlign ::
    (MonadIO m, DOMHTMLParagraphElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLParagraphElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_paragraph_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


