
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLParamElement
    ( 

-- * Exported types
    DOMHTMLParamElement(..)                 ,
    DOMHTMLParamElementK                    ,
    toDOMHTMLParamElement                   ,
    noDOMHTMLParamElement                   ,


 -- * Methods
-- ** dOMHTMLParamElementGetName
    dOMHTMLParamElementGetName              ,


-- ** dOMHTMLParamElementGetValue
    dOMHTMLParamElementGetValue             ,


-- ** dOMHTMLParamElementGetValueType
    dOMHTMLParamElementGetValueType         ,


-- ** dOMHTMLParamElementSetName
    dOMHTMLParamElementSetName              ,


-- ** dOMHTMLParamElementSetValue
    dOMHTMLParamElementSetValue             ,


-- ** dOMHTMLParamElementSetValueType
    dOMHTMLParamElementSetValueType         ,




 -- * Properties
-- ** Name
    DOMHTMLParamElementNamePropertyInfo     ,
    constructDOMHTMLParamElementName        ,
    getDOMHTMLParamElementName              ,
    setDOMHTMLParamElementName              ,


-- ** Type
    DOMHTMLParamElementTypePropertyInfo     ,
    constructDOMHTMLParamElementType        ,
    getDOMHTMLParamElementType              ,
    setDOMHTMLParamElementType              ,


-- ** Value
    DOMHTMLParamElementValuePropertyInfo    ,
    constructDOMHTMLParamElementValue       ,
    getDOMHTMLParamElementValue             ,
    setDOMHTMLParamElementValue             ,


-- ** ValueType
    DOMHTMLParamElementValueTypePropertyInfo,
    constructDOMHTMLParamElementValueType   ,
    getDOMHTMLParamElementValueType         ,
    setDOMHTMLParamElementValueType         ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLParamElement = DOMHTMLParamElement (ForeignPtr DOMHTMLParamElement)
foreign import ccall "webkit_dom_html_param_element_get_type"
    c_webkit_dom_html_param_element_get_type :: IO GType

type instance ParentTypes DOMHTMLParamElement = DOMHTMLParamElementParentTypes
type DOMHTMLParamElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLParamElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_param_element_get_type
    

class GObject o => DOMHTMLParamElementK o
instance (GObject o, IsDescendantOf DOMHTMLParamElement o) => DOMHTMLParamElementK o

toDOMHTMLParamElement :: DOMHTMLParamElementK o => o -> IO DOMHTMLParamElement
toDOMHTMLParamElement = unsafeCastTo DOMHTMLParamElement

noDOMHTMLParamElement :: Maybe DOMHTMLParamElement
noDOMHTMLParamElement = Nothing

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLParamElementName :: (MonadIO m, DOMHTMLParamElementK o) => o -> m T.Text
getDOMHTMLParamElementName obj = liftIO $ getObjectPropertyString obj "name"

setDOMHTMLParamElementName :: (MonadIO m, DOMHTMLParamElementK o) => o -> T.Text -> m ()
setDOMHTMLParamElementName obj val = liftIO $ setObjectPropertyString obj "name" val

constructDOMHTMLParamElementName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLParamElementName val = constructObjectPropertyString "name" val

data DOMHTMLParamElementNamePropertyInfo
instance AttrInfo DOMHTMLParamElementNamePropertyInfo where
    type AttrAllowedOps DOMHTMLParamElementNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLParamElementNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLParamElementNamePropertyInfo = DOMHTMLParamElementK
    type AttrGetType DOMHTMLParamElementNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLParamElementNamePropertyInfo = "DOMHTMLParamElement::name"
    attrGet _ = getDOMHTMLParamElementName
    attrSet _ = setDOMHTMLParamElementName
    attrConstruct _ = constructDOMHTMLParamElementName

-- VVV Prop "type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLParamElementType :: (MonadIO m, DOMHTMLParamElementK o) => o -> m T.Text
getDOMHTMLParamElementType obj = liftIO $ getObjectPropertyString obj "type"

setDOMHTMLParamElementType :: (MonadIO m, DOMHTMLParamElementK o) => o -> T.Text -> m ()
setDOMHTMLParamElementType obj val = liftIO $ setObjectPropertyString obj "type" val

constructDOMHTMLParamElementType :: T.Text -> IO ([Char], GValue)
constructDOMHTMLParamElementType val = constructObjectPropertyString "type" val

data DOMHTMLParamElementTypePropertyInfo
instance AttrInfo DOMHTMLParamElementTypePropertyInfo where
    type AttrAllowedOps DOMHTMLParamElementTypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLParamElementTypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLParamElementTypePropertyInfo = DOMHTMLParamElementK
    type AttrGetType DOMHTMLParamElementTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLParamElementTypePropertyInfo = "DOMHTMLParamElement::type"
    attrGet _ = getDOMHTMLParamElementType
    attrSet _ = setDOMHTMLParamElementType
    attrConstruct _ = constructDOMHTMLParamElementType

-- VVV Prop "value"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLParamElementValue :: (MonadIO m, DOMHTMLParamElementK o) => o -> m T.Text
getDOMHTMLParamElementValue obj = liftIO $ getObjectPropertyString obj "value"

setDOMHTMLParamElementValue :: (MonadIO m, DOMHTMLParamElementK o) => o -> T.Text -> m ()
setDOMHTMLParamElementValue obj val = liftIO $ setObjectPropertyString obj "value" val

constructDOMHTMLParamElementValue :: T.Text -> IO ([Char], GValue)
constructDOMHTMLParamElementValue val = constructObjectPropertyString "value" val

data DOMHTMLParamElementValuePropertyInfo
instance AttrInfo DOMHTMLParamElementValuePropertyInfo where
    type AttrAllowedOps DOMHTMLParamElementValuePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLParamElementValuePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLParamElementValuePropertyInfo = DOMHTMLParamElementK
    type AttrGetType DOMHTMLParamElementValuePropertyInfo = T.Text
    type AttrLabel DOMHTMLParamElementValuePropertyInfo = "DOMHTMLParamElement::value"
    attrGet _ = getDOMHTMLParamElementValue
    attrSet _ = setDOMHTMLParamElementValue
    attrConstruct _ = constructDOMHTMLParamElementValue

-- VVV Prop "value-type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLParamElementValueType :: (MonadIO m, DOMHTMLParamElementK o) => o -> m T.Text
getDOMHTMLParamElementValueType obj = liftIO $ getObjectPropertyString obj "value-type"

setDOMHTMLParamElementValueType :: (MonadIO m, DOMHTMLParamElementK o) => o -> T.Text -> m ()
setDOMHTMLParamElementValueType obj val = liftIO $ setObjectPropertyString obj "value-type" val

constructDOMHTMLParamElementValueType :: T.Text -> IO ([Char], GValue)
constructDOMHTMLParamElementValueType val = constructObjectPropertyString "value-type" val

data DOMHTMLParamElementValueTypePropertyInfo
instance AttrInfo DOMHTMLParamElementValueTypePropertyInfo where
    type AttrAllowedOps DOMHTMLParamElementValueTypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLParamElementValueTypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLParamElementValueTypePropertyInfo = DOMHTMLParamElementK
    type AttrGetType DOMHTMLParamElementValueTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLParamElementValueTypePropertyInfo = "DOMHTMLParamElement::value-type"
    attrGet _ = getDOMHTMLParamElementValueType
    attrSet _ = setDOMHTMLParamElementValueType
    attrConstruct _ = constructDOMHTMLParamElementValueType

type instance AttributeList DOMHTMLParamElement = DOMHTMLParamElementAttributeList
type DOMHTMLParamElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("name", DOMHTMLParamElementNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("type", DOMHTMLParamElementTypePropertyInfo), '("value", DOMHTMLParamElementValuePropertyInfo), '("value-type", DOMHTMLParamElementValueTypePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLParamElement = DOMHTMLParamElementSignalList
type DOMHTMLParamElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLParamElement::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParamElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParamElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_param_element_get_name" webkit_dom_html_param_element_get_name :: 
    Ptr DOMHTMLParamElement ->              -- _obj : TInterface "WebKit" "DOMHTMLParamElement"
    IO CString


dOMHTMLParamElementGetName ::
    (MonadIO m, DOMHTMLParamElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLParamElementGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_param_element_get_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_param_element_get_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLParamElement::get_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParamElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParamElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_param_element_get_value" webkit_dom_html_param_element_get_value :: 
    Ptr DOMHTMLParamElement ->              -- _obj : TInterface "WebKit" "DOMHTMLParamElement"
    IO CString


dOMHTMLParamElementGetValue ::
    (MonadIO m, DOMHTMLParamElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLParamElementGetValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_param_element_get_value _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_param_element_get_value" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLParamElement::get_value_type
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParamElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParamElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_param_element_get_value_type" webkit_dom_html_param_element_get_value_type :: 
    Ptr DOMHTMLParamElement ->              -- _obj : TInterface "WebKit" "DOMHTMLParamElement"
    IO CString


dOMHTMLParamElementGetValueType ::
    (MonadIO m, DOMHTMLParamElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLParamElementGetValueType _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_param_element_get_value_type _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_param_element_get_value_type" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLParamElement::set_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParamElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParamElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_param_element_set_name" webkit_dom_html_param_element_set_name :: 
    Ptr DOMHTMLParamElement ->              -- _obj : TInterface "WebKit" "DOMHTMLParamElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLParamElementSetName ::
    (MonadIO m, DOMHTMLParamElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLParamElementSetName _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_param_element_set_name _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLParamElement::set_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParamElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParamElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_param_element_set_value" webkit_dom_html_param_element_set_value :: 
    Ptr DOMHTMLParamElement ->              -- _obj : TInterface "WebKit" "DOMHTMLParamElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLParamElementSetValue ::
    (MonadIO m, DOMHTMLParamElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLParamElementSetValue _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_param_element_set_value _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLParamElement::set_value_type
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParamElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLParamElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_param_element_set_value_type" webkit_dom_html_param_element_set_value_type :: 
    Ptr DOMHTMLParamElement ->              -- _obj : TInterface "WebKit" "DOMHTMLParamElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLParamElementSetValueType ::
    (MonadIO m, DOMHTMLParamElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLParamElementSetValueType _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_param_element_set_value_type _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


