
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLPropertiesCollection
    ( 

-- * Exported types
    DOMHTMLPropertiesCollection(..)         ,
    DOMHTMLPropertiesCollectionK            ,
    toDOMHTMLPropertiesCollection           ,
    noDOMHTMLPropertiesCollection           ,


 -- * Methods
-- ** dOMHTMLPropertiesCollectionGetLength
    dOMHTMLPropertiesCollectionGetLength    ,


-- ** dOMHTMLPropertiesCollectionGetNames
    dOMHTMLPropertiesCollectionGetNames     ,


-- ** dOMHTMLPropertiesCollectionItem
    dOMHTMLPropertiesCollectionItem         ,


-- ** dOMHTMLPropertiesCollectionNamedItem
    dOMHTMLPropertiesCollectionNamedItem    ,




 -- * Properties
-- ** Length
    DOMHTMLPropertiesCollectionLengthPropertyInfo,
    getDOMHTMLPropertiesCollectionLength    ,


-- ** Names
    DOMHTMLPropertiesCollectionNamesPropertyInfo,
    getDOMHTMLPropertiesCollectionNames     ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLPropertiesCollection = DOMHTMLPropertiesCollection (ForeignPtr DOMHTMLPropertiesCollection)
foreign import ccall "webkit_dom_html_properties_collection_get_type"
    c_webkit_dom_html_properties_collection_get_type :: IO GType

type instance ParentTypes DOMHTMLPropertiesCollection = DOMHTMLPropertiesCollectionParentTypes
type DOMHTMLPropertiesCollectionParentTypes = '[DOMHTMLCollection, DOMObject, GObject.Object]

instance GObject DOMHTMLPropertiesCollection where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_properties_collection_get_type
    

class GObject o => DOMHTMLPropertiesCollectionK o
instance (GObject o, IsDescendantOf DOMHTMLPropertiesCollection o) => DOMHTMLPropertiesCollectionK o

toDOMHTMLPropertiesCollection :: DOMHTMLPropertiesCollectionK o => o -> IO DOMHTMLPropertiesCollection
toDOMHTMLPropertiesCollection = unsafeCastTo DOMHTMLPropertiesCollection

noDOMHTMLPropertiesCollection :: Maybe DOMHTMLPropertiesCollection
noDOMHTMLPropertiesCollection = Nothing

-- VVV Prop "length"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMHTMLPropertiesCollectionLength :: (MonadIO m, DOMHTMLPropertiesCollectionK o) => o -> m Word64
getDOMHTMLPropertiesCollectionLength obj = liftIO $ getObjectPropertyUInt64 obj "length"

data DOMHTMLPropertiesCollectionLengthPropertyInfo
instance AttrInfo DOMHTMLPropertiesCollectionLengthPropertyInfo where
    type AttrAllowedOps DOMHTMLPropertiesCollectionLengthPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLPropertiesCollectionLengthPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLPropertiesCollectionLengthPropertyInfo = DOMHTMLPropertiesCollectionK
    type AttrGetType DOMHTMLPropertiesCollectionLengthPropertyInfo = Word64
    type AttrLabel DOMHTMLPropertiesCollectionLengthPropertyInfo = "DOMHTMLPropertiesCollection::length"
    attrGet _ = getDOMHTMLPropertiesCollectionLength
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "names"
   -- Type: TInterface "WebKit" "DOMDOMStringList"
   -- Flags: [PropertyReadable]

getDOMHTMLPropertiesCollectionNames :: (MonadIO m, DOMHTMLPropertiesCollectionK o) => o -> m DOMDOMStringList
getDOMHTMLPropertiesCollectionNames obj = liftIO $ getObjectPropertyObject obj "names" DOMDOMStringList

data DOMHTMLPropertiesCollectionNamesPropertyInfo
instance AttrInfo DOMHTMLPropertiesCollectionNamesPropertyInfo where
    type AttrAllowedOps DOMHTMLPropertiesCollectionNamesPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLPropertiesCollectionNamesPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLPropertiesCollectionNamesPropertyInfo = DOMHTMLPropertiesCollectionK
    type AttrGetType DOMHTMLPropertiesCollectionNamesPropertyInfo = DOMDOMStringList
    type AttrLabel DOMHTMLPropertiesCollectionNamesPropertyInfo = "DOMHTMLPropertiesCollection::names"
    attrGet _ = getDOMHTMLPropertiesCollectionNames
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMHTMLPropertiesCollection = DOMHTMLPropertiesCollectionAttributeList
type DOMHTMLPropertiesCollectionAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo), '("length", DOMHTMLPropertiesCollectionLengthPropertyInfo), '("names", DOMHTMLPropertiesCollectionNamesPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLPropertiesCollection = DOMHTMLPropertiesCollectionSignalList
type DOMHTMLPropertiesCollectionSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLPropertiesCollection::get_length
-- method type : MemberFunction
-- Args : [Arg {argName = "self", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "self", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_properties_collection_get_length" webkit_dom_html_properties_collection_get_length :: 
    Ptr () ->                               -- self : TBasicType TVoid
    IO Word64

{-# DEPRECATED dOMHTMLPropertiesCollectionGetLength ["(Since version 2.2)"]#-}
dOMHTMLPropertiesCollectionGetLength ::
    (MonadIO m) =>
    Ptr () ->                               -- self
    m Word64
dOMHTMLPropertiesCollectionGetLength self = liftIO $ do
    result <- webkit_dom_html_properties_collection_get_length self
    return result

-- method DOMHTMLPropertiesCollection::get_names
-- method type : MemberFunction
-- Args : [Arg {argName = "self", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "self", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMDOMStringList"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_properties_collection_get_names" webkit_dom_html_properties_collection_get_names :: 
    Ptr () ->                               -- self : TBasicType TVoid
    IO (Ptr DOMDOMStringList)

{-# DEPRECATED dOMHTMLPropertiesCollectionGetNames ["(Since version 2.2)"]#-}
dOMHTMLPropertiesCollectionGetNames ::
    (MonadIO m) =>
    Ptr () ->                               -- self
    m DOMDOMStringList
dOMHTMLPropertiesCollectionGetNames self = liftIO $ do
    result <- webkit_dom_html_properties_collection_get_names self
    checkUnexpectedReturnNULL "webkit_dom_html_properties_collection_get_names" result
    result' <- (newObject DOMDOMStringList) result
    return result'

-- method DOMHTMLPropertiesCollection::item
-- method type : MemberFunction
-- Args : [Arg {argName = "self", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "self", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNode"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_properties_collection_item" webkit_dom_html_properties_collection_item :: 
    Ptr () ->                               -- self : TBasicType TVoid
    Word64 ->                               -- index : TBasicType TUInt64
    IO (Ptr DOMNode)

{-# DEPRECATED dOMHTMLPropertiesCollectionItem ["(Since version 2.2)"]#-}
dOMHTMLPropertiesCollectionItem ::
    (MonadIO m) =>
    Ptr () ->                               -- self
    Word64 ->                               -- index
    m DOMNode
dOMHTMLPropertiesCollectionItem self index = liftIO $ do
    result <- webkit_dom_html_properties_collection_item self index
    checkUnexpectedReturnNULL "webkit_dom_html_properties_collection_item" result
    result' <- (newObject DOMNode) result
    return result'

-- method DOMHTMLPropertiesCollection::named_item
-- method type : MemberFunction
-- Args : [Arg {argName = "self", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "self", argType = TBasicType TVoid, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_properties_collection_named_item" webkit_dom_html_properties_collection_named_item :: 
    Ptr () ->                               -- self : TBasicType TVoid
    CString ->                              -- name : TBasicType TUTF8
    IO ()

{-# DEPRECATED dOMHTMLPropertiesCollectionNamedItem ["(Since version 2.2)"]#-}
dOMHTMLPropertiesCollectionNamedItem ::
    (MonadIO m) =>
    Ptr () ->                               -- self
    T.Text ->                               -- name
    m ()
dOMHTMLPropertiesCollectionNamedItem self name = liftIO $ do
    name' <- textToCString name
    webkit_dom_html_properties_collection_named_item self name'
    freeMem name'
    return ()


