
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLQuoteElement
    ( 

-- * Exported types
    DOMHTMLQuoteElement(..)                 ,
    DOMHTMLQuoteElementK                    ,
    toDOMHTMLQuoteElement                   ,
    noDOMHTMLQuoteElement                   ,


 -- * Methods
-- ** dOMHTMLQuoteElementGetCite
    dOMHTMLQuoteElementGetCite              ,


-- ** dOMHTMLQuoteElementSetCite
    dOMHTMLQuoteElementSetCite              ,




 -- * Properties
-- ** Cite
    DOMHTMLQuoteElementCitePropertyInfo     ,
    constructDOMHTMLQuoteElementCite        ,
    getDOMHTMLQuoteElementCite              ,
    setDOMHTMLQuoteElementCite              ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLQuoteElement = DOMHTMLQuoteElement (ForeignPtr DOMHTMLQuoteElement)
foreign import ccall "webkit_dom_html_quote_element_get_type"
    c_webkit_dom_html_quote_element_get_type :: IO GType

type instance ParentTypes DOMHTMLQuoteElement = DOMHTMLQuoteElementParentTypes
type DOMHTMLQuoteElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLQuoteElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_quote_element_get_type
    

class GObject o => DOMHTMLQuoteElementK o
instance (GObject o, IsDescendantOf DOMHTMLQuoteElement o) => DOMHTMLQuoteElementK o

toDOMHTMLQuoteElement :: DOMHTMLQuoteElementK o => o -> IO DOMHTMLQuoteElement
toDOMHTMLQuoteElement = unsafeCastTo DOMHTMLQuoteElement

noDOMHTMLQuoteElement :: Maybe DOMHTMLQuoteElement
noDOMHTMLQuoteElement = Nothing

-- VVV Prop "cite"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLQuoteElementCite :: (MonadIO m, DOMHTMLQuoteElementK o) => o -> m T.Text
getDOMHTMLQuoteElementCite obj = liftIO $ getObjectPropertyString obj "cite"

setDOMHTMLQuoteElementCite :: (MonadIO m, DOMHTMLQuoteElementK o) => o -> T.Text -> m ()
setDOMHTMLQuoteElementCite obj val = liftIO $ setObjectPropertyString obj "cite" val

constructDOMHTMLQuoteElementCite :: T.Text -> IO ([Char], GValue)
constructDOMHTMLQuoteElementCite val = constructObjectPropertyString "cite" val

data DOMHTMLQuoteElementCitePropertyInfo
instance AttrInfo DOMHTMLQuoteElementCitePropertyInfo where
    type AttrAllowedOps DOMHTMLQuoteElementCitePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLQuoteElementCitePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLQuoteElementCitePropertyInfo = DOMHTMLQuoteElementK
    type AttrGetType DOMHTMLQuoteElementCitePropertyInfo = T.Text
    type AttrLabel DOMHTMLQuoteElementCitePropertyInfo = "DOMHTMLQuoteElement::cite"
    attrGet _ = getDOMHTMLQuoteElementCite
    attrSet _ = setDOMHTMLQuoteElementCite
    attrConstruct _ = constructDOMHTMLQuoteElementCite

type instance AttributeList DOMHTMLQuoteElement = DOMHTMLQuoteElementAttributeList
type DOMHTMLQuoteElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("cite", DOMHTMLQuoteElementCitePropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLQuoteElement = DOMHTMLQuoteElementSignalList
type DOMHTMLQuoteElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLQuoteElement::get_cite
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLQuoteElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLQuoteElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_quote_element_get_cite" webkit_dom_html_quote_element_get_cite :: 
    Ptr DOMHTMLQuoteElement ->              -- _obj : TInterface "WebKit" "DOMHTMLQuoteElement"
    IO CString


dOMHTMLQuoteElementGetCite ::
    (MonadIO m, DOMHTMLQuoteElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLQuoteElementGetCite _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_quote_element_get_cite _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_quote_element_get_cite" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLQuoteElement::set_cite
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLQuoteElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLQuoteElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_quote_element_set_cite" webkit_dom_html_quote_element_set_cite :: 
    Ptr DOMHTMLQuoteElement ->              -- _obj : TInterface "WebKit" "DOMHTMLQuoteElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLQuoteElementSetCite ::
    (MonadIO m, DOMHTMLQuoteElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLQuoteElementSetCite _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_quote_element_set_cite _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


