
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLStyleElement
    ( 

-- * Exported types
    DOMHTMLStyleElement(..)                 ,
    DOMHTMLStyleElementK                    ,
    toDOMHTMLStyleElement                   ,
    noDOMHTMLStyleElement                   ,


 -- * Methods
-- ** dOMHTMLStyleElementGetDisabled
    dOMHTMLStyleElementGetDisabled          ,


-- ** dOMHTMLStyleElementGetMedia
    dOMHTMLStyleElementGetMedia             ,


-- ** dOMHTMLStyleElementGetScoped
    dOMHTMLStyleElementGetScoped            ,


-- ** dOMHTMLStyleElementGetSheet
    dOMHTMLStyleElementGetSheet             ,


-- ** dOMHTMLStyleElementSetDisabled
    dOMHTMLStyleElementSetDisabled          ,


-- ** dOMHTMLStyleElementSetMedia
    dOMHTMLStyleElementSetMedia             ,


-- ** dOMHTMLStyleElementSetScoped
    dOMHTMLStyleElementSetScoped            ,




 -- * Properties
-- ** Disabled
    DOMHTMLStyleElementDisabledPropertyInfo ,
    constructDOMHTMLStyleElementDisabled    ,
    getDOMHTMLStyleElementDisabled          ,
    setDOMHTMLStyleElementDisabled          ,


-- ** Media
    DOMHTMLStyleElementMediaPropertyInfo    ,
    constructDOMHTMLStyleElementMedia       ,
    getDOMHTMLStyleElementMedia             ,
    setDOMHTMLStyleElementMedia             ,


-- ** Sheet
    DOMHTMLStyleElementSheetPropertyInfo    ,
    getDOMHTMLStyleElementSheet             ,


-- ** Type
    DOMHTMLStyleElementTypePropertyInfo     ,
    constructDOMHTMLStyleElementType        ,
    getDOMHTMLStyleElementType              ,
    setDOMHTMLStyleElementType              ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLStyleElement = DOMHTMLStyleElement (ForeignPtr DOMHTMLStyleElement)
foreign import ccall "webkit_dom_html_style_element_get_type"
    c_webkit_dom_html_style_element_get_type :: IO GType

type instance ParentTypes DOMHTMLStyleElement = DOMHTMLStyleElementParentTypes
type DOMHTMLStyleElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLStyleElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_style_element_get_type
    

class GObject o => DOMHTMLStyleElementK o
instance (GObject o, IsDescendantOf DOMHTMLStyleElement o) => DOMHTMLStyleElementK o

toDOMHTMLStyleElement :: DOMHTMLStyleElementK o => o -> IO DOMHTMLStyleElement
toDOMHTMLStyleElement = unsafeCastTo DOMHTMLStyleElement

noDOMHTMLStyleElement :: Maybe DOMHTMLStyleElement
noDOMHTMLStyleElement = Nothing

-- VVV Prop "disabled"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLStyleElementDisabled :: (MonadIO m, DOMHTMLStyleElementK o) => o -> m Bool
getDOMHTMLStyleElementDisabled obj = liftIO $ getObjectPropertyBool obj "disabled"

setDOMHTMLStyleElementDisabled :: (MonadIO m, DOMHTMLStyleElementK o) => o -> Bool -> m ()
setDOMHTMLStyleElementDisabled obj val = liftIO $ setObjectPropertyBool obj "disabled" val

constructDOMHTMLStyleElementDisabled :: Bool -> IO ([Char], GValue)
constructDOMHTMLStyleElementDisabled val = constructObjectPropertyBool "disabled" val

data DOMHTMLStyleElementDisabledPropertyInfo
instance AttrInfo DOMHTMLStyleElementDisabledPropertyInfo where
    type AttrAllowedOps DOMHTMLStyleElementDisabledPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLStyleElementDisabledPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLStyleElementDisabledPropertyInfo = DOMHTMLStyleElementK
    type AttrGetType DOMHTMLStyleElementDisabledPropertyInfo = Bool
    type AttrLabel DOMHTMLStyleElementDisabledPropertyInfo = "DOMHTMLStyleElement::disabled"
    attrGet _ = getDOMHTMLStyleElementDisabled
    attrSet _ = setDOMHTMLStyleElementDisabled
    attrConstruct _ = constructDOMHTMLStyleElementDisabled

-- VVV Prop "media"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLStyleElementMedia :: (MonadIO m, DOMHTMLStyleElementK o) => o -> m T.Text
getDOMHTMLStyleElementMedia obj = liftIO $ getObjectPropertyString obj "media"

setDOMHTMLStyleElementMedia :: (MonadIO m, DOMHTMLStyleElementK o) => o -> T.Text -> m ()
setDOMHTMLStyleElementMedia obj val = liftIO $ setObjectPropertyString obj "media" val

constructDOMHTMLStyleElementMedia :: T.Text -> IO ([Char], GValue)
constructDOMHTMLStyleElementMedia val = constructObjectPropertyString "media" val

data DOMHTMLStyleElementMediaPropertyInfo
instance AttrInfo DOMHTMLStyleElementMediaPropertyInfo where
    type AttrAllowedOps DOMHTMLStyleElementMediaPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLStyleElementMediaPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLStyleElementMediaPropertyInfo = DOMHTMLStyleElementK
    type AttrGetType DOMHTMLStyleElementMediaPropertyInfo = T.Text
    type AttrLabel DOMHTMLStyleElementMediaPropertyInfo = "DOMHTMLStyleElement::media"
    attrGet _ = getDOMHTMLStyleElementMedia
    attrSet _ = setDOMHTMLStyleElementMedia
    attrConstruct _ = constructDOMHTMLStyleElementMedia

-- VVV Prop "sheet"
   -- Type: TInterface "WebKit" "DOMStyleSheet"
   -- Flags: [PropertyReadable]

getDOMHTMLStyleElementSheet :: (MonadIO m, DOMHTMLStyleElementK o) => o -> m DOMStyleSheet
getDOMHTMLStyleElementSheet obj = liftIO $ getObjectPropertyObject obj "sheet" DOMStyleSheet

data DOMHTMLStyleElementSheetPropertyInfo
instance AttrInfo DOMHTMLStyleElementSheetPropertyInfo where
    type AttrAllowedOps DOMHTMLStyleElementSheetPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLStyleElementSheetPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLStyleElementSheetPropertyInfo = DOMHTMLStyleElementK
    type AttrGetType DOMHTMLStyleElementSheetPropertyInfo = DOMStyleSheet
    type AttrLabel DOMHTMLStyleElementSheetPropertyInfo = "DOMHTMLStyleElement::sheet"
    attrGet _ = getDOMHTMLStyleElementSheet
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLStyleElementType :: (MonadIO m, DOMHTMLStyleElementK o) => o -> m T.Text
getDOMHTMLStyleElementType obj = liftIO $ getObjectPropertyString obj "type"

setDOMHTMLStyleElementType :: (MonadIO m, DOMHTMLStyleElementK o) => o -> T.Text -> m ()
setDOMHTMLStyleElementType obj val = liftIO $ setObjectPropertyString obj "type" val

constructDOMHTMLStyleElementType :: T.Text -> IO ([Char], GValue)
constructDOMHTMLStyleElementType val = constructObjectPropertyString "type" val

data DOMHTMLStyleElementTypePropertyInfo
instance AttrInfo DOMHTMLStyleElementTypePropertyInfo where
    type AttrAllowedOps DOMHTMLStyleElementTypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLStyleElementTypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLStyleElementTypePropertyInfo = DOMHTMLStyleElementK
    type AttrGetType DOMHTMLStyleElementTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLStyleElementTypePropertyInfo = "DOMHTMLStyleElement::type"
    attrGet _ = getDOMHTMLStyleElementType
    attrSet _ = setDOMHTMLStyleElementType
    attrConstruct _ = constructDOMHTMLStyleElementType

type instance AttributeList DOMHTMLStyleElement = DOMHTMLStyleElementAttributeList
type DOMHTMLStyleElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("disabled", DOMHTMLStyleElementDisabledPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("media", DOMHTMLStyleElementMediaPropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("sheet", DOMHTMLStyleElementSheetPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("type", DOMHTMLStyleElementTypePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLStyleElement = DOMHTMLStyleElementSignalList
type DOMHTMLStyleElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLStyleElement::get_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_get_disabled" webkit_dom_html_style_element_get_disabled :: 
    Ptr DOMHTMLStyleElement ->              -- _obj : TInterface "WebKit" "DOMHTMLStyleElement"
    IO CInt


dOMHTMLStyleElementGetDisabled ::
    (MonadIO m, DOMHTMLStyleElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLStyleElementGetDisabled _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_style_element_get_disabled _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLStyleElement::get_media
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_get_media" webkit_dom_html_style_element_get_media :: 
    Ptr DOMHTMLStyleElement ->              -- _obj : TInterface "WebKit" "DOMHTMLStyleElement"
    IO CString


dOMHTMLStyleElementGetMedia ::
    (MonadIO m, DOMHTMLStyleElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLStyleElementGetMedia _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_style_element_get_media _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_style_element_get_media" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLStyleElement::get_scoped
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_get_scoped" webkit_dom_html_style_element_get_scoped :: 
    Ptr DOMHTMLStyleElement ->              -- _obj : TInterface "WebKit" "DOMHTMLStyleElement"
    IO CInt

{-# DEPRECATED dOMHTMLStyleElementGetScoped ["(Since version 2.2)"]#-}
dOMHTMLStyleElementGetScoped ::
    (MonadIO m, DOMHTMLStyleElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLStyleElementGetScoped _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_style_element_get_scoped _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLStyleElement::get_sheet
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMStyleSheet"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_get_sheet" webkit_dom_html_style_element_get_sheet :: 
    Ptr DOMHTMLStyleElement ->              -- _obj : TInterface "WebKit" "DOMHTMLStyleElement"
    IO (Ptr DOMStyleSheet)


dOMHTMLStyleElementGetSheet ::
    (MonadIO m, DOMHTMLStyleElementK a) =>
    a ->                                    -- _obj
    m DOMStyleSheet
dOMHTMLStyleElementGetSheet _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_style_element_get_sheet _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_style_element_get_sheet" result
    result' <- (wrapObject DOMStyleSheet) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLStyleElement::set_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_set_disabled" webkit_dom_html_style_element_set_disabled :: 
    Ptr DOMHTMLStyleElement ->              -- _obj : TInterface "WebKit" "DOMHTMLStyleElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLStyleElementSetDisabled ::
    (MonadIO m, DOMHTMLStyleElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLStyleElementSetDisabled _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_style_element_set_disabled _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLStyleElement::set_media
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_set_media" webkit_dom_html_style_element_set_media :: 
    Ptr DOMHTMLStyleElement ->              -- _obj : TInterface "WebKit" "DOMHTMLStyleElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLStyleElementSetMedia ::
    (MonadIO m, DOMHTMLStyleElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLStyleElementSetMedia _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_style_element_set_media _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLStyleElement::set_scoped
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLStyleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_style_element_set_scoped" webkit_dom_html_style_element_set_scoped :: 
    Ptr DOMHTMLStyleElement ->              -- _obj : TInterface "WebKit" "DOMHTMLStyleElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()

{-# DEPRECATED dOMHTMLStyleElementSetScoped ["(Since version 2.2)"]#-}
dOMHTMLStyleElementSetScoped ::
    (MonadIO m, DOMHTMLStyleElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLStyleElementSetScoped _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_style_element_set_scoped _obj' value'
    touchManagedPtr _obj
    return ()


