
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLTableCaptionElement
    ( 

-- * Exported types
    DOMHTMLTableCaptionElement(..)          ,
    DOMHTMLTableCaptionElementK             ,
    toDOMHTMLTableCaptionElement            ,
    noDOMHTMLTableCaptionElement            ,


 -- * Methods
-- ** dOMHTMLTableCaptionElementGetAlign
    dOMHTMLTableCaptionElementGetAlign      ,


-- ** dOMHTMLTableCaptionElementSetAlign
    dOMHTMLTableCaptionElementSetAlign      ,




 -- * Properties
-- ** Align
    DOMHTMLTableCaptionElementAlignPropertyInfo,
    constructDOMHTMLTableCaptionElementAlign,
    getDOMHTMLTableCaptionElementAlign      ,
    setDOMHTMLTableCaptionElementAlign      ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLTableCaptionElement = DOMHTMLTableCaptionElement (ForeignPtr DOMHTMLTableCaptionElement)
foreign import ccall "webkit_dom_html_table_caption_element_get_type"
    c_webkit_dom_html_table_caption_element_get_type :: IO GType

type instance ParentTypes DOMHTMLTableCaptionElement = DOMHTMLTableCaptionElementParentTypes
type DOMHTMLTableCaptionElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLTableCaptionElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_table_caption_element_get_type
    

class GObject o => DOMHTMLTableCaptionElementK o
instance (GObject o, IsDescendantOf DOMHTMLTableCaptionElement o) => DOMHTMLTableCaptionElementK o

toDOMHTMLTableCaptionElement :: DOMHTMLTableCaptionElementK o => o -> IO DOMHTMLTableCaptionElement
toDOMHTMLTableCaptionElement = unsafeCastTo DOMHTMLTableCaptionElement

noDOMHTMLTableCaptionElement :: Maybe DOMHTMLTableCaptionElement
noDOMHTMLTableCaptionElement = Nothing

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCaptionElementAlign :: (MonadIO m, DOMHTMLTableCaptionElementK o) => o -> m T.Text
getDOMHTMLTableCaptionElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLTableCaptionElementAlign :: (MonadIO m, DOMHTMLTableCaptionElementK o) => o -> T.Text -> m ()
setDOMHTMLTableCaptionElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLTableCaptionElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableCaptionElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLTableCaptionElementAlignPropertyInfo
instance AttrInfo DOMHTMLTableCaptionElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCaptionElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCaptionElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableCaptionElementAlignPropertyInfo = DOMHTMLTableCaptionElementK
    type AttrGetType DOMHTMLTableCaptionElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableCaptionElementAlignPropertyInfo = "DOMHTMLTableCaptionElement::align"
    attrGet _ = getDOMHTMLTableCaptionElementAlign
    attrSet _ = setDOMHTMLTableCaptionElementAlign
    attrConstruct _ = constructDOMHTMLTableCaptionElementAlign

type instance AttributeList DOMHTMLTableCaptionElement = DOMHTMLTableCaptionElementAttributeList
type DOMHTMLTableCaptionElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLTableCaptionElementAlignPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLTableCaptionElement = DOMHTMLTableCaptionElementSignalList
type DOMHTMLTableCaptionElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLTableCaptionElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCaptionElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCaptionElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_caption_element_get_align" webkit_dom_html_table_caption_element_get_align :: 
    Ptr DOMHTMLTableCaptionElement ->       -- _obj : TInterface "WebKit" "DOMHTMLTableCaptionElement"
    IO CString


dOMHTMLTableCaptionElementGetAlign ::
    (MonadIO m, DOMHTMLTableCaptionElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableCaptionElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_caption_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_caption_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCaptionElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCaptionElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCaptionElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_caption_element_set_align" webkit_dom_html_table_caption_element_set_align :: 
    Ptr DOMHTMLTableCaptionElement ->       -- _obj : TInterface "WebKit" "DOMHTMLTableCaptionElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableCaptionElementSetAlign ::
    (MonadIO m, DOMHTMLTableCaptionElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableCaptionElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_caption_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


