
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLTableCellElement
    ( 

-- * Exported types
    DOMHTMLTableCellElement(..)             ,
    DOMHTMLTableCellElementK                ,
    toDOMHTMLTableCellElement               ,
    noDOMHTMLTableCellElement               ,


 -- * Methods
-- ** dOMHTMLTableCellElementGetAbbr
    dOMHTMLTableCellElementGetAbbr          ,


-- ** dOMHTMLTableCellElementGetAlign
    dOMHTMLTableCellElementGetAlign         ,


-- ** dOMHTMLTableCellElementGetAxis
    dOMHTMLTableCellElementGetAxis          ,


-- ** dOMHTMLTableCellElementGetBgColor
    dOMHTMLTableCellElementGetBgColor       ,


-- ** dOMHTMLTableCellElementGetCellIndex
    dOMHTMLTableCellElementGetCellIndex     ,


-- ** dOMHTMLTableCellElementGetCh
    dOMHTMLTableCellElementGetCh            ,


-- ** dOMHTMLTableCellElementGetChOff
    dOMHTMLTableCellElementGetChOff         ,


-- ** dOMHTMLTableCellElementGetColSpan
    dOMHTMLTableCellElementGetColSpan       ,


-- ** dOMHTMLTableCellElementGetHeaders
    dOMHTMLTableCellElementGetHeaders       ,


-- ** dOMHTMLTableCellElementGetHeight
    dOMHTMLTableCellElementGetHeight        ,


-- ** dOMHTMLTableCellElementGetNoWrap
    dOMHTMLTableCellElementGetNoWrap        ,


-- ** dOMHTMLTableCellElementGetRowSpan
    dOMHTMLTableCellElementGetRowSpan       ,


-- ** dOMHTMLTableCellElementGetScope
    dOMHTMLTableCellElementGetScope         ,


-- ** dOMHTMLTableCellElementGetVAlign
    dOMHTMLTableCellElementGetVAlign        ,


-- ** dOMHTMLTableCellElementGetWidth
    dOMHTMLTableCellElementGetWidth         ,


-- ** dOMHTMLTableCellElementSetAbbr
    dOMHTMLTableCellElementSetAbbr          ,


-- ** dOMHTMLTableCellElementSetAlign
    dOMHTMLTableCellElementSetAlign         ,


-- ** dOMHTMLTableCellElementSetAxis
    dOMHTMLTableCellElementSetAxis          ,


-- ** dOMHTMLTableCellElementSetBgColor
    dOMHTMLTableCellElementSetBgColor       ,


-- ** dOMHTMLTableCellElementSetCh
    dOMHTMLTableCellElementSetCh            ,


-- ** dOMHTMLTableCellElementSetChOff
    dOMHTMLTableCellElementSetChOff         ,


-- ** dOMHTMLTableCellElementSetColSpan
    dOMHTMLTableCellElementSetColSpan       ,


-- ** dOMHTMLTableCellElementSetHeaders
    dOMHTMLTableCellElementSetHeaders       ,


-- ** dOMHTMLTableCellElementSetHeight
    dOMHTMLTableCellElementSetHeight        ,


-- ** dOMHTMLTableCellElementSetNoWrap
    dOMHTMLTableCellElementSetNoWrap        ,


-- ** dOMHTMLTableCellElementSetRowSpan
    dOMHTMLTableCellElementSetRowSpan       ,


-- ** dOMHTMLTableCellElementSetScope
    dOMHTMLTableCellElementSetScope         ,


-- ** dOMHTMLTableCellElementSetVAlign
    dOMHTMLTableCellElementSetVAlign        ,


-- ** dOMHTMLTableCellElementSetWidth
    dOMHTMLTableCellElementSetWidth         ,




 -- * Properties
-- ** Abbr
    DOMHTMLTableCellElementAbbrPropertyInfo ,
    constructDOMHTMLTableCellElementAbbr    ,
    getDOMHTMLTableCellElementAbbr          ,
    setDOMHTMLTableCellElementAbbr          ,


-- ** Align
    DOMHTMLTableCellElementAlignPropertyInfo,
    constructDOMHTMLTableCellElementAlign   ,
    getDOMHTMLTableCellElementAlign         ,
    setDOMHTMLTableCellElementAlign         ,


-- ** Axis
    DOMHTMLTableCellElementAxisPropertyInfo ,
    constructDOMHTMLTableCellElementAxis    ,
    getDOMHTMLTableCellElementAxis          ,
    setDOMHTMLTableCellElementAxis          ,


-- ** BgColor
    DOMHTMLTableCellElementBgColorPropertyInfo,
    constructDOMHTMLTableCellElementBgColor ,
    getDOMHTMLTableCellElementBgColor       ,
    setDOMHTMLTableCellElementBgColor       ,


-- ** CellIndex
    DOMHTMLTableCellElementCellIndexPropertyInfo,
    getDOMHTMLTableCellElementCellIndex     ,


-- ** Ch
    DOMHTMLTableCellElementChPropertyInfo   ,
    constructDOMHTMLTableCellElementCh      ,
    getDOMHTMLTableCellElementCh            ,
    setDOMHTMLTableCellElementCh            ,


-- ** ChOff
    DOMHTMLTableCellElementChOffPropertyInfo,
    constructDOMHTMLTableCellElementChOff   ,
    getDOMHTMLTableCellElementChOff         ,
    setDOMHTMLTableCellElementChOff         ,


-- ** ColSpan
    DOMHTMLTableCellElementColSpanPropertyInfo,
    constructDOMHTMLTableCellElementColSpan ,
    getDOMHTMLTableCellElementColSpan       ,
    setDOMHTMLTableCellElementColSpan       ,


-- ** Headers
    DOMHTMLTableCellElementHeadersPropertyInfo,
    constructDOMHTMLTableCellElementHeaders ,
    getDOMHTMLTableCellElementHeaders       ,
    setDOMHTMLTableCellElementHeaders       ,


-- ** Height
    DOMHTMLTableCellElementHeightPropertyInfo,
    constructDOMHTMLTableCellElementHeight  ,
    getDOMHTMLTableCellElementHeight        ,
    setDOMHTMLTableCellElementHeight        ,


-- ** NoWrap
    DOMHTMLTableCellElementNoWrapPropertyInfo,
    constructDOMHTMLTableCellElementNoWrap  ,
    getDOMHTMLTableCellElementNoWrap        ,
    setDOMHTMLTableCellElementNoWrap        ,


-- ** RowSpan
    DOMHTMLTableCellElementRowSpanPropertyInfo,
    constructDOMHTMLTableCellElementRowSpan ,
    getDOMHTMLTableCellElementRowSpan       ,
    setDOMHTMLTableCellElementRowSpan       ,


-- ** Scope
    DOMHTMLTableCellElementScopePropertyInfo,
    constructDOMHTMLTableCellElementScope   ,
    getDOMHTMLTableCellElementScope         ,
    setDOMHTMLTableCellElementScope         ,


-- ** VAlign
    DOMHTMLTableCellElementVAlignPropertyInfo,
    constructDOMHTMLTableCellElementVAlign  ,
    getDOMHTMLTableCellElementVAlign        ,
    setDOMHTMLTableCellElementVAlign        ,


-- ** Width
    DOMHTMLTableCellElementWidthPropertyInfo,
    constructDOMHTMLTableCellElementWidth   ,
    getDOMHTMLTableCellElementWidth         ,
    setDOMHTMLTableCellElementWidth         ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLTableCellElement = DOMHTMLTableCellElement (ForeignPtr DOMHTMLTableCellElement)
foreign import ccall "webkit_dom_html_table_cell_element_get_type"
    c_webkit_dom_html_table_cell_element_get_type :: IO GType

type instance ParentTypes DOMHTMLTableCellElement = DOMHTMLTableCellElementParentTypes
type DOMHTMLTableCellElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLTableCellElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_table_cell_element_get_type
    

class GObject o => DOMHTMLTableCellElementK o
instance (GObject o, IsDescendantOf DOMHTMLTableCellElement o) => DOMHTMLTableCellElementK o

toDOMHTMLTableCellElement :: DOMHTMLTableCellElementK o => o -> IO DOMHTMLTableCellElement
toDOMHTMLTableCellElement = unsafeCastTo DOMHTMLTableCellElement

noDOMHTMLTableCellElement :: Maybe DOMHTMLTableCellElement
noDOMHTMLTableCellElement = Nothing

-- VVV Prop "abbr"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementAbbr :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m T.Text
getDOMHTMLTableCellElementAbbr obj = liftIO $ getObjectPropertyString obj "abbr"

setDOMHTMLTableCellElementAbbr :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> T.Text -> m ()
setDOMHTMLTableCellElementAbbr obj val = liftIO $ setObjectPropertyString obj "abbr" val

constructDOMHTMLTableCellElementAbbr :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableCellElementAbbr val = constructObjectPropertyString "abbr" val

data DOMHTMLTableCellElementAbbrPropertyInfo
instance AttrInfo DOMHTMLTableCellElementAbbrPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementAbbrPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementAbbrPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableCellElementAbbrPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementAbbrPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableCellElementAbbrPropertyInfo = "DOMHTMLTableCellElement::abbr"
    attrGet _ = getDOMHTMLTableCellElementAbbr
    attrSet _ = setDOMHTMLTableCellElementAbbr
    attrConstruct _ = constructDOMHTMLTableCellElementAbbr

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementAlign :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m T.Text
getDOMHTMLTableCellElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLTableCellElementAlign :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> T.Text -> m ()
setDOMHTMLTableCellElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLTableCellElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableCellElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLTableCellElementAlignPropertyInfo
instance AttrInfo DOMHTMLTableCellElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableCellElementAlignPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableCellElementAlignPropertyInfo = "DOMHTMLTableCellElement::align"
    attrGet _ = getDOMHTMLTableCellElementAlign
    attrSet _ = setDOMHTMLTableCellElementAlign
    attrConstruct _ = constructDOMHTMLTableCellElementAlign

-- VVV Prop "axis"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementAxis :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m T.Text
getDOMHTMLTableCellElementAxis obj = liftIO $ getObjectPropertyString obj "axis"

setDOMHTMLTableCellElementAxis :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> T.Text -> m ()
setDOMHTMLTableCellElementAxis obj val = liftIO $ setObjectPropertyString obj "axis" val

constructDOMHTMLTableCellElementAxis :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableCellElementAxis val = constructObjectPropertyString "axis" val

data DOMHTMLTableCellElementAxisPropertyInfo
instance AttrInfo DOMHTMLTableCellElementAxisPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementAxisPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementAxisPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableCellElementAxisPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementAxisPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableCellElementAxisPropertyInfo = "DOMHTMLTableCellElement::axis"
    attrGet _ = getDOMHTMLTableCellElementAxis
    attrSet _ = setDOMHTMLTableCellElementAxis
    attrConstruct _ = constructDOMHTMLTableCellElementAxis

-- VVV Prop "bg-color"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementBgColor :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m T.Text
getDOMHTMLTableCellElementBgColor obj = liftIO $ getObjectPropertyString obj "bg-color"

setDOMHTMLTableCellElementBgColor :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> T.Text -> m ()
setDOMHTMLTableCellElementBgColor obj val = liftIO $ setObjectPropertyString obj "bg-color" val

constructDOMHTMLTableCellElementBgColor :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableCellElementBgColor val = constructObjectPropertyString "bg-color" val

data DOMHTMLTableCellElementBgColorPropertyInfo
instance AttrInfo DOMHTMLTableCellElementBgColorPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementBgColorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementBgColorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableCellElementBgColorPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementBgColorPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableCellElementBgColorPropertyInfo = "DOMHTMLTableCellElement::bg-color"
    attrGet _ = getDOMHTMLTableCellElementBgColor
    attrSet _ = setDOMHTMLTableCellElementBgColor
    attrConstruct _ = constructDOMHTMLTableCellElementBgColor

-- VVV Prop "cell-index"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable]

getDOMHTMLTableCellElementCellIndex :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m Int64
getDOMHTMLTableCellElementCellIndex obj = liftIO $ getObjectPropertyInt64 obj "cell-index"

data DOMHTMLTableCellElementCellIndexPropertyInfo
instance AttrInfo DOMHTMLTableCellElementCellIndexPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementCellIndexPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementCellIndexPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLTableCellElementCellIndexPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementCellIndexPropertyInfo = Int64
    type AttrLabel DOMHTMLTableCellElementCellIndexPropertyInfo = "DOMHTMLTableCellElement::cell-index"
    attrGet _ = getDOMHTMLTableCellElementCellIndex
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "ch"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementCh :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m T.Text
getDOMHTMLTableCellElementCh obj = liftIO $ getObjectPropertyString obj "ch"

setDOMHTMLTableCellElementCh :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> T.Text -> m ()
setDOMHTMLTableCellElementCh obj val = liftIO $ setObjectPropertyString obj "ch" val

constructDOMHTMLTableCellElementCh :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableCellElementCh val = constructObjectPropertyString "ch" val

data DOMHTMLTableCellElementChPropertyInfo
instance AttrInfo DOMHTMLTableCellElementChPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementChPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementChPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableCellElementChPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementChPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableCellElementChPropertyInfo = "DOMHTMLTableCellElement::ch"
    attrGet _ = getDOMHTMLTableCellElementCh
    attrSet _ = setDOMHTMLTableCellElementCh
    attrConstruct _ = constructDOMHTMLTableCellElementCh

-- VVV Prop "ch-off"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementChOff :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m T.Text
getDOMHTMLTableCellElementChOff obj = liftIO $ getObjectPropertyString obj "ch-off"

setDOMHTMLTableCellElementChOff :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> T.Text -> m ()
setDOMHTMLTableCellElementChOff obj val = liftIO $ setObjectPropertyString obj "ch-off" val

constructDOMHTMLTableCellElementChOff :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableCellElementChOff val = constructObjectPropertyString "ch-off" val

data DOMHTMLTableCellElementChOffPropertyInfo
instance AttrInfo DOMHTMLTableCellElementChOffPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementChOffPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementChOffPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableCellElementChOffPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementChOffPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableCellElementChOffPropertyInfo = "DOMHTMLTableCellElement::ch-off"
    attrGet _ = getDOMHTMLTableCellElementChOff
    attrSet _ = setDOMHTMLTableCellElementChOff
    attrConstruct _ = constructDOMHTMLTableCellElementChOff

-- VVV Prop "col-span"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementColSpan :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m Int64
getDOMHTMLTableCellElementColSpan obj = liftIO $ getObjectPropertyInt64 obj "col-span"

setDOMHTMLTableCellElementColSpan :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> Int64 -> m ()
setDOMHTMLTableCellElementColSpan obj val = liftIO $ setObjectPropertyInt64 obj "col-span" val

constructDOMHTMLTableCellElementColSpan :: Int64 -> IO ([Char], GValue)
constructDOMHTMLTableCellElementColSpan val = constructObjectPropertyInt64 "col-span" val

data DOMHTMLTableCellElementColSpanPropertyInfo
instance AttrInfo DOMHTMLTableCellElementColSpanPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementColSpanPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementColSpanPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLTableCellElementColSpanPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementColSpanPropertyInfo = Int64
    type AttrLabel DOMHTMLTableCellElementColSpanPropertyInfo = "DOMHTMLTableCellElement::col-span"
    attrGet _ = getDOMHTMLTableCellElementColSpan
    attrSet _ = setDOMHTMLTableCellElementColSpan
    attrConstruct _ = constructDOMHTMLTableCellElementColSpan

-- VVV Prop "headers"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementHeaders :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m T.Text
getDOMHTMLTableCellElementHeaders obj = liftIO $ getObjectPropertyString obj "headers"

setDOMHTMLTableCellElementHeaders :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> T.Text -> m ()
setDOMHTMLTableCellElementHeaders obj val = liftIO $ setObjectPropertyString obj "headers" val

constructDOMHTMLTableCellElementHeaders :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableCellElementHeaders val = constructObjectPropertyString "headers" val

data DOMHTMLTableCellElementHeadersPropertyInfo
instance AttrInfo DOMHTMLTableCellElementHeadersPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementHeadersPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementHeadersPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableCellElementHeadersPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementHeadersPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableCellElementHeadersPropertyInfo = "DOMHTMLTableCellElement::headers"
    attrGet _ = getDOMHTMLTableCellElementHeaders
    attrSet _ = setDOMHTMLTableCellElementHeaders
    attrConstruct _ = constructDOMHTMLTableCellElementHeaders

-- VVV Prop "height"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementHeight :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m T.Text
getDOMHTMLTableCellElementHeight obj = liftIO $ getObjectPropertyString obj "height"

setDOMHTMLTableCellElementHeight :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> T.Text -> m ()
setDOMHTMLTableCellElementHeight obj val = liftIO $ setObjectPropertyString obj "height" val

constructDOMHTMLTableCellElementHeight :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableCellElementHeight val = constructObjectPropertyString "height" val

data DOMHTMLTableCellElementHeightPropertyInfo
instance AttrInfo DOMHTMLTableCellElementHeightPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementHeightPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementHeightPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableCellElementHeightPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementHeightPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableCellElementHeightPropertyInfo = "DOMHTMLTableCellElement::height"
    attrGet _ = getDOMHTMLTableCellElementHeight
    attrSet _ = setDOMHTMLTableCellElementHeight
    attrConstruct _ = constructDOMHTMLTableCellElementHeight

-- VVV Prop "no-wrap"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementNoWrap :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m Bool
getDOMHTMLTableCellElementNoWrap obj = liftIO $ getObjectPropertyBool obj "no-wrap"

setDOMHTMLTableCellElementNoWrap :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> Bool -> m ()
setDOMHTMLTableCellElementNoWrap obj val = liftIO $ setObjectPropertyBool obj "no-wrap" val

constructDOMHTMLTableCellElementNoWrap :: Bool -> IO ([Char], GValue)
constructDOMHTMLTableCellElementNoWrap val = constructObjectPropertyBool "no-wrap" val

data DOMHTMLTableCellElementNoWrapPropertyInfo
instance AttrInfo DOMHTMLTableCellElementNoWrapPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementNoWrapPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementNoWrapPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLTableCellElementNoWrapPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementNoWrapPropertyInfo = Bool
    type AttrLabel DOMHTMLTableCellElementNoWrapPropertyInfo = "DOMHTMLTableCellElement::no-wrap"
    attrGet _ = getDOMHTMLTableCellElementNoWrap
    attrSet _ = setDOMHTMLTableCellElementNoWrap
    attrConstruct _ = constructDOMHTMLTableCellElementNoWrap

-- VVV Prop "row-span"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementRowSpan :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m Int64
getDOMHTMLTableCellElementRowSpan obj = liftIO $ getObjectPropertyInt64 obj "row-span"

setDOMHTMLTableCellElementRowSpan :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> Int64 -> m ()
setDOMHTMLTableCellElementRowSpan obj val = liftIO $ setObjectPropertyInt64 obj "row-span" val

constructDOMHTMLTableCellElementRowSpan :: Int64 -> IO ([Char], GValue)
constructDOMHTMLTableCellElementRowSpan val = constructObjectPropertyInt64 "row-span" val

data DOMHTMLTableCellElementRowSpanPropertyInfo
instance AttrInfo DOMHTMLTableCellElementRowSpanPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementRowSpanPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementRowSpanPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLTableCellElementRowSpanPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementRowSpanPropertyInfo = Int64
    type AttrLabel DOMHTMLTableCellElementRowSpanPropertyInfo = "DOMHTMLTableCellElement::row-span"
    attrGet _ = getDOMHTMLTableCellElementRowSpan
    attrSet _ = setDOMHTMLTableCellElementRowSpan
    attrConstruct _ = constructDOMHTMLTableCellElementRowSpan

-- VVV Prop "scope"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementScope :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m T.Text
getDOMHTMLTableCellElementScope obj = liftIO $ getObjectPropertyString obj "scope"

setDOMHTMLTableCellElementScope :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> T.Text -> m ()
setDOMHTMLTableCellElementScope obj val = liftIO $ setObjectPropertyString obj "scope" val

constructDOMHTMLTableCellElementScope :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableCellElementScope val = constructObjectPropertyString "scope" val

data DOMHTMLTableCellElementScopePropertyInfo
instance AttrInfo DOMHTMLTableCellElementScopePropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementScopePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementScopePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableCellElementScopePropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementScopePropertyInfo = T.Text
    type AttrLabel DOMHTMLTableCellElementScopePropertyInfo = "DOMHTMLTableCellElement::scope"
    attrGet _ = getDOMHTMLTableCellElementScope
    attrSet _ = setDOMHTMLTableCellElementScope
    attrConstruct _ = constructDOMHTMLTableCellElementScope

-- VVV Prop "v-align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementVAlign :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m T.Text
getDOMHTMLTableCellElementVAlign obj = liftIO $ getObjectPropertyString obj "v-align"

setDOMHTMLTableCellElementVAlign :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> T.Text -> m ()
setDOMHTMLTableCellElementVAlign obj val = liftIO $ setObjectPropertyString obj "v-align" val

constructDOMHTMLTableCellElementVAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableCellElementVAlign val = constructObjectPropertyString "v-align" val

data DOMHTMLTableCellElementVAlignPropertyInfo
instance AttrInfo DOMHTMLTableCellElementVAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementVAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementVAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableCellElementVAlignPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementVAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableCellElementVAlignPropertyInfo = "DOMHTMLTableCellElement::v-align"
    attrGet _ = getDOMHTMLTableCellElementVAlign
    attrSet _ = setDOMHTMLTableCellElementVAlign
    attrConstruct _ = constructDOMHTMLTableCellElementVAlign

-- VVV Prop "width"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableCellElementWidth :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> m T.Text
getDOMHTMLTableCellElementWidth obj = liftIO $ getObjectPropertyString obj "width"

setDOMHTMLTableCellElementWidth :: (MonadIO m, DOMHTMLTableCellElementK o) => o -> T.Text -> m ()
setDOMHTMLTableCellElementWidth obj val = liftIO $ setObjectPropertyString obj "width" val

constructDOMHTMLTableCellElementWidth :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableCellElementWidth val = constructObjectPropertyString "width" val

data DOMHTMLTableCellElementWidthPropertyInfo
instance AttrInfo DOMHTMLTableCellElementWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLTableCellElementWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableCellElementWidthPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableCellElementWidthPropertyInfo = DOMHTMLTableCellElementK
    type AttrGetType DOMHTMLTableCellElementWidthPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableCellElementWidthPropertyInfo = "DOMHTMLTableCellElement::width"
    attrGet _ = getDOMHTMLTableCellElementWidth
    attrSet _ = setDOMHTMLTableCellElementWidth
    attrConstruct _ = constructDOMHTMLTableCellElementWidth

type instance AttributeList DOMHTMLTableCellElement = DOMHTMLTableCellElementAttributeList
type DOMHTMLTableCellElementAttributeList = ('[ '("abbr", DOMHTMLTableCellElementAbbrPropertyInfo), '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLTableCellElementAlignPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("axis", DOMHTMLTableCellElementAxisPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("bg-color", DOMHTMLTableCellElementBgColorPropertyInfo), '("cell-index", DOMHTMLTableCellElementCellIndexPropertyInfo), '("ch", DOMHTMLTableCellElementChPropertyInfo), '("ch-off", DOMHTMLTableCellElementChOffPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("col-span", DOMHTMLTableCellElementColSpanPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("headers", DOMHTMLTableCellElementHeadersPropertyInfo), '("height", DOMHTMLTableCellElementHeightPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("no-wrap", DOMHTMLTableCellElementNoWrapPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("row-span", DOMHTMLTableCellElementRowSpanPropertyInfo), '("scope", DOMHTMLTableCellElementScopePropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("v-align", DOMHTMLTableCellElementVAlignPropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("width", DOMHTMLTableCellElementWidthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLTableCellElement = DOMHTMLTableCellElementSignalList
type DOMHTMLTableCellElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLTableCellElement::get_abbr
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_abbr" webkit_dom_html_table_cell_element_get_abbr :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO CString


dOMHTMLTableCellElementGetAbbr ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableCellElementGetAbbr _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_abbr _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_cell_element_get_abbr" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCellElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_align" webkit_dom_html_table_cell_element_get_align :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO CString


dOMHTMLTableCellElementGetAlign ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableCellElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_cell_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCellElement::get_axis
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_axis" webkit_dom_html_table_cell_element_get_axis :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO CString


dOMHTMLTableCellElementGetAxis ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableCellElementGetAxis _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_axis _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_cell_element_get_axis" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCellElement::get_bg_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_bg_color" webkit_dom_html_table_cell_element_get_bg_color :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO CString


dOMHTMLTableCellElementGetBgColor ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableCellElementGetBgColor _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_bg_color _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_cell_element_get_bg_color" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCellElement::get_cell_index
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_cell_index" webkit_dom_html_table_cell_element_get_cell_index :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO Int64


dOMHTMLTableCellElementGetCellIndex ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLTableCellElementGetCellIndex _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_cell_index _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLTableCellElement::get_ch
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_ch" webkit_dom_html_table_cell_element_get_ch :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO CString


dOMHTMLTableCellElementGetCh ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableCellElementGetCh _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_ch _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_cell_element_get_ch" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCellElement::get_ch_off
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_ch_off" webkit_dom_html_table_cell_element_get_ch_off :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO CString


dOMHTMLTableCellElementGetChOff ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableCellElementGetChOff _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_ch_off _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_cell_element_get_ch_off" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCellElement::get_col_span
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_col_span" webkit_dom_html_table_cell_element_get_col_span :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO Int64


dOMHTMLTableCellElementGetColSpan ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLTableCellElementGetColSpan _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_col_span _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLTableCellElement::get_headers
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_headers" webkit_dom_html_table_cell_element_get_headers :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO CString


dOMHTMLTableCellElementGetHeaders ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableCellElementGetHeaders _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_headers _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_cell_element_get_headers" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCellElement::get_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_height" webkit_dom_html_table_cell_element_get_height :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO CString


dOMHTMLTableCellElementGetHeight ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableCellElementGetHeight _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_height _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_cell_element_get_height" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCellElement::get_no_wrap
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_no_wrap" webkit_dom_html_table_cell_element_get_no_wrap :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO CInt


dOMHTMLTableCellElementGetNoWrap ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLTableCellElementGetNoWrap _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_no_wrap _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCellElement::get_row_span
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_row_span" webkit_dom_html_table_cell_element_get_row_span :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO Int64


dOMHTMLTableCellElementGetRowSpan ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLTableCellElementGetRowSpan _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_row_span _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLTableCellElement::get_scope
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_scope" webkit_dom_html_table_cell_element_get_scope :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO CString


dOMHTMLTableCellElementGetScope ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableCellElementGetScope _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_scope _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_cell_element_get_scope" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCellElement::get_v_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_v_align" webkit_dom_html_table_cell_element_get_v_align :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO CString


dOMHTMLTableCellElementGetVAlign ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableCellElementGetVAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_v_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_cell_element_get_v_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCellElement::get_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_get_width" webkit_dom_html_table_cell_element_get_width :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    IO CString


dOMHTMLTableCellElementGetWidth ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableCellElementGetWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_cell_element_get_width _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_cell_element_get_width" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableCellElement::set_abbr
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_abbr" webkit_dom_html_table_cell_element_set_abbr :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableCellElementSetAbbr ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableCellElementSetAbbr _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_cell_element_set_abbr _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableCellElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_align" webkit_dom_html_table_cell_element_set_align :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableCellElementSetAlign ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableCellElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_cell_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableCellElement::set_axis
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_axis" webkit_dom_html_table_cell_element_set_axis :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableCellElementSetAxis ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableCellElementSetAxis _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_cell_element_set_axis _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableCellElement::set_bg_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_bg_color" webkit_dom_html_table_cell_element_set_bg_color :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableCellElementSetBgColor ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableCellElementSetBgColor _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_cell_element_set_bg_color _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableCellElement::set_ch
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_ch" webkit_dom_html_table_cell_element_set_ch :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableCellElementSetCh ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableCellElementSetCh _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_cell_element_set_ch _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableCellElement::set_ch_off
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_ch_off" webkit_dom_html_table_cell_element_set_ch_off :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableCellElementSetChOff ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableCellElementSetChOff _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_cell_element_set_ch_off _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableCellElement::set_col_span
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_col_span" webkit_dom_html_table_cell_element_set_col_span :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    Int64 ->                                -- value : TBasicType TInt64
    IO ()


dOMHTMLTableCellElementSetColSpan ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLTableCellElementSetColSpan _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_table_cell_element_set_col_span _obj' value
    touchManagedPtr _obj
    return ()

-- method DOMHTMLTableCellElement::set_headers
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_headers" webkit_dom_html_table_cell_element_set_headers :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableCellElementSetHeaders ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableCellElementSetHeaders _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_cell_element_set_headers _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableCellElement::set_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_height" webkit_dom_html_table_cell_element_set_height :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableCellElementSetHeight ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableCellElementSetHeight _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_cell_element_set_height _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableCellElement::set_no_wrap
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_no_wrap" webkit_dom_html_table_cell_element_set_no_wrap :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLTableCellElementSetNoWrap ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLTableCellElementSetNoWrap _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_table_cell_element_set_no_wrap _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLTableCellElement::set_row_span
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_row_span" webkit_dom_html_table_cell_element_set_row_span :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    Int64 ->                                -- value : TBasicType TInt64
    IO ()


dOMHTMLTableCellElementSetRowSpan ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLTableCellElementSetRowSpan _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_table_cell_element_set_row_span _obj' value
    touchManagedPtr _obj
    return ()

-- method DOMHTMLTableCellElement::set_scope
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_scope" webkit_dom_html_table_cell_element_set_scope :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableCellElementSetScope ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableCellElementSetScope _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_cell_element_set_scope _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableCellElement::set_v_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_v_align" webkit_dom_html_table_cell_element_set_v_align :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableCellElementSetVAlign ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableCellElementSetVAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_cell_element_set_v_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableCellElement::set_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableCellElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_cell_element_set_width" webkit_dom_html_table_cell_element_set_width :: 
    Ptr DOMHTMLTableCellElement ->          -- _obj : TInterface "WebKit" "DOMHTMLTableCellElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableCellElementSetWidth ::
    (MonadIO m, DOMHTMLTableCellElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableCellElementSetWidth _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_cell_element_set_width _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


