
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLTableColElement
    ( 

-- * Exported types
    DOMHTMLTableColElement(..)              ,
    DOMHTMLTableColElementK                 ,
    toDOMHTMLTableColElement                ,
    noDOMHTMLTableColElement                ,


 -- * Methods
-- ** dOMHTMLTableColElementGetAlign
    dOMHTMLTableColElementGetAlign          ,


-- ** dOMHTMLTableColElementGetCh
    dOMHTMLTableColElementGetCh             ,


-- ** dOMHTMLTableColElementGetChOff
    dOMHTMLTableColElementGetChOff          ,


-- ** dOMHTMLTableColElementGetSpan
    dOMHTMLTableColElementGetSpan           ,


-- ** dOMHTMLTableColElementGetVAlign
    dOMHTMLTableColElementGetVAlign         ,


-- ** dOMHTMLTableColElementGetWidth
    dOMHTMLTableColElementGetWidth          ,


-- ** dOMHTMLTableColElementSetAlign
    dOMHTMLTableColElementSetAlign          ,


-- ** dOMHTMLTableColElementSetCh
    dOMHTMLTableColElementSetCh             ,


-- ** dOMHTMLTableColElementSetChOff
    dOMHTMLTableColElementSetChOff          ,


-- ** dOMHTMLTableColElementSetSpan
    dOMHTMLTableColElementSetSpan           ,


-- ** dOMHTMLTableColElementSetVAlign
    dOMHTMLTableColElementSetVAlign         ,


-- ** dOMHTMLTableColElementSetWidth
    dOMHTMLTableColElementSetWidth          ,




 -- * Properties
-- ** Align
    DOMHTMLTableColElementAlignPropertyInfo ,
    constructDOMHTMLTableColElementAlign    ,
    getDOMHTMLTableColElementAlign          ,
    setDOMHTMLTableColElementAlign          ,


-- ** Ch
    DOMHTMLTableColElementChPropertyInfo    ,
    constructDOMHTMLTableColElementCh       ,
    getDOMHTMLTableColElementCh             ,
    setDOMHTMLTableColElementCh             ,


-- ** ChOff
    DOMHTMLTableColElementChOffPropertyInfo ,
    constructDOMHTMLTableColElementChOff    ,
    getDOMHTMLTableColElementChOff          ,
    setDOMHTMLTableColElementChOff          ,


-- ** Span
    DOMHTMLTableColElementSpanPropertyInfo  ,
    constructDOMHTMLTableColElementSpan     ,
    getDOMHTMLTableColElementSpan           ,
    setDOMHTMLTableColElementSpan           ,


-- ** VAlign
    DOMHTMLTableColElementVAlignPropertyInfo,
    constructDOMHTMLTableColElementVAlign   ,
    getDOMHTMLTableColElementVAlign         ,
    setDOMHTMLTableColElementVAlign         ,


-- ** Width
    DOMHTMLTableColElementWidthPropertyInfo ,
    constructDOMHTMLTableColElementWidth    ,
    getDOMHTMLTableColElementWidth          ,
    setDOMHTMLTableColElementWidth          ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLTableColElement = DOMHTMLTableColElement (ForeignPtr DOMHTMLTableColElement)
foreign import ccall "webkit_dom_html_table_col_element_get_type"
    c_webkit_dom_html_table_col_element_get_type :: IO GType

type instance ParentTypes DOMHTMLTableColElement = DOMHTMLTableColElementParentTypes
type DOMHTMLTableColElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLTableColElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_table_col_element_get_type
    

class GObject o => DOMHTMLTableColElementK o
instance (GObject o, IsDescendantOf DOMHTMLTableColElement o) => DOMHTMLTableColElementK o

toDOMHTMLTableColElement :: DOMHTMLTableColElementK o => o -> IO DOMHTMLTableColElement
toDOMHTMLTableColElement = unsafeCastTo DOMHTMLTableColElement

noDOMHTMLTableColElement :: Maybe DOMHTMLTableColElement
noDOMHTMLTableColElement = Nothing

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableColElementAlign :: (MonadIO m, DOMHTMLTableColElementK o) => o -> m T.Text
getDOMHTMLTableColElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLTableColElementAlign :: (MonadIO m, DOMHTMLTableColElementK o) => o -> T.Text -> m ()
setDOMHTMLTableColElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLTableColElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableColElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLTableColElementAlignPropertyInfo
instance AttrInfo DOMHTMLTableColElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLTableColElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableColElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableColElementAlignPropertyInfo = DOMHTMLTableColElementK
    type AttrGetType DOMHTMLTableColElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableColElementAlignPropertyInfo = "DOMHTMLTableColElement::align"
    attrGet _ = getDOMHTMLTableColElementAlign
    attrSet _ = setDOMHTMLTableColElementAlign
    attrConstruct _ = constructDOMHTMLTableColElementAlign

-- VVV Prop "ch"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableColElementCh :: (MonadIO m, DOMHTMLTableColElementK o) => o -> m T.Text
getDOMHTMLTableColElementCh obj = liftIO $ getObjectPropertyString obj "ch"

setDOMHTMLTableColElementCh :: (MonadIO m, DOMHTMLTableColElementK o) => o -> T.Text -> m ()
setDOMHTMLTableColElementCh obj val = liftIO $ setObjectPropertyString obj "ch" val

constructDOMHTMLTableColElementCh :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableColElementCh val = constructObjectPropertyString "ch" val

data DOMHTMLTableColElementChPropertyInfo
instance AttrInfo DOMHTMLTableColElementChPropertyInfo where
    type AttrAllowedOps DOMHTMLTableColElementChPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableColElementChPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableColElementChPropertyInfo = DOMHTMLTableColElementK
    type AttrGetType DOMHTMLTableColElementChPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableColElementChPropertyInfo = "DOMHTMLTableColElement::ch"
    attrGet _ = getDOMHTMLTableColElementCh
    attrSet _ = setDOMHTMLTableColElementCh
    attrConstruct _ = constructDOMHTMLTableColElementCh

-- VVV Prop "ch-off"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableColElementChOff :: (MonadIO m, DOMHTMLTableColElementK o) => o -> m T.Text
getDOMHTMLTableColElementChOff obj = liftIO $ getObjectPropertyString obj "ch-off"

setDOMHTMLTableColElementChOff :: (MonadIO m, DOMHTMLTableColElementK o) => o -> T.Text -> m ()
setDOMHTMLTableColElementChOff obj val = liftIO $ setObjectPropertyString obj "ch-off" val

constructDOMHTMLTableColElementChOff :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableColElementChOff val = constructObjectPropertyString "ch-off" val

data DOMHTMLTableColElementChOffPropertyInfo
instance AttrInfo DOMHTMLTableColElementChOffPropertyInfo where
    type AttrAllowedOps DOMHTMLTableColElementChOffPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableColElementChOffPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableColElementChOffPropertyInfo = DOMHTMLTableColElementK
    type AttrGetType DOMHTMLTableColElementChOffPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableColElementChOffPropertyInfo = "DOMHTMLTableColElement::ch-off"
    attrGet _ = getDOMHTMLTableColElementChOff
    attrSet _ = setDOMHTMLTableColElementChOff
    attrConstruct _ = constructDOMHTMLTableColElementChOff

-- VVV Prop "span"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableColElementSpan :: (MonadIO m, DOMHTMLTableColElementK o) => o -> m Int64
getDOMHTMLTableColElementSpan obj = liftIO $ getObjectPropertyInt64 obj "span"

setDOMHTMLTableColElementSpan :: (MonadIO m, DOMHTMLTableColElementK o) => o -> Int64 -> m ()
setDOMHTMLTableColElementSpan obj val = liftIO $ setObjectPropertyInt64 obj "span" val

constructDOMHTMLTableColElementSpan :: Int64 -> IO ([Char], GValue)
constructDOMHTMLTableColElementSpan val = constructObjectPropertyInt64 "span" val

data DOMHTMLTableColElementSpanPropertyInfo
instance AttrInfo DOMHTMLTableColElementSpanPropertyInfo where
    type AttrAllowedOps DOMHTMLTableColElementSpanPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableColElementSpanPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLTableColElementSpanPropertyInfo = DOMHTMLTableColElementK
    type AttrGetType DOMHTMLTableColElementSpanPropertyInfo = Int64
    type AttrLabel DOMHTMLTableColElementSpanPropertyInfo = "DOMHTMLTableColElement::span"
    attrGet _ = getDOMHTMLTableColElementSpan
    attrSet _ = setDOMHTMLTableColElementSpan
    attrConstruct _ = constructDOMHTMLTableColElementSpan

-- VVV Prop "v-align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableColElementVAlign :: (MonadIO m, DOMHTMLTableColElementK o) => o -> m T.Text
getDOMHTMLTableColElementVAlign obj = liftIO $ getObjectPropertyString obj "v-align"

setDOMHTMLTableColElementVAlign :: (MonadIO m, DOMHTMLTableColElementK o) => o -> T.Text -> m ()
setDOMHTMLTableColElementVAlign obj val = liftIO $ setObjectPropertyString obj "v-align" val

constructDOMHTMLTableColElementVAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableColElementVAlign val = constructObjectPropertyString "v-align" val

data DOMHTMLTableColElementVAlignPropertyInfo
instance AttrInfo DOMHTMLTableColElementVAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLTableColElementVAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableColElementVAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableColElementVAlignPropertyInfo = DOMHTMLTableColElementK
    type AttrGetType DOMHTMLTableColElementVAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableColElementVAlignPropertyInfo = "DOMHTMLTableColElement::v-align"
    attrGet _ = getDOMHTMLTableColElementVAlign
    attrSet _ = setDOMHTMLTableColElementVAlign
    attrConstruct _ = constructDOMHTMLTableColElementVAlign

-- VVV Prop "width"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableColElementWidth :: (MonadIO m, DOMHTMLTableColElementK o) => o -> m T.Text
getDOMHTMLTableColElementWidth obj = liftIO $ getObjectPropertyString obj "width"

setDOMHTMLTableColElementWidth :: (MonadIO m, DOMHTMLTableColElementK o) => o -> T.Text -> m ()
setDOMHTMLTableColElementWidth obj val = liftIO $ setObjectPropertyString obj "width" val

constructDOMHTMLTableColElementWidth :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableColElementWidth val = constructObjectPropertyString "width" val

data DOMHTMLTableColElementWidthPropertyInfo
instance AttrInfo DOMHTMLTableColElementWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLTableColElementWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableColElementWidthPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableColElementWidthPropertyInfo = DOMHTMLTableColElementK
    type AttrGetType DOMHTMLTableColElementWidthPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableColElementWidthPropertyInfo = "DOMHTMLTableColElement::width"
    attrGet _ = getDOMHTMLTableColElementWidth
    attrSet _ = setDOMHTMLTableColElementWidth
    attrConstruct _ = constructDOMHTMLTableColElementWidth

type instance AttributeList DOMHTMLTableColElement = DOMHTMLTableColElementAttributeList
type DOMHTMLTableColElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLTableColElementAlignPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("ch", DOMHTMLTableColElementChPropertyInfo), '("ch-off", DOMHTMLTableColElementChOffPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("span", DOMHTMLTableColElementSpanPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("v-align", DOMHTMLTableColElementVAlignPropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("width", DOMHTMLTableColElementWidthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLTableColElement = DOMHTMLTableColElementSignalList
type DOMHTMLTableColElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLTableColElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_col_element_get_align" webkit_dom_html_table_col_element_get_align :: 
    Ptr DOMHTMLTableColElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableColElement"
    IO CString


dOMHTMLTableColElementGetAlign ::
    (MonadIO m, DOMHTMLTableColElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableColElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_col_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_col_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableColElement::get_ch
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_col_element_get_ch" webkit_dom_html_table_col_element_get_ch :: 
    Ptr DOMHTMLTableColElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableColElement"
    IO CString


dOMHTMLTableColElementGetCh ::
    (MonadIO m, DOMHTMLTableColElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableColElementGetCh _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_col_element_get_ch _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_col_element_get_ch" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableColElement::get_ch_off
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_col_element_get_ch_off" webkit_dom_html_table_col_element_get_ch_off :: 
    Ptr DOMHTMLTableColElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableColElement"
    IO CString


dOMHTMLTableColElementGetChOff ::
    (MonadIO m, DOMHTMLTableColElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableColElementGetChOff _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_col_element_get_ch_off _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_col_element_get_ch_off" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableColElement::get_span
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_col_element_get_span" webkit_dom_html_table_col_element_get_span :: 
    Ptr DOMHTMLTableColElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableColElement"
    IO Int64


dOMHTMLTableColElementGetSpan ::
    (MonadIO m, DOMHTMLTableColElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLTableColElementGetSpan _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_col_element_get_span _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLTableColElement::get_v_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_col_element_get_v_align" webkit_dom_html_table_col_element_get_v_align :: 
    Ptr DOMHTMLTableColElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableColElement"
    IO CString


dOMHTMLTableColElementGetVAlign ::
    (MonadIO m, DOMHTMLTableColElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableColElementGetVAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_col_element_get_v_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_col_element_get_v_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableColElement::get_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_col_element_get_width" webkit_dom_html_table_col_element_get_width :: 
    Ptr DOMHTMLTableColElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableColElement"
    IO CString


dOMHTMLTableColElementGetWidth ::
    (MonadIO m, DOMHTMLTableColElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableColElementGetWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_col_element_get_width _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_col_element_get_width" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableColElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_col_element_set_align" webkit_dom_html_table_col_element_set_align :: 
    Ptr DOMHTMLTableColElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableColElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableColElementSetAlign ::
    (MonadIO m, DOMHTMLTableColElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableColElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_col_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableColElement::set_ch
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_col_element_set_ch" webkit_dom_html_table_col_element_set_ch :: 
    Ptr DOMHTMLTableColElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableColElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableColElementSetCh ::
    (MonadIO m, DOMHTMLTableColElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableColElementSetCh _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_col_element_set_ch _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableColElement::set_ch_off
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_col_element_set_ch_off" webkit_dom_html_table_col_element_set_ch_off :: 
    Ptr DOMHTMLTableColElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableColElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableColElementSetChOff ::
    (MonadIO m, DOMHTMLTableColElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableColElementSetChOff _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_col_element_set_ch_off _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableColElement::set_span
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_col_element_set_span" webkit_dom_html_table_col_element_set_span :: 
    Ptr DOMHTMLTableColElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableColElement"
    Int64 ->                                -- value : TBasicType TInt64
    IO ()


dOMHTMLTableColElementSetSpan ::
    (MonadIO m, DOMHTMLTableColElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLTableColElementSetSpan _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_table_col_element_set_span _obj' value
    touchManagedPtr _obj
    return ()

-- method DOMHTMLTableColElement::set_v_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_col_element_set_v_align" webkit_dom_html_table_col_element_set_v_align :: 
    Ptr DOMHTMLTableColElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableColElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableColElementSetVAlign ::
    (MonadIO m, DOMHTMLTableColElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableColElementSetVAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_col_element_set_v_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableColElement::set_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableColElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_col_element_set_width" webkit_dom_html_table_col_element_set_width :: 
    Ptr DOMHTMLTableColElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableColElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableColElementSetWidth ::
    (MonadIO m, DOMHTMLTableColElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableColElementSetWidth _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_col_element_set_width _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


