
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLTableElement
    ( 

-- * Exported types
    DOMHTMLTableElement(..)                 ,
    DOMHTMLTableElementK                    ,
    toDOMHTMLTableElement                   ,
    noDOMHTMLTableElement                   ,


 -- * Methods
-- ** dOMHTMLTableElementCreateCaption
    dOMHTMLTableElementCreateCaption        ,


-- ** dOMHTMLTableElementCreateTBody
    dOMHTMLTableElementCreateTBody          ,


-- ** dOMHTMLTableElementCreateTFoot
    dOMHTMLTableElementCreateTFoot          ,


-- ** dOMHTMLTableElementCreateTHead
    dOMHTMLTableElementCreateTHead          ,


-- ** dOMHTMLTableElementDeleteCaption
    dOMHTMLTableElementDeleteCaption        ,


-- ** dOMHTMLTableElementDeleteRow
    dOMHTMLTableElementDeleteRow            ,


-- ** dOMHTMLTableElementDeleteTFoot
    dOMHTMLTableElementDeleteTFoot          ,


-- ** dOMHTMLTableElementDeleteTHead
    dOMHTMLTableElementDeleteTHead          ,


-- ** dOMHTMLTableElementGetAlign
    dOMHTMLTableElementGetAlign             ,


-- ** dOMHTMLTableElementGetBgColor
    dOMHTMLTableElementGetBgColor           ,


-- ** dOMHTMLTableElementGetBorder
    dOMHTMLTableElementGetBorder            ,


-- ** dOMHTMLTableElementGetCaption
    dOMHTMLTableElementGetCaption           ,


-- ** dOMHTMLTableElementGetCellPadding
    dOMHTMLTableElementGetCellPadding       ,


-- ** dOMHTMLTableElementGetCellSpacing
    dOMHTMLTableElementGetCellSpacing       ,


-- ** dOMHTMLTableElementGetFrame
    dOMHTMLTableElementGetFrame             ,


-- ** dOMHTMLTableElementGetRows
    dOMHTMLTableElementGetRows              ,


-- ** dOMHTMLTableElementGetRules
    dOMHTMLTableElementGetRules             ,


-- ** dOMHTMLTableElementGetSummary
    dOMHTMLTableElementGetSummary           ,


-- ** dOMHTMLTableElementGetTBodies
    dOMHTMLTableElementGetTBodies           ,


-- ** dOMHTMLTableElementGetTFoot
    dOMHTMLTableElementGetTFoot             ,


-- ** dOMHTMLTableElementGetTHead
    dOMHTMLTableElementGetTHead             ,


-- ** dOMHTMLTableElementGetWidth
    dOMHTMLTableElementGetWidth             ,


-- ** dOMHTMLTableElementInsertRow
    dOMHTMLTableElementInsertRow            ,


-- ** dOMHTMLTableElementSetAlign
    dOMHTMLTableElementSetAlign             ,


-- ** dOMHTMLTableElementSetBgColor
    dOMHTMLTableElementSetBgColor           ,


-- ** dOMHTMLTableElementSetBorder
    dOMHTMLTableElementSetBorder            ,


-- ** dOMHTMLTableElementSetCaption
    dOMHTMLTableElementSetCaption           ,


-- ** dOMHTMLTableElementSetCellPadding
    dOMHTMLTableElementSetCellPadding       ,


-- ** dOMHTMLTableElementSetCellSpacing
    dOMHTMLTableElementSetCellSpacing       ,


-- ** dOMHTMLTableElementSetFrame
    dOMHTMLTableElementSetFrame             ,


-- ** dOMHTMLTableElementSetRules
    dOMHTMLTableElementSetRules             ,


-- ** dOMHTMLTableElementSetSummary
    dOMHTMLTableElementSetSummary           ,


-- ** dOMHTMLTableElementSetTFoot
    dOMHTMLTableElementSetTFoot             ,


-- ** dOMHTMLTableElementSetTHead
    dOMHTMLTableElementSetTHead             ,


-- ** dOMHTMLTableElementSetWidth
    dOMHTMLTableElementSetWidth             ,




 -- * Properties
-- ** Align
    DOMHTMLTableElementAlignPropertyInfo    ,
    constructDOMHTMLTableElementAlign       ,
    getDOMHTMLTableElementAlign             ,
    setDOMHTMLTableElementAlign             ,


-- ** BgColor
    DOMHTMLTableElementBgColorPropertyInfo  ,
    constructDOMHTMLTableElementBgColor     ,
    getDOMHTMLTableElementBgColor           ,
    setDOMHTMLTableElementBgColor           ,


-- ** Border
    DOMHTMLTableElementBorderPropertyInfo   ,
    constructDOMHTMLTableElementBorder      ,
    getDOMHTMLTableElementBorder            ,
    setDOMHTMLTableElementBorder            ,


-- ** Caption
    DOMHTMLTableElementCaptionPropertyInfo  ,
    getDOMHTMLTableElementCaption           ,


-- ** CellPadding
    DOMHTMLTableElementCellPaddingPropertyInfo,
    constructDOMHTMLTableElementCellPadding ,
    getDOMHTMLTableElementCellPadding       ,
    setDOMHTMLTableElementCellPadding       ,


-- ** CellSpacing
    DOMHTMLTableElementCellSpacingPropertyInfo,
    constructDOMHTMLTableElementCellSpacing ,
    getDOMHTMLTableElementCellSpacing       ,
    setDOMHTMLTableElementCellSpacing       ,


-- ** Frame
    DOMHTMLTableElementFramePropertyInfo    ,
    constructDOMHTMLTableElementFrame       ,
    getDOMHTMLTableElementFrame             ,
    setDOMHTMLTableElementFrame             ,


-- ** Rows
    DOMHTMLTableElementRowsPropertyInfo     ,
    getDOMHTMLTableElementRows              ,


-- ** Rules
    DOMHTMLTableElementRulesPropertyInfo    ,
    constructDOMHTMLTableElementRules       ,
    getDOMHTMLTableElementRules             ,
    setDOMHTMLTableElementRules             ,


-- ** Summary
    DOMHTMLTableElementSummaryPropertyInfo  ,
    constructDOMHTMLTableElementSummary     ,
    getDOMHTMLTableElementSummary           ,
    setDOMHTMLTableElementSummary           ,


-- ** TBodies
    DOMHTMLTableElementTBodiesPropertyInfo  ,
    getDOMHTMLTableElementTBodies           ,


-- ** TFoot
    DOMHTMLTableElementTFootPropertyInfo    ,
    getDOMHTMLTableElementTFoot             ,


-- ** THead
    DOMHTMLTableElementTHeadPropertyInfo    ,
    getDOMHTMLTableElementTHead             ,


-- ** Width
    DOMHTMLTableElementWidthPropertyInfo    ,
    constructDOMHTMLTableElementWidth       ,
    getDOMHTMLTableElementWidth             ,
    setDOMHTMLTableElementWidth             ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLTableElement = DOMHTMLTableElement (ForeignPtr DOMHTMLTableElement)
foreign import ccall "webkit_dom_html_table_element_get_type"
    c_webkit_dom_html_table_element_get_type :: IO GType

type instance ParentTypes DOMHTMLTableElement = DOMHTMLTableElementParentTypes
type DOMHTMLTableElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLTableElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_table_element_get_type
    

class GObject o => DOMHTMLTableElementK o
instance (GObject o, IsDescendantOf DOMHTMLTableElement o) => DOMHTMLTableElementK o

toDOMHTMLTableElement :: DOMHTMLTableElementK o => o -> IO DOMHTMLTableElement
toDOMHTMLTableElement = unsafeCastTo DOMHTMLTableElement

noDOMHTMLTableElement :: Maybe DOMHTMLTableElement
noDOMHTMLTableElement = Nothing

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableElementAlign :: (MonadIO m, DOMHTMLTableElementK o) => o -> m T.Text
getDOMHTMLTableElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLTableElementAlign :: (MonadIO m, DOMHTMLTableElementK o) => o -> T.Text -> m ()
setDOMHTMLTableElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLTableElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLTableElementAlignPropertyInfo
instance AttrInfo DOMHTMLTableElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableElementAlignPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableElementAlignPropertyInfo = "DOMHTMLTableElement::align"
    attrGet _ = getDOMHTMLTableElementAlign
    attrSet _ = setDOMHTMLTableElementAlign
    attrConstruct _ = constructDOMHTMLTableElementAlign

-- VVV Prop "bg-color"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableElementBgColor :: (MonadIO m, DOMHTMLTableElementK o) => o -> m T.Text
getDOMHTMLTableElementBgColor obj = liftIO $ getObjectPropertyString obj "bg-color"

setDOMHTMLTableElementBgColor :: (MonadIO m, DOMHTMLTableElementK o) => o -> T.Text -> m ()
setDOMHTMLTableElementBgColor obj val = liftIO $ setObjectPropertyString obj "bg-color" val

constructDOMHTMLTableElementBgColor :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableElementBgColor val = constructObjectPropertyString "bg-color" val

data DOMHTMLTableElementBgColorPropertyInfo
instance AttrInfo DOMHTMLTableElementBgColorPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementBgColorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementBgColorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableElementBgColorPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementBgColorPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableElementBgColorPropertyInfo = "DOMHTMLTableElement::bg-color"
    attrGet _ = getDOMHTMLTableElementBgColor
    attrSet _ = setDOMHTMLTableElementBgColor
    attrConstruct _ = constructDOMHTMLTableElementBgColor

-- VVV Prop "border"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableElementBorder :: (MonadIO m, DOMHTMLTableElementK o) => o -> m T.Text
getDOMHTMLTableElementBorder obj = liftIO $ getObjectPropertyString obj "border"

setDOMHTMLTableElementBorder :: (MonadIO m, DOMHTMLTableElementK o) => o -> T.Text -> m ()
setDOMHTMLTableElementBorder obj val = liftIO $ setObjectPropertyString obj "border" val

constructDOMHTMLTableElementBorder :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableElementBorder val = constructObjectPropertyString "border" val

data DOMHTMLTableElementBorderPropertyInfo
instance AttrInfo DOMHTMLTableElementBorderPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementBorderPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementBorderPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableElementBorderPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementBorderPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableElementBorderPropertyInfo = "DOMHTMLTableElement::border"
    attrGet _ = getDOMHTMLTableElementBorder
    attrSet _ = setDOMHTMLTableElementBorder
    attrConstruct _ = constructDOMHTMLTableElementBorder

-- VVV Prop "caption"
   -- Type: TInterface "WebKit" "DOMHTMLTableCaptionElement"
   -- Flags: [PropertyReadable]

getDOMHTMLTableElementCaption :: (MonadIO m, DOMHTMLTableElementK o) => o -> m DOMHTMLTableCaptionElement
getDOMHTMLTableElementCaption obj = liftIO $ getObjectPropertyObject obj "caption" DOMHTMLTableCaptionElement

data DOMHTMLTableElementCaptionPropertyInfo
instance AttrInfo DOMHTMLTableElementCaptionPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementCaptionPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementCaptionPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLTableElementCaptionPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementCaptionPropertyInfo = DOMHTMLTableCaptionElement
    type AttrLabel DOMHTMLTableElementCaptionPropertyInfo = "DOMHTMLTableElement::caption"
    attrGet _ = getDOMHTMLTableElementCaption
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "cell-padding"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableElementCellPadding :: (MonadIO m, DOMHTMLTableElementK o) => o -> m T.Text
getDOMHTMLTableElementCellPadding obj = liftIO $ getObjectPropertyString obj "cell-padding"

setDOMHTMLTableElementCellPadding :: (MonadIO m, DOMHTMLTableElementK o) => o -> T.Text -> m ()
setDOMHTMLTableElementCellPadding obj val = liftIO $ setObjectPropertyString obj "cell-padding" val

constructDOMHTMLTableElementCellPadding :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableElementCellPadding val = constructObjectPropertyString "cell-padding" val

data DOMHTMLTableElementCellPaddingPropertyInfo
instance AttrInfo DOMHTMLTableElementCellPaddingPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementCellPaddingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementCellPaddingPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableElementCellPaddingPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementCellPaddingPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableElementCellPaddingPropertyInfo = "DOMHTMLTableElement::cell-padding"
    attrGet _ = getDOMHTMLTableElementCellPadding
    attrSet _ = setDOMHTMLTableElementCellPadding
    attrConstruct _ = constructDOMHTMLTableElementCellPadding

-- VVV Prop "cell-spacing"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableElementCellSpacing :: (MonadIO m, DOMHTMLTableElementK o) => o -> m T.Text
getDOMHTMLTableElementCellSpacing obj = liftIO $ getObjectPropertyString obj "cell-spacing"

setDOMHTMLTableElementCellSpacing :: (MonadIO m, DOMHTMLTableElementK o) => o -> T.Text -> m ()
setDOMHTMLTableElementCellSpacing obj val = liftIO $ setObjectPropertyString obj "cell-spacing" val

constructDOMHTMLTableElementCellSpacing :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableElementCellSpacing val = constructObjectPropertyString "cell-spacing" val

data DOMHTMLTableElementCellSpacingPropertyInfo
instance AttrInfo DOMHTMLTableElementCellSpacingPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementCellSpacingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementCellSpacingPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableElementCellSpacingPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementCellSpacingPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableElementCellSpacingPropertyInfo = "DOMHTMLTableElement::cell-spacing"
    attrGet _ = getDOMHTMLTableElementCellSpacing
    attrSet _ = setDOMHTMLTableElementCellSpacing
    attrConstruct _ = constructDOMHTMLTableElementCellSpacing

-- VVV Prop "frame"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableElementFrame :: (MonadIO m, DOMHTMLTableElementK o) => o -> m T.Text
getDOMHTMLTableElementFrame obj = liftIO $ getObjectPropertyString obj "frame"

setDOMHTMLTableElementFrame :: (MonadIO m, DOMHTMLTableElementK o) => o -> T.Text -> m ()
setDOMHTMLTableElementFrame obj val = liftIO $ setObjectPropertyString obj "frame" val

constructDOMHTMLTableElementFrame :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableElementFrame val = constructObjectPropertyString "frame" val

data DOMHTMLTableElementFramePropertyInfo
instance AttrInfo DOMHTMLTableElementFramePropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementFramePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementFramePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableElementFramePropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementFramePropertyInfo = T.Text
    type AttrLabel DOMHTMLTableElementFramePropertyInfo = "DOMHTMLTableElement::frame"
    attrGet _ = getDOMHTMLTableElementFrame
    attrSet _ = setDOMHTMLTableElementFrame
    attrConstruct _ = constructDOMHTMLTableElementFrame

-- VVV Prop "rows"
   -- Type: TInterface "WebKit" "DOMHTMLCollection"
   -- Flags: [PropertyReadable]

getDOMHTMLTableElementRows :: (MonadIO m, DOMHTMLTableElementK o) => o -> m DOMHTMLCollection
getDOMHTMLTableElementRows obj = liftIO $ getObjectPropertyObject obj "rows" DOMHTMLCollection

data DOMHTMLTableElementRowsPropertyInfo
instance AttrInfo DOMHTMLTableElementRowsPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementRowsPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementRowsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLTableElementRowsPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementRowsPropertyInfo = DOMHTMLCollection
    type AttrLabel DOMHTMLTableElementRowsPropertyInfo = "DOMHTMLTableElement::rows"
    attrGet _ = getDOMHTMLTableElementRows
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "rules"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableElementRules :: (MonadIO m, DOMHTMLTableElementK o) => o -> m T.Text
getDOMHTMLTableElementRules obj = liftIO $ getObjectPropertyString obj "rules"

setDOMHTMLTableElementRules :: (MonadIO m, DOMHTMLTableElementK o) => o -> T.Text -> m ()
setDOMHTMLTableElementRules obj val = liftIO $ setObjectPropertyString obj "rules" val

constructDOMHTMLTableElementRules :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableElementRules val = constructObjectPropertyString "rules" val

data DOMHTMLTableElementRulesPropertyInfo
instance AttrInfo DOMHTMLTableElementRulesPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementRulesPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementRulesPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableElementRulesPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementRulesPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableElementRulesPropertyInfo = "DOMHTMLTableElement::rules"
    attrGet _ = getDOMHTMLTableElementRules
    attrSet _ = setDOMHTMLTableElementRules
    attrConstruct _ = constructDOMHTMLTableElementRules

-- VVV Prop "summary"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableElementSummary :: (MonadIO m, DOMHTMLTableElementK o) => o -> m T.Text
getDOMHTMLTableElementSummary obj = liftIO $ getObjectPropertyString obj "summary"

setDOMHTMLTableElementSummary :: (MonadIO m, DOMHTMLTableElementK o) => o -> T.Text -> m ()
setDOMHTMLTableElementSummary obj val = liftIO $ setObjectPropertyString obj "summary" val

constructDOMHTMLTableElementSummary :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableElementSummary val = constructObjectPropertyString "summary" val

data DOMHTMLTableElementSummaryPropertyInfo
instance AttrInfo DOMHTMLTableElementSummaryPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementSummaryPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementSummaryPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableElementSummaryPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementSummaryPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableElementSummaryPropertyInfo = "DOMHTMLTableElement::summary"
    attrGet _ = getDOMHTMLTableElementSummary
    attrSet _ = setDOMHTMLTableElementSummary
    attrConstruct _ = constructDOMHTMLTableElementSummary

-- VVV Prop "t-bodies"
   -- Type: TInterface "WebKit" "DOMHTMLCollection"
   -- Flags: [PropertyReadable]

getDOMHTMLTableElementTBodies :: (MonadIO m, DOMHTMLTableElementK o) => o -> m DOMHTMLCollection
getDOMHTMLTableElementTBodies obj = liftIO $ getObjectPropertyObject obj "t-bodies" DOMHTMLCollection

data DOMHTMLTableElementTBodiesPropertyInfo
instance AttrInfo DOMHTMLTableElementTBodiesPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementTBodiesPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementTBodiesPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLTableElementTBodiesPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementTBodiesPropertyInfo = DOMHTMLCollection
    type AttrLabel DOMHTMLTableElementTBodiesPropertyInfo = "DOMHTMLTableElement::t-bodies"
    attrGet _ = getDOMHTMLTableElementTBodies
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "t-foot"
   -- Type: TInterface "WebKit" "DOMHTMLTableSectionElement"
   -- Flags: [PropertyReadable]

getDOMHTMLTableElementTFoot :: (MonadIO m, DOMHTMLTableElementK o) => o -> m DOMHTMLTableSectionElement
getDOMHTMLTableElementTFoot obj = liftIO $ getObjectPropertyObject obj "t-foot" DOMHTMLTableSectionElement

data DOMHTMLTableElementTFootPropertyInfo
instance AttrInfo DOMHTMLTableElementTFootPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementTFootPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementTFootPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLTableElementTFootPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementTFootPropertyInfo = DOMHTMLTableSectionElement
    type AttrLabel DOMHTMLTableElementTFootPropertyInfo = "DOMHTMLTableElement::t-foot"
    attrGet _ = getDOMHTMLTableElementTFoot
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "t-head"
   -- Type: TInterface "WebKit" "DOMHTMLTableSectionElement"
   -- Flags: [PropertyReadable]

getDOMHTMLTableElementTHead :: (MonadIO m, DOMHTMLTableElementK o) => o -> m DOMHTMLTableSectionElement
getDOMHTMLTableElementTHead obj = liftIO $ getObjectPropertyObject obj "t-head" DOMHTMLTableSectionElement

data DOMHTMLTableElementTHeadPropertyInfo
instance AttrInfo DOMHTMLTableElementTHeadPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementTHeadPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementTHeadPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLTableElementTHeadPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementTHeadPropertyInfo = DOMHTMLTableSectionElement
    type AttrLabel DOMHTMLTableElementTHeadPropertyInfo = "DOMHTMLTableElement::t-head"
    attrGet _ = getDOMHTMLTableElementTHead
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "width"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableElementWidth :: (MonadIO m, DOMHTMLTableElementK o) => o -> m T.Text
getDOMHTMLTableElementWidth obj = liftIO $ getObjectPropertyString obj "width"

setDOMHTMLTableElementWidth :: (MonadIO m, DOMHTMLTableElementK o) => o -> T.Text -> m ()
setDOMHTMLTableElementWidth obj val = liftIO $ setObjectPropertyString obj "width" val

constructDOMHTMLTableElementWidth :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableElementWidth val = constructObjectPropertyString "width" val

data DOMHTMLTableElementWidthPropertyInfo
instance AttrInfo DOMHTMLTableElementWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLTableElementWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableElementWidthPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableElementWidthPropertyInfo = DOMHTMLTableElementK
    type AttrGetType DOMHTMLTableElementWidthPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableElementWidthPropertyInfo = "DOMHTMLTableElement::width"
    attrGet _ = getDOMHTMLTableElementWidth
    attrSet _ = setDOMHTMLTableElementWidth
    attrConstruct _ = constructDOMHTMLTableElementWidth

type instance AttributeList DOMHTMLTableElement = DOMHTMLTableElementAttributeList
type DOMHTMLTableElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLTableElementAlignPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("bg-color", DOMHTMLTableElementBgColorPropertyInfo), '("border", DOMHTMLTableElementBorderPropertyInfo), '("caption", DOMHTMLTableElementCaptionPropertyInfo), '("cell-padding", DOMHTMLTableElementCellPaddingPropertyInfo), '("cell-spacing", DOMHTMLTableElementCellSpacingPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("frame", DOMHTMLTableElementFramePropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("rows", DOMHTMLTableElementRowsPropertyInfo), '("rules", DOMHTMLTableElementRulesPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("summary", DOMHTMLTableElementSummaryPropertyInfo), '("t-bodies", DOMHTMLTableElementTBodiesPropertyInfo), '("t-foot", DOMHTMLTableElementTFootPropertyInfo), '("t-head", DOMHTMLTableElementTHeadPropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("width", DOMHTMLTableElementWidthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLTableElement = DOMHTMLTableElementSignalList
type DOMHTMLTableElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLTableElement::create_caption
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_create_caption" webkit_dom_html_table_element_create_caption :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO (Ptr DOMHTMLElement)


dOMHTMLTableElementCreateCaption ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLElement
dOMHTMLTableElementCreateCaption _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_create_caption _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_create_caption" result
    result' <- (newObject DOMHTMLElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::create_t_body
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_create_t_body" webkit_dom_html_table_element_create_t_body :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO (Ptr DOMHTMLElement)


dOMHTMLTableElementCreateTBody ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLElement
dOMHTMLTableElementCreateTBody _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_create_t_body _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_create_t_body" result
    result' <- (newObject DOMHTMLElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::create_t_foot
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_create_t_foot" webkit_dom_html_table_element_create_t_foot :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO (Ptr DOMHTMLElement)


dOMHTMLTableElementCreateTFoot ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLElement
dOMHTMLTableElementCreateTFoot _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_create_t_foot _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_create_t_foot" result
    result' <- (newObject DOMHTMLElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::create_t_head
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_create_t_head" webkit_dom_html_table_element_create_t_head :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO (Ptr DOMHTMLElement)


dOMHTMLTableElementCreateTHead ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLElement
dOMHTMLTableElementCreateTHead _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_create_t_head _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_create_t_head" result
    result' <- (newObject DOMHTMLElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::delete_caption
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_delete_caption" webkit_dom_html_table_element_delete_caption :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO ()


dOMHTMLTableElementDeleteCaption ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLTableElementDeleteCaption _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_table_element_delete_caption _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLTableElement::delete_row
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_delete_row" webkit_dom_html_table_element_delete_row :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    Int64 ->                                -- index : TBasicType TInt64
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLTableElementDeleteRow ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- index
    m ()
dOMHTMLTableElementDeleteRow _obj index = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        propagateGError $ webkit_dom_html_table_element_delete_row _obj' index
        touchManagedPtr _obj
        return ()
     ) (do
        return ()
     )

-- method DOMHTMLTableElement::delete_t_foot
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_delete_t_foot" webkit_dom_html_table_element_delete_t_foot :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO ()


dOMHTMLTableElementDeleteTFoot ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLTableElementDeleteTFoot _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_table_element_delete_t_foot _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLTableElement::delete_t_head
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_delete_t_head" webkit_dom_html_table_element_delete_t_head :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO ()


dOMHTMLTableElementDeleteTHead ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLTableElementDeleteTHead _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_table_element_delete_t_head _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLTableElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_align" webkit_dom_html_table_element_get_align :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO CString


dOMHTMLTableElementGetAlign ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_bg_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_bg_color" webkit_dom_html_table_element_get_bg_color :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO CString


dOMHTMLTableElementGetBgColor ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableElementGetBgColor _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_bg_color _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_bg_color" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_border
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_border" webkit_dom_html_table_element_get_border :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO CString


dOMHTMLTableElementGetBorder ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableElementGetBorder _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_border _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_border" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_caption
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLTableCaptionElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_caption" webkit_dom_html_table_element_get_caption :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO (Ptr DOMHTMLTableCaptionElement)


dOMHTMLTableElementGetCaption ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLTableCaptionElement
dOMHTMLTableElementGetCaption _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_caption _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_caption" result
    result' <- (newObject DOMHTMLTableCaptionElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_cell_padding
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_cell_padding" webkit_dom_html_table_element_get_cell_padding :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO CString


dOMHTMLTableElementGetCellPadding ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableElementGetCellPadding _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_cell_padding _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_cell_padding" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_cell_spacing
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_cell_spacing" webkit_dom_html_table_element_get_cell_spacing :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO CString


dOMHTMLTableElementGetCellSpacing ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableElementGetCellSpacing _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_cell_spacing _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_cell_spacing" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_frame
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_frame" webkit_dom_html_table_element_get_frame :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO CString


dOMHTMLTableElementGetFrame ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableElementGetFrame _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_frame _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_frame" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_rows
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLCollection"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_rows" webkit_dom_html_table_element_get_rows :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO (Ptr DOMHTMLCollection)


dOMHTMLTableElementGetRows ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLCollection
dOMHTMLTableElementGetRows _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_rows _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_rows" result
    result' <- (wrapObject DOMHTMLCollection) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_rules
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_rules" webkit_dom_html_table_element_get_rules :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO CString


dOMHTMLTableElementGetRules ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableElementGetRules _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_rules _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_rules" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_summary
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_summary" webkit_dom_html_table_element_get_summary :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO CString


dOMHTMLTableElementGetSummary ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableElementGetSummary _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_summary _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_summary" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_t_bodies
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLCollection"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_t_bodies" webkit_dom_html_table_element_get_t_bodies :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO (Ptr DOMHTMLCollection)


dOMHTMLTableElementGetTBodies ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLCollection
dOMHTMLTableElementGetTBodies _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_t_bodies _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_t_bodies" result
    result' <- (wrapObject DOMHTMLCollection) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_t_foot
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLTableSectionElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_t_foot" webkit_dom_html_table_element_get_t_foot :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO (Ptr DOMHTMLTableSectionElement)


dOMHTMLTableElementGetTFoot ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLTableSectionElement
dOMHTMLTableElementGetTFoot _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_t_foot _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_t_foot" result
    result' <- (newObject DOMHTMLTableSectionElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_t_head
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLTableSectionElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_t_head" webkit_dom_html_table_element_get_t_head :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO (Ptr DOMHTMLTableSectionElement)


dOMHTMLTableElementGetTHead ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLTableSectionElement
dOMHTMLTableElementGetTHead _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_t_head _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_t_head" result
    result' <- (newObject DOMHTMLTableSectionElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::get_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_get_width" webkit_dom_html_table_element_get_width :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    IO CString


dOMHTMLTableElementGetWidth ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableElementGetWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_element_get_width _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_element_get_width" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableElement::insert_row
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLElement"
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_insert_row" webkit_dom_html_table_element_insert_row :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    Int64 ->                                -- index : TBasicType TInt64
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr DOMHTMLElement)


dOMHTMLTableElementInsertRow ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- index
    m DOMHTMLElement
dOMHTMLTableElementInsertRow _obj index = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        result <- propagateGError $ webkit_dom_html_table_element_insert_row _obj' index
        checkUnexpectedReturnNULL "webkit_dom_html_table_element_insert_row" result
        result' <- (newObject DOMHTMLElement) result
        touchManagedPtr _obj
        return result'
     ) (do
        return ()
     )

-- method DOMHTMLTableElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_set_align" webkit_dom_html_table_element_set_align :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableElementSetAlign ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableElement::set_bg_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_set_bg_color" webkit_dom_html_table_element_set_bg_color :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableElementSetBgColor ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableElementSetBgColor _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_element_set_bg_color _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableElement::set_border
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_set_border" webkit_dom_html_table_element_set_border :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableElementSetBorder ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableElementSetBorder _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_element_set_border _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableElement::set_caption
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TInterface "WebKit" "DOMHTMLTableCaptionElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TInterface "WebKit" "DOMHTMLTableCaptionElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_set_caption" webkit_dom_html_table_element_set_caption :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    Ptr DOMHTMLTableCaptionElement ->       -- value : TInterface "WebKit" "DOMHTMLTableCaptionElement"
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLTableElementSetCaption ::
    (MonadIO m, DOMHTMLTableElementK a, DOMHTMLTableCaptionElementK b) =>
    a ->                                    -- _obj
    b ->                                    -- value
    m ()
dOMHTMLTableElementSetCaption _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = unsafeManagedPtrCastPtr value
    onException (do
        propagateGError $ webkit_dom_html_table_element_set_caption _obj' value'
        touchManagedPtr _obj
        touchManagedPtr value
        return ()
     ) (do
        return ()
     )

-- method DOMHTMLTableElement::set_cell_padding
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_set_cell_padding" webkit_dom_html_table_element_set_cell_padding :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableElementSetCellPadding ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableElementSetCellPadding _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_element_set_cell_padding _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableElement::set_cell_spacing
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_set_cell_spacing" webkit_dom_html_table_element_set_cell_spacing :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableElementSetCellSpacing ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableElementSetCellSpacing _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_element_set_cell_spacing _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableElement::set_frame
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_set_frame" webkit_dom_html_table_element_set_frame :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableElementSetFrame ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableElementSetFrame _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_element_set_frame _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableElement::set_rules
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_set_rules" webkit_dom_html_table_element_set_rules :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableElementSetRules ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableElementSetRules _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_element_set_rules _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableElement::set_summary
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_set_summary" webkit_dom_html_table_element_set_summary :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableElementSetSummary ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableElementSetSummary _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_element_set_summary _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableElement::set_t_foot
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TInterface "WebKit" "DOMHTMLTableSectionElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TInterface "WebKit" "DOMHTMLTableSectionElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_set_t_foot" webkit_dom_html_table_element_set_t_foot :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    Ptr DOMHTMLTableSectionElement ->       -- value : TInterface "WebKit" "DOMHTMLTableSectionElement"
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLTableElementSetTFoot ::
    (MonadIO m, DOMHTMLTableElementK a, DOMHTMLTableSectionElementK b) =>
    a ->                                    -- _obj
    b ->                                    -- value
    m ()
dOMHTMLTableElementSetTFoot _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = unsafeManagedPtrCastPtr value
    onException (do
        propagateGError $ webkit_dom_html_table_element_set_t_foot _obj' value'
        touchManagedPtr _obj
        touchManagedPtr value
        return ()
     ) (do
        return ()
     )

-- method DOMHTMLTableElement::set_t_head
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TInterface "WebKit" "DOMHTMLTableSectionElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TInterface "WebKit" "DOMHTMLTableSectionElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_set_t_head" webkit_dom_html_table_element_set_t_head :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    Ptr DOMHTMLTableSectionElement ->       -- value : TInterface "WebKit" "DOMHTMLTableSectionElement"
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLTableElementSetTHead ::
    (MonadIO m, DOMHTMLTableElementK a, DOMHTMLTableSectionElementK b) =>
    a ->                                    -- _obj
    b ->                                    -- value
    m ()
dOMHTMLTableElementSetTHead _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = unsafeManagedPtrCastPtr value
    onException (do
        propagateGError $ webkit_dom_html_table_element_set_t_head _obj' value'
        touchManagedPtr _obj
        touchManagedPtr value
        return ()
     ) (do
        return ()
     )

-- method DOMHTMLTableElement::set_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_element_set_width" webkit_dom_html_table_element_set_width :: 
    Ptr DOMHTMLTableElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTableElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableElementSetWidth ::
    (MonadIO m, DOMHTMLTableElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableElementSetWidth _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_element_set_width _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


