
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLTableRowElement
    ( 

-- * Exported types
    DOMHTMLTableRowElement(..)              ,
    DOMHTMLTableRowElementK                 ,
    toDOMHTMLTableRowElement                ,
    noDOMHTMLTableRowElement                ,


 -- * Methods
-- ** dOMHTMLTableRowElementDeleteCell
    dOMHTMLTableRowElementDeleteCell        ,


-- ** dOMHTMLTableRowElementGetAlign
    dOMHTMLTableRowElementGetAlign          ,


-- ** dOMHTMLTableRowElementGetBgColor
    dOMHTMLTableRowElementGetBgColor        ,


-- ** dOMHTMLTableRowElementGetCells
    dOMHTMLTableRowElementGetCells          ,


-- ** dOMHTMLTableRowElementGetCh
    dOMHTMLTableRowElementGetCh             ,


-- ** dOMHTMLTableRowElementGetChOff
    dOMHTMLTableRowElementGetChOff          ,


-- ** dOMHTMLTableRowElementGetRowIndex
    dOMHTMLTableRowElementGetRowIndex       ,


-- ** dOMHTMLTableRowElementGetSectionRowIndex
    dOMHTMLTableRowElementGetSectionRowIndex,


-- ** dOMHTMLTableRowElementGetVAlign
    dOMHTMLTableRowElementGetVAlign         ,


-- ** dOMHTMLTableRowElementInsertCell
    dOMHTMLTableRowElementInsertCell        ,


-- ** dOMHTMLTableRowElementSetAlign
    dOMHTMLTableRowElementSetAlign          ,


-- ** dOMHTMLTableRowElementSetBgColor
    dOMHTMLTableRowElementSetBgColor        ,


-- ** dOMHTMLTableRowElementSetCh
    dOMHTMLTableRowElementSetCh             ,


-- ** dOMHTMLTableRowElementSetChOff
    dOMHTMLTableRowElementSetChOff          ,


-- ** dOMHTMLTableRowElementSetVAlign
    dOMHTMLTableRowElementSetVAlign         ,




 -- * Properties
-- ** Align
    DOMHTMLTableRowElementAlignPropertyInfo ,
    constructDOMHTMLTableRowElementAlign    ,
    getDOMHTMLTableRowElementAlign          ,
    setDOMHTMLTableRowElementAlign          ,


-- ** BgColor
    DOMHTMLTableRowElementBgColorPropertyInfo,
    constructDOMHTMLTableRowElementBgColor  ,
    getDOMHTMLTableRowElementBgColor        ,
    setDOMHTMLTableRowElementBgColor        ,


-- ** Cells
    DOMHTMLTableRowElementCellsPropertyInfo ,
    getDOMHTMLTableRowElementCells          ,


-- ** Ch
    DOMHTMLTableRowElementChPropertyInfo    ,
    constructDOMHTMLTableRowElementCh       ,
    getDOMHTMLTableRowElementCh             ,
    setDOMHTMLTableRowElementCh             ,


-- ** ChOff
    DOMHTMLTableRowElementChOffPropertyInfo ,
    constructDOMHTMLTableRowElementChOff    ,
    getDOMHTMLTableRowElementChOff          ,
    setDOMHTMLTableRowElementChOff          ,


-- ** RowIndex
    DOMHTMLTableRowElementRowIndexPropertyInfo,
    getDOMHTMLTableRowElementRowIndex       ,


-- ** SectionRowIndex
    DOMHTMLTableRowElementSectionRowIndexPropertyInfo,
    getDOMHTMLTableRowElementSectionRowIndex,


-- ** VAlign
    DOMHTMLTableRowElementVAlignPropertyInfo,
    constructDOMHTMLTableRowElementVAlign   ,
    getDOMHTMLTableRowElementVAlign         ,
    setDOMHTMLTableRowElementVAlign         ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLTableRowElement = DOMHTMLTableRowElement (ForeignPtr DOMHTMLTableRowElement)
foreign import ccall "webkit_dom_html_table_row_element_get_type"
    c_webkit_dom_html_table_row_element_get_type :: IO GType

type instance ParentTypes DOMHTMLTableRowElement = DOMHTMLTableRowElementParentTypes
type DOMHTMLTableRowElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLTableRowElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_table_row_element_get_type
    

class GObject o => DOMHTMLTableRowElementK o
instance (GObject o, IsDescendantOf DOMHTMLTableRowElement o) => DOMHTMLTableRowElementK o

toDOMHTMLTableRowElement :: DOMHTMLTableRowElementK o => o -> IO DOMHTMLTableRowElement
toDOMHTMLTableRowElement = unsafeCastTo DOMHTMLTableRowElement

noDOMHTMLTableRowElement :: Maybe DOMHTMLTableRowElement
noDOMHTMLTableRowElement = Nothing

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableRowElementAlign :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> m T.Text
getDOMHTMLTableRowElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLTableRowElementAlign :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> T.Text -> m ()
setDOMHTMLTableRowElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLTableRowElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableRowElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLTableRowElementAlignPropertyInfo
instance AttrInfo DOMHTMLTableRowElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLTableRowElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableRowElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableRowElementAlignPropertyInfo = DOMHTMLTableRowElementK
    type AttrGetType DOMHTMLTableRowElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableRowElementAlignPropertyInfo = "DOMHTMLTableRowElement::align"
    attrGet _ = getDOMHTMLTableRowElementAlign
    attrSet _ = setDOMHTMLTableRowElementAlign
    attrConstruct _ = constructDOMHTMLTableRowElementAlign

-- VVV Prop "bg-color"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableRowElementBgColor :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> m T.Text
getDOMHTMLTableRowElementBgColor obj = liftIO $ getObjectPropertyString obj "bg-color"

setDOMHTMLTableRowElementBgColor :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> T.Text -> m ()
setDOMHTMLTableRowElementBgColor obj val = liftIO $ setObjectPropertyString obj "bg-color" val

constructDOMHTMLTableRowElementBgColor :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableRowElementBgColor val = constructObjectPropertyString "bg-color" val

data DOMHTMLTableRowElementBgColorPropertyInfo
instance AttrInfo DOMHTMLTableRowElementBgColorPropertyInfo where
    type AttrAllowedOps DOMHTMLTableRowElementBgColorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableRowElementBgColorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableRowElementBgColorPropertyInfo = DOMHTMLTableRowElementK
    type AttrGetType DOMHTMLTableRowElementBgColorPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableRowElementBgColorPropertyInfo = "DOMHTMLTableRowElement::bg-color"
    attrGet _ = getDOMHTMLTableRowElementBgColor
    attrSet _ = setDOMHTMLTableRowElementBgColor
    attrConstruct _ = constructDOMHTMLTableRowElementBgColor

-- VVV Prop "cells"
   -- Type: TInterface "WebKit" "DOMHTMLCollection"
   -- Flags: [PropertyReadable]

getDOMHTMLTableRowElementCells :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> m DOMHTMLCollection
getDOMHTMLTableRowElementCells obj = liftIO $ getObjectPropertyObject obj "cells" DOMHTMLCollection

data DOMHTMLTableRowElementCellsPropertyInfo
instance AttrInfo DOMHTMLTableRowElementCellsPropertyInfo where
    type AttrAllowedOps DOMHTMLTableRowElementCellsPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableRowElementCellsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLTableRowElementCellsPropertyInfo = DOMHTMLTableRowElementK
    type AttrGetType DOMHTMLTableRowElementCellsPropertyInfo = DOMHTMLCollection
    type AttrLabel DOMHTMLTableRowElementCellsPropertyInfo = "DOMHTMLTableRowElement::cells"
    attrGet _ = getDOMHTMLTableRowElementCells
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "ch"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableRowElementCh :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> m T.Text
getDOMHTMLTableRowElementCh obj = liftIO $ getObjectPropertyString obj "ch"

setDOMHTMLTableRowElementCh :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> T.Text -> m ()
setDOMHTMLTableRowElementCh obj val = liftIO $ setObjectPropertyString obj "ch" val

constructDOMHTMLTableRowElementCh :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableRowElementCh val = constructObjectPropertyString "ch" val

data DOMHTMLTableRowElementChPropertyInfo
instance AttrInfo DOMHTMLTableRowElementChPropertyInfo where
    type AttrAllowedOps DOMHTMLTableRowElementChPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableRowElementChPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableRowElementChPropertyInfo = DOMHTMLTableRowElementK
    type AttrGetType DOMHTMLTableRowElementChPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableRowElementChPropertyInfo = "DOMHTMLTableRowElement::ch"
    attrGet _ = getDOMHTMLTableRowElementCh
    attrSet _ = setDOMHTMLTableRowElementCh
    attrConstruct _ = constructDOMHTMLTableRowElementCh

-- VVV Prop "ch-off"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableRowElementChOff :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> m T.Text
getDOMHTMLTableRowElementChOff obj = liftIO $ getObjectPropertyString obj "ch-off"

setDOMHTMLTableRowElementChOff :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> T.Text -> m ()
setDOMHTMLTableRowElementChOff obj val = liftIO $ setObjectPropertyString obj "ch-off" val

constructDOMHTMLTableRowElementChOff :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableRowElementChOff val = constructObjectPropertyString "ch-off" val

data DOMHTMLTableRowElementChOffPropertyInfo
instance AttrInfo DOMHTMLTableRowElementChOffPropertyInfo where
    type AttrAllowedOps DOMHTMLTableRowElementChOffPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableRowElementChOffPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableRowElementChOffPropertyInfo = DOMHTMLTableRowElementK
    type AttrGetType DOMHTMLTableRowElementChOffPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableRowElementChOffPropertyInfo = "DOMHTMLTableRowElement::ch-off"
    attrGet _ = getDOMHTMLTableRowElementChOff
    attrSet _ = setDOMHTMLTableRowElementChOff
    attrConstruct _ = constructDOMHTMLTableRowElementChOff

-- VVV Prop "row-index"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable]

getDOMHTMLTableRowElementRowIndex :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> m Int64
getDOMHTMLTableRowElementRowIndex obj = liftIO $ getObjectPropertyInt64 obj "row-index"

data DOMHTMLTableRowElementRowIndexPropertyInfo
instance AttrInfo DOMHTMLTableRowElementRowIndexPropertyInfo where
    type AttrAllowedOps DOMHTMLTableRowElementRowIndexPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableRowElementRowIndexPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLTableRowElementRowIndexPropertyInfo = DOMHTMLTableRowElementK
    type AttrGetType DOMHTMLTableRowElementRowIndexPropertyInfo = Int64
    type AttrLabel DOMHTMLTableRowElementRowIndexPropertyInfo = "DOMHTMLTableRowElement::row-index"
    attrGet _ = getDOMHTMLTableRowElementRowIndex
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "section-row-index"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable]

getDOMHTMLTableRowElementSectionRowIndex :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> m Int64
getDOMHTMLTableRowElementSectionRowIndex obj = liftIO $ getObjectPropertyInt64 obj "section-row-index"

data DOMHTMLTableRowElementSectionRowIndexPropertyInfo
instance AttrInfo DOMHTMLTableRowElementSectionRowIndexPropertyInfo where
    type AttrAllowedOps DOMHTMLTableRowElementSectionRowIndexPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableRowElementSectionRowIndexPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLTableRowElementSectionRowIndexPropertyInfo = DOMHTMLTableRowElementK
    type AttrGetType DOMHTMLTableRowElementSectionRowIndexPropertyInfo = Int64
    type AttrLabel DOMHTMLTableRowElementSectionRowIndexPropertyInfo = "DOMHTMLTableRowElement::section-row-index"
    attrGet _ = getDOMHTMLTableRowElementSectionRowIndex
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "v-align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTableRowElementVAlign :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> m T.Text
getDOMHTMLTableRowElementVAlign obj = liftIO $ getObjectPropertyString obj "v-align"

setDOMHTMLTableRowElementVAlign :: (MonadIO m, DOMHTMLTableRowElementK o) => o -> T.Text -> m ()
setDOMHTMLTableRowElementVAlign obj val = liftIO $ setObjectPropertyString obj "v-align" val

constructDOMHTMLTableRowElementVAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTableRowElementVAlign val = constructObjectPropertyString "v-align" val

data DOMHTMLTableRowElementVAlignPropertyInfo
instance AttrInfo DOMHTMLTableRowElementVAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLTableRowElementVAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTableRowElementVAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTableRowElementVAlignPropertyInfo = DOMHTMLTableRowElementK
    type AttrGetType DOMHTMLTableRowElementVAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLTableRowElementVAlignPropertyInfo = "DOMHTMLTableRowElement::v-align"
    attrGet _ = getDOMHTMLTableRowElementVAlign
    attrSet _ = setDOMHTMLTableRowElementVAlign
    attrConstruct _ = constructDOMHTMLTableRowElementVAlign

type instance AttributeList DOMHTMLTableRowElement = DOMHTMLTableRowElementAttributeList
type DOMHTMLTableRowElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLTableRowElementAlignPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("bg-color", DOMHTMLTableRowElementBgColorPropertyInfo), '("cells", DOMHTMLTableRowElementCellsPropertyInfo), '("ch", DOMHTMLTableRowElementChPropertyInfo), '("ch-off", DOMHTMLTableRowElementChOffPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("row-index", DOMHTMLTableRowElementRowIndexPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("section-row-index", DOMHTMLTableRowElementSectionRowIndexPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("v-align", DOMHTMLTableRowElementVAlignPropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLTableRowElement = DOMHTMLTableRowElementSignalList
type DOMHTMLTableRowElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLTableRowElement::delete_cell
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_delete_cell" webkit_dom_html_table_row_element_delete_cell :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    Int64 ->                                -- index : TBasicType TInt64
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLTableRowElementDeleteCell ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- index
    m ()
dOMHTMLTableRowElementDeleteCell _obj index = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        propagateGError $ webkit_dom_html_table_row_element_delete_cell _obj' index
        touchManagedPtr _obj
        return ()
     ) (do
        return ()
     )

-- method DOMHTMLTableRowElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_get_align" webkit_dom_html_table_row_element_get_align :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    IO CString


dOMHTMLTableRowElementGetAlign ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableRowElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_row_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_row_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableRowElement::get_bg_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_get_bg_color" webkit_dom_html_table_row_element_get_bg_color :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    IO CString


dOMHTMLTableRowElementGetBgColor ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableRowElementGetBgColor _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_row_element_get_bg_color _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_row_element_get_bg_color" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableRowElement::get_cells
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLCollection"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_get_cells" webkit_dom_html_table_row_element_get_cells :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    IO (Ptr DOMHTMLCollection)


dOMHTMLTableRowElementGetCells ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLCollection
dOMHTMLTableRowElementGetCells _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_row_element_get_cells _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_row_element_get_cells" result
    result' <- (wrapObject DOMHTMLCollection) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableRowElement::get_ch
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_get_ch" webkit_dom_html_table_row_element_get_ch :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    IO CString


dOMHTMLTableRowElementGetCh ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableRowElementGetCh _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_row_element_get_ch _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_row_element_get_ch" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableRowElement::get_ch_off
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_get_ch_off" webkit_dom_html_table_row_element_get_ch_off :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    IO CString


dOMHTMLTableRowElementGetChOff ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableRowElementGetChOff _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_row_element_get_ch_off _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_row_element_get_ch_off" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableRowElement::get_row_index
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_get_row_index" webkit_dom_html_table_row_element_get_row_index :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    IO Int64


dOMHTMLTableRowElementGetRowIndex ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLTableRowElementGetRowIndex _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_row_element_get_row_index _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLTableRowElement::get_section_row_index
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_get_section_row_index" webkit_dom_html_table_row_element_get_section_row_index :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    IO Int64


dOMHTMLTableRowElementGetSectionRowIndex ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLTableRowElementGetSectionRowIndex _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_row_element_get_section_row_index _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLTableRowElement::get_v_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_get_v_align" webkit_dom_html_table_row_element_get_v_align :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    IO CString


dOMHTMLTableRowElementGetVAlign ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTableRowElementGetVAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_table_row_element_get_v_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_table_row_element_get_v_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTableRowElement::insert_cell
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMHTMLElement"
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_insert_cell" webkit_dom_html_table_row_element_insert_cell :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    Int64 ->                                -- index : TBasicType TInt64
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr DOMHTMLElement)


dOMHTMLTableRowElementInsertCell ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- index
    m DOMHTMLElement
dOMHTMLTableRowElementInsertCell _obj index = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        result <- propagateGError $ webkit_dom_html_table_row_element_insert_cell _obj' index
        checkUnexpectedReturnNULL "webkit_dom_html_table_row_element_insert_cell" result
        result' <- (newObject DOMHTMLElement) result
        touchManagedPtr _obj
        return result'
     ) (do
        return ()
     )

-- method DOMHTMLTableRowElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_set_align" webkit_dom_html_table_row_element_set_align :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableRowElementSetAlign ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableRowElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_row_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableRowElement::set_bg_color
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_set_bg_color" webkit_dom_html_table_row_element_set_bg_color :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableRowElementSetBgColor ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableRowElementSetBgColor _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_row_element_set_bg_color _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableRowElement::set_ch
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_set_ch" webkit_dom_html_table_row_element_set_ch :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableRowElementSetCh ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableRowElementSetCh _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_row_element_set_ch _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableRowElement::set_ch_off
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_set_ch_off" webkit_dom_html_table_row_element_set_ch_off :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableRowElementSetChOff ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableRowElementSetChOff _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_row_element_set_ch_off _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLTableRowElement::set_v_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTableRowElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_table_row_element_set_v_align" webkit_dom_html_table_row_element_set_v_align :: 
    Ptr DOMHTMLTableRowElement ->           -- _obj : TInterface "WebKit" "DOMHTMLTableRowElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTableRowElementSetVAlign ::
    (MonadIO m, DOMHTMLTableRowElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTableRowElementSetVAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_table_row_element_set_v_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


