
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLTitleElement
    ( 

-- * Exported types
    DOMHTMLTitleElement(..)                 ,
    DOMHTMLTitleElementK                    ,
    toDOMHTMLTitleElement                   ,
    noDOMHTMLTitleElement                   ,


 -- * Methods
-- ** dOMHTMLTitleElementGetText
    dOMHTMLTitleElementGetText              ,


-- ** dOMHTMLTitleElementSetText
    dOMHTMLTitleElementSetText              ,




 -- * Properties
-- ** Text
    DOMHTMLTitleElementTextPropertyInfo     ,
    constructDOMHTMLTitleElementText        ,
    getDOMHTMLTitleElementText              ,
    setDOMHTMLTitleElementText              ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLTitleElement = DOMHTMLTitleElement (ForeignPtr DOMHTMLTitleElement)
foreign import ccall "webkit_dom_html_title_element_get_type"
    c_webkit_dom_html_title_element_get_type :: IO GType

type instance ParentTypes DOMHTMLTitleElement = DOMHTMLTitleElementParentTypes
type DOMHTMLTitleElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLTitleElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_title_element_get_type
    

class GObject o => DOMHTMLTitleElementK o
instance (GObject o, IsDescendantOf DOMHTMLTitleElement o) => DOMHTMLTitleElementK o

toDOMHTMLTitleElement :: DOMHTMLTitleElementK o => o -> IO DOMHTMLTitleElement
toDOMHTMLTitleElement = unsafeCastTo DOMHTMLTitleElement

noDOMHTMLTitleElement :: Maybe DOMHTMLTitleElement
noDOMHTMLTitleElement = Nothing

-- VVV Prop "text"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLTitleElementText :: (MonadIO m, DOMHTMLTitleElementK o) => o -> m T.Text
getDOMHTMLTitleElementText obj = liftIO $ getObjectPropertyString obj "text"

setDOMHTMLTitleElementText :: (MonadIO m, DOMHTMLTitleElementK o) => o -> T.Text -> m ()
setDOMHTMLTitleElementText obj val = liftIO $ setObjectPropertyString obj "text" val

constructDOMHTMLTitleElementText :: T.Text -> IO ([Char], GValue)
constructDOMHTMLTitleElementText val = constructObjectPropertyString "text" val

data DOMHTMLTitleElementTextPropertyInfo
instance AttrInfo DOMHTMLTitleElementTextPropertyInfo where
    type AttrAllowedOps DOMHTMLTitleElementTextPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLTitleElementTextPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLTitleElementTextPropertyInfo = DOMHTMLTitleElementK
    type AttrGetType DOMHTMLTitleElementTextPropertyInfo = T.Text
    type AttrLabel DOMHTMLTitleElementTextPropertyInfo = "DOMHTMLTitleElement::text"
    attrGet _ = getDOMHTMLTitleElementText
    attrSet _ = setDOMHTMLTitleElementText
    attrConstruct _ = constructDOMHTMLTitleElementText

type instance AttributeList DOMHTMLTitleElement = DOMHTMLTitleElementAttributeList
type DOMHTMLTitleElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text", DOMHTMLTitleElementTextPropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLTitleElement = DOMHTMLTitleElementSignalList
type DOMHTMLTitleElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLTitleElement::get_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTitleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTitleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_title_element_get_text" webkit_dom_html_title_element_get_text :: 
    Ptr DOMHTMLTitleElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTitleElement"
    IO CString


dOMHTMLTitleElementGetText ::
    (MonadIO m, DOMHTMLTitleElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLTitleElementGetText _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_title_element_get_text _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_title_element_get_text" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLTitleElement::set_text
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTitleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLTitleElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_title_element_set_text" webkit_dom_html_title_element_set_text :: 
    Ptr DOMHTMLTitleElement ->              -- _obj : TInterface "WebKit" "DOMHTMLTitleElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLTitleElementSetText ::
    (MonadIO m, DOMHTMLTitleElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLTitleElementSetText _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_title_element_set_text _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()


