
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMHTMLUListElement
    ( 

-- * Exported types
    DOMHTMLUListElement(..)                 ,
    DOMHTMLUListElementK                    ,
    toDOMHTMLUListElement                   ,
    noDOMHTMLUListElement                   ,


 -- * Methods
-- ** dOMHTMLUListElementGetCompact
    dOMHTMLUListElementGetCompact           ,


-- ** dOMHTMLUListElementSetCompact
    dOMHTMLUListElementSetCompact           ,




 -- * Properties
-- ** Compact
    DOMHTMLUListElementCompactPropertyInfo  ,
    constructDOMHTMLUListElementCompact     ,
    getDOMHTMLUListElementCompact           ,
    setDOMHTMLUListElementCompact           ,


-- ** Type
    DOMHTMLUListElementTypePropertyInfo     ,
    constructDOMHTMLUListElementType        ,
    getDOMHTMLUListElementType              ,
    setDOMHTMLUListElementType              ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLUListElement = DOMHTMLUListElement (ForeignPtr DOMHTMLUListElement)
foreign import ccall "webkit_dom_htmlu_list_element_get_type"
    c_webkit_dom_htmlu_list_element_get_type :: IO GType

type instance ParentTypes DOMHTMLUListElement = DOMHTMLUListElementParentTypes
type DOMHTMLUListElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLUListElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_htmlu_list_element_get_type
    

class GObject o => DOMHTMLUListElementK o
instance (GObject o, IsDescendantOf DOMHTMLUListElement o) => DOMHTMLUListElementK o

toDOMHTMLUListElement :: DOMHTMLUListElementK o => o -> IO DOMHTMLUListElement
toDOMHTMLUListElement = unsafeCastTo DOMHTMLUListElement

noDOMHTMLUListElement :: Maybe DOMHTMLUListElement
noDOMHTMLUListElement = Nothing

-- VVV Prop "compact"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLUListElementCompact :: (MonadIO m, DOMHTMLUListElementK o) => o -> m Bool
getDOMHTMLUListElementCompact obj = liftIO $ getObjectPropertyBool obj "compact"

setDOMHTMLUListElementCompact :: (MonadIO m, DOMHTMLUListElementK o) => o -> Bool -> m ()
setDOMHTMLUListElementCompact obj val = liftIO $ setObjectPropertyBool obj "compact" val

constructDOMHTMLUListElementCompact :: Bool -> IO ([Char], GValue)
constructDOMHTMLUListElementCompact val = constructObjectPropertyBool "compact" val

data DOMHTMLUListElementCompactPropertyInfo
instance AttrInfo DOMHTMLUListElementCompactPropertyInfo where
    type AttrAllowedOps DOMHTMLUListElementCompactPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLUListElementCompactPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLUListElementCompactPropertyInfo = DOMHTMLUListElementK
    type AttrGetType DOMHTMLUListElementCompactPropertyInfo = Bool
    type AttrLabel DOMHTMLUListElementCompactPropertyInfo = "DOMHTMLUListElement::compact"
    attrGet _ = getDOMHTMLUListElementCompact
    attrSet _ = setDOMHTMLUListElementCompact
    attrConstruct _ = constructDOMHTMLUListElementCompact

-- VVV Prop "type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLUListElementType :: (MonadIO m, DOMHTMLUListElementK o) => o -> m T.Text
getDOMHTMLUListElementType obj = liftIO $ getObjectPropertyString obj "type"

setDOMHTMLUListElementType :: (MonadIO m, DOMHTMLUListElementK o) => o -> T.Text -> m ()
setDOMHTMLUListElementType obj val = liftIO $ setObjectPropertyString obj "type" val

constructDOMHTMLUListElementType :: T.Text -> IO ([Char], GValue)
constructDOMHTMLUListElementType val = constructObjectPropertyString "type" val

data DOMHTMLUListElementTypePropertyInfo
instance AttrInfo DOMHTMLUListElementTypePropertyInfo where
    type AttrAllowedOps DOMHTMLUListElementTypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLUListElementTypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLUListElementTypePropertyInfo = DOMHTMLUListElementK
    type AttrGetType DOMHTMLUListElementTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLUListElementTypePropertyInfo = "DOMHTMLUListElement::type"
    attrGet _ = getDOMHTMLUListElementType
    attrSet _ = setDOMHTMLUListElementType
    attrConstruct _ = constructDOMHTMLUListElementType

type instance AttributeList DOMHTMLUListElement = DOMHTMLUListElementAttributeList
type DOMHTMLUListElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-list", DOMElementClassListPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("compact", DOMHTMLUListElementCompactPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMHTMLElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMHTMLElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("type", DOMHTMLUListElementTypePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLUListElement = DOMHTMLUListElementSignalList
type DOMHTMLUListElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLUListElement::get_compact
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLUListElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLUListElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlu_list_element_get_compact" webkit_dom_htmlu_list_element_get_compact :: 
    Ptr DOMHTMLUListElement ->              -- _obj : TInterface "WebKit" "DOMHTMLUListElement"
    IO CInt


dOMHTMLUListElementGetCompact ::
    (MonadIO m, DOMHTMLUListElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLUListElementGetCompact _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_htmlu_list_element_get_compact _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLUListElement::set_compact
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLUListElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMHTMLUListElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_htmlu_list_element_set_compact" webkit_dom_htmlu_list_element_set_compact :: 
    Ptr DOMHTMLUListElement ->              -- _obj : TInterface "WebKit" "DOMHTMLUListElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLUListElementSetCompact ::
    (MonadIO m, DOMHTMLUListElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLUListElementSetCompact _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_htmlu_list_element_set_compact _obj' value'
    touchManagedPtr _obj
    return ()


