
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMMessagePort
    ( 

-- * Exported types
    DOMMessagePort(..)                      ,
    DOMMessagePortK                         ,
    toDOMMessagePort                        ,
    noDOMMessagePort                        ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMMessagePort = DOMMessagePort (ForeignPtr DOMMessagePort)
foreign import ccall "webkit_dom_message_port_get_type"
    c_webkit_dom_message_port_get_type :: IO GType

type instance ParentTypes DOMMessagePort = DOMMessagePortParentTypes
type DOMMessagePortParentTypes = '[DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMMessagePort where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_message_port_get_type
    

class GObject o => DOMMessagePortK o
instance (GObject o, IsDescendantOf DOMMessagePort o) => DOMMessagePortK o

toDOMMessagePort :: DOMMessagePortK o => o -> IO DOMMessagePort
toDOMMessagePort = unsafeCastTo DOMMessagePort

noDOMMessagePort :: Maybe DOMMessagePort
noDOMMessagePort = Nothing

type instance AttributeList DOMMessagePort = DOMMessagePortAttributeList
type DOMMessagePortAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMMessagePort = DOMMessagePortSignalList
type DOMMessagePortSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


