
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMMicroDataItemValue
    ( 

-- * Exported types
    DOMMicroDataItemValue(..)               ,
    DOMMicroDataItemValueK                  ,
    toDOMMicroDataItemValue                 ,
    noDOMMicroDataItemValue                 ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMMicroDataItemValue = DOMMicroDataItemValue (ForeignPtr DOMMicroDataItemValue)
foreign import ccall "webkit_dom_micro_data_item_value_get_type"
    c_webkit_dom_micro_data_item_value_get_type :: IO GType

type instance ParentTypes DOMMicroDataItemValue = DOMMicroDataItemValueParentTypes
type DOMMicroDataItemValueParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMMicroDataItemValue where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_micro_data_item_value_get_type
    

class GObject o => DOMMicroDataItemValueK o
instance (GObject o, IsDescendantOf DOMMicroDataItemValue o) => DOMMicroDataItemValueK o

toDOMMicroDataItemValue :: DOMMicroDataItemValueK o => o -> IO DOMMicroDataItemValue
toDOMMicroDataItemValue = unsafeCastTo DOMMicroDataItemValue

noDOMMicroDataItemValue :: Maybe DOMMicroDataItemValue
noDOMMicroDataItemValue = Nothing

type instance AttributeList DOMMicroDataItemValue = DOMMicroDataItemValueAttributeList
type DOMMicroDataItemValueAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMMicroDataItemValue = DOMMicroDataItemValueSignalList
type DOMMicroDataItemValueSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


