
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMNamedNodeMap
    ( 

-- * Exported types
    DOMNamedNodeMap(..)                     ,
    DOMNamedNodeMapK                        ,
    toDOMNamedNodeMap                       ,
    noDOMNamedNodeMap                       ,


 -- * Methods
-- ** dOMNamedNodeMapGetLength
    dOMNamedNodeMapGetLength                ,


-- ** dOMNamedNodeMapGetNamedItem
    dOMNamedNodeMapGetNamedItem             ,


-- ** dOMNamedNodeMapGetNamedItemNs
    dOMNamedNodeMapGetNamedItemNs           ,


-- ** dOMNamedNodeMapItem
    dOMNamedNodeMapItem                     ,


-- ** dOMNamedNodeMapRemoveNamedItem
    dOMNamedNodeMapRemoveNamedItem          ,


-- ** dOMNamedNodeMapRemoveNamedItemNs
    dOMNamedNodeMapRemoveNamedItemNs        ,


-- ** dOMNamedNodeMapSetNamedItem
    dOMNamedNodeMapSetNamedItem             ,


-- ** dOMNamedNodeMapSetNamedItemNs
    dOMNamedNodeMapSetNamedItemNs           ,




 -- * Properties
-- ** Length
    DOMNamedNodeMapLengthPropertyInfo       ,
    getDOMNamedNodeMapLength                ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMNamedNodeMap = DOMNamedNodeMap (ForeignPtr DOMNamedNodeMap)
foreign import ccall "webkit_dom_named_node_map_get_type"
    c_webkit_dom_named_node_map_get_type :: IO GType

type instance ParentTypes DOMNamedNodeMap = DOMNamedNodeMapParentTypes
type DOMNamedNodeMapParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMNamedNodeMap where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_named_node_map_get_type
    

class GObject o => DOMNamedNodeMapK o
instance (GObject o, IsDescendantOf DOMNamedNodeMap o) => DOMNamedNodeMapK o

toDOMNamedNodeMap :: DOMNamedNodeMapK o => o -> IO DOMNamedNodeMap
toDOMNamedNodeMap = unsafeCastTo DOMNamedNodeMap

noDOMNamedNodeMap :: Maybe DOMNamedNodeMap
noDOMNamedNodeMap = Nothing

-- VVV Prop "length"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMNamedNodeMapLength :: (MonadIO m, DOMNamedNodeMapK o) => o -> m Word64
getDOMNamedNodeMapLength obj = liftIO $ getObjectPropertyUInt64 obj "length"

data DOMNamedNodeMapLengthPropertyInfo
instance AttrInfo DOMNamedNodeMapLengthPropertyInfo where
    type AttrAllowedOps DOMNamedNodeMapLengthPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMNamedNodeMapLengthPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMNamedNodeMapLengthPropertyInfo = DOMNamedNodeMapK
    type AttrGetType DOMNamedNodeMapLengthPropertyInfo = Word64
    type AttrLabel DOMNamedNodeMapLengthPropertyInfo = "DOMNamedNodeMap::length"
    attrGet _ = getDOMNamedNodeMapLength
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMNamedNodeMap = DOMNamedNodeMapAttributeList
type DOMNamedNodeMapAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo), '("length", DOMNamedNodeMapLengthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMNamedNodeMap = DOMNamedNodeMapSignalList
type DOMNamedNodeMapSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMNamedNodeMap::get_length
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_named_node_map_get_length" webkit_dom_named_node_map_get_length :: 
    Ptr DOMNamedNodeMap ->                  -- _obj : TInterface "WebKit" "DOMNamedNodeMap"
    IO Word64


dOMNamedNodeMapGetLength ::
    (MonadIO m, DOMNamedNodeMapK a) =>
    a ->                                    -- _obj
    m Word64
dOMNamedNodeMapGetLength _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_named_node_map_get_length _obj'
    touchManagedPtr _obj
    return result

-- method DOMNamedNodeMap::get_named_item
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNode"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_named_node_map_get_named_item" webkit_dom_named_node_map_get_named_item :: 
    Ptr DOMNamedNodeMap ->                  -- _obj : TInterface "WebKit" "DOMNamedNodeMap"
    CString ->                              -- name : TBasicType TUTF8
    IO (Ptr DOMNode)


dOMNamedNodeMapGetNamedItem ::
    (MonadIO m, DOMNamedNodeMapK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- name
    m DOMNode
dOMNamedNodeMapGetNamedItem _obj name = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    name' <- textToCString name
    result <- webkit_dom_named_node_map_get_named_item _obj' name'
    checkUnexpectedReturnNULL "webkit_dom_named_node_map_get_named_item" result
    result' <- (newObject DOMNode) result
    touchManagedPtr _obj
    freeMem name'
    return result'

-- method DOMNamedNodeMap::get_named_item_ns
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "namespaceURI", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "localName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "namespaceURI", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "localName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNode"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_named_node_map_get_named_item_ns" webkit_dom_named_node_map_get_named_item_ns :: 
    Ptr DOMNamedNodeMap ->                  -- _obj : TInterface "WebKit" "DOMNamedNodeMap"
    CString ->                              -- namespaceURI : TBasicType TUTF8
    CString ->                              -- localName : TBasicType TUTF8
    IO (Ptr DOMNode)


dOMNamedNodeMapGetNamedItemNs ::
    (MonadIO m, DOMNamedNodeMapK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- namespaceURI
    T.Text ->                               -- localName
    m DOMNode
dOMNamedNodeMapGetNamedItemNs _obj namespaceURI localName = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    namespaceURI' <- textToCString namespaceURI
    localName' <- textToCString localName
    result <- webkit_dom_named_node_map_get_named_item_ns _obj' namespaceURI' localName'
    checkUnexpectedReturnNULL "webkit_dom_named_node_map_get_named_item_ns" result
    result' <- (newObject DOMNode) result
    touchManagedPtr _obj
    freeMem namespaceURI'
    freeMem localName'
    return result'

-- method DOMNamedNodeMap::item
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNode"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_named_node_map_item" webkit_dom_named_node_map_item :: 
    Ptr DOMNamedNodeMap ->                  -- _obj : TInterface "WebKit" "DOMNamedNodeMap"
    Word64 ->                               -- index : TBasicType TUInt64
    IO (Ptr DOMNode)


dOMNamedNodeMapItem ::
    (MonadIO m, DOMNamedNodeMapK a) =>
    a ->                                    -- _obj
    Word64 ->                               -- index
    m DOMNode
dOMNamedNodeMapItem _obj index = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_named_node_map_item _obj' index
    checkUnexpectedReturnNULL "webkit_dom_named_node_map_item" result
    result' <- (newObject DOMNode) result
    touchManagedPtr _obj
    return result'

-- method DOMNamedNodeMap::remove_named_item
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "name", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNode"
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_named_node_map_remove_named_item" webkit_dom_named_node_map_remove_named_item :: 
    Ptr DOMNamedNodeMap ->                  -- _obj : TInterface "WebKit" "DOMNamedNodeMap"
    CString ->                              -- name : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr DOMNode)


dOMNamedNodeMapRemoveNamedItem ::
    (MonadIO m, DOMNamedNodeMapK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- name
    m DOMNode
dOMNamedNodeMapRemoveNamedItem _obj name = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    name' <- textToCString name
    onException (do
        result <- propagateGError $ webkit_dom_named_node_map_remove_named_item _obj' name'
        checkUnexpectedReturnNULL "webkit_dom_named_node_map_remove_named_item" result
        result' <- (newObject DOMNode) result
        touchManagedPtr _obj
        freeMem name'
        return result'
     ) (do
        freeMem name'
     )

-- method DOMNamedNodeMap::remove_named_item_ns
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "namespaceURI", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "localName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "namespaceURI", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "localName", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNode"
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_named_node_map_remove_named_item_ns" webkit_dom_named_node_map_remove_named_item_ns :: 
    Ptr DOMNamedNodeMap ->                  -- _obj : TInterface "WebKit" "DOMNamedNodeMap"
    CString ->                              -- namespaceURI : TBasicType TUTF8
    CString ->                              -- localName : TBasicType TUTF8
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr DOMNode)


dOMNamedNodeMapRemoveNamedItemNs ::
    (MonadIO m, DOMNamedNodeMapK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- namespaceURI
    T.Text ->                               -- localName
    m DOMNode
dOMNamedNodeMapRemoveNamedItemNs _obj namespaceURI localName = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    namespaceURI' <- textToCString namespaceURI
    localName' <- textToCString localName
    onException (do
        result <- propagateGError $ webkit_dom_named_node_map_remove_named_item_ns _obj' namespaceURI' localName'
        checkUnexpectedReturnNULL "webkit_dom_named_node_map_remove_named_item_ns" result
        result' <- (newObject DOMNode) result
        touchManagedPtr _obj
        freeMem namespaceURI'
        freeMem localName'
        return result'
     ) (do
        freeMem namespaceURI'
        freeMem localName'
     )

-- method DOMNamedNodeMap::set_named_item
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "node", argType = TInterface "WebKit" "DOMNode", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "node", argType = TInterface "WebKit" "DOMNode", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNode"
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_named_node_map_set_named_item" webkit_dom_named_node_map_set_named_item :: 
    Ptr DOMNamedNodeMap ->                  -- _obj : TInterface "WebKit" "DOMNamedNodeMap"
    Ptr DOMNode ->                          -- node : TInterface "WebKit" "DOMNode"
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr DOMNode)


dOMNamedNodeMapSetNamedItem ::
    (MonadIO m, DOMNamedNodeMapK a, DOMNodeK b) =>
    a ->                                    -- _obj
    b ->                                    -- node
    m DOMNode
dOMNamedNodeMapSetNamedItem _obj node = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let node' = unsafeManagedPtrCastPtr node
    onException (do
        result <- propagateGError $ webkit_dom_named_node_map_set_named_item _obj' node'
        checkUnexpectedReturnNULL "webkit_dom_named_node_map_set_named_item" result
        result' <- (newObject DOMNode) result
        touchManagedPtr _obj
        touchManagedPtr node
        return result'
     ) (do
        return ()
     )

-- method DOMNamedNodeMap::set_named_item_ns
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "node", argType = TInterface "WebKit" "DOMNode", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMNamedNodeMap", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "node", argType = TInterface "WebKit" "DOMNode", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNode"
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_named_node_map_set_named_item_ns" webkit_dom_named_node_map_set_named_item_ns :: 
    Ptr DOMNamedNodeMap ->                  -- _obj : TInterface "WebKit" "DOMNamedNodeMap"
    Ptr DOMNode ->                          -- node : TInterface "WebKit" "DOMNode"
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr DOMNode)


dOMNamedNodeMapSetNamedItemNs ::
    (MonadIO m, DOMNamedNodeMapK a, DOMNodeK b) =>
    a ->                                    -- _obj
    b ->                                    -- node
    m DOMNode
dOMNamedNodeMapSetNamedItemNs _obj node = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let node' = unsafeManagedPtrCastPtr node
    onException (do
        result <- propagateGError $ webkit_dom_named_node_map_set_named_item_ns _obj' node'
        checkUnexpectedReturnNULL "webkit_dom_named_node_map_set_named_item_ns" result
        result' <- (newObject DOMNode) result
        touchManagedPtr _obj
        touchManagedPtr node
        return result'
     ) (do
        return ()
     )


