
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMObject
    ( 

-- * Exported types
    DOMObject(..)                           ,
    DOMObjectK                              ,
    toDOMObject                             ,
    noDOMObject                             ,


 -- * Properties
-- ** CoreObject
    DOMObjectCoreObjectPropertyInfo         ,
    constructDOMObjectCoreObject            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMObject = DOMObject (ForeignPtr DOMObject)
foreign import ccall "webkit_dom_object_get_type"
    c_webkit_dom_object_get_type :: IO GType

type instance ParentTypes DOMObject = DOMObjectParentTypes
type DOMObjectParentTypes = '[GObject.Object]

instance GObject DOMObject where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_object_get_type
    

class GObject o => DOMObjectK o
instance (GObject o, IsDescendantOf DOMObject o) => DOMObjectK o

toDOMObject :: DOMObjectK o => o -> IO DOMObject
toDOMObject = unsafeCastTo DOMObject

noDOMObject :: Maybe DOMObject
noDOMObject = Nothing

-- VVV Prop "core-object"
   -- Type: TBasicType TVoid
   -- Flags: [PropertyWritable,PropertyConstructOnly]

constructDOMObjectCoreObject :: (Ptr ()) -> IO ([Char], GValue)
constructDOMObjectCoreObject val = constructObjectPropertyPtr "core-object" val

data DOMObjectCoreObjectPropertyInfo
instance AttrInfo DOMObjectCoreObjectPropertyInfo where
    type AttrAllowedOps DOMObjectCoreObjectPropertyInfo = '[ 'AttrConstruct]
    type AttrSetTypeConstraint DOMObjectCoreObjectPropertyInfo = (~) (Ptr ())
    type AttrBaseTypeConstraint DOMObjectCoreObjectPropertyInfo = DOMObjectK
    type AttrGetType DOMObjectCoreObjectPropertyInfo = ()
    type AttrLabel DOMObjectCoreObjectPropertyInfo = "DOMObject::core-object"
    attrGet _ = undefined
    attrSet _ = undefined
    attrConstruct _ = constructDOMObjectCoreObject

type instance AttributeList DOMObject = DOMObjectAttributeList
type DOMObjectAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMObject = DOMObjectSignalList
type DOMObjectSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


