
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMPerformanceNavigation
    ( 

-- * Exported types
    DOMPerformanceNavigation(..)            ,
    DOMPerformanceNavigationK               ,
    toDOMPerformanceNavigation              ,
    noDOMPerformanceNavigation              ,


 -- * Methods
-- ** dOMPerformanceNavigationGetRedirectCount
    dOMPerformanceNavigationGetRedirectCount,




 -- * Properties
-- ** RedirectCount
    DOMPerformanceNavigationRedirectCountPropertyInfo,
    getDOMPerformanceNavigationRedirectCount,


-- ** Type
    DOMPerformanceNavigationTypePropertyInfo,
    getDOMPerformanceNavigationType         ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMPerformanceNavigation = DOMPerformanceNavigation (ForeignPtr DOMPerformanceNavigation)
foreign import ccall "webkit_dom_performance_navigation_get_type"
    c_webkit_dom_performance_navigation_get_type :: IO GType

type instance ParentTypes DOMPerformanceNavigation = DOMPerformanceNavigationParentTypes
type DOMPerformanceNavigationParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMPerformanceNavigation where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_performance_navigation_get_type
    

class GObject o => DOMPerformanceNavigationK o
instance (GObject o, IsDescendantOf DOMPerformanceNavigation o) => DOMPerformanceNavigationK o

toDOMPerformanceNavigation :: DOMPerformanceNavigationK o => o -> IO DOMPerformanceNavigation
toDOMPerformanceNavigation = unsafeCastTo DOMPerformanceNavigation

noDOMPerformanceNavigation :: Maybe DOMPerformanceNavigation
noDOMPerformanceNavigation = Nothing

-- VVV Prop "redirect-count"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable]

getDOMPerformanceNavigationRedirectCount :: (MonadIO m, DOMPerformanceNavigationK o) => o -> m Word32
getDOMPerformanceNavigationRedirectCount obj = liftIO $ getObjectPropertyCUInt obj "redirect-count"

data DOMPerformanceNavigationRedirectCountPropertyInfo
instance AttrInfo DOMPerformanceNavigationRedirectCountPropertyInfo where
    type AttrAllowedOps DOMPerformanceNavigationRedirectCountPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceNavigationRedirectCountPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceNavigationRedirectCountPropertyInfo = DOMPerformanceNavigationK
    type AttrGetType DOMPerformanceNavigationRedirectCountPropertyInfo = Word32
    type AttrLabel DOMPerformanceNavigationRedirectCountPropertyInfo = "DOMPerformanceNavigation::redirect-count"
    attrGet _ = getDOMPerformanceNavigationRedirectCount
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "type"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable]

getDOMPerformanceNavigationType :: (MonadIO m, DOMPerformanceNavigationK o) => o -> m Word32
getDOMPerformanceNavigationType obj = liftIO $ getObjectPropertyCUInt obj "type"

data DOMPerformanceNavigationTypePropertyInfo
instance AttrInfo DOMPerformanceNavigationTypePropertyInfo where
    type AttrAllowedOps DOMPerformanceNavigationTypePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceNavigationTypePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceNavigationTypePropertyInfo = DOMPerformanceNavigationK
    type AttrGetType DOMPerformanceNavigationTypePropertyInfo = Word32
    type AttrLabel DOMPerformanceNavigationTypePropertyInfo = "DOMPerformanceNavigation::type"
    attrGet _ = getDOMPerformanceNavigationType
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMPerformanceNavigation = DOMPerformanceNavigationAttributeList
type DOMPerformanceNavigationAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo), '("redirect-count", DOMPerformanceNavigationRedirectCountPropertyInfo), '("type", DOMPerformanceNavigationTypePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMPerformanceNavigation = DOMPerformanceNavigationSignalList
type DOMPerformanceNavigationSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMPerformanceNavigation::get_redirect_count
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceNavigation", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceNavigation", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt16
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_navigation_get_redirect_count" webkit_dom_performance_navigation_get_redirect_count :: 
    Ptr DOMPerformanceNavigation ->         -- _obj : TInterface "WebKit" "DOMPerformanceNavigation"
    IO Word16


dOMPerformanceNavigationGetRedirectCount ::
    (MonadIO m, DOMPerformanceNavigationK a) =>
    a ->                                    -- _obj
    m Word16
dOMPerformanceNavigationGetRedirectCount _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_navigation_get_redirect_count _obj'
    touchManagedPtr _obj
    return result


