
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMPerformanceTiming
    ( 

-- * Exported types
    DOMPerformanceTiming(..)                ,
    DOMPerformanceTimingK                   ,
    toDOMPerformanceTiming                  ,
    noDOMPerformanceTiming                  ,


 -- * Methods
-- ** dOMPerformanceTimingGetConnectEnd
    dOMPerformanceTimingGetConnectEnd       ,


-- ** dOMPerformanceTimingGetConnectStart
    dOMPerformanceTimingGetConnectStart     ,


-- ** dOMPerformanceTimingGetDomComplete
    dOMPerformanceTimingGetDomComplete      ,


-- ** dOMPerformanceTimingGetDomContentLoadedEventEnd
    dOMPerformanceTimingGetDomContentLoadedEventEnd,


-- ** dOMPerformanceTimingGetDomContentLoadedEventStart
    dOMPerformanceTimingGetDomContentLoadedEventStart,


-- ** dOMPerformanceTimingGetDomInteractive
    dOMPerformanceTimingGetDomInteractive   ,


-- ** dOMPerformanceTimingGetDomLoading
    dOMPerformanceTimingGetDomLoading       ,


-- ** dOMPerformanceTimingGetDomainLookupEnd
    dOMPerformanceTimingGetDomainLookupEnd  ,


-- ** dOMPerformanceTimingGetDomainLookupStart
    dOMPerformanceTimingGetDomainLookupStart,


-- ** dOMPerformanceTimingGetFetchStart
    dOMPerformanceTimingGetFetchStart       ,


-- ** dOMPerformanceTimingGetLoadEventEnd
    dOMPerformanceTimingGetLoadEventEnd     ,


-- ** dOMPerformanceTimingGetLoadEventStart
    dOMPerformanceTimingGetLoadEventStart   ,


-- ** dOMPerformanceTimingGetNavigationStart
    dOMPerformanceTimingGetNavigationStart  ,


-- ** dOMPerformanceTimingGetRedirectEnd
    dOMPerformanceTimingGetRedirectEnd      ,


-- ** dOMPerformanceTimingGetRedirectStart
    dOMPerformanceTimingGetRedirectStart    ,


-- ** dOMPerformanceTimingGetRequestStart
    dOMPerformanceTimingGetRequestStart     ,


-- ** dOMPerformanceTimingGetResponseEnd
    dOMPerformanceTimingGetResponseEnd      ,


-- ** dOMPerformanceTimingGetResponseStart
    dOMPerformanceTimingGetResponseStart    ,


-- ** dOMPerformanceTimingGetSecureConnectionStart
    dOMPerformanceTimingGetSecureConnectionStart,


-- ** dOMPerformanceTimingGetUnloadEventEnd
    dOMPerformanceTimingGetUnloadEventEnd   ,


-- ** dOMPerformanceTimingGetUnloadEventStart
    dOMPerformanceTimingGetUnloadEventStart ,




 -- * Properties
-- ** ConnectEnd
    DOMPerformanceTimingConnectEndPropertyInfo,
    getDOMPerformanceTimingConnectEnd       ,


-- ** ConnectStart
    DOMPerformanceTimingConnectStartPropertyInfo,
    getDOMPerformanceTimingConnectStart     ,


-- ** DomComplete
    DOMPerformanceTimingDomCompletePropertyInfo,
    getDOMPerformanceTimingDomComplete      ,


-- ** DomContentLoadedEventEnd
    DOMPerformanceTimingDomContentLoadedEventEndPropertyInfo,
    getDOMPerformanceTimingDomContentLoadedEventEnd,


-- ** DomContentLoadedEventStart
    DOMPerformanceTimingDomContentLoadedEventStartPropertyInfo,
    getDOMPerformanceTimingDomContentLoadedEventStart,


-- ** DomInteractive
    DOMPerformanceTimingDomInteractivePropertyInfo,
    getDOMPerformanceTimingDomInteractive   ,


-- ** DomLoading
    DOMPerformanceTimingDomLoadingPropertyInfo,
    getDOMPerformanceTimingDomLoading       ,


-- ** DomainLookupEnd
    DOMPerformanceTimingDomainLookupEndPropertyInfo,
    getDOMPerformanceTimingDomainLookupEnd  ,


-- ** DomainLookupStart
    DOMPerformanceTimingDomainLookupStartPropertyInfo,
    getDOMPerformanceTimingDomainLookupStart,


-- ** FetchStart
    DOMPerformanceTimingFetchStartPropertyInfo,
    getDOMPerformanceTimingFetchStart       ,


-- ** LoadEventEnd
    DOMPerformanceTimingLoadEventEndPropertyInfo,
    getDOMPerformanceTimingLoadEventEnd     ,


-- ** LoadEventStart
    DOMPerformanceTimingLoadEventStartPropertyInfo,
    getDOMPerformanceTimingLoadEventStart   ,


-- ** NavigationStart
    DOMPerformanceTimingNavigationStartPropertyInfo,
    getDOMPerformanceTimingNavigationStart  ,


-- ** RedirectEnd
    DOMPerformanceTimingRedirectEndPropertyInfo,
    getDOMPerformanceTimingRedirectEnd      ,


-- ** RedirectStart
    DOMPerformanceTimingRedirectStartPropertyInfo,
    getDOMPerformanceTimingRedirectStart    ,


-- ** RequestStart
    DOMPerformanceTimingRequestStartPropertyInfo,
    getDOMPerformanceTimingRequestStart     ,


-- ** ResponseEnd
    DOMPerformanceTimingResponseEndPropertyInfo,
    getDOMPerformanceTimingResponseEnd      ,


-- ** ResponseStart
    DOMPerformanceTimingResponseStartPropertyInfo,
    getDOMPerformanceTimingResponseStart    ,


-- ** SecureConnectionStart
    DOMPerformanceTimingSecureConnectionStartPropertyInfo,
    getDOMPerformanceTimingSecureConnectionStart,


-- ** UnloadEventEnd
    DOMPerformanceTimingUnloadEventEndPropertyInfo,
    getDOMPerformanceTimingUnloadEventEnd   ,


-- ** UnloadEventStart
    DOMPerformanceTimingUnloadEventStartPropertyInfo,
    getDOMPerformanceTimingUnloadEventStart ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMPerformanceTiming = DOMPerformanceTiming (ForeignPtr DOMPerformanceTiming)
foreign import ccall "webkit_dom_performance_timing_get_type"
    c_webkit_dom_performance_timing_get_type :: IO GType

type instance ParentTypes DOMPerformanceTiming = DOMPerformanceTimingParentTypes
type DOMPerformanceTimingParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMPerformanceTiming where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_performance_timing_get_type
    

class GObject o => DOMPerformanceTimingK o
instance (GObject o, IsDescendantOf DOMPerformanceTiming o) => DOMPerformanceTimingK o

toDOMPerformanceTiming :: DOMPerformanceTimingK o => o -> IO DOMPerformanceTiming
toDOMPerformanceTiming = unsafeCastTo DOMPerformanceTiming

noDOMPerformanceTiming :: Maybe DOMPerformanceTiming
noDOMPerformanceTiming = Nothing

-- VVV Prop "connect-end"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingConnectEnd :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingConnectEnd obj = liftIO $ getObjectPropertyUInt64 obj "connect-end"

data DOMPerformanceTimingConnectEndPropertyInfo
instance AttrInfo DOMPerformanceTimingConnectEndPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingConnectEndPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingConnectEndPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingConnectEndPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingConnectEndPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingConnectEndPropertyInfo = "DOMPerformanceTiming::connect-end"
    attrGet _ = getDOMPerformanceTimingConnectEnd
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "connect-start"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingConnectStart :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingConnectStart obj = liftIO $ getObjectPropertyUInt64 obj "connect-start"

data DOMPerformanceTimingConnectStartPropertyInfo
instance AttrInfo DOMPerformanceTimingConnectStartPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingConnectStartPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingConnectStartPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingConnectStartPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingConnectStartPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingConnectStartPropertyInfo = "DOMPerformanceTiming::connect-start"
    attrGet _ = getDOMPerformanceTimingConnectStart
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "dom-complete"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingDomComplete :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingDomComplete obj = liftIO $ getObjectPropertyUInt64 obj "dom-complete"

data DOMPerformanceTimingDomCompletePropertyInfo
instance AttrInfo DOMPerformanceTimingDomCompletePropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingDomCompletePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingDomCompletePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingDomCompletePropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingDomCompletePropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingDomCompletePropertyInfo = "DOMPerformanceTiming::dom-complete"
    attrGet _ = getDOMPerformanceTimingDomComplete
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "dom-content-loaded-event-end"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingDomContentLoadedEventEnd :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingDomContentLoadedEventEnd obj = liftIO $ getObjectPropertyUInt64 obj "dom-content-loaded-event-end"

data DOMPerformanceTimingDomContentLoadedEventEndPropertyInfo
instance AttrInfo DOMPerformanceTimingDomContentLoadedEventEndPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingDomContentLoadedEventEndPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingDomContentLoadedEventEndPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingDomContentLoadedEventEndPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingDomContentLoadedEventEndPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingDomContentLoadedEventEndPropertyInfo = "DOMPerformanceTiming::dom-content-loaded-event-end"
    attrGet _ = getDOMPerformanceTimingDomContentLoadedEventEnd
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "dom-content-loaded-event-start"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingDomContentLoadedEventStart :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingDomContentLoadedEventStart obj = liftIO $ getObjectPropertyUInt64 obj "dom-content-loaded-event-start"

data DOMPerformanceTimingDomContentLoadedEventStartPropertyInfo
instance AttrInfo DOMPerformanceTimingDomContentLoadedEventStartPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingDomContentLoadedEventStartPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingDomContentLoadedEventStartPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingDomContentLoadedEventStartPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingDomContentLoadedEventStartPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingDomContentLoadedEventStartPropertyInfo = "DOMPerformanceTiming::dom-content-loaded-event-start"
    attrGet _ = getDOMPerformanceTimingDomContentLoadedEventStart
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "dom-interactive"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingDomInteractive :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingDomInteractive obj = liftIO $ getObjectPropertyUInt64 obj "dom-interactive"

data DOMPerformanceTimingDomInteractivePropertyInfo
instance AttrInfo DOMPerformanceTimingDomInteractivePropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingDomInteractivePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingDomInteractivePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingDomInteractivePropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingDomInteractivePropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingDomInteractivePropertyInfo = "DOMPerformanceTiming::dom-interactive"
    attrGet _ = getDOMPerformanceTimingDomInteractive
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "dom-loading"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingDomLoading :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingDomLoading obj = liftIO $ getObjectPropertyUInt64 obj "dom-loading"

data DOMPerformanceTimingDomLoadingPropertyInfo
instance AttrInfo DOMPerformanceTimingDomLoadingPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingDomLoadingPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingDomLoadingPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingDomLoadingPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingDomLoadingPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingDomLoadingPropertyInfo = "DOMPerformanceTiming::dom-loading"
    attrGet _ = getDOMPerformanceTimingDomLoading
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "domain-lookup-end"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingDomainLookupEnd :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingDomainLookupEnd obj = liftIO $ getObjectPropertyUInt64 obj "domain-lookup-end"

data DOMPerformanceTimingDomainLookupEndPropertyInfo
instance AttrInfo DOMPerformanceTimingDomainLookupEndPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingDomainLookupEndPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingDomainLookupEndPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingDomainLookupEndPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingDomainLookupEndPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingDomainLookupEndPropertyInfo = "DOMPerformanceTiming::domain-lookup-end"
    attrGet _ = getDOMPerformanceTimingDomainLookupEnd
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "domain-lookup-start"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingDomainLookupStart :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingDomainLookupStart obj = liftIO $ getObjectPropertyUInt64 obj "domain-lookup-start"

data DOMPerformanceTimingDomainLookupStartPropertyInfo
instance AttrInfo DOMPerformanceTimingDomainLookupStartPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingDomainLookupStartPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingDomainLookupStartPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingDomainLookupStartPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingDomainLookupStartPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingDomainLookupStartPropertyInfo = "DOMPerformanceTiming::domain-lookup-start"
    attrGet _ = getDOMPerformanceTimingDomainLookupStart
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "fetch-start"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingFetchStart :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingFetchStart obj = liftIO $ getObjectPropertyUInt64 obj "fetch-start"

data DOMPerformanceTimingFetchStartPropertyInfo
instance AttrInfo DOMPerformanceTimingFetchStartPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingFetchStartPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingFetchStartPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingFetchStartPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingFetchStartPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingFetchStartPropertyInfo = "DOMPerformanceTiming::fetch-start"
    attrGet _ = getDOMPerformanceTimingFetchStart
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "load-event-end"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingLoadEventEnd :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingLoadEventEnd obj = liftIO $ getObjectPropertyUInt64 obj "load-event-end"

data DOMPerformanceTimingLoadEventEndPropertyInfo
instance AttrInfo DOMPerformanceTimingLoadEventEndPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingLoadEventEndPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingLoadEventEndPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingLoadEventEndPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingLoadEventEndPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingLoadEventEndPropertyInfo = "DOMPerformanceTiming::load-event-end"
    attrGet _ = getDOMPerformanceTimingLoadEventEnd
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "load-event-start"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingLoadEventStart :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingLoadEventStart obj = liftIO $ getObjectPropertyUInt64 obj "load-event-start"

data DOMPerformanceTimingLoadEventStartPropertyInfo
instance AttrInfo DOMPerformanceTimingLoadEventStartPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingLoadEventStartPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingLoadEventStartPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingLoadEventStartPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingLoadEventStartPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingLoadEventStartPropertyInfo = "DOMPerformanceTiming::load-event-start"
    attrGet _ = getDOMPerformanceTimingLoadEventStart
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "navigation-start"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingNavigationStart :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingNavigationStart obj = liftIO $ getObjectPropertyUInt64 obj "navigation-start"

data DOMPerformanceTimingNavigationStartPropertyInfo
instance AttrInfo DOMPerformanceTimingNavigationStartPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingNavigationStartPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingNavigationStartPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingNavigationStartPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingNavigationStartPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingNavigationStartPropertyInfo = "DOMPerformanceTiming::navigation-start"
    attrGet _ = getDOMPerformanceTimingNavigationStart
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "redirect-end"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingRedirectEnd :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingRedirectEnd obj = liftIO $ getObjectPropertyUInt64 obj "redirect-end"

data DOMPerformanceTimingRedirectEndPropertyInfo
instance AttrInfo DOMPerformanceTimingRedirectEndPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingRedirectEndPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingRedirectEndPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingRedirectEndPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingRedirectEndPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingRedirectEndPropertyInfo = "DOMPerformanceTiming::redirect-end"
    attrGet _ = getDOMPerformanceTimingRedirectEnd
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "redirect-start"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingRedirectStart :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingRedirectStart obj = liftIO $ getObjectPropertyUInt64 obj "redirect-start"

data DOMPerformanceTimingRedirectStartPropertyInfo
instance AttrInfo DOMPerformanceTimingRedirectStartPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingRedirectStartPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingRedirectStartPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingRedirectStartPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingRedirectStartPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingRedirectStartPropertyInfo = "DOMPerformanceTiming::redirect-start"
    attrGet _ = getDOMPerformanceTimingRedirectStart
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "request-start"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingRequestStart :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingRequestStart obj = liftIO $ getObjectPropertyUInt64 obj "request-start"

data DOMPerformanceTimingRequestStartPropertyInfo
instance AttrInfo DOMPerformanceTimingRequestStartPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingRequestStartPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingRequestStartPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingRequestStartPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingRequestStartPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingRequestStartPropertyInfo = "DOMPerformanceTiming::request-start"
    attrGet _ = getDOMPerformanceTimingRequestStart
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "response-end"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingResponseEnd :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingResponseEnd obj = liftIO $ getObjectPropertyUInt64 obj "response-end"

data DOMPerformanceTimingResponseEndPropertyInfo
instance AttrInfo DOMPerformanceTimingResponseEndPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingResponseEndPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingResponseEndPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingResponseEndPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingResponseEndPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingResponseEndPropertyInfo = "DOMPerformanceTiming::response-end"
    attrGet _ = getDOMPerformanceTimingResponseEnd
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "response-start"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingResponseStart :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingResponseStart obj = liftIO $ getObjectPropertyUInt64 obj "response-start"

data DOMPerformanceTimingResponseStartPropertyInfo
instance AttrInfo DOMPerformanceTimingResponseStartPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingResponseStartPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingResponseStartPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingResponseStartPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingResponseStartPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingResponseStartPropertyInfo = "DOMPerformanceTiming::response-start"
    attrGet _ = getDOMPerformanceTimingResponseStart
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "secure-connection-start"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingSecureConnectionStart :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingSecureConnectionStart obj = liftIO $ getObjectPropertyUInt64 obj "secure-connection-start"

data DOMPerformanceTimingSecureConnectionStartPropertyInfo
instance AttrInfo DOMPerformanceTimingSecureConnectionStartPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingSecureConnectionStartPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingSecureConnectionStartPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingSecureConnectionStartPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingSecureConnectionStartPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingSecureConnectionStartPropertyInfo = "DOMPerformanceTiming::secure-connection-start"
    attrGet _ = getDOMPerformanceTimingSecureConnectionStart
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "unload-event-end"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingUnloadEventEnd :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingUnloadEventEnd obj = liftIO $ getObjectPropertyUInt64 obj "unload-event-end"

data DOMPerformanceTimingUnloadEventEndPropertyInfo
instance AttrInfo DOMPerformanceTimingUnloadEventEndPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingUnloadEventEndPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingUnloadEventEndPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingUnloadEventEndPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingUnloadEventEndPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingUnloadEventEndPropertyInfo = "DOMPerformanceTiming::unload-event-end"
    attrGet _ = getDOMPerformanceTimingUnloadEventEnd
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "unload-event-start"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMPerformanceTimingUnloadEventStart :: (MonadIO m, DOMPerformanceTimingK o) => o -> m Word64
getDOMPerformanceTimingUnloadEventStart obj = liftIO $ getObjectPropertyUInt64 obj "unload-event-start"

data DOMPerformanceTimingUnloadEventStartPropertyInfo
instance AttrInfo DOMPerformanceTimingUnloadEventStartPropertyInfo where
    type AttrAllowedOps DOMPerformanceTimingUnloadEventStartPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMPerformanceTimingUnloadEventStartPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMPerformanceTimingUnloadEventStartPropertyInfo = DOMPerformanceTimingK
    type AttrGetType DOMPerformanceTimingUnloadEventStartPropertyInfo = Word64
    type AttrLabel DOMPerformanceTimingUnloadEventStartPropertyInfo = "DOMPerformanceTiming::unload-event-start"
    attrGet _ = getDOMPerformanceTimingUnloadEventStart
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMPerformanceTiming = DOMPerformanceTimingAttributeList
type DOMPerformanceTimingAttributeList = ('[ '("connect-end", DOMPerformanceTimingConnectEndPropertyInfo), '("connect-start", DOMPerformanceTimingConnectStartPropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dom-complete", DOMPerformanceTimingDomCompletePropertyInfo), '("dom-content-loaded-event-end", DOMPerformanceTimingDomContentLoadedEventEndPropertyInfo), '("dom-content-loaded-event-start", DOMPerformanceTimingDomContentLoadedEventStartPropertyInfo), '("dom-interactive", DOMPerformanceTimingDomInteractivePropertyInfo), '("dom-loading", DOMPerformanceTimingDomLoadingPropertyInfo), '("domain-lookup-end", DOMPerformanceTimingDomainLookupEndPropertyInfo), '("domain-lookup-start", DOMPerformanceTimingDomainLookupStartPropertyInfo), '("fetch-start", DOMPerformanceTimingFetchStartPropertyInfo), '("load-event-end", DOMPerformanceTimingLoadEventEndPropertyInfo), '("load-event-start", DOMPerformanceTimingLoadEventStartPropertyInfo), '("navigation-start", DOMPerformanceTimingNavigationStartPropertyInfo), '("redirect-end", DOMPerformanceTimingRedirectEndPropertyInfo), '("redirect-start", DOMPerformanceTimingRedirectStartPropertyInfo), '("request-start", DOMPerformanceTimingRequestStartPropertyInfo), '("response-end", DOMPerformanceTimingResponseEndPropertyInfo), '("response-start", DOMPerformanceTimingResponseStartPropertyInfo), '("secure-connection-start", DOMPerformanceTimingSecureConnectionStartPropertyInfo), '("unload-event-end", DOMPerformanceTimingUnloadEventEndPropertyInfo), '("unload-event-start", DOMPerformanceTimingUnloadEventStartPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMPerformanceTiming = DOMPerformanceTimingSignalList
type DOMPerformanceTimingSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMPerformanceTiming::get_connect_end
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_connect_end" webkit_dom_performance_timing_get_connect_end :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetConnectEnd ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetConnectEnd _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_connect_end _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_connect_start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_connect_start" webkit_dom_performance_timing_get_connect_start :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetConnectStart ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetConnectStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_connect_start _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_dom_complete
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_dom_complete" webkit_dom_performance_timing_get_dom_complete :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetDomComplete ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetDomComplete _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_dom_complete _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_dom_content_loaded_event_end
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_dom_content_loaded_event_end" webkit_dom_performance_timing_get_dom_content_loaded_event_end :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetDomContentLoadedEventEnd ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetDomContentLoadedEventEnd _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_dom_content_loaded_event_end _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_dom_content_loaded_event_start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_dom_content_loaded_event_start" webkit_dom_performance_timing_get_dom_content_loaded_event_start :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetDomContentLoadedEventStart ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetDomContentLoadedEventStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_dom_content_loaded_event_start _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_dom_interactive
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_dom_interactive" webkit_dom_performance_timing_get_dom_interactive :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetDomInteractive ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetDomInteractive _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_dom_interactive _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_dom_loading
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_dom_loading" webkit_dom_performance_timing_get_dom_loading :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetDomLoading ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetDomLoading _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_dom_loading _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_domain_lookup_end
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_domain_lookup_end" webkit_dom_performance_timing_get_domain_lookup_end :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetDomainLookupEnd ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetDomainLookupEnd _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_domain_lookup_end _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_domain_lookup_start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_domain_lookup_start" webkit_dom_performance_timing_get_domain_lookup_start :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetDomainLookupStart ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetDomainLookupStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_domain_lookup_start _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_fetch_start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_fetch_start" webkit_dom_performance_timing_get_fetch_start :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetFetchStart ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetFetchStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_fetch_start _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_load_event_end
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_load_event_end" webkit_dom_performance_timing_get_load_event_end :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetLoadEventEnd ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetLoadEventEnd _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_load_event_end _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_load_event_start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_load_event_start" webkit_dom_performance_timing_get_load_event_start :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetLoadEventStart ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetLoadEventStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_load_event_start _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_navigation_start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_navigation_start" webkit_dom_performance_timing_get_navigation_start :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetNavigationStart ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetNavigationStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_navigation_start _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_redirect_end
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_redirect_end" webkit_dom_performance_timing_get_redirect_end :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetRedirectEnd ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetRedirectEnd _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_redirect_end _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_redirect_start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_redirect_start" webkit_dom_performance_timing_get_redirect_start :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetRedirectStart ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetRedirectStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_redirect_start _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_request_start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_request_start" webkit_dom_performance_timing_get_request_start :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetRequestStart ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetRequestStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_request_start _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_response_end
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_response_end" webkit_dom_performance_timing_get_response_end :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetResponseEnd ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetResponseEnd _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_response_end _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_response_start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_response_start" webkit_dom_performance_timing_get_response_start :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetResponseStart ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetResponseStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_response_start _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_secure_connection_start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_secure_connection_start" webkit_dom_performance_timing_get_secure_connection_start :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetSecureConnectionStart ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetSecureConnectionStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_secure_connection_start _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_unload_event_end
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_unload_event_end" webkit_dom_performance_timing_get_unload_event_end :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetUnloadEventEnd ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetUnloadEventEnd _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_unload_event_end _obj'
    touchManagedPtr _obj
    return result

-- method DOMPerformanceTiming::get_unload_event_start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMPerformanceTiming", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_performance_timing_get_unload_event_start" webkit_dom_performance_timing_get_unload_event_start :: 
    Ptr DOMPerformanceTiming ->             -- _obj : TInterface "WebKit" "DOMPerformanceTiming"
    IO Word64


dOMPerformanceTimingGetUnloadEventStart ::
    (MonadIO m, DOMPerformanceTimingK a) =>
    a ->                                    -- _obj
    m Word64
dOMPerformanceTimingGetUnloadEventStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_performance_timing_get_unload_event_start _obj'
    touchManagedPtr _obj
    return result


