
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMStorageInfo
    ( 

-- * Exported types
    DOMStorageInfo(..)                      ,
    DOMStorageInfoK                         ,
    toDOMStorageInfo                        ,
    noDOMStorageInfo                        ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMStorageInfo = DOMStorageInfo (ForeignPtr DOMStorageInfo)
foreign import ccall "webkit_dom_storage_info_get_type"
    c_webkit_dom_storage_info_get_type :: IO GType

type instance ParentTypes DOMStorageInfo = DOMStorageInfoParentTypes
type DOMStorageInfoParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMStorageInfo where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_storage_info_get_type
    

class GObject o => DOMStorageInfoK o
instance (GObject o, IsDescendantOf DOMStorageInfo o) => DOMStorageInfoK o

toDOMStorageInfo :: DOMStorageInfoK o => o -> IO DOMStorageInfo
toDOMStorageInfo = unsafeCastTo DOMStorageInfo

noDOMStorageInfo :: Maybe DOMStorageInfo
noDOMStorageInfo = Nothing

type instance AttributeList DOMStorageInfo = DOMStorageInfoAttributeList
type DOMStorageInfoAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMStorageInfo = DOMStorageInfoSignalList
type DOMStorageInfoSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


