
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMStorageQuota
    ( 

-- * Exported types
    DOMStorageQuota(..)                     ,
    DOMStorageQuotaK                        ,
    toDOMStorageQuota                       ,
    noDOMStorageQuota                       ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMStorageQuota = DOMStorageQuota (ForeignPtr DOMStorageQuota)
foreign import ccall "webkit_dom_storage_quota_get_type"
    c_webkit_dom_storage_quota_get_type :: IO GType

type instance ParentTypes DOMStorageQuota = DOMStorageQuotaParentTypes
type DOMStorageQuotaParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMStorageQuota where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_storage_quota_get_type
    

class GObject o => DOMStorageQuotaK o
instance (GObject o, IsDescendantOf DOMStorageQuota o) => DOMStorageQuotaK o

toDOMStorageQuota :: DOMStorageQuotaK o => o -> IO DOMStorageQuota
toDOMStorageQuota = unsafeCastTo DOMStorageQuota

noDOMStorageQuota :: Maybe DOMStorageQuota
noDOMStorageQuota = Nothing

type instance AttributeList DOMStorageQuota = DOMStorageQuotaAttributeList
type DOMStorageQuotaAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMStorageQuota = DOMStorageQuotaSignalList
type DOMStorageQuotaSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


