
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMTrackEvent
    ( 

-- * Exported types
    DOMTrackEvent(..)                       ,
    DOMTrackEventK                          ,
    toDOMTrackEvent                         ,
    noDOMTrackEvent                         ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMTrackEvent = DOMTrackEvent (ForeignPtr DOMTrackEvent)
foreign import ccall "webkit_dom_track_event_get_type"
    c_webkit_dom_track_event_get_type :: IO GType

type instance ParentTypes DOMTrackEvent = DOMTrackEventParentTypes
type DOMTrackEventParentTypes = '[DOMEvent, DOMObject, GObject.Object]

instance GObject DOMTrackEvent where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_track_event_get_type
    

class GObject o => DOMTrackEventK o
instance (GObject o, IsDescendantOf DOMTrackEvent o) => DOMTrackEventK o

toDOMTrackEvent :: DOMTrackEventK o => o -> IO DOMTrackEvent
toDOMTrackEvent = unsafeCastTo DOMTrackEvent

noDOMTrackEvent :: Maybe DOMTrackEvent
noDOMTrackEvent = Nothing

type instance AttributeList DOMTrackEvent = DOMTrackEventAttributeList
type DOMTrackEventAttributeList = ('[ '("bubbles", DOMEventBubblesPropertyInfo), '("cancel-bubble", DOMEventCancelBubblePropertyInfo), '("cancelable", DOMEventCancelablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("current-target", DOMEventCurrentTargetPropertyInfo), '("default-prevented", DOMEventDefaultPreventedPropertyInfo), '("event-phase", DOMEventEventPhasePropertyInfo), '("return-value", DOMEventReturnValuePropertyInfo), '("src-element", DOMEventSrcElementPropertyInfo), '("target", DOMEventTargetPropertyInfo), '("time-stamp", DOMEventTimeStampPropertyInfo), '("type", DOMEventTypePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMTrackEvent = DOMTrackEventSignalList
type DOMTrackEventSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


