
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMValidityState
    ( 

-- * Exported types
    DOMValidityState(..)                    ,
    DOMValidityStateK                       ,
    toDOMValidityState                      ,
    noDOMValidityState                      ,


 -- * Methods
-- ** dOMValidityStateGetBadInput
    dOMValidityStateGetBadInput             ,


-- ** dOMValidityStateGetCustomError
    dOMValidityStateGetCustomError          ,


-- ** dOMValidityStateGetPatternMismatch
    dOMValidityStateGetPatternMismatch      ,


-- ** dOMValidityStateGetRangeOverflow
    dOMValidityStateGetRangeOverflow        ,


-- ** dOMValidityStateGetRangeUnderflow
    dOMValidityStateGetRangeUnderflow       ,


-- ** dOMValidityStateGetStepMismatch
    dOMValidityStateGetStepMismatch         ,


-- ** dOMValidityStateGetTooLong
    dOMValidityStateGetTooLong              ,


-- ** dOMValidityStateGetTypeMismatch
    dOMValidityStateGetTypeMismatch         ,


-- ** dOMValidityStateGetValid
    dOMValidityStateGetValid                ,


-- ** dOMValidityStateGetValueMissing
    dOMValidityStateGetValueMissing         ,




 -- * Properties
-- ** BadInput
    DOMValidityStateBadInputPropertyInfo    ,
    getDOMValidityStateBadInput             ,


-- ** CustomError
    DOMValidityStateCustomErrorPropertyInfo ,
    getDOMValidityStateCustomError          ,


-- ** PatternMismatch
    DOMValidityStatePatternMismatchPropertyInfo,
    getDOMValidityStatePatternMismatch      ,


-- ** RangeOverflow
    DOMValidityStateRangeOverflowPropertyInfo,
    getDOMValidityStateRangeOverflow        ,


-- ** RangeUnderflow
    DOMValidityStateRangeUnderflowPropertyInfo,
    getDOMValidityStateRangeUnderflow       ,


-- ** StepMismatch
    DOMValidityStateStepMismatchPropertyInfo,
    getDOMValidityStateStepMismatch         ,


-- ** TooLong
    DOMValidityStateTooLongPropertyInfo     ,
    getDOMValidityStateTooLong              ,


-- ** TypeMismatch
    DOMValidityStateTypeMismatchPropertyInfo,
    getDOMValidityStateTypeMismatch         ,


-- ** Valid
    DOMValidityStateValidPropertyInfo       ,
    getDOMValidityStateValid                ,


-- ** ValueMissing
    DOMValidityStateValueMissingPropertyInfo,
    getDOMValidityStateValueMissing         ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMValidityState = DOMValidityState (ForeignPtr DOMValidityState)
foreign import ccall "webkit_dom_validity_state_get_type"
    c_webkit_dom_validity_state_get_type :: IO GType

type instance ParentTypes DOMValidityState = DOMValidityStateParentTypes
type DOMValidityStateParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMValidityState where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_validity_state_get_type
    

class GObject o => DOMValidityStateK o
instance (GObject o, IsDescendantOf DOMValidityState o) => DOMValidityStateK o

toDOMValidityState :: DOMValidityStateK o => o -> IO DOMValidityState
toDOMValidityState = unsafeCastTo DOMValidityState

noDOMValidityState :: Maybe DOMValidityState
noDOMValidityState = Nothing

-- VVV Prop "bad-input"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMValidityStateBadInput :: (MonadIO m, DOMValidityStateK o) => o -> m Bool
getDOMValidityStateBadInput obj = liftIO $ getObjectPropertyBool obj "bad-input"

data DOMValidityStateBadInputPropertyInfo
instance AttrInfo DOMValidityStateBadInputPropertyInfo where
    type AttrAllowedOps DOMValidityStateBadInputPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMValidityStateBadInputPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMValidityStateBadInputPropertyInfo = DOMValidityStateK
    type AttrGetType DOMValidityStateBadInputPropertyInfo = Bool
    type AttrLabel DOMValidityStateBadInputPropertyInfo = "DOMValidityState::bad-input"
    attrGet _ = getDOMValidityStateBadInput
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "custom-error"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMValidityStateCustomError :: (MonadIO m, DOMValidityStateK o) => o -> m Bool
getDOMValidityStateCustomError obj = liftIO $ getObjectPropertyBool obj "custom-error"

data DOMValidityStateCustomErrorPropertyInfo
instance AttrInfo DOMValidityStateCustomErrorPropertyInfo where
    type AttrAllowedOps DOMValidityStateCustomErrorPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMValidityStateCustomErrorPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMValidityStateCustomErrorPropertyInfo = DOMValidityStateK
    type AttrGetType DOMValidityStateCustomErrorPropertyInfo = Bool
    type AttrLabel DOMValidityStateCustomErrorPropertyInfo = "DOMValidityState::custom-error"
    attrGet _ = getDOMValidityStateCustomError
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "pattern-mismatch"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMValidityStatePatternMismatch :: (MonadIO m, DOMValidityStateK o) => o -> m Bool
getDOMValidityStatePatternMismatch obj = liftIO $ getObjectPropertyBool obj "pattern-mismatch"

data DOMValidityStatePatternMismatchPropertyInfo
instance AttrInfo DOMValidityStatePatternMismatchPropertyInfo where
    type AttrAllowedOps DOMValidityStatePatternMismatchPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMValidityStatePatternMismatchPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMValidityStatePatternMismatchPropertyInfo = DOMValidityStateK
    type AttrGetType DOMValidityStatePatternMismatchPropertyInfo = Bool
    type AttrLabel DOMValidityStatePatternMismatchPropertyInfo = "DOMValidityState::pattern-mismatch"
    attrGet _ = getDOMValidityStatePatternMismatch
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "range-overflow"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMValidityStateRangeOverflow :: (MonadIO m, DOMValidityStateK o) => o -> m Bool
getDOMValidityStateRangeOverflow obj = liftIO $ getObjectPropertyBool obj "range-overflow"

data DOMValidityStateRangeOverflowPropertyInfo
instance AttrInfo DOMValidityStateRangeOverflowPropertyInfo where
    type AttrAllowedOps DOMValidityStateRangeOverflowPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMValidityStateRangeOverflowPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMValidityStateRangeOverflowPropertyInfo = DOMValidityStateK
    type AttrGetType DOMValidityStateRangeOverflowPropertyInfo = Bool
    type AttrLabel DOMValidityStateRangeOverflowPropertyInfo = "DOMValidityState::range-overflow"
    attrGet _ = getDOMValidityStateRangeOverflow
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "range-underflow"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMValidityStateRangeUnderflow :: (MonadIO m, DOMValidityStateK o) => o -> m Bool
getDOMValidityStateRangeUnderflow obj = liftIO $ getObjectPropertyBool obj "range-underflow"

data DOMValidityStateRangeUnderflowPropertyInfo
instance AttrInfo DOMValidityStateRangeUnderflowPropertyInfo where
    type AttrAllowedOps DOMValidityStateRangeUnderflowPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMValidityStateRangeUnderflowPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMValidityStateRangeUnderflowPropertyInfo = DOMValidityStateK
    type AttrGetType DOMValidityStateRangeUnderflowPropertyInfo = Bool
    type AttrLabel DOMValidityStateRangeUnderflowPropertyInfo = "DOMValidityState::range-underflow"
    attrGet _ = getDOMValidityStateRangeUnderflow
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "step-mismatch"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMValidityStateStepMismatch :: (MonadIO m, DOMValidityStateK o) => o -> m Bool
getDOMValidityStateStepMismatch obj = liftIO $ getObjectPropertyBool obj "step-mismatch"

data DOMValidityStateStepMismatchPropertyInfo
instance AttrInfo DOMValidityStateStepMismatchPropertyInfo where
    type AttrAllowedOps DOMValidityStateStepMismatchPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMValidityStateStepMismatchPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMValidityStateStepMismatchPropertyInfo = DOMValidityStateK
    type AttrGetType DOMValidityStateStepMismatchPropertyInfo = Bool
    type AttrLabel DOMValidityStateStepMismatchPropertyInfo = "DOMValidityState::step-mismatch"
    attrGet _ = getDOMValidityStateStepMismatch
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "too-long"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMValidityStateTooLong :: (MonadIO m, DOMValidityStateK o) => o -> m Bool
getDOMValidityStateTooLong obj = liftIO $ getObjectPropertyBool obj "too-long"

data DOMValidityStateTooLongPropertyInfo
instance AttrInfo DOMValidityStateTooLongPropertyInfo where
    type AttrAllowedOps DOMValidityStateTooLongPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMValidityStateTooLongPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMValidityStateTooLongPropertyInfo = DOMValidityStateK
    type AttrGetType DOMValidityStateTooLongPropertyInfo = Bool
    type AttrLabel DOMValidityStateTooLongPropertyInfo = "DOMValidityState::too-long"
    attrGet _ = getDOMValidityStateTooLong
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "type-mismatch"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMValidityStateTypeMismatch :: (MonadIO m, DOMValidityStateK o) => o -> m Bool
getDOMValidityStateTypeMismatch obj = liftIO $ getObjectPropertyBool obj "type-mismatch"

data DOMValidityStateTypeMismatchPropertyInfo
instance AttrInfo DOMValidityStateTypeMismatchPropertyInfo where
    type AttrAllowedOps DOMValidityStateTypeMismatchPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMValidityStateTypeMismatchPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMValidityStateTypeMismatchPropertyInfo = DOMValidityStateK
    type AttrGetType DOMValidityStateTypeMismatchPropertyInfo = Bool
    type AttrLabel DOMValidityStateTypeMismatchPropertyInfo = "DOMValidityState::type-mismatch"
    attrGet _ = getDOMValidityStateTypeMismatch
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "valid"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMValidityStateValid :: (MonadIO m, DOMValidityStateK o) => o -> m Bool
getDOMValidityStateValid obj = liftIO $ getObjectPropertyBool obj "valid"

data DOMValidityStateValidPropertyInfo
instance AttrInfo DOMValidityStateValidPropertyInfo where
    type AttrAllowedOps DOMValidityStateValidPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMValidityStateValidPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMValidityStateValidPropertyInfo = DOMValidityStateK
    type AttrGetType DOMValidityStateValidPropertyInfo = Bool
    type AttrLabel DOMValidityStateValidPropertyInfo = "DOMValidityState::valid"
    attrGet _ = getDOMValidityStateValid
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "value-missing"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMValidityStateValueMissing :: (MonadIO m, DOMValidityStateK o) => o -> m Bool
getDOMValidityStateValueMissing obj = liftIO $ getObjectPropertyBool obj "value-missing"

data DOMValidityStateValueMissingPropertyInfo
instance AttrInfo DOMValidityStateValueMissingPropertyInfo where
    type AttrAllowedOps DOMValidityStateValueMissingPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMValidityStateValueMissingPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMValidityStateValueMissingPropertyInfo = DOMValidityStateK
    type AttrGetType DOMValidityStateValueMissingPropertyInfo = Bool
    type AttrLabel DOMValidityStateValueMissingPropertyInfo = "DOMValidityState::value-missing"
    attrGet _ = getDOMValidityStateValueMissing
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMValidityState = DOMValidityStateAttributeList
type DOMValidityStateAttributeList = ('[ '("bad-input", DOMValidityStateBadInputPropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("custom-error", DOMValidityStateCustomErrorPropertyInfo), '("pattern-mismatch", DOMValidityStatePatternMismatchPropertyInfo), '("range-overflow", DOMValidityStateRangeOverflowPropertyInfo), '("range-underflow", DOMValidityStateRangeUnderflowPropertyInfo), '("step-mismatch", DOMValidityStateStepMismatchPropertyInfo), '("too-long", DOMValidityStateTooLongPropertyInfo), '("type-mismatch", DOMValidityStateTypeMismatchPropertyInfo), '("valid", DOMValidityStateValidPropertyInfo), '("value-missing", DOMValidityStateValueMissingPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMValidityState = DOMValidityStateSignalList
type DOMValidityStateSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMValidityState::get_bad_input
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_validity_state_get_bad_input" webkit_dom_validity_state_get_bad_input :: 
    Ptr DOMValidityState ->                 -- _obj : TInterface "WebKit" "DOMValidityState"
    IO CInt


dOMValidityStateGetBadInput ::
    (MonadIO m, DOMValidityStateK a) =>
    a ->                                    -- _obj
    m Bool
dOMValidityStateGetBadInput _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_validity_state_get_bad_input _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMValidityState::get_custom_error
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_validity_state_get_custom_error" webkit_dom_validity_state_get_custom_error :: 
    Ptr DOMValidityState ->                 -- _obj : TInterface "WebKit" "DOMValidityState"
    IO CInt


dOMValidityStateGetCustomError ::
    (MonadIO m, DOMValidityStateK a) =>
    a ->                                    -- _obj
    m Bool
dOMValidityStateGetCustomError _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_validity_state_get_custom_error _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMValidityState::get_pattern_mismatch
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_validity_state_get_pattern_mismatch" webkit_dom_validity_state_get_pattern_mismatch :: 
    Ptr DOMValidityState ->                 -- _obj : TInterface "WebKit" "DOMValidityState"
    IO CInt


dOMValidityStateGetPatternMismatch ::
    (MonadIO m, DOMValidityStateK a) =>
    a ->                                    -- _obj
    m Bool
dOMValidityStateGetPatternMismatch _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_validity_state_get_pattern_mismatch _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMValidityState::get_range_overflow
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_validity_state_get_range_overflow" webkit_dom_validity_state_get_range_overflow :: 
    Ptr DOMValidityState ->                 -- _obj : TInterface "WebKit" "DOMValidityState"
    IO CInt


dOMValidityStateGetRangeOverflow ::
    (MonadIO m, DOMValidityStateK a) =>
    a ->                                    -- _obj
    m Bool
dOMValidityStateGetRangeOverflow _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_validity_state_get_range_overflow _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMValidityState::get_range_underflow
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_validity_state_get_range_underflow" webkit_dom_validity_state_get_range_underflow :: 
    Ptr DOMValidityState ->                 -- _obj : TInterface "WebKit" "DOMValidityState"
    IO CInt


dOMValidityStateGetRangeUnderflow ::
    (MonadIO m, DOMValidityStateK a) =>
    a ->                                    -- _obj
    m Bool
dOMValidityStateGetRangeUnderflow _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_validity_state_get_range_underflow _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMValidityState::get_step_mismatch
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_validity_state_get_step_mismatch" webkit_dom_validity_state_get_step_mismatch :: 
    Ptr DOMValidityState ->                 -- _obj : TInterface "WebKit" "DOMValidityState"
    IO CInt


dOMValidityStateGetStepMismatch ::
    (MonadIO m, DOMValidityStateK a) =>
    a ->                                    -- _obj
    m Bool
dOMValidityStateGetStepMismatch _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_validity_state_get_step_mismatch _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMValidityState::get_too_long
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_validity_state_get_too_long" webkit_dom_validity_state_get_too_long :: 
    Ptr DOMValidityState ->                 -- _obj : TInterface "WebKit" "DOMValidityState"
    IO CInt


dOMValidityStateGetTooLong ::
    (MonadIO m, DOMValidityStateK a) =>
    a ->                                    -- _obj
    m Bool
dOMValidityStateGetTooLong _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_validity_state_get_too_long _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMValidityState::get_type_mismatch
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_validity_state_get_type_mismatch" webkit_dom_validity_state_get_type_mismatch :: 
    Ptr DOMValidityState ->                 -- _obj : TInterface "WebKit" "DOMValidityState"
    IO CInt


dOMValidityStateGetTypeMismatch ::
    (MonadIO m, DOMValidityStateK a) =>
    a ->                                    -- _obj
    m Bool
dOMValidityStateGetTypeMismatch _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_validity_state_get_type_mismatch _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMValidityState::get_valid
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_validity_state_get_valid" webkit_dom_validity_state_get_valid :: 
    Ptr DOMValidityState ->                 -- _obj : TInterface "WebKit" "DOMValidityState"
    IO CInt


dOMValidityStateGetValid ::
    (MonadIO m, DOMValidityStateK a) =>
    a ->                                    -- _obj
    m Bool
dOMValidityStateGetValid _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_validity_state_get_valid _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMValidityState::get_value_missing
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMValidityState", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_validity_state_get_value_missing" webkit_dom_validity_state_get_value_missing :: 
    Ptr DOMValidityState ->                 -- _obj : TInterface "WebKit" "DOMValidityState"
    IO CInt


dOMValidityStateGetValueMissing ::
    (MonadIO m, DOMValidityStateK a) =>
    a ->                                    -- _obj
    m Bool
dOMValidityStateGetValueMissing _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_validity_state_get_value_missing _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'


