
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMVideoTrack
    ( 

-- * Exported types
    DOMVideoTrack(..)                       ,
    DOMVideoTrackK                          ,
    toDOMVideoTrack                         ,
    noDOMVideoTrack                         ,


 -- * Methods
-- ** dOMVideoTrackGetId
    dOMVideoTrackGetId                      ,


-- ** dOMVideoTrackGetKind
    dOMVideoTrackGetKind                    ,


-- ** dOMVideoTrackGetLabel
    dOMVideoTrackGetLabel                   ,


-- ** dOMVideoTrackGetLanguage
    dOMVideoTrackGetLanguage                ,


-- ** dOMVideoTrackGetSelected
    dOMVideoTrackGetSelected                ,


-- ** dOMVideoTrackSetSelected
    dOMVideoTrackSetSelected                ,




 -- * Properties
-- ** Id
    DOMVideoTrackIdPropertyInfo             ,
    getDOMVideoTrackId                      ,


-- ** Kind
    DOMVideoTrackKindPropertyInfo           ,
    getDOMVideoTrackKind                    ,


-- ** Label
    DOMVideoTrackLabelPropertyInfo          ,
    getDOMVideoTrackLabel                   ,


-- ** Language
    DOMVideoTrackLanguagePropertyInfo       ,
    getDOMVideoTrackLanguage                ,


-- ** Selected
    DOMVideoTrackSelectedPropertyInfo       ,
    constructDOMVideoTrackSelected          ,
    getDOMVideoTrackSelected                ,
    setDOMVideoTrackSelected                ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMVideoTrack = DOMVideoTrack (ForeignPtr DOMVideoTrack)
foreign import ccall "webkit_dom_video_track_get_type"
    c_webkit_dom_video_track_get_type :: IO GType

type instance ParentTypes DOMVideoTrack = DOMVideoTrackParentTypes
type DOMVideoTrackParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMVideoTrack where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_video_track_get_type
    

class GObject o => DOMVideoTrackK o
instance (GObject o, IsDescendantOf DOMVideoTrack o) => DOMVideoTrackK o

toDOMVideoTrack :: DOMVideoTrackK o => o -> IO DOMVideoTrack
toDOMVideoTrack = unsafeCastTo DOMVideoTrack

noDOMVideoTrack :: Maybe DOMVideoTrack
noDOMVideoTrack = Nothing

-- VVV Prop "id"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMVideoTrackId :: (MonadIO m, DOMVideoTrackK o) => o -> m T.Text
getDOMVideoTrackId obj = liftIO $ getObjectPropertyString obj "id"

data DOMVideoTrackIdPropertyInfo
instance AttrInfo DOMVideoTrackIdPropertyInfo where
    type AttrAllowedOps DOMVideoTrackIdPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMVideoTrackIdPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMVideoTrackIdPropertyInfo = DOMVideoTrackK
    type AttrGetType DOMVideoTrackIdPropertyInfo = T.Text
    type AttrLabel DOMVideoTrackIdPropertyInfo = "DOMVideoTrack::id"
    attrGet _ = getDOMVideoTrackId
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "kind"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMVideoTrackKind :: (MonadIO m, DOMVideoTrackK o) => o -> m T.Text
getDOMVideoTrackKind obj = liftIO $ getObjectPropertyString obj "kind"

data DOMVideoTrackKindPropertyInfo
instance AttrInfo DOMVideoTrackKindPropertyInfo where
    type AttrAllowedOps DOMVideoTrackKindPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMVideoTrackKindPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMVideoTrackKindPropertyInfo = DOMVideoTrackK
    type AttrGetType DOMVideoTrackKindPropertyInfo = T.Text
    type AttrLabel DOMVideoTrackKindPropertyInfo = "DOMVideoTrack::kind"
    attrGet _ = getDOMVideoTrackKind
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "label"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMVideoTrackLabel :: (MonadIO m, DOMVideoTrackK o) => o -> m T.Text
getDOMVideoTrackLabel obj = liftIO $ getObjectPropertyString obj "label"

data DOMVideoTrackLabelPropertyInfo
instance AttrInfo DOMVideoTrackLabelPropertyInfo where
    type AttrAllowedOps DOMVideoTrackLabelPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMVideoTrackLabelPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMVideoTrackLabelPropertyInfo = DOMVideoTrackK
    type AttrGetType DOMVideoTrackLabelPropertyInfo = T.Text
    type AttrLabel DOMVideoTrackLabelPropertyInfo = "DOMVideoTrack::label"
    attrGet _ = getDOMVideoTrackLabel
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "language"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMVideoTrackLanguage :: (MonadIO m, DOMVideoTrackK o) => o -> m T.Text
getDOMVideoTrackLanguage obj = liftIO $ getObjectPropertyString obj "language"

data DOMVideoTrackLanguagePropertyInfo
instance AttrInfo DOMVideoTrackLanguagePropertyInfo where
    type AttrAllowedOps DOMVideoTrackLanguagePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMVideoTrackLanguagePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMVideoTrackLanguagePropertyInfo = DOMVideoTrackK
    type AttrGetType DOMVideoTrackLanguagePropertyInfo = T.Text
    type AttrLabel DOMVideoTrackLanguagePropertyInfo = "DOMVideoTrack::language"
    attrGet _ = getDOMVideoTrackLanguage
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "selected"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMVideoTrackSelected :: (MonadIO m, DOMVideoTrackK o) => o -> m Bool
getDOMVideoTrackSelected obj = liftIO $ getObjectPropertyBool obj "selected"

setDOMVideoTrackSelected :: (MonadIO m, DOMVideoTrackK o) => o -> Bool -> m ()
setDOMVideoTrackSelected obj val = liftIO $ setObjectPropertyBool obj "selected" val

constructDOMVideoTrackSelected :: Bool -> IO ([Char], GValue)
constructDOMVideoTrackSelected val = constructObjectPropertyBool "selected" val

data DOMVideoTrackSelectedPropertyInfo
instance AttrInfo DOMVideoTrackSelectedPropertyInfo where
    type AttrAllowedOps DOMVideoTrackSelectedPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMVideoTrackSelectedPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMVideoTrackSelectedPropertyInfo = DOMVideoTrackK
    type AttrGetType DOMVideoTrackSelectedPropertyInfo = Bool
    type AttrLabel DOMVideoTrackSelectedPropertyInfo = "DOMVideoTrack::selected"
    attrGet _ = getDOMVideoTrackSelected
    attrSet _ = setDOMVideoTrackSelected
    attrConstruct _ = constructDOMVideoTrackSelected

type instance AttributeList DOMVideoTrack = DOMVideoTrackAttributeList
type DOMVideoTrackAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo), '("id", DOMVideoTrackIdPropertyInfo), '("kind", DOMVideoTrackKindPropertyInfo), '("label", DOMVideoTrackLabelPropertyInfo), '("language", DOMVideoTrackLanguagePropertyInfo), '("selected", DOMVideoTrackSelectedPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMVideoTrack = DOMVideoTrackSignalList
type DOMVideoTrackSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMVideoTrack::get_id
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMVideoTrack", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMVideoTrack", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_video_track_get_id" webkit_dom_video_track_get_id :: 
    Ptr DOMVideoTrack ->                    -- _obj : TInterface "WebKit" "DOMVideoTrack"
    IO CString


dOMVideoTrackGetId ::
    (MonadIO m, DOMVideoTrackK a) =>
    a ->                                    -- _obj
    m T.Text
dOMVideoTrackGetId _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_video_track_get_id _obj'
    checkUnexpectedReturnNULL "webkit_dom_video_track_get_id" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMVideoTrack::get_kind
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMVideoTrack", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMVideoTrack", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_video_track_get_kind" webkit_dom_video_track_get_kind :: 
    Ptr DOMVideoTrack ->                    -- _obj : TInterface "WebKit" "DOMVideoTrack"
    IO CString


dOMVideoTrackGetKind ::
    (MonadIO m, DOMVideoTrackK a) =>
    a ->                                    -- _obj
    m T.Text
dOMVideoTrackGetKind _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_video_track_get_kind _obj'
    checkUnexpectedReturnNULL "webkit_dom_video_track_get_kind" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMVideoTrack::get_label
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMVideoTrack", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMVideoTrack", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_video_track_get_label" webkit_dom_video_track_get_label :: 
    Ptr DOMVideoTrack ->                    -- _obj : TInterface "WebKit" "DOMVideoTrack"
    IO CString


dOMVideoTrackGetLabel ::
    (MonadIO m, DOMVideoTrackK a) =>
    a ->                                    -- _obj
    m T.Text
dOMVideoTrackGetLabel _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_video_track_get_label _obj'
    checkUnexpectedReturnNULL "webkit_dom_video_track_get_label" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMVideoTrack::get_language
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMVideoTrack", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMVideoTrack", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_video_track_get_language" webkit_dom_video_track_get_language :: 
    Ptr DOMVideoTrack ->                    -- _obj : TInterface "WebKit" "DOMVideoTrack"
    IO CString


dOMVideoTrackGetLanguage ::
    (MonadIO m, DOMVideoTrackK a) =>
    a ->                                    -- _obj
    m T.Text
dOMVideoTrackGetLanguage _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_video_track_get_language _obj'
    checkUnexpectedReturnNULL "webkit_dom_video_track_get_language" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMVideoTrack::get_selected
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMVideoTrack", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMVideoTrack", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_video_track_get_selected" webkit_dom_video_track_get_selected :: 
    Ptr DOMVideoTrack ->                    -- _obj : TInterface "WebKit" "DOMVideoTrack"
    IO CInt


dOMVideoTrackGetSelected ::
    (MonadIO m, DOMVideoTrackK a) =>
    a ->                                    -- _obj
    m Bool
dOMVideoTrackGetSelected _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_video_track_get_selected _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMVideoTrack::set_selected
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMVideoTrack", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMVideoTrack", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_video_track_set_selected" webkit_dom_video_track_set_selected :: 
    Ptr DOMVideoTrack ->                    -- _obj : TInterface "WebKit" "DOMVideoTrack"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMVideoTrackSetSelected ::
    (MonadIO m, DOMVideoTrackK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMVideoTrackSetSelected _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_video_track_set_selected _obj' value'
    touchManagedPtr _obj
    return ()


