
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMWebKitNamedFlow
    ( 

-- * Exported types
    DOMWebKitNamedFlow(..)                  ,
    DOMWebKitNamedFlowK                     ,
    toDOMWebKitNamedFlow                    ,
    noDOMWebKitNamedFlow                    ,


 -- * Methods
-- ** dOMWebKitNamedFlowDispatchEvent
    dOMWebKitNamedFlowDispatchEvent         ,


-- ** dOMWebKitNamedFlowGetContent
    dOMWebKitNamedFlowGetContent            ,


-- ** dOMWebKitNamedFlowGetContentNodes
    dOMWebKitNamedFlowGetContentNodes       ,


-- ** dOMWebKitNamedFlowGetFirstEmptyRegionIndex
    dOMWebKitNamedFlowGetFirstEmptyRegionIndex,


-- ** dOMWebKitNamedFlowGetName
    dOMWebKitNamedFlowGetName               ,


-- ** dOMWebKitNamedFlowGetOverflow
    dOMWebKitNamedFlowGetOverflow           ,


-- ** dOMWebKitNamedFlowGetOverset
    dOMWebKitNamedFlowGetOverset            ,


-- ** dOMWebKitNamedFlowGetRegions
    dOMWebKitNamedFlowGetRegions            ,


-- ** dOMWebKitNamedFlowGetRegionsByContent
    dOMWebKitNamedFlowGetRegionsByContent   ,


-- ** dOMWebKitNamedFlowGetRegionsByContentNode
    dOMWebKitNamedFlowGetRegionsByContentNode,




 -- * Properties
-- ** FirstEmptyRegionIndex
    DOMWebKitNamedFlowFirstEmptyRegionIndexPropertyInfo,
    getDOMWebKitNamedFlowFirstEmptyRegionIndex,


-- ** Name
    DOMWebKitNamedFlowNamePropertyInfo      ,
    getDOMWebKitNamedFlowName               ,


-- ** Overset
    DOMWebKitNamedFlowOversetPropertyInfo   ,
    getDOMWebKitNamedFlowOverset            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMWebKitNamedFlow = DOMWebKitNamedFlow (ForeignPtr DOMWebKitNamedFlow)
foreign import ccall "webkit_dom_webkit_named_flow_get_type"
    c_webkit_dom_webkit_named_flow_get_type :: IO GType

type instance ParentTypes DOMWebKitNamedFlow = DOMWebKitNamedFlowParentTypes
type DOMWebKitNamedFlowParentTypes = '[DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMWebKitNamedFlow where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_webkit_named_flow_get_type
    

class GObject o => DOMWebKitNamedFlowK o
instance (GObject o, IsDescendantOf DOMWebKitNamedFlow o) => DOMWebKitNamedFlowK o

toDOMWebKitNamedFlow :: DOMWebKitNamedFlowK o => o -> IO DOMWebKitNamedFlow
toDOMWebKitNamedFlow = unsafeCastTo DOMWebKitNamedFlow

noDOMWebKitNamedFlow :: Maybe DOMWebKitNamedFlow
noDOMWebKitNamedFlow = Nothing

-- VVV Prop "first-empty-region-index"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable]

getDOMWebKitNamedFlowFirstEmptyRegionIndex :: (MonadIO m, DOMWebKitNamedFlowK o) => o -> m Int64
getDOMWebKitNamedFlowFirstEmptyRegionIndex obj = liftIO $ getObjectPropertyInt64 obj "first-empty-region-index"

data DOMWebKitNamedFlowFirstEmptyRegionIndexPropertyInfo
instance AttrInfo DOMWebKitNamedFlowFirstEmptyRegionIndexPropertyInfo where
    type AttrAllowedOps DOMWebKitNamedFlowFirstEmptyRegionIndexPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMWebKitNamedFlowFirstEmptyRegionIndexPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMWebKitNamedFlowFirstEmptyRegionIndexPropertyInfo = DOMWebKitNamedFlowK
    type AttrGetType DOMWebKitNamedFlowFirstEmptyRegionIndexPropertyInfo = Int64
    type AttrLabel DOMWebKitNamedFlowFirstEmptyRegionIndexPropertyInfo = "DOMWebKitNamedFlow::first-empty-region-index"
    attrGet _ = getDOMWebKitNamedFlowFirstEmptyRegionIndex
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMWebKitNamedFlowName :: (MonadIO m, DOMWebKitNamedFlowK o) => o -> m T.Text
getDOMWebKitNamedFlowName obj = liftIO $ getObjectPropertyString obj "name"

data DOMWebKitNamedFlowNamePropertyInfo
instance AttrInfo DOMWebKitNamedFlowNamePropertyInfo where
    type AttrAllowedOps DOMWebKitNamedFlowNamePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMWebKitNamedFlowNamePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMWebKitNamedFlowNamePropertyInfo = DOMWebKitNamedFlowK
    type AttrGetType DOMWebKitNamedFlowNamePropertyInfo = T.Text
    type AttrLabel DOMWebKitNamedFlowNamePropertyInfo = "DOMWebKitNamedFlow::name"
    attrGet _ = getDOMWebKitNamedFlowName
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "overset"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMWebKitNamedFlowOverset :: (MonadIO m, DOMWebKitNamedFlowK o) => o -> m Bool
getDOMWebKitNamedFlowOverset obj = liftIO $ getObjectPropertyBool obj "overset"

data DOMWebKitNamedFlowOversetPropertyInfo
instance AttrInfo DOMWebKitNamedFlowOversetPropertyInfo where
    type AttrAllowedOps DOMWebKitNamedFlowOversetPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMWebKitNamedFlowOversetPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMWebKitNamedFlowOversetPropertyInfo = DOMWebKitNamedFlowK
    type AttrGetType DOMWebKitNamedFlowOversetPropertyInfo = Bool
    type AttrLabel DOMWebKitNamedFlowOversetPropertyInfo = "DOMWebKitNamedFlow::overset"
    attrGet _ = getDOMWebKitNamedFlowOverset
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMWebKitNamedFlow = DOMWebKitNamedFlowAttributeList
type DOMWebKitNamedFlowAttributeList = ('[ '("core-object", DOMObjectCoreObjectPropertyInfo), '("first-empty-region-index", DOMWebKitNamedFlowFirstEmptyRegionIndexPropertyInfo), '("name", DOMWebKitNamedFlowNamePropertyInfo), '("overset", DOMWebKitNamedFlowOversetPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMWebKitNamedFlow = DOMWebKitNamedFlowSignalList
type DOMWebKitNamedFlowSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMWebKitNamedFlow::dispatch_event
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "event", argType = TInterface "WebKit" "DOMEvent", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "event", argType = TInterface "WebKit" "DOMEvent", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_webkit_named_flow_dispatch_event" webkit_dom_webkit_named_flow_dispatch_event :: 
    Ptr DOMWebKitNamedFlow ->               -- _obj : TInterface "WebKit" "DOMWebKitNamedFlow"
    Ptr DOMEvent ->                         -- event : TInterface "WebKit" "DOMEvent"
    Ptr (Ptr GError) ->                     -- error
    IO CInt

{-# DEPRECATED dOMWebKitNamedFlowDispatchEvent ["(Since version 2.4)","Use webkit_dom_event_target_dispatch_event() instead."]#-}
dOMWebKitNamedFlowDispatchEvent ::
    (MonadIO m, DOMWebKitNamedFlowK a, DOMEventK b) =>
    a ->                                    -- _obj
    b ->                                    -- event
    m ()
dOMWebKitNamedFlowDispatchEvent _obj event = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let event' = unsafeManagedPtrCastPtr event
    onException (do
        _ <- propagateGError $ webkit_dom_webkit_named_flow_dispatch_event _obj' event'
        touchManagedPtr _obj
        touchManagedPtr event
        return ()
     ) (do
        return ()
     )

-- method DOMWebKitNamedFlow::get_content
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNodeList"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_webkit_named_flow_get_content" webkit_dom_webkit_named_flow_get_content :: 
    Ptr DOMWebKitNamedFlow ->               -- _obj : TInterface "WebKit" "DOMWebKitNamedFlow"
    IO (Ptr DOMNodeList)


dOMWebKitNamedFlowGetContent ::
    (MonadIO m, DOMWebKitNamedFlowK a) =>
    a ->                                    -- _obj
    m DOMNodeList
dOMWebKitNamedFlowGetContent _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_webkit_named_flow_get_content _obj'
    checkUnexpectedReturnNULL "webkit_dom_webkit_named_flow_get_content" result
    result' <- (wrapObject DOMNodeList) result
    touchManagedPtr _obj
    return result'

-- method DOMWebKitNamedFlow::get_content_nodes
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNodeList"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_webkit_named_flow_get_content_nodes" webkit_dom_webkit_named_flow_get_content_nodes :: 
    Ptr DOMWebKitNamedFlow ->               -- _obj : TInterface "WebKit" "DOMWebKitNamedFlow"
    IO (Ptr DOMNodeList)

{-# DEPRECATED dOMWebKitNamedFlowGetContentNodes ["(Since version 1.10)","Use webkit_dom_webkit_named_flow_get_content() instead."]#-}
dOMWebKitNamedFlowGetContentNodes ::
    (MonadIO m, DOMWebKitNamedFlowK a) =>
    a ->                                    -- _obj
    m DOMNodeList
dOMWebKitNamedFlowGetContentNodes _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_webkit_named_flow_get_content_nodes _obj'
    checkUnexpectedReturnNULL "webkit_dom_webkit_named_flow_get_content_nodes" result
    result' <- (newObject DOMNodeList) result
    touchManagedPtr _obj
    return result'

-- method DOMWebKitNamedFlow::get_first_empty_region_index
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_webkit_named_flow_get_first_empty_region_index" webkit_dom_webkit_named_flow_get_first_empty_region_index :: 
    Ptr DOMWebKitNamedFlow ->               -- _obj : TInterface "WebKit" "DOMWebKitNamedFlow"
    IO Int64


dOMWebKitNamedFlowGetFirstEmptyRegionIndex ::
    (MonadIO m, DOMWebKitNamedFlowK a) =>
    a ->                                    -- _obj
    m Int64
dOMWebKitNamedFlowGetFirstEmptyRegionIndex _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_webkit_named_flow_get_first_empty_region_index _obj'
    touchManagedPtr _obj
    return result

-- method DOMWebKitNamedFlow::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_webkit_named_flow_get_name" webkit_dom_webkit_named_flow_get_name :: 
    Ptr DOMWebKitNamedFlow ->               -- _obj : TInterface "WebKit" "DOMWebKitNamedFlow"
    IO CString


dOMWebKitNamedFlowGetName ::
    (MonadIO m, DOMWebKitNamedFlowK a) =>
    a ->                                    -- _obj
    m T.Text
dOMWebKitNamedFlowGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_webkit_named_flow_get_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_webkit_named_flow_get_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMWebKitNamedFlow::get_overflow
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_webkit_named_flow_get_overflow" webkit_dom_webkit_named_flow_get_overflow :: 
    Ptr DOMWebKitNamedFlow ->               -- _obj : TInterface "WebKit" "DOMWebKitNamedFlow"
    IO CInt

{-# DEPRECATED dOMWebKitNamedFlowGetOverflow ["(Since version 1.10)","Use webkit_dom_webkit_named_flow_get_overset() instead."]#-}
dOMWebKitNamedFlowGetOverflow ::
    (MonadIO m, DOMWebKitNamedFlowK a) =>
    a ->                                    -- _obj
    m Bool
dOMWebKitNamedFlowGetOverflow _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_webkit_named_flow_get_overflow _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMWebKitNamedFlow::get_overset
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_webkit_named_flow_get_overset" webkit_dom_webkit_named_flow_get_overset :: 
    Ptr DOMWebKitNamedFlow ->               -- _obj : TInterface "WebKit" "DOMWebKitNamedFlow"
    IO CInt


dOMWebKitNamedFlowGetOverset ::
    (MonadIO m, DOMWebKitNamedFlowK a) =>
    a ->                                    -- _obj
    m Bool
dOMWebKitNamedFlowGetOverset _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_webkit_named_flow_get_overset _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMWebKitNamedFlow::get_regions
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNodeList"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_webkit_named_flow_get_regions" webkit_dom_webkit_named_flow_get_regions :: 
    Ptr DOMWebKitNamedFlow ->               -- _obj : TInterface "WebKit" "DOMWebKitNamedFlow"
    IO (Ptr DOMNodeList)


dOMWebKitNamedFlowGetRegions ::
    (MonadIO m, DOMWebKitNamedFlowK a) =>
    a ->                                    -- _obj
    m DOMNodeList
dOMWebKitNamedFlowGetRegions _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_webkit_named_flow_get_regions _obj'
    checkUnexpectedReturnNULL "webkit_dom_webkit_named_flow_get_regions" result
    result' <- (wrapObject DOMNodeList) result
    touchManagedPtr _obj
    return result'

-- method DOMWebKitNamedFlow::get_regions_by_content
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "contentNode", argType = TInterface "WebKit" "DOMNode", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "contentNode", argType = TInterface "WebKit" "DOMNode", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNodeList"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_webkit_named_flow_get_regions_by_content" webkit_dom_webkit_named_flow_get_regions_by_content :: 
    Ptr DOMWebKitNamedFlow ->               -- _obj : TInterface "WebKit" "DOMWebKitNamedFlow"
    Ptr DOMNode ->                          -- contentNode : TInterface "WebKit" "DOMNode"
    IO (Ptr DOMNodeList)


dOMWebKitNamedFlowGetRegionsByContent ::
    (MonadIO m, DOMWebKitNamedFlowK a, DOMNodeK b) =>
    a ->                                    -- _obj
    b ->                                    -- contentNode
    m DOMNodeList
dOMWebKitNamedFlowGetRegionsByContent _obj contentNode = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let contentNode' = unsafeManagedPtrCastPtr contentNode
    result <- webkit_dom_webkit_named_flow_get_regions_by_content _obj' contentNode'
    checkUnexpectedReturnNULL "webkit_dom_webkit_named_flow_get_regions_by_content" result
    result' <- (wrapObject DOMNodeList) result
    touchManagedPtr _obj
    touchManagedPtr contentNode
    return result'

-- method DOMWebKitNamedFlow::get_regions_by_content_node
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "content_node", argType = TInterface "WebKit" "DOMNode", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMWebKitNamedFlow", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "content_node", argType = TInterface "WebKit" "DOMNode", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNodeList"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_webkit_named_flow_get_regions_by_content_node" webkit_dom_webkit_named_flow_get_regions_by_content_node :: 
    Ptr DOMWebKitNamedFlow ->               -- _obj : TInterface "WebKit" "DOMWebKitNamedFlow"
    Ptr DOMNode ->                          -- content_node : TInterface "WebKit" "DOMNode"
    IO (Ptr DOMNodeList)

{-# DEPRECATED dOMWebKitNamedFlowGetRegionsByContentNode ["(Since version 1.10)","Use webkit_dom_webkit_named_flow_get_regions_by_content() instead."]#-}
dOMWebKitNamedFlowGetRegionsByContentNode ::
    (MonadIO m, DOMWebKitNamedFlowK a, DOMNodeK b) =>
    a ->                                    -- _obj
    b ->                                    -- content_node
    m DOMNodeList
dOMWebKitNamedFlowGetRegionsByContentNode _obj content_node = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let content_node' = unsafeManagedPtrCastPtr content_node
    result <- webkit_dom_webkit_named_flow_get_regions_by_content_node _obj' content_node'
    checkUnexpectedReturnNULL "webkit_dom_webkit_named_flow_get_regions_by_content_node" result
    result' <- (newObject DOMNodeList) result
    touchManagedPtr _obj
    touchManagedPtr content_node
    return result'


