
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.DOMXPathResult
    ( 

-- * Exported types
    DOMXPathResult(..)                      ,
    DOMXPathResultK                         ,
    toDOMXPathResult                        ,
    noDOMXPathResult                        ,


 -- * Methods
-- ** dOMXPathResultGetBooleanValue
    dOMXPathResultGetBooleanValue           ,


-- ** dOMXPathResultGetInvalidIteratorState
    dOMXPathResultGetInvalidIteratorState   ,


-- ** dOMXPathResultGetNumberValue
    dOMXPathResultGetNumberValue            ,


-- ** dOMXPathResultGetResultType
    dOMXPathResultGetResultType             ,


-- ** dOMXPathResultGetSingleNodeValue
    dOMXPathResultGetSingleNodeValue        ,


-- ** dOMXPathResultGetSnapshotLength
    dOMXPathResultGetSnapshotLength         ,


-- ** dOMXPathResultGetStringValue
    dOMXPathResultGetStringValue            ,


-- ** dOMXPathResultIterateNext
    dOMXPathResultIterateNext               ,


-- ** dOMXPathResultSnapshotItem
    dOMXPathResultSnapshotItem              ,




 -- * Properties
-- ** BooleanValue
    DOMXPathResultBooleanValuePropertyInfo  ,
    getDOMXPathResultBooleanValue           ,


-- ** InvalidIteratorState
    DOMXPathResultInvalidIteratorStatePropertyInfo,
    getDOMXPathResultInvalidIteratorState   ,


-- ** NumberValue
    DOMXPathResultNumberValuePropertyInfo   ,
    getDOMXPathResultNumberValue            ,


-- ** ResultType
    DOMXPathResultResultTypePropertyInfo    ,
    getDOMXPathResultResultType             ,


-- ** SingleNodeValue
    DOMXPathResultSingleNodeValuePropertyInfo,
    getDOMXPathResultSingleNodeValue        ,


-- ** SnapshotLength
    DOMXPathResultSnapshotLengthPropertyInfo,
    getDOMXPathResultSnapshotLength         ,


-- ** StringValue
    DOMXPathResultStringValuePropertyInfo   ,
    getDOMXPathResultStringValue            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype DOMXPathResult = DOMXPathResult (ForeignPtr DOMXPathResult)
foreign import ccall "webkit_dom_xpath_result_get_type"
    c_webkit_dom_xpath_result_get_type :: IO GType

type instance ParentTypes DOMXPathResult = DOMXPathResultParentTypes
type DOMXPathResultParentTypes = '[DOMObject, GObject.Object]

instance GObject DOMXPathResult where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_xpath_result_get_type
    

class GObject o => DOMXPathResultK o
instance (GObject o, IsDescendantOf DOMXPathResult o) => DOMXPathResultK o

toDOMXPathResult :: DOMXPathResultK o => o -> IO DOMXPathResult
toDOMXPathResult = unsafeCastTo DOMXPathResult

noDOMXPathResult :: Maybe DOMXPathResult
noDOMXPathResult = Nothing

-- VVV Prop "boolean-value"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMXPathResultBooleanValue :: (MonadIO m, DOMXPathResultK o) => o -> m Bool
getDOMXPathResultBooleanValue obj = liftIO $ getObjectPropertyBool obj "boolean-value"

data DOMXPathResultBooleanValuePropertyInfo
instance AttrInfo DOMXPathResultBooleanValuePropertyInfo where
    type AttrAllowedOps DOMXPathResultBooleanValuePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMXPathResultBooleanValuePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMXPathResultBooleanValuePropertyInfo = DOMXPathResultK
    type AttrGetType DOMXPathResultBooleanValuePropertyInfo = Bool
    type AttrLabel DOMXPathResultBooleanValuePropertyInfo = "DOMXPathResult::boolean-value"
    attrGet _ = getDOMXPathResultBooleanValue
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "invalid-iterator-state"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMXPathResultInvalidIteratorState :: (MonadIO m, DOMXPathResultK o) => o -> m Bool
getDOMXPathResultInvalidIteratorState obj = liftIO $ getObjectPropertyBool obj "invalid-iterator-state"

data DOMXPathResultInvalidIteratorStatePropertyInfo
instance AttrInfo DOMXPathResultInvalidIteratorStatePropertyInfo where
    type AttrAllowedOps DOMXPathResultInvalidIteratorStatePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMXPathResultInvalidIteratorStatePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMXPathResultInvalidIteratorStatePropertyInfo = DOMXPathResultK
    type AttrGetType DOMXPathResultInvalidIteratorStatePropertyInfo = Bool
    type AttrLabel DOMXPathResultInvalidIteratorStatePropertyInfo = "DOMXPathResult::invalid-iterator-state"
    attrGet _ = getDOMXPathResultInvalidIteratorState
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "number-value"
   -- Type: TBasicType TDouble
   -- Flags: [PropertyReadable]

getDOMXPathResultNumberValue :: (MonadIO m, DOMXPathResultK o) => o -> m Double
getDOMXPathResultNumberValue obj = liftIO $ getObjectPropertyDouble obj "number-value"

data DOMXPathResultNumberValuePropertyInfo
instance AttrInfo DOMXPathResultNumberValuePropertyInfo where
    type AttrAllowedOps DOMXPathResultNumberValuePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMXPathResultNumberValuePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMXPathResultNumberValuePropertyInfo = DOMXPathResultK
    type AttrGetType DOMXPathResultNumberValuePropertyInfo = Double
    type AttrLabel DOMXPathResultNumberValuePropertyInfo = "DOMXPathResult::number-value"
    attrGet _ = getDOMXPathResultNumberValue
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "result-type"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable]

getDOMXPathResultResultType :: (MonadIO m, DOMXPathResultK o) => o -> m Word32
getDOMXPathResultResultType obj = liftIO $ getObjectPropertyCUInt obj "result-type"

data DOMXPathResultResultTypePropertyInfo
instance AttrInfo DOMXPathResultResultTypePropertyInfo where
    type AttrAllowedOps DOMXPathResultResultTypePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMXPathResultResultTypePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMXPathResultResultTypePropertyInfo = DOMXPathResultK
    type AttrGetType DOMXPathResultResultTypePropertyInfo = Word32
    type AttrLabel DOMXPathResultResultTypePropertyInfo = "DOMXPathResult::result-type"
    attrGet _ = getDOMXPathResultResultType
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "single-node-value"
   -- Type: TInterface "WebKit" "DOMNode"
   -- Flags: [PropertyReadable]

getDOMXPathResultSingleNodeValue :: (MonadIO m, DOMXPathResultK o) => o -> m DOMNode
getDOMXPathResultSingleNodeValue obj = liftIO $ getObjectPropertyObject obj "single-node-value" DOMNode

data DOMXPathResultSingleNodeValuePropertyInfo
instance AttrInfo DOMXPathResultSingleNodeValuePropertyInfo where
    type AttrAllowedOps DOMXPathResultSingleNodeValuePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMXPathResultSingleNodeValuePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMXPathResultSingleNodeValuePropertyInfo = DOMXPathResultK
    type AttrGetType DOMXPathResultSingleNodeValuePropertyInfo = DOMNode
    type AttrLabel DOMXPathResultSingleNodeValuePropertyInfo = "DOMXPathResult::single-node-value"
    attrGet _ = getDOMXPathResultSingleNodeValue
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "snapshot-length"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getDOMXPathResultSnapshotLength :: (MonadIO m, DOMXPathResultK o) => o -> m Word64
getDOMXPathResultSnapshotLength obj = liftIO $ getObjectPropertyUInt64 obj "snapshot-length"

data DOMXPathResultSnapshotLengthPropertyInfo
instance AttrInfo DOMXPathResultSnapshotLengthPropertyInfo where
    type AttrAllowedOps DOMXPathResultSnapshotLengthPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMXPathResultSnapshotLengthPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMXPathResultSnapshotLengthPropertyInfo = DOMXPathResultK
    type AttrGetType DOMXPathResultSnapshotLengthPropertyInfo = Word64
    type AttrLabel DOMXPathResultSnapshotLengthPropertyInfo = "DOMXPathResult::snapshot-length"
    attrGet _ = getDOMXPathResultSnapshotLength
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "string-value"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMXPathResultStringValue :: (MonadIO m, DOMXPathResultK o) => o -> m T.Text
getDOMXPathResultStringValue obj = liftIO $ getObjectPropertyString obj "string-value"

data DOMXPathResultStringValuePropertyInfo
instance AttrInfo DOMXPathResultStringValuePropertyInfo where
    type AttrAllowedOps DOMXPathResultStringValuePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMXPathResultStringValuePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMXPathResultStringValuePropertyInfo = DOMXPathResultK
    type AttrGetType DOMXPathResultStringValuePropertyInfo = T.Text
    type AttrLabel DOMXPathResultStringValuePropertyInfo = "DOMXPathResult::string-value"
    attrGet _ = getDOMXPathResultStringValue
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMXPathResult = DOMXPathResultAttributeList
type DOMXPathResultAttributeList = ('[ '("boolean-value", DOMXPathResultBooleanValuePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("invalid-iterator-state", DOMXPathResultInvalidIteratorStatePropertyInfo), '("number-value", DOMXPathResultNumberValuePropertyInfo), '("result-type", DOMXPathResultResultTypePropertyInfo), '("single-node-value", DOMXPathResultSingleNodeValuePropertyInfo), '("snapshot-length", DOMXPathResultSnapshotLengthPropertyInfo), '("string-value", DOMXPathResultStringValuePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMXPathResult = DOMXPathResultSignalList
type DOMXPathResultSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMXPathResult::get_boolean_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_xpath_result_get_boolean_value" webkit_dom_xpath_result_get_boolean_value :: 
    Ptr DOMXPathResult ->                   -- _obj : TInterface "WebKit" "DOMXPathResult"
    Ptr (Ptr GError) ->                     -- error
    IO CInt


dOMXPathResultGetBooleanValue ::
    (MonadIO m, DOMXPathResultK a) =>
    a ->                                    -- _obj
    m ()
dOMXPathResultGetBooleanValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        _ <- propagateGError $ webkit_dom_xpath_result_get_boolean_value _obj'
        touchManagedPtr _obj
        return ()
     ) (do
        return ()
     )

-- method DOMXPathResult::get_invalid_iterator_state
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_xpath_result_get_invalid_iterator_state" webkit_dom_xpath_result_get_invalid_iterator_state :: 
    Ptr DOMXPathResult ->                   -- _obj : TInterface "WebKit" "DOMXPathResult"
    IO CInt


dOMXPathResultGetInvalidIteratorState ::
    (MonadIO m, DOMXPathResultK a) =>
    a ->                                    -- _obj
    m Bool
dOMXPathResultGetInvalidIteratorState _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_xpath_result_get_invalid_iterator_state _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMXPathResult::get_number_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TDouble
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_xpath_result_get_number_value" webkit_dom_xpath_result_get_number_value :: 
    Ptr DOMXPathResult ->                   -- _obj : TInterface "WebKit" "DOMXPathResult"
    Ptr (Ptr GError) ->                     -- error
    IO CDouble


dOMXPathResultGetNumberValue ::
    (MonadIO m, DOMXPathResultK a) =>
    a ->                                    -- _obj
    m Double
dOMXPathResultGetNumberValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        result <- propagateGError $ webkit_dom_xpath_result_get_number_value _obj'
        let result' = realToFrac result
        touchManagedPtr _obj
        return result'
     ) (do
        return ()
     )

-- method DOMXPathResult::get_result_type
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt16
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_xpath_result_get_result_type" webkit_dom_xpath_result_get_result_type :: 
    Ptr DOMXPathResult ->                   -- _obj : TInterface "WebKit" "DOMXPathResult"
    IO Word16


dOMXPathResultGetResultType ::
    (MonadIO m, DOMXPathResultK a) =>
    a ->                                    -- _obj
    m Word16
dOMXPathResultGetResultType _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_xpath_result_get_result_type _obj'
    touchManagedPtr _obj
    return result

-- method DOMXPathResult::get_single_node_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNode"
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_xpath_result_get_single_node_value" webkit_dom_xpath_result_get_single_node_value :: 
    Ptr DOMXPathResult ->                   -- _obj : TInterface "WebKit" "DOMXPathResult"
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr DOMNode)


dOMXPathResultGetSingleNodeValue ::
    (MonadIO m, DOMXPathResultK a) =>
    a ->                                    -- _obj
    m DOMNode
dOMXPathResultGetSingleNodeValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        result <- propagateGError $ webkit_dom_xpath_result_get_single_node_value _obj'
        checkUnexpectedReturnNULL "webkit_dom_xpath_result_get_single_node_value" result
        result' <- (newObject DOMNode) result
        touchManagedPtr _obj
        return result'
     ) (do
        return ()
     )

-- method DOMXPathResult::get_snapshot_length
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_xpath_result_get_snapshot_length" webkit_dom_xpath_result_get_snapshot_length :: 
    Ptr DOMXPathResult ->                   -- _obj : TInterface "WebKit" "DOMXPathResult"
    Ptr (Ptr GError) ->                     -- error
    IO Word64


dOMXPathResultGetSnapshotLength ::
    (MonadIO m, DOMXPathResultK a) =>
    a ->                                    -- _obj
    m Word64
dOMXPathResultGetSnapshotLength _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        result <- propagateGError $ webkit_dom_xpath_result_get_snapshot_length _obj'
        touchManagedPtr _obj
        return result
     ) (do
        return ()
     )

-- method DOMXPathResult::get_string_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_xpath_result_get_string_value" webkit_dom_xpath_result_get_string_value :: 
    Ptr DOMXPathResult ->                   -- _obj : TInterface "WebKit" "DOMXPathResult"
    Ptr (Ptr GError) ->                     -- error
    IO CString


dOMXPathResultGetStringValue ::
    (MonadIO m, DOMXPathResultK a) =>
    a ->                                    -- _obj
    m T.Text
dOMXPathResultGetStringValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        result <- propagateGError $ webkit_dom_xpath_result_get_string_value _obj'
        checkUnexpectedReturnNULL "webkit_dom_xpath_result_get_string_value" result
        result' <- cstringToText result
        freeMem result
        touchManagedPtr _obj
        return result'
     ) (do
        return ()
     )

-- method DOMXPathResult::iterate_next
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNode"
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_xpath_result_iterate_next" webkit_dom_xpath_result_iterate_next :: 
    Ptr DOMXPathResult ->                   -- _obj : TInterface "WebKit" "DOMXPathResult"
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr DOMNode)


dOMXPathResultIterateNext ::
    (MonadIO m, DOMXPathResultK a) =>
    a ->                                    -- _obj
    m DOMNode
dOMXPathResultIterateNext _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        result <- propagateGError $ webkit_dom_xpath_result_iterate_next _obj'
        checkUnexpectedReturnNULL "webkit_dom_xpath_result_iterate_next" result
        result' <- (newObject DOMNode) result
        touchManagedPtr _obj
        return result'
     ) (do
        return ()
     )

-- method DOMXPathResult::snapshot_item
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "DOMXPathResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "index", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit" "DOMNode"
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_xpath_result_snapshot_item" webkit_dom_xpath_result_snapshot_item :: 
    Ptr DOMXPathResult ->                   -- _obj : TInterface "WebKit" "DOMXPathResult"
    Word64 ->                               -- index : TBasicType TUInt64
    Ptr (Ptr GError) ->                     -- error
    IO (Ptr DOMNode)


dOMXPathResultSnapshotItem ::
    (MonadIO m, DOMXPathResultK a) =>
    a ->                                    -- _obj
    Word64 ->                               -- index
    m DOMNode
dOMXPathResultSnapshotItem _obj index = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        result <- propagateGError $ webkit_dom_xpath_result_snapshot_item _obj' index
        checkUnexpectedReturnNULL "webkit_dom_xpath_result_snapshot_item" result
        result' <- (newObject DOMNode) result
        touchManagedPtr _obj
        return result'
     ) (do
        return ()
     )


