
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.GeolocationPolicyDecision
    ( 

-- * Exported types
    GeolocationPolicyDecision(..)           ,
    GeolocationPolicyDecisionK              ,
    toGeolocationPolicyDecision             ,
    noGeolocationPolicyDecision             ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype GeolocationPolicyDecision = GeolocationPolicyDecision (ForeignPtr GeolocationPolicyDecision)
foreign import ccall "webkit_geolocation_policy_decision_get_type"
    c_webkit_geolocation_policy_decision_get_type :: IO GType

type instance ParentTypes GeolocationPolicyDecision = GeolocationPolicyDecisionParentTypes
type GeolocationPolicyDecisionParentTypes = '[GObject.Object]

instance GObject GeolocationPolicyDecision where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_geolocation_policy_decision_get_type
    

class GObject o => GeolocationPolicyDecisionK o
instance (GObject o, IsDescendantOf GeolocationPolicyDecision o) => GeolocationPolicyDecisionK o

toGeolocationPolicyDecision :: GeolocationPolicyDecisionK o => o -> IO GeolocationPolicyDecision
toGeolocationPolicyDecision = unsafeCastTo GeolocationPolicyDecision

noGeolocationPolicyDecision :: Maybe GeolocationPolicyDecision
noGeolocationPolicyDecision = Nothing

type instance AttributeList GeolocationPolicyDecision = GeolocationPolicyDecisionAttributeList
type GeolocationPolicyDecisionAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList GeolocationPolicyDecision = GeolocationPolicyDecisionSignalList
type GeolocationPolicyDecisionSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


