
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit.Objects.ViewportAttributes
    ( 

-- * Exported types
    ViewportAttributes(..)                  ,
    ViewportAttributesK                     ,
    toViewportAttributes                    ,
    noViewportAttributes                    ,


 -- * Methods
-- ** viewportAttributesRecompute
    viewportAttributesRecompute             ,




 -- * Properties
-- ** AvailableHeight
    ViewportAttributesAvailableHeightPropertyInfo,
    constructViewportAttributesAvailableHeight,
    getViewportAttributesAvailableHeight    ,
    setViewportAttributesAvailableHeight    ,


-- ** AvailableWidth
    ViewportAttributesAvailableWidthPropertyInfo,
    constructViewportAttributesAvailableWidth,
    getViewportAttributesAvailableWidth     ,
    setViewportAttributesAvailableWidth     ,


-- ** DesktopWidth
    ViewportAttributesDesktopWidthPropertyInfo,
    constructViewportAttributesDesktopWidth ,
    getViewportAttributesDesktopWidth       ,
    setViewportAttributesDesktopWidth       ,


-- ** DeviceDpi
    ViewportAttributesDeviceDpiPropertyInfo ,
    constructViewportAttributesDeviceDpi    ,
    getViewportAttributesDeviceDpi          ,
    setViewportAttributesDeviceDpi          ,


-- ** DeviceHeight
    ViewportAttributesDeviceHeightPropertyInfo,
    constructViewportAttributesDeviceHeight ,
    getViewportAttributesDeviceHeight       ,
    setViewportAttributesDeviceHeight       ,


-- ** DevicePixelRatio
    ViewportAttributesDevicePixelRatioPropertyInfo,
    getViewportAttributesDevicePixelRatio   ,


-- ** DeviceWidth
    ViewportAttributesDeviceWidthPropertyInfo,
    constructViewportAttributesDeviceWidth  ,
    getViewportAttributesDeviceWidth        ,
    setViewportAttributesDeviceWidth        ,


-- ** Height
    ViewportAttributesHeightPropertyInfo    ,
    getViewportAttributesHeight             ,


-- ** InitialScaleFactor
    ViewportAttributesInitialScaleFactorPropertyInfo,
    getViewportAttributesInitialScaleFactor ,


-- ** MaximumScaleFactor
    ViewportAttributesMaximumScaleFactorPropertyInfo,
    getViewportAttributesMaximumScaleFactor ,


-- ** MinimumScaleFactor
    ViewportAttributesMinimumScaleFactorPropertyInfo,
    getViewportAttributesMinimumScaleFactor ,


-- ** UserScalable
    ViewportAttributesUserScalablePropertyInfo,
    getViewportAttributesUserScalable       ,


-- ** Valid
    ViewportAttributesValidPropertyInfo     ,
    getViewportAttributesValid              ,


-- ** Width
    ViewportAttributesWidthPropertyInfo     ,
    getViewportAttributesWidth              ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit.Types
import GI.WebKit.Callbacks
import qualified GI.GObject as GObject

newtype ViewportAttributes = ViewportAttributes (ForeignPtr ViewportAttributes)
foreign import ccall "webkit_viewport_attributes_get_type"
    c_webkit_viewport_attributes_get_type :: IO GType

type instance ParentTypes ViewportAttributes = ViewportAttributesParentTypes
type ViewportAttributesParentTypes = '[GObject.Object]

instance GObject ViewportAttributes where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_viewport_attributes_get_type
    

class GObject o => ViewportAttributesK o
instance (GObject o, IsDescendantOf ViewportAttributes o) => ViewportAttributesK o

toViewportAttributes :: ViewportAttributesK o => o -> IO ViewportAttributes
toViewportAttributes = unsafeCastTo ViewportAttributes

noViewportAttributes :: Maybe ViewportAttributes
noViewportAttributes = Nothing

-- VVV Prop "available-height"
   -- Type: TBasicType TInt32
   -- Flags: [PropertyReadable,PropertyWritable]

getViewportAttributesAvailableHeight :: (MonadIO m, ViewportAttributesK o) => o -> m Int32
getViewportAttributesAvailableHeight obj = liftIO $ getObjectPropertyCInt obj "available-height"

setViewportAttributesAvailableHeight :: (MonadIO m, ViewportAttributesK o) => o -> Int32 -> m ()
setViewportAttributesAvailableHeight obj val = liftIO $ setObjectPropertyCInt obj "available-height" val

constructViewportAttributesAvailableHeight :: Int32 -> IO ([Char], GValue)
constructViewportAttributesAvailableHeight val = constructObjectPropertyCInt "available-height" val

data ViewportAttributesAvailableHeightPropertyInfo
instance AttrInfo ViewportAttributesAvailableHeightPropertyInfo where
    type AttrAllowedOps ViewportAttributesAvailableHeightPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesAvailableHeightPropertyInfo = (~) Int32
    type AttrBaseTypeConstraint ViewportAttributesAvailableHeightPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesAvailableHeightPropertyInfo = Int32
    type AttrLabel ViewportAttributesAvailableHeightPropertyInfo = "ViewportAttributes::available-height"
    attrGet _ = getViewportAttributesAvailableHeight
    attrSet _ = setViewportAttributesAvailableHeight
    attrConstruct _ = constructViewportAttributesAvailableHeight

-- VVV Prop "available-width"
   -- Type: TBasicType TInt32
   -- Flags: [PropertyReadable,PropertyWritable]

getViewportAttributesAvailableWidth :: (MonadIO m, ViewportAttributesK o) => o -> m Int32
getViewportAttributesAvailableWidth obj = liftIO $ getObjectPropertyCInt obj "available-width"

setViewportAttributesAvailableWidth :: (MonadIO m, ViewportAttributesK o) => o -> Int32 -> m ()
setViewportAttributesAvailableWidth obj val = liftIO $ setObjectPropertyCInt obj "available-width" val

constructViewportAttributesAvailableWidth :: Int32 -> IO ([Char], GValue)
constructViewportAttributesAvailableWidth val = constructObjectPropertyCInt "available-width" val

data ViewportAttributesAvailableWidthPropertyInfo
instance AttrInfo ViewportAttributesAvailableWidthPropertyInfo where
    type AttrAllowedOps ViewportAttributesAvailableWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesAvailableWidthPropertyInfo = (~) Int32
    type AttrBaseTypeConstraint ViewportAttributesAvailableWidthPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesAvailableWidthPropertyInfo = Int32
    type AttrLabel ViewportAttributesAvailableWidthPropertyInfo = "ViewportAttributes::available-width"
    attrGet _ = getViewportAttributesAvailableWidth
    attrSet _ = setViewportAttributesAvailableWidth
    attrConstruct _ = constructViewportAttributesAvailableWidth

-- VVV Prop "desktop-width"
   -- Type: TBasicType TInt32
   -- Flags: [PropertyReadable,PropertyWritable]

getViewportAttributesDesktopWidth :: (MonadIO m, ViewportAttributesK o) => o -> m Int32
getViewportAttributesDesktopWidth obj = liftIO $ getObjectPropertyCInt obj "desktop-width"

setViewportAttributesDesktopWidth :: (MonadIO m, ViewportAttributesK o) => o -> Int32 -> m ()
setViewportAttributesDesktopWidth obj val = liftIO $ setObjectPropertyCInt obj "desktop-width" val

constructViewportAttributesDesktopWidth :: Int32 -> IO ([Char], GValue)
constructViewportAttributesDesktopWidth val = constructObjectPropertyCInt "desktop-width" val

data ViewportAttributesDesktopWidthPropertyInfo
instance AttrInfo ViewportAttributesDesktopWidthPropertyInfo where
    type AttrAllowedOps ViewportAttributesDesktopWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesDesktopWidthPropertyInfo = (~) Int32
    type AttrBaseTypeConstraint ViewportAttributesDesktopWidthPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesDesktopWidthPropertyInfo = Int32
    type AttrLabel ViewportAttributesDesktopWidthPropertyInfo = "ViewportAttributes::desktop-width"
    attrGet _ = getViewportAttributesDesktopWidth
    attrSet _ = setViewportAttributesDesktopWidth
    attrConstruct _ = constructViewportAttributesDesktopWidth

-- VVV Prop "device-dpi"
   -- Type: TBasicType TInt32
   -- Flags: [PropertyReadable,PropertyWritable]

getViewportAttributesDeviceDpi :: (MonadIO m, ViewportAttributesK o) => o -> m Int32
getViewportAttributesDeviceDpi obj = liftIO $ getObjectPropertyCInt obj "device-dpi"

setViewportAttributesDeviceDpi :: (MonadIO m, ViewportAttributesK o) => o -> Int32 -> m ()
setViewportAttributesDeviceDpi obj val = liftIO $ setObjectPropertyCInt obj "device-dpi" val

constructViewportAttributesDeviceDpi :: Int32 -> IO ([Char], GValue)
constructViewportAttributesDeviceDpi val = constructObjectPropertyCInt "device-dpi" val

data ViewportAttributesDeviceDpiPropertyInfo
instance AttrInfo ViewportAttributesDeviceDpiPropertyInfo where
    type AttrAllowedOps ViewportAttributesDeviceDpiPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesDeviceDpiPropertyInfo = (~) Int32
    type AttrBaseTypeConstraint ViewportAttributesDeviceDpiPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesDeviceDpiPropertyInfo = Int32
    type AttrLabel ViewportAttributesDeviceDpiPropertyInfo = "ViewportAttributes::device-dpi"
    attrGet _ = getViewportAttributesDeviceDpi
    attrSet _ = setViewportAttributesDeviceDpi
    attrConstruct _ = constructViewportAttributesDeviceDpi

-- VVV Prop "device-height"
   -- Type: TBasicType TInt32
   -- Flags: [PropertyReadable,PropertyWritable]

getViewportAttributesDeviceHeight :: (MonadIO m, ViewportAttributesK o) => o -> m Int32
getViewportAttributesDeviceHeight obj = liftIO $ getObjectPropertyCInt obj "device-height"

setViewportAttributesDeviceHeight :: (MonadIO m, ViewportAttributesK o) => o -> Int32 -> m ()
setViewportAttributesDeviceHeight obj val = liftIO $ setObjectPropertyCInt obj "device-height" val

constructViewportAttributesDeviceHeight :: Int32 -> IO ([Char], GValue)
constructViewportAttributesDeviceHeight val = constructObjectPropertyCInt "device-height" val

data ViewportAttributesDeviceHeightPropertyInfo
instance AttrInfo ViewportAttributesDeviceHeightPropertyInfo where
    type AttrAllowedOps ViewportAttributesDeviceHeightPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesDeviceHeightPropertyInfo = (~) Int32
    type AttrBaseTypeConstraint ViewportAttributesDeviceHeightPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesDeviceHeightPropertyInfo = Int32
    type AttrLabel ViewportAttributesDeviceHeightPropertyInfo = "ViewportAttributes::device-height"
    attrGet _ = getViewportAttributesDeviceHeight
    attrSet _ = setViewportAttributesDeviceHeight
    attrConstruct _ = constructViewportAttributesDeviceHeight

-- VVV Prop "device-pixel-ratio"
   -- Type: TBasicType TFloat
   -- Flags: [PropertyReadable]

getViewportAttributesDevicePixelRatio :: (MonadIO m, ViewportAttributesK o) => o -> m Float
getViewportAttributesDevicePixelRatio obj = liftIO $ getObjectPropertyFloat obj "device-pixel-ratio"

data ViewportAttributesDevicePixelRatioPropertyInfo
instance AttrInfo ViewportAttributesDevicePixelRatioPropertyInfo where
    type AttrAllowedOps ViewportAttributesDevicePixelRatioPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesDevicePixelRatioPropertyInfo = (~) ()
    type AttrBaseTypeConstraint ViewportAttributesDevicePixelRatioPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesDevicePixelRatioPropertyInfo = Float
    type AttrLabel ViewportAttributesDevicePixelRatioPropertyInfo = "ViewportAttributes::device-pixel-ratio"
    attrGet _ = getViewportAttributesDevicePixelRatio
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "device-width"
   -- Type: TBasicType TInt32
   -- Flags: [PropertyReadable,PropertyWritable]

getViewportAttributesDeviceWidth :: (MonadIO m, ViewportAttributesK o) => o -> m Int32
getViewportAttributesDeviceWidth obj = liftIO $ getObjectPropertyCInt obj "device-width"

setViewportAttributesDeviceWidth :: (MonadIO m, ViewportAttributesK o) => o -> Int32 -> m ()
setViewportAttributesDeviceWidth obj val = liftIO $ setObjectPropertyCInt obj "device-width" val

constructViewportAttributesDeviceWidth :: Int32 -> IO ([Char], GValue)
constructViewportAttributesDeviceWidth val = constructObjectPropertyCInt "device-width" val

data ViewportAttributesDeviceWidthPropertyInfo
instance AttrInfo ViewportAttributesDeviceWidthPropertyInfo where
    type AttrAllowedOps ViewportAttributesDeviceWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesDeviceWidthPropertyInfo = (~) Int32
    type AttrBaseTypeConstraint ViewportAttributesDeviceWidthPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesDeviceWidthPropertyInfo = Int32
    type AttrLabel ViewportAttributesDeviceWidthPropertyInfo = "ViewportAttributes::device-width"
    attrGet _ = getViewportAttributesDeviceWidth
    attrSet _ = setViewportAttributesDeviceWidth
    attrConstruct _ = constructViewportAttributesDeviceWidth

-- VVV Prop "height"
   -- Type: TBasicType TInt32
   -- Flags: [PropertyReadable]

getViewportAttributesHeight :: (MonadIO m, ViewportAttributesK o) => o -> m Int32
getViewportAttributesHeight obj = liftIO $ getObjectPropertyCInt obj "height"

data ViewportAttributesHeightPropertyInfo
instance AttrInfo ViewportAttributesHeightPropertyInfo where
    type AttrAllowedOps ViewportAttributesHeightPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesHeightPropertyInfo = (~) ()
    type AttrBaseTypeConstraint ViewportAttributesHeightPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesHeightPropertyInfo = Int32
    type AttrLabel ViewportAttributesHeightPropertyInfo = "ViewportAttributes::height"
    attrGet _ = getViewportAttributesHeight
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "initial-scale-factor"
   -- Type: TBasicType TFloat
   -- Flags: [PropertyReadable]

getViewportAttributesInitialScaleFactor :: (MonadIO m, ViewportAttributesK o) => o -> m Float
getViewportAttributesInitialScaleFactor obj = liftIO $ getObjectPropertyFloat obj "initial-scale-factor"

data ViewportAttributesInitialScaleFactorPropertyInfo
instance AttrInfo ViewportAttributesInitialScaleFactorPropertyInfo where
    type AttrAllowedOps ViewportAttributesInitialScaleFactorPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesInitialScaleFactorPropertyInfo = (~) ()
    type AttrBaseTypeConstraint ViewportAttributesInitialScaleFactorPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesInitialScaleFactorPropertyInfo = Float
    type AttrLabel ViewportAttributesInitialScaleFactorPropertyInfo = "ViewportAttributes::initial-scale-factor"
    attrGet _ = getViewportAttributesInitialScaleFactor
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "maximum-scale-factor"
   -- Type: TBasicType TFloat
   -- Flags: [PropertyReadable]

getViewportAttributesMaximumScaleFactor :: (MonadIO m, ViewportAttributesK o) => o -> m Float
getViewportAttributesMaximumScaleFactor obj = liftIO $ getObjectPropertyFloat obj "maximum-scale-factor"

data ViewportAttributesMaximumScaleFactorPropertyInfo
instance AttrInfo ViewportAttributesMaximumScaleFactorPropertyInfo where
    type AttrAllowedOps ViewportAttributesMaximumScaleFactorPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesMaximumScaleFactorPropertyInfo = (~) ()
    type AttrBaseTypeConstraint ViewportAttributesMaximumScaleFactorPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesMaximumScaleFactorPropertyInfo = Float
    type AttrLabel ViewportAttributesMaximumScaleFactorPropertyInfo = "ViewportAttributes::maximum-scale-factor"
    attrGet _ = getViewportAttributesMaximumScaleFactor
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "minimum-scale-factor"
   -- Type: TBasicType TFloat
   -- Flags: [PropertyReadable]

getViewportAttributesMinimumScaleFactor :: (MonadIO m, ViewportAttributesK o) => o -> m Float
getViewportAttributesMinimumScaleFactor obj = liftIO $ getObjectPropertyFloat obj "minimum-scale-factor"

data ViewportAttributesMinimumScaleFactorPropertyInfo
instance AttrInfo ViewportAttributesMinimumScaleFactorPropertyInfo where
    type AttrAllowedOps ViewportAttributesMinimumScaleFactorPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesMinimumScaleFactorPropertyInfo = (~) ()
    type AttrBaseTypeConstraint ViewportAttributesMinimumScaleFactorPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesMinimumScaleFactorPropertyInfo = Float
    type AttrLabel ViewportAttributesMinimumScaleFactorPropertyInfo = "ViewportAttributes::minimum-scale-factor"
    attrGet _ = getViewportAttributesMinimumScaleFactor
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "user-scalable"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getViewportAttributesUserScalable :: (MonadIO m, ViewportAttributesK o) => o -> m Bool
getViewportAttributesUserScalable obj = liftIO $ getObjectPropertyBool obj "user-scalable"

data ViewportAttributesUserScalablePropertyInfo
instance AttrInfo ViewportAttributesUserScalablePropertyInfo where
    type AttrAllowedOps ViewportAttributesUserScalablePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesUserScalablePropertyInfo = (~) ()
    type AttrBaseTypeConstraint ViewportAttributesUserScalablePropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesUserScalablePropertyInfo = Bool
    type AttrLabel ViewportAttributesUserScalablePropertyInfo = "ViewportAttributes::user-scalable"
    attrGet _ = getViewportAttributesUserScalable
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "valid"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getViewportAttributesValid :: (MonadIO m, ViewportAttributesK o) => o -> m Bool
getViewportAttributesValid obj = liftIO $ getObjectPropertyBool obj "valid"

data ViewportAttributesValidPropertyInfo
instance AttrInfo ViewportAttributesValidPropertyInfo where
    type AttrAllowedOps ViewportAttributesValidPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesValidPropertyInfo = (~) ()
    type AttrBaseTypeConstraint ViewportAttributesValidPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesValidPropertyInfo = Bool
    type AttrLabel ViewportAttributesValidPropertyInfo = "ViewportAttributes::valid"
    attrGet _ = getViewportAttributesValid
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "width"
   -- Type: TBasicType TInt32
   -- Flags: [PropertyReadable]

getViewportAttributesWidth :: (MonadIO m, ViewportAttributesK o) => o -> m Int32
getViewportAttributesWidth obj = liftIO $ getObjectPropertyCInt obj "width"

data ViewportAttributesWidthPropertyInfo
instance AttrInfo ViewportAttributesWidthPropertyInfo where
    type AttrAllowedOps ViewportAttributesWidthPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint ViewportAttributesWidthPropertyInfo = (~) ()
    type AttrBaseTypeConstraint ViewportAttributesWidthPropertyInfo = ViewportAttributesK
    type AttrGetType ViewportAttributesWidthPropertyInfo = Int32
    type AttrLabel ViewportAttributesWidthPropertyInfo = "ViewportAttributes::width"
    attrGet _ = getViewportAttributesWidth
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList ViewportAttributes = ViewportAttributesAttributeList
type ViewportAttributesAttributeList = ('[ '("available-height", ViewportAttributesAvailableHeightPropertyInfo), '("available-width", ViewportAttributesAvailableWidthPropertyInfo), '("desktop-width", ViewportAttributesDesktopWidthPropertyInfo), '("device-dpi", ViewportAttributesDeviceDpiPropertyInfo), '("device-height", ViewportAttributesDeviceHeightPropertyInfo), '("device-pixel-ratio", ViewportAttributesDevicePixelRatioPropertyInfo), '("device-width", ViewportAttributesDeviceWidthPropertyInfo), '("height", ViewportAttributesHeightPropertyInfo), '("initial-scale-factor", ViewportAttributesInitialScaleFactorPropertyInfo), '("maximum-scale-factor", ViewportAttributesMaximumScaleFactorPropertyInfo), '("minimum-scale-factor", ViewportAttributesMinimumScaleFactorPropertyInfo), '("user-scalable", ViewportAttributesUserScalablePropertyInfo), '("valid", ViewportAttributesValidPropertyInfo), '("width", ViewportAttributesWidthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList ViewportAttributes = ViewportAttributesSignalList
type ViewportAttributesSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method ViewportAttributes::recompute
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit" "ViewportAttributes", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit" "ViewportAttributes", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_viewport_attributes_recompute" webkit_viewport_attributes_recompute :: 
    Ptr ViewportAttributes ->               -- _obj : TInterface "WebKit" "ViewportAttributes"
    IO ()


viewportAttributesRecompute ::
    (MonadIO m, ViewportAttributesK a) =>
    a ->                                    -- _obj
    m ()
viewportAttributesRecompute _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_viewport_attributes_recompute _obj'
    touchManagedPtr _obj
    return ()


